Package: DiffBind
Type: Package
Version: 3.23.3
Title: Differential Binding Analysis of ChIP-Seq Peak Data
Authors@R: c(person("Rory","Stark", email="bioconductor@starkhome.com",
                  role = c("aut", "cre")),
             person("Gord","Brown",email="DECEASED",
                  role="aut"))
Description: Compute differentially bound sites from multiple ChIP-seq
        experiments using affinity (quantitative) data. Also enables
        occupancy (overlap) analysis and plotting functions.
License: Artistic-2.0
LazyLoad: yes
Depends: R (>= 4.0), GenomicRanges, SummarizedExperiment
Imports: RColorBrewer, amap, gplots, grDevices, limma,
        GenomicAlignments, locfit, stats, utils, IRanges, lattice,
        systemPipeR, tools, Rcpp, dplyr, ggplot2, BiocParallel,
        parallel, S4Vectors, Rsamtools (>= 2.13.1), DESeq2, methods,
        graphics, ggrepel, apeglm, ashr, GreyListChIP
Suggests: BiocStyle, testthat, xtable, rgl, XLConnect, edgeR, csaw,
        BSgenome, GenomeInfoDb, rtracklayer, grid
LinkingTo: Rhtslib (>= 1.99.1), Rcpp
SystemRequirements: GNU make
Collate: core.R parallel.R model.R counts.R contrast.R normalize.R
        analyze.R analyze_deseq2.R analyze_edgeR.R blacklist.R report.R
        plots.R plotProfile.R io.R helper.R utils.R RcppExports.R
        cpp_wrapper.R DBA.R
biocViews: Sequencing, ChIPSeq,ATACSeq, DNaseSeq, MethylSeq, RIPSeq,
        DifferentialPeakCalling, DifferentialMethylation,
        GeneRegulation, HistoneModification, PeakDetection,
        BiomedicalInformatics, CellBiology, MultipleComparison,
        Normalization, ReportWriting, Epigenetics, FunctionalGenomics
URL: https://bioconductor.org/packages/DiffBind/
git_url: https://git.bioconductor.org/packages/DiffBind
git_branch: devel
git_last_commit: a26ef8d
git_last_commit_date: 2026-07-01
Repository: Bioconductor 3.24
Date/Publication: 2026-07-05
NeedsCompilation: yes
Packaged: 2026-07-05 21:26:26 UTC; biocbuild
Author: Rory Stark [aut, cre],
  Gord Brown [aut]
Maintainer: Rory Stark <bioconductor@starkhome.com>

#################GENERIC PARALLEL INTERFACE #################

DBA_PARALLEL_MULTICORE <- 1
DBA_PARALLEL_RLSF      <- 2
DBA_PARALLEL_LSFR      <- 3
DBA_PARALLEL_BIOC      <- 4

### INITIALIZE ###
dba.parallel <- function(DBA) {
   
   if(DBA$config$parallelPackage==DBA_PARALLEL_MULTICORE) {
      DBA$config <-  dba.multicore.init(DBA$config)
      DBA$config$parallelInit <- TRUE
      return(DBA)
   }
   
   if(DBA$config$parallelPackage==DBA_PARALLEL_BIOC) {
      DBA$config <-  dba.biocparallel.init(DBA$config)
      DBA$config$parallelInit <- TRUE
      return(DBA)
   }
   # 
   # if(DBA$config$parallelPackage==DBA_PARALLEL_RLSF) {
   #    DBA$config <-  dba.Rlsf.init(DBA$config)
   #    DBA$config$parallelInit <- TRUE
   #    return(DBA)
   # }
   # 
   # if(DBA$config$parallelPackage==DBA_PARALLEL_LSFR) {
   #    DBA$config <-  dba.lsfR.init(DBA$config)
   #    DBA$config$parallelInit <- TRUE
   #    return(DBA)
   # }
   # 
   if(DBA$config$parallelPackage > 0) {
      warning('UNKNOWN PARALLEL PACKAGE: ',DBA$config$parallelPackage,call.=FALSE)
   }
   return(DBA)
}

dba.parallel.init <- function(config){
   config <- config$initFun(config)
   return(config)
}

### CONFIG ###
dba.parallel.params <- function(config,funlist) {
   params <- config$paramFun(config,funlist)
   return(params)
}

### PARALLEL LAPPLY ###
dba.parallel.lapply <- function(config,params,arglist,fn,...) {
   jobs <- config$lapplyFun(config,params,arglist,fn,...)
   return(jobs)
}

### ADD JOB ###
dba.parallel.addjob <- function(config,params,fn,...) {
   job <- config$addjobFun(config,params,fn,...)
   return(job)
}

### WAIT FOR JOBS TO COMPLETE AND GATHER RESULTS ###
dba.parallel.wait4jobs <- function(config,joblist) {
   res <- config$wait4jobsFun(config,joblist)
   return(res)
}

# dba.Rlsf.init <- function(config){
#    if (length(find.package(package="DiffBindCRI",quiet=TRUE))>0) {
#       config <- dba.CRI.Rlsf.init(config)    
#    } else {
#       warning('Rlsf interface not supported in this version')
#    }
#    
#    return(config)
# }
# 
# dba.lsfR.init <- function(config){
#    if (length(find.package(package="DiffBindCRI",quiet=TRUE))>0) {
#       config <- dba.CRI.lsfR.init(config)    
#    } else {
#       warning('lsfR interface not supported in this version')
#    }
#    
#    return(config)
# }

################# multicore INTERFACE #################

### INITIALIZE ###

dba.multicore.init <- function(config) {
   
   noparallel <- FALSE
   if (requireNamespace("parallel",quietly=TRUE)) {
      if(!exists("mcparallel")) {
         noparallel <- TRUE
      }     
      if(!exists("mclapply")) {
         noparallel <- TRUE
      } 
   } else {
      noparallel <- TRUE
   }
   if(noparallel){
      warning("Parallel execution unavailable: executing serially.",call.=FALSE)
      config$RunParallel <- FALSE
      config$parallelPackage <- 0
      return(config)
   }
   
   config$multicoreInit <- TRUE    
   
   config$initFun      <- dba.multicore.init
   config$paramFun     <- dba.multicore.params
   config$addjobFun    <- dba.multicore.addjob
   config$lapplyFun    <- dba.multicore.lapply
   config$wait4jobsFun <- dba.multicore.wait4jobs
   
   if(is.null(config$cores)) {
      config$cores <- dba.multicore.setCores()
   }
   
   return(config)
}

### CONFIG ###
dba.multicore.params <- function(config,funlist) {
   return(NULL)
}

### PARALLEL LAPPLY ###
dba.multicore.lapply <- function(config,params,arglist,fn,...){
   savecores <- options("cores")$cores
   savemccores <- options("mc.cores")$mc.cores
   options(cores=config$cores)
   options(mc.cores=config$cores)
   res <- mclapply(arglist,fn,...,mc.preschedule=TRUE,mc.allow.recursive=TRUE)
   options(cores=savecores)
   options(mc.cores=savemccores)
   return(res)
}

### ADD JOB ###
dba.multicore.addjob <- function(config,params,fn,...) {
   job <- parallel::mcparallel(fn(...))
   return(job)
}

### WAIT FOR JOBS TO COMPLETE AND GATHER RESULTS ###
dba.multicore.wait4jobs <- function(config,joblist) {
   res <- parallel::mccollect(joblist)
   return(res)
}

### set cores if none specified ###
dba.multicore.setCores <- function(config=NULL) {
  if(!is.null(config$cores)) {
    return(config$cores)
  }
  
  if(!is.null(options("mc.cores")$mc.cores)) {
    return(options("mc.cores")$mc.cores)
  }
  
  if(!is.null(options("cores")$cores)) {
    return(options("cores")$cores)
  }
  
  return(parallel::detectCores(logical=FALSE))
  
}

################# BiocParallel INTERFACE #################

### INITIALIZE ###

dba.biocparallel.init <- function(config) {
   
   noparallel <- FALSE
   if (!requireNamespace("BiocParallel",quietly=TRUE)) {
      noparallel <- TRUE
   }
   if(noparallel){
      warning("Parallel execution unavailable: executing serially.",call.=FALSE)
      config$RunParallel <- FALSE
      config$parallelPackage <- 0
      return(config)
   }
   
   config$biocparallelInit <- TRUE    
   
   config$initFun      <- dba.biocparallel.init
   config$paramFun     <- dba.biocparallel.params
   config$addjobFun    <- dba.biocparallel.addjob
   config$lapplyFun    <- dba.biocparallel.lapply
   config$wait4jobsFun <- dba.biocparallel.wait4jobs
   
   return(config)
}

### CONFIG ###
dba.biocparallel.params <- function(config,funlist) {
   return(NULL)
}

### PARALLEL LAPPLY ###
dba.biocparallel.lapply <- function(config,params,arglist,fn,...){
   if(!is.null(config$bpparam)) {
      res <- bplapply(arglist,fn,...,BPPARAM=config$bpparam)        
   } else {
      res <- bplapply(arglist,fn,...)        
   }
   return(res)
}

### ADD JOB ###
dba.biocparallel.addjob <- function(config,params,fn,...) {
   stop('addjob unimplemented when using BiocParallel.',call.=FALSE)
}

### WAIT FOR JOBS TO COMPLETE AND GATHER RESULTS ###
dba.biocparallel.wait4jobs <- function(config,joblist) {
   stop('wait4jobs unimplemented when using BiocParallel.',call.=FALSE)
}

#####################################
## pv_counts.R -- count-dependant  ##
## 20 October 2009                 ##
## 3 February 2011 -- packaged     ##
## Rory Stark                      ##
## Cancer Research UK              ##
#####################################
PV_DEBUG <- FALSE


## pv.counts -- add peaksets with scores based on read counts
PV_RES_RPKM             <- 1
PV_RES_RPKM_FOLD        <- 2
PV_RES_READS            <- 3
PV_RES_READS_FOLD       <- 4
PV_RES_READS_MINUS      <- 5
PV_RES_RPKM_MINUS       <- 20
PV_SCORE_RPKM           <- PV_RES_RPKM
PV_SCORE_RPKM_FOLD      <- PV_RES_RPKM_FOLD
PV_SCORE_RPKM_MINUS     <- PV_RES_RPKM_MINUS
PV_SCORE_READS          <- PV_RES_READS
PV_SCORE_READS_FOLD     <- PV_RES_READS_FOLD
PV_SCORE_READS_MINUS    <- PV_RES_READS_MINUS
PV_SCORE_CONTROL_READS  <- 18
PV_SCORE_TMM_MINUS_FULL       <- 6
PV_SCORE_TMM_MINUS_EFFECTIVE  <- 7
PV_SCORE_TMM_READS_FULL       <- 8
PV_SCORE_TMM_READS_EFFECTIVE  <- 9
PV_SCORE_TMM_MINUS_FULL_CPM       <- 10
PV_SCORE_TMM_MINUS_EFFECTIVE_CPM  <- 11
PV_SCORE_TMM_READS_FULL_CPM       <- 12
PV_SCORE_TMM_READS_EFFECTIVE_CPM  <- 13
PV_SCORE_READS_FULL               <- 14
PV_SCORE_READS_EFFECTIVE          <- 15
PV_SCORE_READS_MINUS_FULL         <- 16
PV_SCORE_READS_MINUS_EFFECTIVE    <- 17
PV_SCORE_SUMMIT                   <- 101
PV_SCORE_SUMMIT_ADJ               <- 102
PV_SCORE_SUMMIT_POS               <- 103
PV_SCORE_NORMALIZED               <- 104

PV_READS_DEFAULT   <- 0
PV_READS_BAM       <- 3
PV_READS_BED       <- 1

PV_DEFAULT_FILTER <- 1

pv.counts <- function(pv,peaks,minOverlap=2,defaultScore=PV_SCORE_NORMALIZED,
                      bLog=TRUE,insertLength=0,
                      bOnlyCounts=TRUE,bCalledMasks=TRUE,
                      minMaxval= PV_DEFAULT_FILTER,filterFun=max,
                      bParallel=FALSE,bUseLast=FALSE,bWithoutDupes=FALSE, 
                      bScaleControl=FALSE, bSignal2Noise=TRUE,
                      bLowMem=FALSE, readFormat=PV_READS_DEFAULT, 
                      summits, minMappingQuality=0,
                      maxGap=-1, bRecentered=FALSE, minCount=0,
                      bSubControl=FALSE) {
  
  pv <- pv.check(pv)
  
  if(sum(is.na(pv$class[PV_BAMREADS,]))) {
    stop("Can't count: some peaksets are not associated with a .bam file.",call.=FALSE)
  }
  
  pv$class[PV_BAMCONTROL,pv$class[PV_BAMCONTROL,]==""]=NA
  
  if(minOverlap >0 && minOverlap <1) {
    minOverlap <- ceiling(length(pv$peaks) * minOverlap)	
  }
  
  bRecenter <- FALSE
  saveLowMem <- bLowMem
  if(is.logical(summits) && summits==FALSE) {
    summits <- -1
  } 
  if(summits != -1) {
    if(bLowMem==TRUE) {
      bLowMem <- bRecentered
      if(bRecentered == TRUE) {
        #message("Summit info will be lost when using summarizeOverlaps.")
        summits <- -1
      } else {
        message("Computing summits...")
      }
    }
    if(is.logical(summits) && summits==TRUE) {
      summits=0
    }
    if (summits>0) {
      bRecenter=TRUE
    } 
  }
  
  bed <- NULL
  called <- NULL
  if(!missing(peaks)) { # peaks provided
    if(is.vector(peaks)) {
      if(is.character(peaks)){ # peaks in file
        tmp <- pv.peakset(NULL,peaks)
        pv$chrmap <- tmp$chrmap
        peaks <- tmp$peaks[[1]]
        if(is.character(peaks[1,1])){
          peaks[,1] <- factor(peaks[,1],pv$chrmap)
        }
      } else { # peaks based on mask
        saveCorPlot <- pv$config$bCorPlot
        pv$config$bCorPlot <- FALSE
        tmp <- dba(pv,mask=peaks,minOverlap=minOverlap)
        pv$config$bCorPlot <- saveCorPlot 
        pv$chrmap <- tmp$chrmap
        bed <- tmp$binding[,1:3]
        if(!is.null(tmp$allcalled)) {
          tmp$called <- tmp$allcalled
        }
        called <- tmp$called[pv.overlaps(tmp,minOverlap),]
      }
    } else { # peaks provided
      pv$chrmap <- unique(as.character(peaks[,1]))
      rownames(peaks) <- 1:nrow(peaks)
      if(is.character(peaks[1,1])){
        peaks[,1] <- factor(peaks[,1],pv$chrmap)
      }
      if(!is.null(pv$called)) {
        if(nrow(peaks) == do.nrow(pv$called)) {
          called <- pv$called
        } else {
          pv$allcalled <- pv$called <- called <- NULL
        }
      }
      peaks <- pv.peaksort(peaks)
    }
    if(is.null(bed)) {
      colnames(peaks)[1:3] <- c("CHR","START","END")
      bed <- mergePeaks(peaks[,1:3],maxGap)
    }
  } else { # no peaks provided, derive consensus
    overlaps <- pv.overlaps(pv,minOverlap)
    if(minOverlap == pv$minOverlap) {
      bed <- pv$binding[,1:3]
    } else {
      bed <- pv$merged[overlaps,]
    }
    if(!is.null(pv$allcalled)) {
      pv$called <- pv$allcalled[overlaps,]
    } else {
      called <- pv$called[overlaps,]
    }
  }
  
  bed <- pv.check1(bed)
  called <- pv.check1(called)
  
  if(nrow(bed)==0) {
    stop("Zero peaks to count!",call.=FALSE)
  }
  
  bed <- as.data.frame(pv.peaksort(bed,pv$chrmap))
  bed[,1] <- pv$chrmap[bed[,1]]
  
  numChips <- ncol(pv$class)
  chips  <- unique(pv$class[PV_BAMREADS,])
  chips  <- unique(chips[!is.na(chips)])
  inputs <- pv$class[PV_BAMCONTROL,]
  inputs <- unique(inputs[!is.na(inputs)])
  todo   <- unique(c(chips,inputs))
  
  if(!pv.checkExists(todo)) {
    stop('Some read files could not be accessed. See warnings for details.',
         call.=FALSE)
  }
  
  if(length(insertLength)==1) {
    insertLength <- rep(insertLength,length(todo))
  }
  if(length(insertLength)<length(todo)) {
    warning('Fewer fragment sizes than libraries -- using mean fragment size for missing values',
            call.=FALSE)
    insertLength <- c(insertLength,rep(mean(insertLength),length(todo)-length(insertLength)))
  }
  if(length(insertLength)>length(todo)) {
    warning('More fragment sizes than libraries',call.=FALSE)
  }
  
  todorecs <- NULL
  for(i in 1:length(todo)) {
    newrec =NULL
    newrec$bamfile <- todo[i]
    newrec$insert <- insertLength[1]
    todorecs <- pv.listadd(todorecs,newrec)
  }
  
  yieldSize <- 5000000
  mode      <- "IntersectionNotEmpty"
  singleEnd <- NULL
  interfeature <- TRUE
  
  scanbamparam <- NULL
  addfuns <- NULL
  if(bLowMem){
    
    requireNamespace("Rsamtools",quietly=TRUE)
    
    addfuns <- c("BamFileList","summarizeOverlaps","ScanBamParam","scanBamFlag","countBam","SummarizedExperiment")   
    if (insertLength[1] !=0) {
      #warning("fragmentSize ignored when bUseSummarizeOverlaps is TRUE in dba.count",call.=FALSE)
    }
    bAllBam <- TRUE
    # for(st in todo) {
    #   if(substr(st,nchar(st)-3,nchar(st)) != ".bam")	{
    #     bAllBam <- FALSE
    #     warning(st,": not a .bam",call.=FALSE)	
    #   } else if(file.access(paste(st,".bai",sep=""))==-1) {
    #     bAllBam <- FALSE
    #     warning(st,": no associated .bam.bai index",call.=FALSE)	
    #   }
    # }
    # if(!bAllBam) {
    #   stop('All files must be BAM (.bam) with associated .bam.bai index when UseSummarizeOverlaps is TRUE in dba.count',call.=FALSE)	
    # }
    if(!is.null(pv$config$yieldSize)) {
      yieldSize <- pv$config$yieldSize	
    }
    if(!is.null(pv$config$intersectMode)) {
      mode <- pv$config$intersectMode	
    }
    
    if(!is.null(pv$config$inter.feature)) {
      interfeature <- pv$config$inter.feature	
    } 
    
    if(is.null(pv$config$singleEnd)) {
      # bfile <- pv.BamFile(todo[1], bIndex=TRUE)
      # pv$config$singleEnd	<- !suppressMessages(
      #   Rsamtools::testPairedEndBam(bfile))
    } else {
      singleEnd <-  pv$config$singleEnd
    }
    if(!is.null(singleEnd)) {
      if(singleEnd) {
        message("Reads will be counted as Single-end.")
      } else {
        message("Reads will be counted as Paired-end.")        
      }
    }
    
    if(!is.null(pv$config$fragments)) {
      fragments <- pv$config$fragments   
    } else fragments <- FALSE
    
    scanbamparam <- pv$config$scanbamparam 	
  }
  
  if(!bUseLast) {
    pv <- dba.parallel(pv)
    if((pv$config$parallelPackage>0) && bParallel) {   	     
      params  <- dba.parallel.params(pv$config,c("pv.do_getCounts","pv.getCounts",
                                                 "pv.bamReads","pv.BAMstats",
                                                 "fdebug",addfuns))            
      results <- dba.parallel.lapply(pv$config,params,todorecs,
                                     pv.do_getCounts,bed,bWithoutDupes=bWithoutDupes,
                                     bLowMem,yieldSize,mode,singleEnd,
                                     scanbamparam,readFormat,
                                     summits,fragments,minMappingQuality,minCount,
                                     interfeature)
    } else {
      results <- NULL
      for(job in todorecs) {
        message('Sample: ',job,' ')
        results <- pv.listadd(results,pv.do_getCounts(job,bed,bWithoutDupes=bWithoutDupes,
                                                      bLowMem,yieldSize,mode,singleEnd,
                                                      scanbamparam,readFormat,
                                                      summits,fragments,
                                                      minMappingQuality,minCount,
                                                      interfeature))
      }	
    }
    if(PV_DEBUG){
      #save(results,file='dba_last_result.RData')
    }
  } else {
    if(PV_DEBUG) {
      load('dba_last_result.RData')
    } else {
      warning("Can't load last result: debug off")
    }
  }
  
  pv.gc()
  
  #  if(minMaxval>0) {
  redoScore <- defaultScore
  if(bSubControl) {
    defaultScore <- PV_SCORE_RPKM_MINUS
  } else {
    defaultScore <- PV_SCORE_RPKM
  }
  #  } else redoScore <- 0
  if(defaultScore == redoScore) redoScore <- 0
  
  errors <- vapply(results,function(x) 
    if(is.list(x)) return(FALSE) else return(TRUE), TRUE)
  
  if(sum(errors)) {
    errors <- which(errors)
    for(err in errors) {
      if(is(results[[err]],"try-error")) {
        warning(strsplit(results[[err]][1],'\n')[[1]][2],call.=FALSE)   
      } else {
        warning(results[[err]],call.=FALSE)
      }
    }
    stop("Error processing one or more read files. Check warnings().",call.=FALSE)
  }
  
  allchips <- unique(pv$class[c(PV_BAMREADS,PV_BAMCONTROL),])
  numAdded <- 0
  mergedsamps <- NULL
  for(chipnum in 1:numChips) {
    if (pv.nodup(pv,chipnum)) {
      jnum <- which(todo %in% pv$class[PV_BAMREADS,chipnum])
      cond <- results[[jnum]]
      if(length(cond$counts)==0){
        warning('ERROR IN PROCESSING ',todo[jnum],call.=FALSE)
      }
      if(length(cond$libsize)==0){
        warning('ERROR IN PROCESSING ',todo[jnum],call.=FALSE)
      }         
      if(!is.na(pv$class[PV_BAMCONTROL,chipnum])) {
        cnum <- which(todo %in% pv$class[PV_BAMCONTROL,chipnum])
        cont <- results[[cnum]]
        if(length(cont$counts)==0){
          warning('ERROR IN PROCESSING ',todo[cnum],call.=FALSE)
        }
        if(bScaleControl==TRUE) {
          if(cond$libsize>0) {
            scale <- cond$libsize / cont$libsize
            if(scale > 1) scale <- 1
            if(scale != 0) {
              cont$counts <- ceiling(cont$counts * scale)
            }	
          }   	        
        }
      } else {
        cont <- NULL
        cont$counts <- rep(minCount,length(cond$counts))	
        cont$rpkm   <- rep(minCount,length(cond$rpkm))   
      }
      
      cond$counts[cond$counts<minCount] <- minCount
      rpkm_fold   <- cond$rpkm   / cont$rpkm
      reads_fold  <- cond$counts / cont$counts
      rpkm_minus  <- cond$rpkm   - cont$rpkm
      rpkm_minus[rpkm_minus<minCount] <- minCount
      reads_minus <- cond$counts - cont$counts
      reads_minus[reads_minus<minCount] <- minCount
      
      if(bLog) {
        rpkm_fold  <- log2(rpkm_fold)
        reads_fold <- log2(reads_fold)
      }
      if(defaultScore == PV_RES_RPKM) {
        scores <- cond$rpkm
      } else if (defaultScore == PV_RES_RPKM_FOLD) {
        scores <- rpkm_fold
      } else if (defaultScore == PV_RES_RPKM_MINUS) {
        scores <- rpkm_minus
      } else if (defaultScore == PV_RES_READS) {
        scores <- cond$counts    
      } else if (defaultScore == PV_RES_READS_FOLD) {
        scores <- reads_fold
      } else if (defaultScore == PV_RES_READS_MINUS) {
        scores <- reads_minus
      }
      
      if (summits != -1) {
        res <- cbind(bed,scores,cond$rpkm,cond$counts,cont$rpkm,cont$counts,cond$summits,cond$heights)
        colnames(res) <- c("Chr","Start","End","Score","RPKM","Reads","cRPKM","cReads","Summits","Heights")
      } else {
        res <- cbind(bed,scores,cond$rpkm,cond$counts,cont$rpkm,cont$counts)
        colnames(res) <- c("Chr","Start","End","Score","RPKM","Reads","cRPKM","cReads")
      }
      pv <- pv.peakset(pv,
                       peaks       = res,
                       sampID      = pv$class[PV_ID,chipnum],
                       tissue      = pv$class[PV_TISSUE,chipnum],
                       factor      = pv$class[PV_FACTOR,chipnum],
                       condition   = pv$class[PV_CONDITION,chipnum],
                       treatment   = pv$class[PV_TREATMENT,chipnum],
                       consensus   = TRUE,
                       peak.caller = 'counts',
                       control     = pv$class[PV_CONTROL,chipnum],
                       reads       = cond$libsize, #pv$class[PV_READS,chipnum],
                       replicate   = pv$class[PV_REPLICATE,chipnum],
                       readBam     = pv$class[PV_BAMREADS,chipnum],
                       controlBam  = pv$class[PV_BAMCONTROL,chipnum],
                       spikein     = pv$class[PV_SPIKEIN,chipnum],
                       scoreCol    = 0,
                       bRemoveM = FALSE, bRemoveRandom=FALSE,bMakeMasks=FALSE)
      numAdded <- numAdded + 1
    } else {
      mergedsamps <- c(mergedsamps,chipnum)
    }               
  }
  
  pv.gc()
  
  if(redoScore > 0) {
    pv$score <- redoScore
  } else {
    pv$score <- defaultScore
  }
  
  pv$maxFilter <- minMaxval
  pv$filterFun <- filterFun
  pv$bSubControl <- bSubControl
  
  if(bOnlyCounts) {
    
    if(!is.null(mergedsamps)) {
      warning("Samples have been merged or lost during counting. ",
              "Check for duplicate bam files.",
              call.=FALSE)
      pv$called <- pv$called[,-mergedsamps]
      pv$class  <- pv$class[,-mergedsamps]
      if(!is.null(pv$called)) {
        pv$allcalled <- pv$allcalled[,-mergedsamps]
      }
      pv$peaks <- pv$peaks[-mergedsamps]
      pv$binding < pv$binding[,-(mergedsamps+3)]
    }
    
    numpeaks <- length(pv$peaks)
    
    if(bRecenter) {
      if(is.null(called)) {
        called <- pv$called
      }
      res <- pv.Recenter(pv,summits,(numpeaks-numAdded+1):numpeaks,called)
      if(redoScore>0) {
        defaultScore <- redoScore
        redoScore <- 0
      }
      res <- pv.counts(res,peaks=res$merged,defaultScore=defaultScore,
                       bLog=bLog,insertLength=insertLength,
                       bOnlyCounts=TRUE,bCalledMasks=TRUE,minMaxval=minMaxval,
                       filterFun=filterFun,
                       bParallel=bParallel,bWithoutDupes=bWithoutDupes,
                       bScaleControl=bScaleControl,
                       bSignal2Noise=bSignal2Noise,bLowMem=saveLowMem,
                       readFormat=readFormat,summits=0,
                       bRecentered=TRUE,minMappingQuality=minMappingQuality,
                       bSubControl=bSubControl,
                       maxGap=maxGap)
      pv.gc()
      return(res)
    } else {
      # if(!is.null(pv$allcalled)) {
      #   savecalled <- pv$allcalled
      # } else {
      #   savecalled <- pv$called
      # }
      savecalled <- pv$called
      if(!is.null(savecalled)) {
        if(ncol(savecalled) == numAdded) {
          pv$called <- pv$allcalled <- NULL
        }
      }
      res <- pv.vectors(pv,(numpeaks-numAdded+1):numpeaks,minOverlap=1,bAllSame=TRUE)
      if(is.null(res$called)) {
        if(!is.null(savecalled)) {
          if(nrow(savecalled)==nrow(res$peaks[[length(res$peaks)]])) {
            res$called <- savecalled
          } 
        } else if(!is.null(called)) {
          if (nrow(called) == nrow(res$peaks[[length(res$peaks)]])) {
            res$called <- called
          }
        }
      }
      if(bRecentered) {
        if(!is.null(res$called)) {
          if(nrow(res$called) == nrow(res$peaks[[length(res$peaks)]])) {
            called <- res$called
          } else {
            called <- pv$called
          }
        } 
      }
    }   
    if(!missing(minMaxval)) {
      data <- pv.check1(res$binding[,4:ncol(res$binding)])
      maxs <- apply(data,1,filterFun)
      tokeep <- maxs >= minMaxval
      if(sum(tokeep) < length(tokeep)) {
        if(sum(tokeep) > 1) {
          res$binding <- pv.check1(res$binding[tokeep,])
          rownames(res$binding) <- 1:sum(tokeep)
          for(i in 1:length(res$peaks)) {
            res$peaks[[i]] <- res$peaks[[i]][tokeep,]
            rownames(res$peaks[[i]]) <- 1:sum(tokeep)
          } 
          if(!is.null(res$called)) {
            res$called <- res$called[tokeep,]
          }
          res <- pv.vectors(res,minOverlap=1,bAllSame=pv.allSame(res))
        } else {
          stop('No sites have activity greater than filter value.',call.=FALSE)
        }
      }
    } else {
      minMaxval <- PV_DEFAULT_FILTER
    }
    if(redoScore > 0) {
      res <- pv.setScore(res,redoScore,minMaxval=minMaxval,filterFun=filterFun,
                         bSignal2Noise=bSignal2Noise)
    }
    if(is.null(res$called)) {
      res$called <- called
    }
  } else {
    if(redoScore > 0) {
      res <- pv.setScore(res,redoScore,minMaxval=minMaxval,filterFun=filterFun,
                         bSignal2Noise=bSignal2Noise)	
    } 
    res <- pv.vectors(pv,bAllSame=pv.allSame(pv))   
  }
  
  if(bSignal2Noise) {
    res$SN <- pv.Signal2Noise(res)
  }
  
  res$minCount <- minCount
  ## Preserve the control-subtraction setting on the reconstructed object.
  ## pv.vectors() rebuilds 'res' from 'pv' and does not carry $bSubControl,
  ## so it must be re-stamped here (matching res$minCount above); otherwise
  ## downstream pv.normalize() falls back to is.null(pv$greylist) and can
  ## silently override the user's bSubControl choice from dba.count().
  res$bSubControl <- bSubControl

  pv.gc()
  return(res)
}

pv.nodup <- function(pv,chipnum) {
  
  
  if(is.null(pv$class[PV_BAMREADS,chipnum])){
    return(FALSE)
  }
  
  if(is.na(pv$class[PV_BAMREADS,chipnum])){
    return(FALSE)
  }   
  
  if(chipnum == 1) {
    return(TRUE)
  }
  
  chips <- pv$class[PV_BAMREADS,1:(chipnum-1)] == pv$class[PV_BAMREADS,chipnum]
  conts <- pv$class[PV_BAMCONTROL,1:(chipnum-1)] == pv$class[PV_BAMCONTROL,chipnum]
  
  conts[is.na(conts)] <- TRUE
  
  if(sum(chips&conts)>0) {
    return(FALSE)
  } else {
    return(TRUE)
  }
  
}

pv.checkExists <- function(filelist){
  res <- file.access(filelist,mode=4)
  for(i in 1:length(filelist)) {
    if(res[i]==-1) {
      warning(filelist[i]," not accessible",call.=FALSE)	
    }	
  }
  return(sum(res)==0)
}

pv.do_getCounts <- function(countrec,intervals,bWithoutDupes=FALSE,
                            bLowMem=FALSE,yieldSize,mode,singleEnd,scanbamparam,
                            fileType=0,summits,fragments,minMappingQuality=0,
                            minCount=0, interfeature=TRUE) {
  
  res <- pv.getCounts(bamfile=countrec$bamfile,intervals=intervals,insertLength=countrec$insert,
                      bWithoutDupes=bWithoutDupes,
                      bLowMem=bLowMem,yieldSize=yieldSize,mode=mode,singleEnd=singleEnd,
                      scanbamparam=scanbamparam,
                      fileType=fileType,summits=summits,fragments=fragments,
                      minMappingQuality=minMappingQuality,minCount=minCount,
                      interfeature=interfeature)
  pv.gc()
  return(res)
  
}
pv.getCounts <- function(bamfile,intervals,insertLength=0,bWithoutDupes=FALSE,
                         bLowMem=FALSE,yieldSize,mode,singleEnd,scanbamparam,
                         fileType=0,summits=-1,fragments,minMappingQuality=0,
                         minCount=0, interfeature=TRUE) {
  
  bufferSize <- 1e6
  fdebug(sprintf('pv.getCounts: ENTER %s',bamfile))
  
  if(bLowMem) {
    if(minMappingQuality>0) {
      #warning('minMappingQuality ignored for summarizeOverlaps, set in ScanBamParam.',call.=FALSE)
    }
    
    if(is.null(singleEnd)) {
      bfile <- pv.BamFile(bamfile, bIndex=TRUE)
      singleEnd	<- !suppressMessages(Rsamtools::testPairedEndBam(bfile))
    }
    
    if(!is.null(singleEnd)) {
      if(singleEnd) {
        message("Reads will be counted as Single-end.")
      } else {
        message("Reads will be counted as Paired-end.")        
      }
    } else {
      message("End not detected.")
    }
    
    res <- pv.getCountsLowMem(bamfile,intervals,bWithoutDupes,mode,yieldSize,
                              singleEnd,fragments,
                              scanbamparam,minCount=minCount,minQC=minMappingQuality,
                              interfeature=interfeature)
    return(res)
  }
  
  fdebug("Starting croi_count_reads...")
  result <- cpp_count_reads(bamfile,insertLength,fileType,bufferSize,
                            intervals,bWithoutDupes,summits,minMappingQuality,
                            minVal=minCount)
  fdebug("Done croi_count_reads...")
  fdebug(sprintf("Counted %d reads...",result$libsize))
  return(result)
}

pv.filterRate <- function(pv,vFilter,filterFun=max) {
  if(!is.numeric(vFilter)) {
    stop('Filter value must be a numeric vector to retrieve filter rate',call.=FALSE)	
  }
  maxs <- apply(pv$binding[,4:ncol(pv$binding)],1,filterFun)
  res <- NULL
  for(filter in vFilter) {
    tokeep <- maxs >= filter
    res <- c(res,sum(tokeep))	
  }
  return(res)
}

pv.getCountsLowMem <- function(bamfile,intervals,bWithoutDups=FALSE,
                               mode="IntersectionNotEmpty",yieldSize=5000000,
                               singleEnd=TRUE,fragments=FALSE,params=NULL,
                               minCount=0, minQC=0, interfeature=TRUE) {
  
  intervals <- pv.peaks2DataType(intervals,DBA_DATA_GRANGES)
  
  bf  <- pv.BamFile(bamfile)
  bfl <- Rsamtools::BamFileList(bf,yieldSize=yieldSize)
  
  if(is.null(params)) {
    if(bWithoutDups==FALSE) {
      Dups <- NA
    } else {
      Dups <- FALSE   
    }
    params  <- 
      Rsamtools::ScanBamParam(flag=Rsamtools::scanBamFlag(isDuplicate=Dups),
                              mapqFilter=minQC)
  }
  
  counts  <- assay(
    GenomicAlignments::summarizeOverlaps(features=intervals,reads=bfl, 
                                         ignore.strand=TRUE,singleEnd=singleEnd,
                                         mode=mode, inter.feature=interfeature,
                                         fragments=fragments,param=params))
  counts[counts<minCount] <- minCount
  libsize <-
    Rsamtools::countBam(bfl,param=params)$records
  if(singleEnd == FALSE) {
    libsize <- libsize/2
  }
  rpkm    <- (counts/(width(intervals)/1000))/(libsize/1e+06)
  
  return(list(counts=counts,rpkm=rpkm,libsize=libsize))
}

pv.BamFile <- function(bamfile,bIndex=TRUE) {
  bai <- NULL
  trybai <- paste(substr(bamfile, 1,nchar(bamfile)-4),".bai", sep="")
  if(file.access(trybai,mode=4) > -1) {
    bai <- trybai
  } else {
    trybai <- paste(bamfile,".bai",sep="") 
    if(file.access(trybai,mode=4) > -1) {
      bai <- trybai
    } 
  }
  if(is.null(bai)) {
    if(!bIndex) {
      stop(bamfile, " has no associated .bai.", call.=FALSE)
    } else {
      message("Indexing ",bamfile)
      bai <- Rsamtools::indexBam(bamfile)
    }
  }
  bamfileobj <- Rsamtools::BamFile(bamfile, index=bai)
  
  return(bamfileobj)
}

pv.Recenter <- function(pv,summits,peakrange,called=NULL) {
  peaklist <- pv$peaks[peakrange]
  if(is.null(peaklist[[1]]$Summits)) {
    stop('Summits not available; re-run dba.count with summits=TRUE',call.=FALSE)   
  }
  
  if(is.null(pv$config$mergeOverlap)) {
    maxGap <- as.integer(-1)
  } else {
    maxGap <- as.integer(-pv$config$mergeOverlap)
  }
  
  message('Re-centering peaks...')
  
  positions <- sapply(peaklist,function(x)x$Summits)
  heights   <- sapply(peaklist,function(x) pmax.int(1,x$Heights))
  
  if(!is.null(called)) {
    if(ncol(heights) != ncol(called)) {
      warning("Samples have been merged or lost during counting. Check for duplicate bam files.",
              call.=FALSE)
    } else {
      called <- split(called,rep(1:ncol(called),each=nrow(called)))
      heights <- heights * sapply(called,function(x)x)
    }
  }
  
  centers <- sapply(1:nrow(positions),
                    function(x)round(weighted.mean(positions[x,],heights[x,])))
  starts  <- centers-summits
  ends    <- centers+summits
  
  bed <- peaklist[[1]][,1:3]
  bed[,2] <- starts
  bed[,3] <- ends
  
  pv$peaks <- peaklist
  pv$class <- pv$class[,peakrange]
  if(!is.null(called)) {
    peaklist <- lapply(called,function(x)cbind(bed,x))
    res <- pv.merge(bed,peaklist,pv$class,maxgap=maxGap)
    pv$merged <- res$merged[,1:3]
    pv$called <- res$merged[,4:ncol(res$merged)]
    pv$chrmap <- res$chrmap
  } else {
    res <- pv.merge(bed,maxgap=maxGap)
    pv$merged <- res$merged
    pv$chrmap <- res$chrmap
  }
  pv$merged <- data.frame(pv$merged)
  pv$merged[,1] <- pv$chrmap[pv$merged[,1]]
  pv$binding <- pv$merged
  return(pv)
}

makepv <- function(peakset,called) {
  peaklist <- lapply(called,function(x)cbind(peakset,x))
}

pv.controlID <- function(samples,i,class, curnum){
  makeID <- FALSE
  if(is.null(samples$ControlID[i])) {
    makeID <- TRUE
  } else if(is.na(samples$ControlID[i])) {
    makeID <- TRUE
  } else {
    return(as.character(samples$ControlID[i]))
  }
  newid <- NULL
  if(makeID) {
    if(!is.null(samples$bamControl[i])) {
      if(!is.na(samples$bamControl[i])) {
        if(!samples$bamControl[i]=="") {
          if(i==1) {
            newid <- 1
          } else {
            res <- samples$bamReads %in% samples$bamControl[i]
            if(sum(res)) {
              return(samples$sampID[which(res)[1]])
            }
            res <- samples$bamControl[1:(i-1)] %in% samples$bamControl[i]
            if(sum(res)) {
              newid <- class[PV_CONTROL,which(res)[1]]
            } else {
              return(curnum)
            }
          }
        }
      }
    }  
  }
  
  if(!is.null(newid)) {
    res <- newid
  } else {
    res <- ""
  }
  return(res)
}

pv.resetCounts <- function(pv,counts,minCount=0) {
  
  if(!is(counts,"data.frame")) {
    stop("New counts must be passed as a data.frame.",call.=FALSE)
  }
  if(sum(pv$class[PV_CALLER,]=="counts") != ncol(pv$class)) {
    stop("All peaks must have counts to replace.")
  }
  if(do.nrow(pv$binding) != nrow(counts)) {
    stop("All samples must have same number of peaks as binding matrix.",call.=FALSE)
  }
  if(ncol(pv$binding) != ncol(counts)) {
    stop("All samples must have same number of samples as binding matrix.",call.=FALSE)
  }
  if(sum(pv$class[PV_ID,] == colnames(counts[,4:ncol(counts)])) != 
     ncol(pv$class)) {
    stop("All samples must have same IDs, and be in same order, as binding matrix.",call.=FALSE)
  }
  
  for(sample in 4:ncol(counts)) {
    snum <- sample - 3
    pv$peaks[[snum]]$Reads <- sapply(round(counts[,sample]),
                                     function(x){max(minCount,x)})
  }
  if(!is.null(pv$score)) {
    scoreVal <- pv$score
    pv$score <- NULL
    pv <- dba.count(pv,peaks=NULL,score=scoreVal)
  }
  return(pv)
} 

pv.get_reads <- function(pv,peaksets,bSubControl=FALSE,numReads){
  
  if(is.null(bSubControl)) {
    bSubControl <- FALSE
  }
  if(missing(peaksets)) {
    peaksets <- rep(TRUE,length(pv$peaks))
  }
  reads <- NULL
  if(!is.null(pv$peaks_alt)) {
    peaklist <- pv$peaks_alt
  } else {
    peaklist <- pv$peaks
  }
  
  if(is.logical(peaksets)) {
    peaksets <- which(peaksets)
  }
  
  if(!missing(numReads)) {
    numReads <- min(length(peaklist[[1]]$Reads),numReads)
    for(peakset in peaksets) {
      reads <- cbind(reads,as.integer(peaklist[[peakset]]$Reads[1:numReads]))
      if(bSubControl) {
        reads[,ncol(reads)] <- reads[,ncol(reads)] - 
          as.integer(peaklist[[peakset]]$cReads[1:numReads])
      }
    }
  } else {
    for(peakset in peaksets) {
      reads <- cbind(reads,as.integer(peaklist[[peakset]]$Reads))
      if(bSubControl) {
        reads[,ncol(reads)] <- reads[,ncol(reads)] - 
          as.integer(peaklist[[peakset]]$cReads)
      }
    }
  }
  
  if(!is.null(pv$minCount)) {
    reads[reads<pv$minCount] <- pv$minCount
  } else {
    reads[reads<0] <- 0    
  }
  
  rownames(reads) <- 1:nrow(reads)
  
  return(reads)
}

pv.setScore <- function(pv,score,bLog=FALSE,minMaxval=0,rescore=FALSE,
                        filterFun=max,bSignal2Noise=TRUE) {
  
  doscore <- TRUE
  if(rescore == TRUE) {
    if(!is.null(pv$score)) {
      if(pv$score == score) {
        if(!is.null(pv$maxFilter)) {
          if(pv$maxFilter == minMaxval) {
            return(pv)	
          }
        } 
        doscore <- FALSE
      }	
    }
  }
  
  if(!is.null(pv$maxFilter)) {
    if(pv$maxFilter != minMaxval) {
      pv <- pv.doSetScore(pv, DBA_SCORE_RPKM)
      pv <- pv.doFilter(pv, minMaxval, filterFun, bSignal2Noise)	
      doscore <- TRUE
    }	
  }
  
  if(doscore) {
    
    pv <- pv.doSetScore(pv, score, noSub=!rescore)
    
  }
  
  pv$score <- score
  pv$maxFilter <- minMaxval
  pv$filterFun <- filterFun
  # pv$bSubControl <- bSubControl
  
  return(pv)
  
}

pv.doSetScore <- function(pv,score,bLog=FALSE,rescore=TRUE,
                          bSignal2Noise=TRUE, noSub=FALSE) {  
  
  if ((score >= DBA_SCORE_TMM_MINUS_FULL) && (score <= DBA_SCORE_TMM_READS_EFFECTIVE_CPM) ) {
    bCPM=FALSE
    if(score == DBA_SCORE_TMM_MINUS_FULL || score == DBA_SCORE_TMM_MINUS_FULL_CPM) {
      bMinus   <- TRUE
      bFullLib <- TRUE
      if(score == DBA_SCORE_TMM_MINUS_FULL_CPM) {
        bCPM=TRUE
      }
    }
    if(score == DBA_SCORE_TMM_MINUS_EFFECTIVE || score == DBA_SCORE_TMM_MINUS_EFFECTIVE_CPM) {
      bMinus   <- TRUE
      bFullLib <- FALSE
      if(score == DBA_SCORE_TMM_MINUS_EFFECTIVE_CPM) {
        bCPM=TRUE
      }
    }
    if(score == DBA_SCORE_TMM_READS_FULL || score == DBA_SCORE_TMM_READS_FULL_CPM) {
      bMinus   <- FALSE
      bFullLib <- TRUE	
      if(score == DBA_SCORE_TMM_READS_FULL_CPM) {
        bCPM=TRUE
      }
    }
    if(score == DBA_SCORE_TMM_READS_EFFECTIVE || score == DBA_SCORE_TMM_READS_EFFECTIVE_CPM) {
      bMinus   <- FALSE
      bFullLib <- FALSE	
      if(score == DBA_SCORE_TMM_READS_EFFECTIVE_CPM) {
        bCPM=TRUE
      }
    }
    
    pv$binding[,4:ncol(pv$binding)] <- pv.normTMM(pv,bMinus=bMinus,bFullLib=bFullLib,bCPM=bCPM)
    
    for(i in 1:length(pv$peaks)) {
      colnum <- 3+i
      pv$peaks[[i]]$Score <- pv$binding[,colnum]
    }
    
  } else {
    
    if(score %in% c(PV_SCORE_READS_FULL,PV_SCORE_READS_MINUS_FULL, 
                    PV_SCORE_READS_EFFECTIVE, PV_SCORE_READS_MINUS_EFFECTIVE)) {
      
      pv$binding[,4:ncol(pv$binding)] <- pv.normLibsize(pv,score)
      
      for(i in 1:length(pv$peaks)) {
        colnum <- 3+i
        pv$peaks[[i]]$Score <- pv$binding[,colnum]
      }
      
    } else if(score == PV_SCORE_NORMALIZED) {
      
      pv$binding[,4:ncol(pv$binding)] <- 
        pv.countsMA(pv, method=DBA_DESEQ2, contrast=NULL, 
                    bNormalized=TRUE, bCountsOnly=TRUE, filter=0,
                    noSub=noSub)
      
      for(i in 1:length(pv$peaks)) {
        colnum <- 3+i
        pv$peaks[[i]]$Score <- pv$binding[,colnum]
      }
      
    } else {
      
      for(i in 1:length(pv$peaks)) {
        colnum <- 3+i
        if(score == PV_SCORE_RPKM) {
          pv$binding[,colnum] <- pv$peaks[[i]]$RPKM	
        }   		
        if(score == PV_SCORE_RPKM) {
          pv$binding[,colnum] <- pv$peaks[[i]]$RPKM	
        } else if(score == PV_SCORE_RPKM_FOLD) {
          numer <- pv$peaks[[i]]$RPKM
          numer[numer==0] <- 1
          denom <- pv$peaks[[i]]$cRPKM
          denom[denom==0] <- 1
          pv$binding[,colnum] <- numer/denom
          if(bLog) {
            pv$binding[,colnum] <- log2(pv$binding[,colnum])	
          }
        } else if(score == PV_SCORE_RPKM_MINUS) {
          pv$binding[,colnum] <- pv$peaks[[i]]$RPKM-pv$peaks[[i]]$cRPKM	
        } else if(score == PV_SCORE_READS) {
          pv$binding[,colnum] <- pv$peaks[[i]]$Reads	
        }  else if(score == PV_SCORE_CONTROL_READS) {
          pv$binding[,colnum] <- pv$peaks[[i]]$cReads	
        } else if(score == PV_SCORE_READS_FOLD) {
          numer <- pv$peaks[[i]]$Reads
          numer[numer==0] <- 1
          denom <- pv$peaks[[i]]$cReads
          denom[denom==0] <- 1
          pv$binding[,colnum] <- numer/denom
          if(bLog) {
            pv$binding[,colnum] <- log2(pv$binding[,colnum])	
          }
        } else if(score == PV_SCORE_READS_MINUS) {
          pv$binding[,colnum] <- pv$peaks[[i]]$Reads-pv$peaks[[i]]$cReads	
        } else if(score == PV_SCORE_SUMMIT || score == PV_SCORE_SUMMIT_ADJ) {
          if(is.null(pv$peaks[[i]]$Heights)) {
            warning('DBA_SCORE_SUMMIT not available; re-run dba.count with summits=TRUE',
                    call.=FALSE)   
          } else {
            pv$binding[,colnum] <- pv$peaks[[i]]$Heights
            if (score == PV_SCORE_SUMMIT_ADJ) {
              pv$binding[,colnum] <- pv$binding[,colnum] * pv.normFactors(pv)[i]   
            }
          }
        } else if(score == PV_SCORE_SUMMIT_POS) {
          if(is.null(pv$peaks[[i]]$Summits)) {
            warning('DBA_SCORE_SUMMIT_POS not available; re-run dba.count with summits=TRUE',
                    call.=FALSE)   
          } else {
            pv$binding[,colnum] <- pv$peaks[[i]]$Summits
          }
        }
        checkscores <- pv$binding[,colnum]
        if(is.null(pv$minCount)) {
          minRead <- 0
        } else {
          minRead <- pv$minCount
        }
        pv$binding[checkscores<minRead,colnum] <- minRead
        pv$peaks[[i]]$Score <- pv$binding[,colnum]
      }
    }
  }
  pv$score <- score
  
  if(bSignal2Noise) {
    pv$SN <- pv.Signal2Noise(pv)
  }
  
  return(pv)
}

pv.doFilter <- function(pv,minMaxval, filterFun, bSignal2Noise=TRUE) {
  
  if(!missing(minMaxval)) {
    maxs <- apply(pv$binding[,4:ncol(pv$binding)],1,filterFun)
    maxs[is.na(maxs)] <- 0
    tokeep <- maxs>=minMaxval
    if(sum(tokeep)>1 && (sum(tokeep) < length(tokeep)) ) {
      pv$binding <- pv$binding[tokeep,]
      rownames(pv$binding) <- 1:sum(tokeep)
      for(i in 1:length(pv$peaks)) {
        pv$peaks[[i]] <- pv$peaks[[i]][tokeep,]
        rownames(pv$peaks[[i]]) <- 1:sum(tokeep)
      }
      if(!is.null(pv$called)) {
        pv$called <- pv$called[tokeep,]
      }
      pv <- pv.vectors(pv,minOverlap=1,bAllSame=TRUE)
      
      if(!is.null(pv$contrasts)) {
        for(i in 1:length(pv$contrasts)) {
          pv$contrasts[[i]]$edgeR=NULL
          pv$contrasts[[i]]$DESeq=NULL
        }
      }
    } else {
      if(sum(tokeep)<2) {
        stop('No sites have activity greater than filter value',call.=FALSE)
      }
    }
    pv$maxFilter <- minMaxval
  }
  
  if(bSignal2Noise) {
    pv$SN <- pv.Signal2Noise(pv)
  }
  
  return(pv)
}

pv.countsMA <- function(pv, method, contrast, 
                        bNormalized=FALSE, bCountsOnly=FALSE,
                        filter=0, filterFun=max, noSub=FALSE) {
  
  #message("pv.countsMA")
  if(is.null(contrast)) {
    contrast<-NULL
    contrast$group1 <- rep(FALSE,ncol(pv$class))
    contrast$group1[1] <- TRUE
    contrast$group2 <- !contrast$group1
  }
  
  if(bNormalized) {
    
    design <- pv$design
    if(is.null(design)) {
      pv$design <- "~1"
    }
    
    savescore <- pv$score
    pv$score <- DBA_SCORE_READS
    
    nofilter <- FALSE
    if(is.null(filter)) {
      filter <- pv$maxFilter
      nofilter <- TRUE
    }
    
    if(noSub) {
      dosub <- FALSE
    } else {
      dosub <- is.null(pv$greylist)
    }
    
    if(method == DBA_DESEQ2) {
      
      if(is.null(pv$norm$DESeq2)) {
        pv <- dba.normalize(pv, method=DBA_DESEQ2, background=FALSE,
                            bSubControl=dosub)
      }
      
      if(is.null(pv$DESeq2$DEdata)) {
        
        if(nofilter)  {
          filter <- pv$norm$DESeq2$filter.val
          filterFun <- pv$norm$DESeq2$filter.fun
        }
        
        dedata <- pv.DEinitDESeq2(pv,bSubControl=pv$norm$DESeq2$bSubControl,
                                  bFullLibrarySize=pv$norm$DESeq2$lib.sizes,
                                  filter=filter,filterFun=filterFun) 
      } else {
        dedata <- pv$DESeq2$DEdata
      }
      counts <- DESeq2::counts(dedata, normalized = bNormalized)
      
    } else if(method == DBA_EDGER) {
      
      if(is.null(pv$norm$edgeR)) {
        pv <- dba.normalize(pv, method=DBA_EDGER, background=FALSE,
                            bSubControl=dosub)
      }
      
      if(nofilter)  {
        filter <- pv$norm$edgeR$filter.val
        filterFun <- pv$norm$edgeR$filter.fun
      }
      
      if(is.null(pv$edgeR$DEdata)) {
        dedata <- pv.DEinitedgeR(pv,bSubControl=pv$norm$edgeR$bSubControl,
                                 filter=filter, filterFun=filterFun)
      } else {
        dedata <-pv$norm$edgeR 
      }
      counts <- pv.edgeRCounts(pv,method,bNormalized)
    }
    counts <- cbind(counts[,contrast$group1], counts[,contrast$group2])
    pv$design <- design
    pv$score <- savescore
  } else {
    counts <- pv.DEinit(pv,contrast$group1, contrast$group2, bRawCounts=TRUE)
  }
  
  if(bCountsOnly) {
    return(counts)
  }
  
  num1 <- sum(contrast$group1)
  num2 <- sum(contrast$group2)
  samps <- num1 + num2
  
  conc <- log2(apply(counts,1,mean))
  
  if(num1>1) {
    con1 <- log2(apply(counts[,1:num1],1,mean))
  } else {
    con1 <- log2(counts[,1])
  }
  
  if(num2>1) {
    con2 <- log2(apply(counts[,(num1+1):ncol(counts)],1,mean))
  } else {
    con2 <- log2(counts[,num1+1])
  }
  
  con1[con1<0] <- 0
  con2[con2<0] <- 0
  conc[conc<0] <- 0
  
  fold <- con1 - con2
  
  res <- NULL
  res$Conc <- conc
  res$Fold <- con1 - con2
  res$Con1 <- con1
  res$Con2 <- con2
  
  return(res)
}

pv.DBAplotMA <- function(pv,contrast,method='edgeR',bMA=TRUE,bXY=FALSE,th=0.05,
                         bUsePval=FALSE,fold=0,facname="",bNormalized=TRUE,
                         cex=.15,bSignificant=TRUE, bSmooth=TRUE, bFlip=FALSE,
                         highlight=NULL, xrange, yrange, bLoess=TRUE, ...) {
  noreport <- FALSE
  if(missing(contrast)){
    contrast <- 1:length(pv$contrasts)
  } else if(is(contrast,"list")){
    noreport <- TRUE
    group1 <- contrast[[1]]
    name1 <- names(contrast)[1]
    if(!is(group1,"logical")) {
      g1 <- rep(FALSE,length(pv$peaks))
      g1[group1] <- TRUE
      group1 <- g1
    }
    if(length(contrast) == 2) {
      group2 <- contrast[[2]]
      name2 <- names(contrast)[2]
      if(!is(group2,"logical")) {
        g1 <- rep(FALSE,length(pv$peaks))
        g1[group2] <- TRUE
        group2 <- g1
      }
    } else if (length(contrast) == 1) {
      group2 <- !group1
      name2  <- paste("!",name1,sep="")
    } else {
      stop("If contrast is a list, if muct be of length 1 or 2",call.=FALSE)
    }
    contrast <- contrast[1]
  } else if(max(contrast) > length(pv$contrasts)) {
    stop('Specified contrast number is greater than number of contrasts',
         call.=FALSE)
    return(NULL)
  }
  
  
  plotfun <- plot
  if (bSmooth) {
    plotfun <- smoothScatter
  }
  
  numSites <- do.nrow(pv$binding)
  
  for(con in 1:length(contrast)) {
    if(noreport) {
      conrec <- NULL
      conrec$group1 <- group1
      conrec$group2 <- group2
      conrec$name1  <- name1
      conrec$name2  <- name2
    } else {
      conrec <- pv$contrasts[[contrast[con]]]
      name1 <- conrec$name1
      name2 <- conrec$name2
    }
    if(bFlip) {
      name1 <- conrec$name2
      name2 <- conrec$name1   
    }
    for(meth in method) {
      if(noreport) {
        res <- pv.countsMA(pv, meth, conrec, bNormalized)
      } else {
        res <- pv.DBAreport(pv,contrast=contrast[con],method=meth,
                            bUsePval=TRUE,th=100,bNormalized=bNormalized,
                            bFlip=bFlip,precision=0, lfc=fold)
      }
      if(!is.null(res)) {
        if(noreport) {
          bSignificant <- FALSE
          idx <- hilite <- rep(FALSE, length(res$Fold))
        } else {
          if(!is.null(highlight)) {
            hilite <- GRanges(res) %over% GRanges(highlight)
          } else {
            hilite <- rep(FALSE, length(res$Fold))
          }
          if(bUsePval) {
            idx <- res$"p-value" <= th
            #hilite <- hilite & (res$"p-value" <= th)
            tstr <- "p"
          } else {
            idx <- res$FDR <= th
            #hilite <- hilite & (res$FDR <= th)
            tstr <- "FDR"
          }
          idx <- idx & (abs(res$Fold) >= fold)
        }
        if(bMA){
          if(missing(xrange)) {
            xmin  <- floor(min(res$Conc))
            xmax  <- ceiling(max(res$Conc))
          } else {
            if (length(xrange) != 2) {
              stop("xrange must be vector of two numbers",call.=FALSE)
            }
            xmin <- xrange[1]
            xmax <- xrange[2]
          }
          if(missing(yrange)) {
            ymin  <- floor(min(res$Fold))
            ymax  <- ceiling(max(res$Fold))
          } else {
            if (length(yrange) != 2) {
              stop("yrange must be vector of two numbers",call.=FALSE)
            }
            ymin <- yrange[1]
            ymax <- yrange[2]
          }
          
          constr <- pv.getContrastString(conrec, bFlip)
          
          if(is(res,"list")) {
            mainstr <- constr
          } else {
            if(facname=="") {
              mainstr <- sprintf('%s (%s %s < %1.3f)', 
                                 constr,sum(idx),tstr,th) 
            } else {
              mainstr <- sprintf('%s: %s (%s %s < %1.3f)', 
                                 facname, constr,sum(idx),tstr,th)               
            }
          }
          
          if(is.null(conrec$group1)) {
            ylabstr <- sprintf('log Fold Change')
          } else {
            ylabstr <- sprintf('log Fold Change: %s - %s',name1,name2)
          }
          
          if(!is.na(match("main",names(list(...))))){
            mainstr <- NULL
          }
          
          if(bSmooth | !bSignificant) {
            plotfun(res$Conc,res$Fold,pch=20,cex=cex,col=crukBlue,
                    xaxp=c(xmin,xmax,xmax-xmin),xlim=c(xmin,xmax),
                    xlab='log concentration',
                    yaxp=c(ymin,ymax,(ymax-ymin)),ylim=c(ymin,ymax),
                    ylab=ylabstr,main=mainstr,...)              	
          } else {
            plotfun(res$Conc[!idx],res$Fold[!idx],pch=20,cex=cex, col=crukBlue,
                    xaxp=c(xmin,xmax,xmax-xmin),xlim=c(xmin,xmax),
                    xlab='log concentration',
                    yaxp=c(ymin,ymax,(ymax-ymin)),ylim=c(ymin,ymax),
                    ylab=ylabstr, main=mainstr,...)
          }
          if(bSignificant) {
            points(res$Conc[idx],res$Fold[idx],pch=20,cex=cex,col=crukMagenta)
          }
          if(sum(hilite)>0) {
            points(res$Conc[hilite],res$Fold[hilite],pch=20,cex=cex,
                   col="green")
          }
          abline(h=0,col='dodgerblue')
          if(bLoess) {
            lfit <- limma::loessFit(y=res$Fold,x=res$Conc)
            o <- order(res$Conc)
            lines(res$Conc[o],lfit$fitted[o],col="red")
          } 
        }
      }
      if(bXY){
        if(is.null(conrec$group1)) {
          stop('Can not plot XY for complex contrast.',call.=FALSE)
        }
        if(missing(xrange)) {
          if(is(res,"list")) {
            xmin <- floor(min(res$Con1))
            xmax <- ceiling(max(res$Con1))
          } else {
            xmin  <- floor(min(res[,5]))
            xmax  <- ceiling(max(res[,5]))
          }
        } else {
          if (length(xrange) != 2) {
            stop("xrange must be vector of two numbers",call.=FALSE)
          }
          xmin <- xrange[1]
          xmax <- xrange[2]
        }
        if(missing(yrange)) {
          if(is(res,"list")) {
            ymin <- floor(min(res$Con2))
            ymax <- ceiling(max(res$Con2))
          } else {
            ymin  <- floor(min(res[,6]))
            ymax  <- ceiling(max(res[,6]))
          }
        } else {
          if (length(yrange) != 2) {
            stop("yrange must be vector of two numbers",call.=FALSE)
          }
          ymin <- yrange[1]
          ymax <- yrange[2]
        }
        xymin <- min(xmin,ymin)
        xymin <- max(xymin,0)
        xymax <- max(xmax,ymax)
        
        constr <- pv.getContrastString(conrec,bFlip)
        
        if(is(res,"list")) {
          mainstr <- constr
          xvals <- res$Con1
          yvals <- res$Con2
        } else {
          xvals <- res[,5]
          yvals <- res[,6]
          if(facname=="") {
            mainstr <- sprintf('%s (%s %s < %1.3f)', 
                               constr,sum(idx),tstr,th) 
          } else {
            mainstr <- sprintf('%s: %s (%s %s < %1.3f)', 
                               facname, constr,sum(idx),tstr,th)               
          }
        }
        
        plotfun(yvals[!idx], xvals[!idx], pch=20,cex=cex,col=crukBlue,
                xaxp=c(xymin,xymax,xymax-xymin),xlim=c(xymin,xymax),
                xlab=sprintf('log concentration :%s',name2),
                yaxp=c(xymin,xymax,(xymax-xymin)),ylim=c(xymin,xymax),
                ylab=sprintf('log concentration :%s',name1),
                main=mainstr,...)
        if(bSignificant) {
          points(yvals[idx],xvals[idx],pch=20,cex=cex,col=crukMagenta)
        }
        if(sum(hilite)>0) {
          points(res$Conc[hilite],res$Fold[hilite],pch=20,cex=cex,
                 col=crukCyan)
        }
        abline(0,1,col='red')
        
      }
    }
  }      	
}	

Legend <- Fold <- NULL
pv.DBAplotVolcano <- function(pv,contrast,method='edgeR', th=0.05,
                              bUsePval=FALSE,fold=0,facname="",
                              bLabels=FALSE,maxLabels=50,
                              dotSize=1,bSignificant=TRUE, bFlip=FALSE,
                              xrange,yrange, bReturnPlot=FALSE) {
  
  if(missing(contrast)){
    contrast <- 1:length(pv$contrasts)
  } else {
    if(contrast > length(pv$contrasts)) {
      stop('Specified contrast number is greater than number of contrasts',call.=FALSE)
      return(NULL)
    }
  }
  
  for(con in 1:length(contrast)) {
    conrec <- pv$contrasts[[contrast[con]]]
    name1 <- conrec$name1
    name2 <- conrec$name2
    if(bFlip) {
      name1 <- conrec$name2
      name2 <- conrec$name1   
    }
    for(meth in method) {
      res <- pv.DBAreport(pv,contrast=contrast[con],method=meth,bUsePval=TRUE,
                          th=100,bNormalized=TRUE,bFlip=bFlip,precision=0,
                          lfc=fold)
      
      if(!is.null(res)) {
        if(bUsePval) {
          vals <- res$"p-value" 
          idx  <- vals <= th
          tstr <- "p"
          res = mutate(res,
                       Legend=ifelse(res$"p-value"<=th,
                                     sprintf(" p-val<=%1.2f",th),
                                     sprintf(" p-val >%1.2f",th)))
        } else {
          vals <- res$FDR 
          idx  <- vals <= th
          tstr <- "FDR"
          res = mutate(res,
                       Legend=ifelse(res$FDR<th,
                                     sprintf(" FDR<=%1.2f",th),
                                     sprintf(" FDR >%1.2f",th)))
        }
        
        res$Legend[idx & abs(res$Fold) < fold] <- 
          sprintf("abs(Fold)<%1.2f",2^fold)
        idx <- idx & abs(res$Fold) >= fold 
        
        sigSites <- res[idx,]
        if(sum(idx)>0){
          rownames(sigSites) <- 1:sum(idx)
        }
        
        res <- cbind(0,res)
        colnames(res)[1] <- "SiteNum"
        if(sum(idx)>0){
          res[idx,1] <- 1:sum(idx)
          sidx <- sum(idx)
        } else {
          sidx <- 0
        }
        
        constr <- pv.getContrastString(conrec, bFlip)
        plotTitle <- sprintf('%s Contrast: %s  [%s %s<=%1.3f',
                             facname, constr,sidx,tstr,th)
        if(fold>0) {
          plotTitle <- sprintf("%s & abs(Fold)>=%1.2f]",
                               plotTitle, 2^fold)
        } else {
          plotTitle <- sprintf("%s]",plotTitle)
        }
        
        # if(is.null(conrec$name2)) {
        #   xLabel <- "log Fold Change"
        # } else {
        #   xLabel <- sprintf('log Fold Change [log2(%s) - log2(%s)]',name1,name2)
        # }
        xLabel <- "log2 Fold Change"
        
        yLabel <- sprintf("-log10(%s)",tstr)
        
        p <- ggplot(res,aes(Fold,-log10(vals))) +
          geom_point(aes(col=Legend),size=dotSize) +
          scale_color_manual(values=c(crukBlue,crukMagenta,crukGrey)) + 
          labs(title=plotTitle,x=xLabel,y=yLabel)
        
        if(bLabels) {
          maxLabels <- min(sidx,maxLabels)
          if(maxLabels > 0 && sidx > 0) {
            xx <-  which(idx)[1:maxLabels]
            p <- p + geom_text_repel(data=sigSites[1:maxLabels,],
                                     aes(x=Fold, 
                                         y = -log10(vals[xx]),
                                         label=rownames(sigSites)[1:maxLabels]))
          }
        }
        plot(p)
      }
    }
  }
  if(bReturnPlot) {
    return(p)
  } else {
    if(sidx > 0) {
      return(sigSites[,-10])
    } else {
      return(NULL)
    }
  }
}

## pv.plotHeatmap -- draw a heatmap using a subset of binding sites
PV_ONLYA <- 3
PV_ONLYB <- 4
PV_INALL <- 5
PV_COR   <- 6
PV_OLAP  <- 7
PV_TOTAL <- 0
pv.plotHeatmap <-
  function(pv,numSites = 1000,attributes = pv$attributes,mask,sites,contrast,
           overlaps, olmask, olPlot = PV_COR,divVal,RowAttributes,ColAttributes,
           rowSideCols,colSideCols,
           bTop = TRUE,minval,maxval,bReorder = FALSE,
           ColScheme ="Greens",distMeth = "pearson", key.title,
           ...) {
    pv <- pv.check(pv)
    
    if (missing(mask)) {
      mask <- rep(TRUE,ncol(pv$class))
    } else if (is.null(mask)) {
      mask <- rep(TRUE,ncol(pv$class))
    }
    
    ocm <- NULL
    if (!missing(overlaps)) {
      cres  <- overlaps
      if (!missing(olmask)) {
        cres <- cres[olmask,]
      }
      if (is.null(nrow(cres))) {
        cres <- matrix(cres,1,length(cres))
      }
      #cres <- pv.overlapToLabels(pv,cres,attributes)
      if (missing(divVal)) {
        ocm <- pv.occ2matrix(cres,olPlot)
      } else {
        ocm <- pv.occ2matrix(cres,olPlot,divVal)
      }
      labels <- pv.nums2labels(pv,rownames(ocm),attributes)
      rowlab <- collab <- labels
      rownames(ocm) <- labels
      colnames(ocm) <- labels
      domap <- ocm
      
    } else {
      if (missing(sites)) {
        sites <- 1:do.nrow(pv$binding)
        numSites <- min(length(sites),numSites)
      } else {
        if (sum(sites) <= length(sites)) {
          numSites <- min(sum(sites),numSites)
          sites <- which(sites)
        } else {
          numSites <- length(sites)
        }
      }
      
      if (bTop == TRUE) {
        sites <- sites[1:numSites]
      } else {
        tsites <- length(sites)
        sites <- sites[(tsites - numSites + 1):tsites]
      }
      colnames <- NULL
      for (i in 1:ncol(pv$class)) {
        colnames <-
          c(colnames,pv.namestrings(pv$class[attributes,i])$tstring)
      }
      domap <- matrix(0.1,length(sites),sum(mask))
      for (i in 1:ncol(domap)) {
        domap[,i] <- as.numeric(pv$binding[sites,c(FALSE,FALSE,FALSE,mask)][,i])
      }
      rowlab <- ""
      collab <- colnames[mask]
    }
    
    if (!missing(minval)) {
      domap[domap < minval] <- minval
    }
    if (!missing(maxval)) {
      domap[domap > maxval] <- maxval
    }
    
    if (missing(overlaps)) {
      for (i in 1:ncol(domap)) {
        if (sum(domap[,i] == 0) == nrow(domap)) {
          domap[1,i] <- 0.000001
        }
      }
    }
    
    domap <- domap[rowSums(domap)!=0,]
    
    if (length(ColScheme) == 1) {
      cols <- colorRampPalette(brewer.pal(9,ColScheme))(256)
    } else
      cols <- ColScheme
    
    if (missing(rowSideCols)) {
      rowSideCols <- pv.colsv
    }
    rowatts <- NULL
    rowcols <- 0
    if (missing(RowAttributes)) {
      if (!missing(contrast)) {
        if (sum(pv$contrasts[[contrast]]$group1) ||
            sum(pv$contrasts[[contrast]]$group2)) {
          rowatts <-
            pv.attributematrix(pv,mask,contrast = contrast,PV_GROUP,rowSideCols)
          rowcols <- length(unique(as.vector(rowatts)))
        }
      }
    } else if (!is.null(RowAttributes)) {
      rowatts <-
        pv.attributematrix(
          pv,mask,contrast = contrast,RowAttributes,rowSideCols,bReverse = TRUE
        )
      rowcols <- length(unique(as.vector(rowatts)))
    }
    
    if (missing(colSideCols)) {
      colSideCols <- pv.colsv
    }
    if (missing(ColAttributes)) {
      colatts <-
        pv.attributematrix(pv,mask,contrast = contrast,NULL,colSideCols,bAddGroup =
                             is.null(ocm))
      colcols <- length(unique(as.vector(colatts)))
    } else if (!is.null(ColAttributes)) {
      colatts <-
        pv.attributematrix(pv,mask,contrast = contrast,ColAttributes,colSideCols)
      colcols <- length(unique(as.vector(colatts)))
    } else {
      colatts <- NULL
      colcols <- 0
    }
    
    if (is.null(ocm)) {
      if (!missing(RowAttributes)) {
        warning("Row color bars not permitted for peak score heatmaps.",
                call.=FALSE)
      }
      if(missing(key.title)) {
        key.title <- "Score"
      }
      heatmap.3(
        domap,labCol = collab,col = cols,trace = "none",labRow = rowlab,
        KeyValueName = key.title,
        distfun = function(x) amap::Dist(x,method = distMeth),
        ColSideColors = colatts,NumColSideColors = colcols,
        ...
      )
    } else {
      if(missing(key.title)) {
        key.title <- "Correlation"
      }
      res <-
        heatmap.3(
          domap,labCol = collab,col = cols,trace = "none",labRow = rowlab, 
          KeyValueName = key.title,
          distfun = function(x) amap::Dist(x,method = distMeth),
          symm = TRUE,revC = TRUE,Colv = TRUE,
          RowSideColors = rowatts,ColSideColors = colatts,
          NumRowSideColors = rowcols,NumColSideColors = colcols,
          ...
        )
      if (bReorder) {
        if (length(unique(rownames(ocm))) == nrow(ocm)) {
          ocm <- pv.reorderM(ocm,res$rowDendrogram)
        } else {
          warning("Unable to re-order returned correlation matrix as labels are non-unique",call.=FALSE)
        }
      }
      ocm <- signif(ocm,2) 
      return(ocm)
    }
  }



## pv.plotPCA -- 3D plot of PCA
pv.plotPCA <-
  function(pv,attributes = PV_ID,second,third,fourth,size,mask,
           numSites,sites,cor = FALSE,comps=1:3, b3D = TRUE,vColors,
           label = NULL,bLog = TRUE,labelSize = .8,labelCols = "black",...) {
    
    pv <- pv.check(pv)
    
    if(length(comps)==1) {
      c1 <- comps
      c2 <- comps+1
      c3 <- comps+2
    } else{
      c1 <- comps[1]
      c2 <- comps[2]         
      if(length(comps)==2) {
        c3 <- comps[2]+1
      } else {
        c3 <- comps[3]
      }
    }
    compnums <- c(c1,c2,c3)
    
    class  <- attributes[1]
    if (length(attributes) > 1) {
      second <- attributes[2]
      if (length(attributes) > 2) {
        third <- attributes[3]
      }
      if (length(attributes) > 3) {
        fourth <- attributes[4]
      }
    }
    
    if (missing(sites))
      sites <- NULL
    
    if (missing(numSites)) {
      numSites <- do.nrow(pv$binding)
    }
    
    config <- pv$config
    
    if (!missing(mask) || !missing(numSites)) {
      if (missing(mask)) {
        mask <- rep(TRUE,ncol(pv$class))
      }
      pv <-
        pv.pcmask(pv,numSites,mask,sites,cor = cor,bLog = bLog)
    }
    pv$config <- config
    pc <- pv$pc
    
    if (is.null(pc)) {
      warning("Unable to perform PCA. Make sure there aren't fewer sites than there are samples.",
              call. = FALSE)
      return(NULL)
    }
    
    #if(!is.null(pv$mask)) {
    #   classes <- pv$class[,which(pv$mask)]
    #} else {
    classes <- pv$class[,mask]
    #}
    
    if (max(class) > nrow(classes)) {
      return(FALSE)
    }
    
    vr <- rep(0,length(pc$sdev))
    for (i in 1:length(vr)) {
      vr[i] <- pc$sdev[i] ^ 2
    }
    
    if (b3D) {
      #startComp <- 1
      pvar <- sum(vr[compnums[1:3]]) / sum(vr) * 100
    } else {
      pvar <- sum(vr[compnums[1:2]]) / sum(vr) * 100
    }
    c1p <- vr[c1] / sum(vr) * 100
    c2p <- vr[c2] / sum(vr) * 100
    c3p <- vr[c3] / sum(vr) * 100
    
    if (!missing(second)) {
      if (!missing(third)) {
        if (!missing(fourth)) {
          classvec <-
            sprintf("%s:%s:%s:%s",classes[class,],classes[second,],classes[third,],classes[fourth,])
          thetitle <-
            sprintf(
              "PCA: %s+%s+%s+%s",pv.attname(class,pv),
              pv.attname(second,pv),
              pv.attname(third,pv),
              pv.attname(fourth,pv))
        } else {
          classvec <-
            sprintf("%s:%s:%s",classes[class,],classes[second,],classes[third,])
          thetitle <-
            sprintf(
              "PCA: %s+%s+%s",pv.attname(class,pv),
              pv.attname(second,pv),
              pv.attname(third,pv))
        }
      } else {
        classvec <- sprintf("%s:%s",classes[class,],classes[second,])
        thetitle <- sprintf("PCA: %s+%s",pv.attname(class,pv),
                            pv.attname(second,pv))
      }
    } else {
      classvec <- classes[class,]
      thetitle <- sprintf("PCA: %s",pv.attname(class,pv))
    }
    
    if (!is.null(label)) {
      addlabels <- classes[label,]
    } else
      addlabels <- NULL
    
    numsamps <- ncol(classes)
    if (numsamps <= 10) {
      sval <- 2.25
    } else if (numsamps <= 25) {
      sval <- 1.75
    } else {
      sval <- 1.5
    }
    if (!missing(size)) {
      if (!is.null(size)) {
        sval <- size
      }
    }
    
    if (missing(vColors)) {
      vColors <- pv.colsv
    }
    
    if (b3D) {
      if (requireNamespace("rgl",quietly = TRUE)) {
        rgl::plot3d(
          pc$x[,compnums[c(1,3,2)]],
          col = pv.colorv(classvec,vColors),type = 's',size = sval,
          xlab = sprintf('PC #%d [%2.0f%%]',c1,c1p),
          ylab = sprintf('PC #%d [%2.0f%%]',c3,c3p),
          zlab = sprintf('PC #%d [%2.0f%%]',c2,c2p),
          aspect = c(1,1,1),main = thetitle,...
        )
        uclass <- unique(classvec)
        p <- matrix(vColors[1:length(uclass)],length(uclass),1)
        rownames(p) <- uclass
        colnames(p) <- "Legend"
        for (i in 1:nrow(p)) {
          if (p[i] == crukBlue)
            p[i] <- "crukBlue"
          if (p[i] == crukMagenta)
            p[i] <- "crukMagenta"
          if (p[i] == crukCyan)
            p[i] <- "crukCyan"
        }
        print(p)
      } else {
        warning("Package rgl not installed",call.=FALSE)
        p <-
          pv.doPCAplot(pc,classvec,c1,c2,sval,vColors,thetitle,c1p,c2p,addlabels,...)
      }
    } else {
      if (!missing(size)) {
        #sval <- sval + .5
      }
      p <-
        pv.doPCAplot(
          pc,classvec,c1,c2,sval,vColors,thetitle,c1p,c2p,
          addlabels,labelSize,labelCols,...
        )
    }
    return(p)
  }

pv.doPCAplot <-
  function(pc,classvec,c1,c2,sval,vColors,thetitle,c1p,c2p,
           addlabels = NULL,labelSize = .8,labelCols = "black",...) {
    
    plotData <- as.data.frame(pc$x[,c(c1,c2)])
    colnames(plotData) <- c("PC1","PC2")
    p <- xyplot(
      PC2 ~ PC1,
      #groups=classvec,
      data = plotData,
      pch = 16, cex = sval,aspect = 1,
      col = pv.colorv(classvec,vColors),
      xlab = sprintf('Principal Component #%d [%2.0f%%]',c1,c1p),
      ylab = sprintf('Principal Component #%d [%2.0f%%]',c2,c2p),
      main = thetitle,
      key = list(
        space = "right",
        rect = list(col = unique(pv.colorv(classvec,vColors))[1:length(unique(classvec))]),
        text = list(unique(classvec)),
        rep = FALSE
      ),
      ...
    )
    
    if (!is.null(addlabels)) {
      if (length(labelCols) > 1) {
        newcols <- rep("",length(addlabels))
        colvals <- unique(addlabels)
        for (i in 1:length(colvals)) {
          newcols[addlabels %in% colvals[i]] <- labelCols[i]
        }
        labelCols <- newcols
      }
      p <- update(
        p, panel = function(x, y, ...) {
          lattice::panel.xyplot(x, y, ...);
          lattice::ltext(
            x = x, y = y, labels = as.character(addlabels), pos = 1,
            offset = 1, cex = labelSize,col = labelCols
          )
        }
      )
    }
    print(p)
  }

## pv.plotBoxplot -- Boxplots
pv.plotBoxplot <-
  function(DBA, contrast, method=DBA_DESEQ2, th=0.05, bUsePval=FALSE, bNormalized=TRUE, 
           attribute=DBA_GROUP, mask,
           bAll, bAllIncreased, bAllDecreased, bDB, bDBIncreased, bDBDecreased,
           pvalMethod=wilcox.test,  bReversePos=FALSE, attribOrder, vColors, 
           varwidth=TRUE, notch=TRUE, ...) {
    
    if (missing(bAll) &&
        missing(bAllIncreased) && missing(bAllDecreased)) {
      bMissingAll <- TRUE
    } else
      bMissingAll <- FALSE
    
    if (missing(bDB) &&
        missing(bDBIncreased) && missing(bDBDecreased)) {
      bMissingDB <- TRUE
    } else
      bMissingDB <- FALSE
    
    if (missing(contrast)) {
      if (bMissingAll) {
        bAll          <- TRUE
        bAllIncreased <- FALSE
        bAllDecreased <- FALSE
        bDB           <- FALSE
        bDBIncreased  <- FALSE
        bDBDecreased  <- FALSE
      }
    } else {
      if (bMissingAll && bMissingDB) {
        bAll          <- FALSE
        bAllIncreased <- FALSE
        bAllDecreased <- FALSE
        bDB           <- TRUE
        bDBIncreased  <- FALSE
        bDBDecreased  <- FALSE
      }
    }
    
    if (missing(vColors)) {
      vColors <- pv.colsv
      #vColors <- vColors[2:length(vColors)]
    }
    
    if (attribute == DBA_GROUP &&
        !is.null(DBA$contrasts[[contrast]]$group1)) {
      numPlots <- 2
      cols <- vColors[1:2]
      groups <-
        list(DBA$class[PV_ID,DBA$contrasts[[contrast]]$group1],DBA$class[PV_ID,DBA$contrasts[[contrast]]$group2])
      names <-
        c(DBA$contrasts[[contrast]]$name1,DBA$contrasts[[contrast]]$name2)
      if (!missing(attribOrder)) {
        if (attribOrder[1] == 2 & attribOrder[2] == 1) {
          groups <-
            list(DBA$class[PV_ID,DBA$contrasts[[contrast]]$group2],DBA$class[PV_ID,DBA$contrasts[[contrast]]$group1])
          names <-
            c(DBA$contrasts[[contrast]]$name2,DBA$contrasts[[contrast]]$name1)
        }
      }
      if(bReversePos) {
        groups <- list(groups[[2]],groups[[1]]) 
        names  <- list(names[[2]], names[[1]])
      }
    } else {
      if(attribute == DBA_GROUP) {
        attribute <- pv.attributePCA(DBA)
      }
      if(!is.null(DBA$contrasts[[contrast]]$group1)) {
        samples <-
          which(DBA$contrasts[[contrast]]$group1 |
                  DBA$contrasts[[contrast]]$group2)
      } else {
        if(missing(mask)) {
          samples <- 1:ncol(DBA$class)
        } else {
          samples <- which(mask)
        }
      }
      classes <- DBA$class[, samples]
      names <- unique(classes[attribute,])
      numPlots <- length(names)
      if (!missing(attribOrder)) {
        if (length(attribOrder < numPlots)) {
          neworder <- 1:numPlots
          neworder[1:length(attribOrder)] <- attribOrder
          attribOrder <- neworder
        }
        names  <- names[attribOrder[1:numPlots]]
      }
      cols <- vColors[1:numPlots]
      groups <- NULL
      for (name in names) {
        groups <-
          pv.listadd(groups,classes[PV_ID, classes[attribute,] == name])
      }
    }
    
    subtitle <- FALSE
    
    if (bAll | bAllIncreased | bAllDecreased) {
      report <-
        pv.DBAreport(
          DBA, contrast=contrast, method=method,th=1,
          bNormalized=bNormalized,bCounts = TRUE, precision=0
        )
      if (bReversePos) {
        increase <- report$Fold < 0
      } else {
        increase <- report$Fold > 0
      }
      if (bUsePval) {
        DB <- report$p <= th
      } else {
        DB <- report$FDR <= th
      }
    } else {
      report <- NULL
    }
    
    toplot <- NULL
    vcols  <- NULL
    vnames <- NULL
    
    if (bAll) {
      res       <- lapply(groups,pv.box,report)
      for (i in 1:length(res)) {
        names(res)[i] <- sprintf("%s",names[i])
      }
      toplot   <- c(toplot,res)
      vnames   <- c(vnames,names)
      vcols    <- c(vcols,cols)
    }
    
    if (bAllIncreased) {
      res       <- lapply(groups,pv.box,report[increase,])
      for (i in 1:length(res)) {
        names(res)[i] <- sprintf("%s+",names[i])
      }
      toplot   <- c(toplot,res)
      vnames   <- c(vnames,rep("+",numPlots))
      vcols    <- c(vcols,cols)
      subtitle <- TRUE
    }
    
    if (bAllDecreased) {
      res       <- lapply(groups,pv.box,report[!increase,])
      for (i in 1:length(res)) {
        names(res)[i] <- sprintf("%s-",names[i])
      }
      toplot   <- c(toplot,res)
      vnames   <- c(vnames,rep("-",numPlots))
      vcols    <- c(vcols,cols)
      subtitle <- TRUE
    }
    
    
    if (is.null(report)) {
      report <-
        pv.DBAreport(
          DBA, contrast=contrast, method=method,th=th,bUsePval=bUsePval,
          bNormalized=bNormalized,bCounts=TRUE, precision=0
        )
    } else {
      report <- report[DB,]
    }
    
    if (nrow(report) == 1) {
      stop('Need more than one DB site for boxplot',call.=FALSE)
    }
    
    if(bReversePos) {
      increase <- report$Fold < 0
    } else {
      increase <- report$Fold > 0
    }
    posgroup <- names[[1]]
    neggroup <- names[[2]]
    
    if (bDB) {
      res       <- lapply(groups,pv.box,report)
      for (i in 1:length(res)) {
        names(res)[i] <- sprintf("%s.DB",names[i])
      }
      toplot   <- c(toplot,res)
      vnames   <- c(vnames,names)
      vcols    <- c(vcols,cols)
    }
    
    if (bDBIncreased) {
      res <- lapply(groups,pv.box,report[increase,])
      for (i in 1:length(res)) {
        names(res)[i] <- sprintf("%s.DB+",names[i])
      }
      toplot <- c(toplot,res)
      vnames <- c(vnames,rep("+",numPlots))
      vcols  <- c(vcols,cols)
      subtitle <- TRUE
    }
    
    if (bDBDecreased) {
      res <- lapply(groups,pv.box,report[!increase,])
      for (i in 1:length(res)) {
        names(res)[i] <- sprintf("%s.DB-",names[i])
      }
      toplot <- c(toplot,res)
      vnames <- c(vnames,rep("-",numPlots))
      vcols <- c(vcols,cols)
      subtitle <- TRUE
    }
    
    if (bNormalized == TRUE) {
      ystr <- "log2 normalized reads in binding sites"
    } else {
      ystr <- "log2 reads in binding sites"
    }
    
    if (subtitle == TRUE && !is.null(DBA$contrasts[[contrast]]$group1)) {
      subt <-
        sprintf(
          "+ indicates sites with increased affinity in %s\n- indicates sites with increased affinity in %s",
          posgroup,neggroup
        )
    } else {
      subt <- ""
    }
    
    toplot <- lapply(toplot,pv.infToNA)
    mainstr <- pv.getContrastString(DBA$contrasts[[contrast]])
    boxplot(
      toplot,notch=notch, varwidth=varwidth,
      col=vcols,names=vnames,main=mainstr,
      sub=subt,ylab=ystr
    )
    
    if (!is.null(pvalMethod)) {
      pvals <- matrix(1,length(toplot),length(toplot))
      rownames(pvals) <- names(toplot)
      colnames(pvals) <- names(toplot)
      for (i in 1:(length(toplot) - 1)) {
        for (j in (i + 1):length(toplot)) {
          if (length(toplot[[i]]) == length(toplot[[j]])) {
            pvals[i,j] <-
              pvalMethod(toplot[[i]],toplot[[j]],paired=TRUE)$p.value
          } else {
            pvals[i,j] <-
              pvalMethod(toplot[[i]],toplot[[j]],paired=FALSE)$p.value
          }
          pvals[j,i] <- pvals[i,j]
        }
      }
    } else {
      pvals <- NULL
    }
    pvals <- signif(pvals,3)
    return(pvals)
  }

pv.box <- function(ids,report) {
  idx <- match(ids,colnames(report))
  res <- log2(apply(report[,idx],1,mean))
  return(res)
}

pv.infToNA <- function(vals) {
  if(min(vals)==-Inf) {
    vals[vals==-Inf] <- NA
  }
  return(vals)
}

## pv.plotVenn -- draw venn diagrams
pv.plotVenn <-
  function(ovrec,label1 = "A",label2 = "B",label3 = "C",label4 = "D",
           main = "",sub = "") {
    if (length(ovrec) == 3) {
      pv.venn2(ovrec,label1,label2,main,sub)
    }
    
    if (length(ovrec) == 7) {
      pv.venn3(ovrec,label1,label2,label3,main,sub)
    }
    
    if (length(ovrec) == 15) {
      pv.venn4(ovrec,label1,label2,label3,label4,main,sub)
    }
  }


pv.venn2 <- function(olaps,l1,l2,main="",sub="") {
  
  counts <- c(nrow(olaps$onlyA),
              nrow(olaps$onlyB),
              nrow(olaps$inAll))
  names(counts) <- c("A","B","A_B")		
  counts <- list(counts)
  vennPlot(counts,setlabels=c(l1,l2),mysub=sub,mymain=main)
  
}

pv.venn3 <- function(olaps,l1,l2,l3,main="",sub="") {
  
  counts <- c(nrow(olaps$onlyA),
              nrow(olaps$onlyB),
              nrow(olaps$onlyC),	
              nrow(olaps$notC),
              nrow(olaps$notB),
              nrow(olaps$notA),
              nrow(olaps$inAll))
  names(counts) <- c("A","B","C","A_B","A_C","B_C","A_B_C")		
  counts <- list(counts)
  vennPlot(counts,setlabels=c(l1,l2,l3),mysub=sub,mymain=main)
  
}


pv.venn4 <- function(olaps,l1,l2,l3,l4,main="",sub="") {
  
  counts <- c(nrow(olaps$onlyA),
              nrow(olaps$onlyB),
              nrow(olaps$onlyC),	
              nrow(olaps$onlyD),
              nrow(olaps$AandB),
              nrow(olaps$AandC),
              nrow(olaps$AandD),
              nrow(olaps$BandC),
              nrow(olaps$BandD),
              nrow(olaps$CandD),
              nrow(olaps$notD),
              nrow(olaps$notC),
              nrow(olaps$notB),
              nrow(olaps$notA),
              nrow(olaps$inAll))
  names(counts) <- c("A","B","C","D","A_B","A_C","A_D","B_C","B_D","C_D",
                     "A_B_C","A_B_D","A_C_D","B_C_D","A_B_C_D")		
  counts <- list(counts)
  
  vennPlot(counts,setlabels=c(l1,l2,l3,l4),mysub=sub,mymain=main)
  
}


crukMagenta=rgb(236,0,140,maxColorValue=255) #CRUK Magenta
crukBlue=rgb(46,0,139,maxColorValue=255) #CRUK Blue
crukGrey='grey'#rgb(200,201,199,maxColorValue=255) #CRUK grey
crukCyan=rgb(0,182,237,maxColorValue=255) #CRUK light blue

pv.colsv <- c(crukBlue, crukMagenta, crukCyan,crukGrey,
              "lightgreen", "orange","rosybrown",
              "black","red","dodgerblue","darkgreen",
              "yellow","grey50","purple3",
              "sienna","limegreen","lightblue",
              "violet","seagreen1",
              "lavender","olivedrab")

pv.colorv <- function(classes,cols=pv.colsv){
  
  colv <- rep(0,length(classes))
  uv <- unique(classes)
  for(i in 1:length(uv)){
    colv[classes==uv[i]] <- cols[i]
  }
  return(colv)	
} 

pv.peaks2DataType <- function(peaks,datatype=DBA_DATA_DEFAULT) {
   
   res <- peaks
   
   if(is.null(peaks)) {
      return(NULL)
   }   
   
   if(datatype==DBA_DATA_FRAME) {
      return(peaks)	
   }
   
   if(is(peaks,"data.frame")) {
      if(nrow(peaks)==0) {
         return(NULL)
      }   
   }
   
   if(datatype==DBA_DATA_RANGEDDATA) {
      if(!is(peaks,"RangedData")) {
         #require(IRanges)
         cnames <- colnames(peaks)
         cnames[1:3] <- c("space","start","end")
         colnames(peaks) <- cnames
      }
      res <- as(peaks,"RangedData")
   }
   
   if(datatype==DBA_DATA_GRANGES) {
      #require(GenomicRanges)
      if(is(peaks,"RangedData")) {
         res <- suppressWarnings(as(peaks,"GRanges"))
      } else if (!is(peaks,"GRanges")) {
         chrmap <- sort(unique(peaks[,1]))
         res <- GRanges(Rle(factor(peaks[,1],levels=chrmap)),
                        IRanges(peaks[,2],width=peaks[,3]-peaks[,2]+1,
                                names=rownames(peaks)),
                        strand <- Rle("*", length(seqnames)))
         if(ncol(peaks)>3) {
            mdata <- data.frame(peaks[,4:ncol(peaks)])
            colnames(mdata)  <- colnames(peaks)[4:ncol(peaks)]
            elementMetadata(res) <- mdata
         }   	
      }
   }   
   
   return(res)
   
}

pv.peakMatrix_toGR <- function(pv, peaks) {
   
   res <- GRanges(Rle(factor(pv$chrmap[peaks[,1]])),
                  IRanges(peaks[,2],width=peaks[,3]-peaks[,2]+1,
                          names=rownames(peaks)),
                  strand <- Rle("*", length(seqnames)))
   
   if(ncol(peaks)>3) {
      mdata <- data.frame(peaks[,4:ncol(peaks)])
      colnames(mdata)  <- colnames(peaks)[4:ncol(peaks)]
      elementMetadata(res) <- mdata
   }   	
   
   return(res)
}

pv.DataType2Peaks <- function(RDpeaks){
   
   if(is.null(RDpeaks)) {
      return(NULL)
   }
   if(is(RDpeaks,'logical')) {
      return(RDpeaks)
   }
   if(is(RDpeaks,'integer')) {
      return(RDpeaks)
   }
   if(is(RDpeaks,'numeric')) {
      return(RDpeaks)
   }
   if(is(RDpeaks,'character')) {
      return(RDpeaks)
   }
   if(!is(RDpeaks,"data.frame")) {
      #require(IRanges)
      res <- as.data.frame(RDpeaks)[,-4]
      cnames <- colnames(res)
      cnames[1:3] <- c("CHR","START","END")
      colnames(res) <- cnames
      if(is(RDpeaks,"GRanges")) {
         res <- res[,-4]	
      }
   } else {
      res <- RDpeaks
   }
   if(is(res,"data.frame")) {
      res[,1] <- as.character(res[,1])
   }
   return(res)
}


pv.getoneorNA <- function(vec) {
   res <- unique(vec)
   if (length(res) == 1) {
      return(res)
   } else {
      return(NA)
   }
}

pv.add_consensus <- function(model,psets){
   
   if(missing(psets)) {
      toadd <- unique(model$class[PV_ID,duplicated(model$class[PV_ID,])])
      for(pset in toadd) {
         tomerge <- which(model$class[PV_ID,] %in% pset)
         model <- pv.consensus(model,tomerge,minOverlap=2)
      }   
      return(model) 
   }
   
   if(is.null(psets)) {
      return(model)
   }
   
   model$psets <- psets
   for(pset in psets){
      if(length(pset)>1){
         model <- pv.consensus(model,pset,minOverlap=2)
      }   
   }
   return(model)	
}

pv.removeComp <- function (data,numRemove=0) {
   
   if(numRemove == 0) {
      return(data)
   }
   
   res <- svd(data)
   U   <- res$u
   d   <- res$d
   Vt  <- t(res$v)
   
   tot <- sum(d)
   run <- 0
   for(i in 1:numRemove) {
      run <- run + d[i]
      #cat(i,d[i],d[i]/tot,run/tot,'\n')
      d[i] <- 0
   }	
   M <-  U %*% diag(d) %*% Vt
   return(M)
}

pv.occ2matrix <- function(occ,col=PV_COR,div){
   #occ[,1] <- as.character(occ[,1])
   #occ[,2] <- as.character(occ[,2])
   els <- unique(c(occ[,1],occ[,2]))
   
   nels <- length(els)
   els  <- els[order(els,decreasing=FALSE)]
   res <- matrix(NA,nels,nels)
   
   for(i in 1:nels) {
      for(j in 1:nels) {
         if(i==j) {
            res[i,j] <- 1
         } else {
            entry <- (occ[,1] == els[i]) & (occ[,2] == els[j])
            entry <- entry | (occ[,1] == els[j]) & (occ[,2] == els[i])
            if(sum(entry)>0) {
               res[i,j] <- as.numeric(occ[entry,col])
               if(!missing(div)) {
                  if(div != PV_TOTAL) {
                     todiv <- as.numeric(occ[entry,div])
                  } else {
                     todiv <- as.numeric(occ[entry,PV_ONLYA]) +
                        as.numeric(occ[entry,PV_ONLYB]) +
                        as.numeric(occ[entry,PV_INALL])
                  }
                  res[i,j] <- res[i,j] / todiv
               }
            }
         }
      }
   } 
   
   colnames(res) <- els
   rownames(res) <- els
   return(res)
}

pv.nums2labels <- function(pv,els,atts) {
   if(is.null(atts)) {
      return(els)
   }
   for(i in 1:length(els)) {
      els[i] <- pv.namestrings(pv$class[atts,as.numeric(els[i])])$tstring
   }
   return(els)
}

pv.getOverlapData <- function(pv,contrast,report) {
   con <- pv$contrasts[[contrast]]                       	
   repcols <- colnames(report)
   numsamps <- sum(con$group1)+sum(con$group2)
   if(length(repcols) < (numsamps+9)) {
      return(pv)
   }
   first <- 10
   if(repcols[10]=="Called1") {
      if(length(repcols) < (numsamps+11)) {
         return(pv)
      }
      first <- 12	 
   }
   
   domap <- report[,first:(first+numsamps-1)]
   
   pv$binding    <- cbind(report[,1:3],domap)
   pv$class      <- cbind(pv$class[,con$group1],pv$class[,con$group2])
   
   return(pv)     
}

#PV_CHIP_RPKM      <- 6
#PV_CHIP_READS     <- 7
#PV_CONTROL_RPKM   <- 8
#PV_CONTROL_READS  <- 9


pv.get_scores <- function(pv,peaksets){
   control <- rep(0,nrow(pv$peaks[[peaksets[1]]]))
   scores <- NULL
   for(peakset in peaksets) {
      control <- control + pv$peaks[[peakset]]$cRPKM
      scores <- cbind(scores,pv$peaks[[peakset]]$RPKM)
   }
   control <- control/length(peaksets)
   for(i in 1:ncol(scores)) {
      scores[,i] <- log2(scores[,i] / control)	
   }
   return(scores)
}

pv.attname <- function(attribute,pv=NULL) {
   if(attribute == PV_ID) {
      if(!is.null(pv)) {
         if(!is.null(pv$config$id)) {
            return(pv$config$id)
         }
      }
      return("ID")
   }
   if(attribute == PV_GROUP) {
      if(!is.null(pv)) {
         if(!is.null(pv$config$group)) {
            return(pv$config$group)
         }
      }
      return("Group")
   }
   if(attribute == PV_TISSUE) {
      if(!is.null(pv)) {
         if(!is.null(pv$config$tissue)) {
            return(pv$config$tissue)
         }
      }
      return("Tissue")
   }
   if(attribute == PV_FACTOR) {
      if(!is.null(pv)) {
         if(!is.null(pv$config$factor)) {
            return(pv$config$factor)
         }
      }
      return("Factor")
   }
   if(attribute == PV_CONDITION) {
      if(!is.null(pv)) {
         if(!is.null(pv$config$condition)) {
            return(pv$config$condition)
         }
      }
      return("Condition")
   }
   if(attribute == PV_TREATMENT) {
      if(!is.null(pv)) {
         if(!is.null(pv$config$treatment)) {
            return(pv$config$treatment)
         }
      }
      return("Treatment")
   }
   
   if(attribute == PV_REPLICATE) {
      if(!is.null(pv)) {
         if(!is.null(pv$config$replicate)) {
            return(pv$config$replicate)
         }
      }
      return("Replicate")
   }
   if(attribute == PV_CALLER) {
      if(!is.null(pv)) {
         if(!is.null(pv$config$caller)) {
            return(pv$config$caller)
         }
      }
      return("Caller")
   }
   if(attribute == PV_READS) {
      if(!is.null(pv)) {
         if(!is.null(pv$config$reads)) {
            return(pv$config$reads)
         }
      }
      return("Reads")
   }
   
   if(!is.null(pv)) {
      if(!is.null(pv$config$group)) {
         return(pv$config$group)
      }
   }
   return("Group")
}

pv.attributematrix <- function(pv,mask,contrast,attributes,cols,bReverse=FALSE,bAddGroup=FALSE) {
   
   if(is.null(attributes)){
      attributes=c(PV_TISSUE,PV_FACTOR,PV_CONDITION,PV_TREATMENT,PV_REPLICATE,PV_CALLER)
      if(bAddGroup) {
         attributes=c(PV_GROUP,attributes)	
      }	
   }
   
   classdb <- pv$class[,mask]
   numsamps <- ncol(classdb)
   atts <- NULL
   for(num in length(attributes):1) {
      attribute <- attributes[num]
      if(attribute==PV_GROUP) {
         vals <- NA
         if(!missing(contrast)) {
            if(sum(pv$contrasts[[contrast]]$group1) || 
               sum(pv$contrasts[[contrast]]$group2)) {
               gps <- rep(3,length(pv$contrasts[[contrast]]$group1))
               gps[pv$contrasts[[contrast]]$group1]=1
               gps[pv$contrasts[[contrast]]$group2]=2
               classdb <- rbind(classdb,gps)
               attribute <- nrow(classdb)
               vals <- 1:max(gps)
            }
         } else {
            vals <- NA	
         }
      } else {
         vals <- unique(classdb[attribute,])
      }
      numvals <- suppressWarnings(as.numeric(vals))
      if(!sum(is.na(numvals))) {
         vals <- sort(numvals)
      }
      if ( (sum(!is.na(vals))>1) && (sum(!is.na(vals))<numsamps) ) {
         addcol <- matrix(classdb[attribute,],numsamps,1)
         for(i in 1:length(vals)) {
            #addcol[addcol[,1]==vals[i],1]=cols[i]
            addcol[addcol[,1]==vals[i],1]=i
         }
         colnames(addcol) <- pv.attname(attribute,pv)
         if(bReverse) {
            atts <- cbind(addcol,atts)  
         } else { 	
            atts <- cbind(atts,addcol)  	
         }
      }         	
   }
   if(is.null(atts)) {
      return(NULL)
   }
   attnum <- 1
   for(i in ncol(atts):1) {
      if(is.list(cols)) {
         usecols <- cols[[attnum]]
      } else usecols <- cols
      atts[,i] <- usecols[as.numeric(atts[,i])]
      attnum <- attnum+1
   }
   return(atts)	
}

pv.attributePCA <- function(DBA) {
   
   if(pv.morethanone(DBA,DBA_TISSUE))    return(DBA_TISSUE)	
   if(pv.morethanone(DBA,DBA_FACTOR))    return(DBA_FACTOR)	
   if(pv.morethanone(DBA,DBA_CONDITION)) return(DBA_CONDITION)	
   if(pv.morethanone(DBA,DBA_TREATMENT)) return(DBA_TREATMENT)	
   if(pv.morethanone(DBA,DBA_REPLICATE)) return(DBA_REPLICATE)	
   if(pv.morethanone(DBA,DBA_CALLER))    return(DBA_CALLER)
   
   return(DBA_ID)
}

pv.morethanone <- function(DBA,att){
   
   vals <- unique(DBA$class[att,])
   
   if(sum(!is.na(vals))>=2) {
      return(TRUE)
   } else {
      return(FALSE)	
   }	
}

pv.checkValue <- function(val,check) {
   if(is.null(val)) {
      return(FALSE)
   } 
   if (val != check) {
      return(FALSE)
   }
   return(TRUE)
}

pv.setMask <- function(pv,mask,contrast) {
   
   newmask <- rep(TRUE,length(pv$peaks))
   
   if(!missing(contrast)) {
      if(contrast <= length(pv$contrasts)) {
         if(!is.null(pv$contrasts[[contrast]]$group1)) {
            newmask <- pv$contrasts[[contrast]]$group1 | pv$contrasts[[contrast]]$group2
         }
      } else {
         stop('Invalid contrast',call.=FALSE)
      }
   }
   if(missing(mask)) {
      mask <- newmask
   } else if(is.null(mask)) {
      mask <- newmask   
   } else {
      if(!is.logical(mask)) {
         tmp  <- rep(FALSE,length(pv$peaks))
         tmp[mask] <- TRUE
         mask <- tmp
      }
   }
   if(length(mask) != length(pv$peaks)) {
      stop('Mask does not match samples.',call.=FALSE)
   }
   for(pnum in 1:length(pv$peaks)) {
      if(nrow(pv$peaks[[pnum]])==0) {
         mask[pnum] <- FALSE
      }
   }
   return(mask)
}



### Thanks to Obi Griffith 
### Obtained at http://www.biostars.org/post/show/18211/how-do-i-draw-a-heatmap-in-r-with-both-a-color-key-and-multiple-color-side-bars/
### Downloaded from http://dl.dropbox.com/u/16769159/Biostar/heatmap.3.R
checkinvalid = function (x) 
{
   if (missing(x) || is.null(x) || length(x) == 0) 
      return(TRUE)
   if (is.list(x)) 
      return(all(sapply(x, checkinvalid)))
   else if (is.vector(x)) 
      return(all(is.na(x)))
   else return(FALSE)
}


heatmap.3=function (x, Rowv = TRUE, Colv = if (symm) "Rowv" else TRUE, 
                    distfun = dist, hclustfun = hclust, 
                    dendrogram = c("both","row", "column", "none"), 
                    symm = FALSE, scale = c("none", "row", "column"),
                    na.rm = TRUE, revC = identical(Colv, "Rowv"), add.expr, breaks, 
                    symbreaks = min(x < 0, na.rm = TRUE) ||  scale != "none", 
                    col = "heat.colors", colsep, rowsep, 
                    sepcolor = "white", sepwidth = c(0.05, 0.05), cellnote, 
                    notecex = 1, notecol = "cyan",
                    na.color = par("bg"), trace = c("column","row", "both", "none"), 
                    tracecol = "cyan", hline = median(breaks), 
                    vline = median(breaks), linecol = tracecol, 
                    margins = c(5, 5), ColSideColors, RowSideColors, 
                    cexRow = 0.2 + 1/log10(nr), 
                    cexCol = 0.2 + 1/log10(nc), labRow = NULL, labCol = NULL, 
                    key = TRUE, keysize = 1.5, 
                    density.info = c("histogram","density", "none"), 
                    denscol = tracecol, 
                    symkey = min(x < 0, na.rm = TRUE) || symbreaks,
                    densadj = 0.25, main = NULL, 
                    xlab = NULL, ylab = NULL, lmat = NULL, lhei = NULL, lwid = NULL,
                    NumColSideColors = 1, NumRowSideColors = 1, KeyValueName="Value",
                    ...) 
{
   scale01 <- function(x, low = min(x), high = max(x)) {
      x <- (x - low)/(high - low)
      x
   }
   retval <- list()
   scale <- if (symm && missing(scale)) 
      "none"
   else match.arg(scale)
   dendrogram <- match.arg(dendrogram)
   trace <- match.arg(trace)
   density.info <- match.arg(density.info)
   if (length(col) == 1 && is.character(col)) 
      col <- get(col, mode = "function")
   if (!missing(breaks) && (scale != "none")) 
      warning("Using scale=\"row\" or scale=\"column\" when breaks are", 
              "specified can produce unpredictable results.", "Please consider using only one or the other."
              ,call.=FALSE)
   if (is.null(Rowv) || is.na(Rowv)) 
      Rowv <- FALSE
   if (is.null(Colv) || is.na(Colv)) 
      Colv <- FALSE
   else if (Colv == "Rowv" && !isTRUE(Rowv)) 
      Colv <- FALSE
   if (length(di <- dim(x)) != 2 || !is.numeric(x)) 
      stop("`x' must be a numeric matrix",call.=FALSE)
   nr <- di[1]
   nc <- di[2]
   if (nr <= 1 || nc <= 1) 
      stop("`x' must have at least 2 rows and 2 columns",call.=FALSE)
   if (!is.numeric(margins) || length(margins) != 2) 
      stop("`margins' must be a numeric vector of length 2",call.=FALSE)
   if (missing(cellnote)) 
      cellnote <- matrix("", ncol = ncol(x), nrow = nrow(x))
   if (!inherits(Rowv, "dendrogram")) {
      if (((!isTRUE(Rowv)) || (is.null(Rowv))) && (dendrogram %in% 
                                                   c("both", "row"))) {
         if (is.logical(Colv) && (Colv)) 
            dendrogram <- "column"
         else dedrogram <- "none"
         warning("Discrepancy: Rowv is FALSE, while dendrogram is `", 
                 dendrogram, "'. Omitting row dendogram.",
                 call.=FALSE)
      }
   }
   if (!inherits(Colv, "dendrogram")) {
      if (((!isTRUE(Colv)) || (is.null(Colv))) && (dendrogram %in% 
                                                   c("both", "column"))) {
         if (is.logical(Rowv) && (Rowv)) 
            dendrogram <- "row"
         else dendrogram <- "none"
         warning("Discrepancy: Colv is FALSE, while dendrogram is `", 
                 dendrogram, "'. Omitting column dendogram.",
                 call.=FALSE)
      }
   }
   if (inherits(Rowv, "dendrogram")) {
      ddr <- Rowv
      rowInd <- order.dendrogram(ddr)
   }
   else if (is.integer(Rowv)) {
      hcr <- hclustfun(distfun(x))
      ddr <- as.dendrogram(hcr)
      ddr <- reorder(ddr, Rowv)
      rowInd <- order.dendrogram(ddr)
      if (nr != length(rowInd)) 
         stop("row dendrogram ordering gave index of wrong length",call.=FALSE)
   }
   else if (isTRUE(Rowv)) {
      Rowv <- rowMeans(x, na.rm = na.rm)
      hcr <- hclustfun(distfun(x))
      ddr <- as.dendrogram(hcr)
      ddr <- reorder(ddr, Rowv)
      rowInd <- order.dendrogram(ddr)
      if (nr != length(rowInd)) 
         stop("row dendrogram ordering gave index of wrong length",call.=FALSE)
   }
   else {
      rowInd <- nr:1
   }
   if (inherits(Colv, "dendrogram")) {
      ddc <- Colv
      colInd <- order.dendrogram(ddc)
   }
   else if (identical(Colv, "Rowv")) {
      if (nr != nc) 
         stop("Colv = \"Rowv\" but nrow(x) != ncol(x)",call.=FALSE)
      if (exists("ddr")) {
         ddc <- ddr
         colInd <- order.dendrogram(ddc)
      }
      else colInd <- rowInd
   }
   else if (is.integer(Colv)) {
      hcc <- hclustfun(distfun(if (symm) 
         x
         else t(x)))
      ddc <- as.dendrogram(hcc)
      ddc <- reorder(ddc, Colv)
      colInd <- order.dendrogram(ddc)
      if (nc != length(colInd)) 
         stop("column dendrogram ordering gave index of wrong length",call.=FALSE)
   }
   else if (isTRUE(Colv)) {
      Colv <- colMeans(x, na.rm = na.rm)
      hcc <- hclustfun(distfun(if (symm) 
         x
         else t(x)))
      ddc <- as.dendrogram(hcc)
      ddc <- reorder(ddc, Colv)
      colInd <- order.dendrogram(ddc)
      if (nc != length(colInd)) 
         stop("column dendrogram ordering gave index of wrong length",call.=FALSE)
   }
   else {
      colInd <- 1:nc
   }
   retval$rowInd <- rowInd
   retval$colInd <- colInd
   retval$call <- match.call()
   x <- x[rowInd, colInd]
   x.unscaled <- x
   cellnote <- cellnote[rowInd, colInd]
   if (is.null(labRow)) 
      labRow <- if (is.null(rownames(x))) 
         (1:nr)[rowInd]
   else rownames(x)
   else labRow <- labRow[rowInd]
   if (is.null(labCol)) 
      labCol <- if (is.null(colnames(x))) 
         (1:nc)[colInd]
   else colnames(x)
   else labCol <- labCol[colInd]
   if (scale == "row") {
      retval$rowMeans <- rm <- rowMeans(x, na.rm = na.rm)
      x <- sweep(x, 1, rm)
      retval$rowSDs <- sx <- apply(x, 1, sd, na.rm = na.rm)
      x <- sweep(x, 1, sx, "/")
   }
   else if (scale == "column") {
      retval$colMeans <- rm <- colMeans(x, na.rm = na.rm)
      x <- sweep(x, 2, rm)
      retval$colSDs <- sx <- apply(x, 2, sd, na.rm = na.rm)
      x <- sweep(x, 2, sx, "/")
   }
   if (missing(breaks) || is.null(breaks) || length(breaks) < 
       1) {
      if (missing(col) || is.function(col)) 
         breaks <- 16
      else breaks <- length(col) + 1
   }
   if (length(breaks) == 1) {
      if (!symbreaks) 
         breaks <- seq(min(x, na.rm = na.rm), max(x, na.rm = na.rm), 
                       length = breaks)
      else {
         extreme <- max(abs(x), na.rm = TRUE)
         breaks <- seq(-extreme, extreme, length = breaks)
      }
   }
   nbr <- length(breaks)
   ncol <- length(breaks) - 1
   if (is(col,"function")) {
      col <- col(ncol)
   }
   min.breaks <- min(breaks)
   max.breaks <- max(breaks)
   x[x < min.breaks] <- min.breaks
   x[x > max.breaks] <- max.breaks
   if (missing(lhei) || is.null(lhei)) 
      lhei <- c(keysize, 4)
   if (missing(lwid) || is.null(lwid)) 
      lwid <- c(keysize, 4)
   if (missing(lmat) || is.null(lmat)) {
      lmat <- rbind(4:3, 2:1)
      
      if (!missing(ColSideColors)) {
         if(!is.null(ColSideColors)) {	
            #if (!is.matrix(ColSideColors)) 
            #stop("'ColSideColors' must be a matrix")
            if (!is.character(ColSideColors) || dim(ColSideColors)[1] != 
                nc) 
               stop("'ColSideColors' dim()[2] must be of length ncol(x)",call.=FALSE)
            lmat <- rbind(lmat[1, ] + 1, c(NA, 1), lmat[2, ] + 1)
            #lhei <- c(lhei[1], 0.2, lhei[2])
            lhei=c(lhei[1], 0.1*NumColSideColors, lhei[2]) 
         }
      }
      if (!missing(RowSideColors)) {
         if(!is.null(RowSideColors)) { 
            #if (!is.matrix(RowSideColors)) 
            #stop("'RowSideColors' must be a matrix")
            if (!is.character(RowSideColors) || dim(RowSideColors)[1] != 
                nr) 
               stop("'RowSideColors' must be a character vector of length nrow(x)",call.=FALSE)
            lmat <- cbind(lmat[, 1] + 1, c(rep(NA, nrow(lmat) - 1), 1), lmat[,2] + 1)
            #lwid <- c(lwid[1], 0.2, lwid[2])
            lwid <- c(lwid[1], 0.1*NumRowSideColors, lwid[2])
         }
      }
      lmat[is.na(lmat)] <- 0     
   }
   
   if (length(lhei) != nrow(lmat))
      stop("lhei must have length = nrow(lmat) = ", nrow(lmat),call.=FALSE)
   if (length(lwid) != ncol(lmat))
      stop("lwid must have length = ncol(lmat) =", ncol(lmat),call.=FALSE)
   op <- par(no.readonly = TRUE)
   on.exit(par(op))
   layout(lmat, widths = lwid, heights = lhei, respect = FALSE)     
   
   if (!missing(RowSideColors)) {
      if (!is.null(RowSideColors)) {
         #if (!is.matrix(RowSideColors)){
         if(revC) {
            xrowInd = rev(rowInd)	
         } else {
            xrowInd = rowInd	
         }	
         if(ncol(RowSideColors)==1) {	
            par(mar = c(margins[1], 0, 0, 0.5))
            image(rbind(1:nr), col = RowSideColors[,1][xrowInd], axes = FALSE)
            axis(1,0,colnames(RowSideColors)[1],las=2,tick=FALSE)
         } 
         else{
            par(mar = c(margins[1], 0, 0, 0.5))
            rsc = RowSideColors[xrowInd, ]
            rsc.colors = matrix()
            rsc.names = names(table(rsc))
            rsc.i = 1
            for (rsc.name in rsc.names) {
               rsc.colors[rsc.i] = rsc.name
               rsc[rsc == rsc.name] = rsc.i
               rsc.i = rsc.i + 1
            }
            rsc = matrix(as.numeric(rsc), nrow = dim(rsc)[1])
            image(t(rsc), col = as.vector(rsc.colors), axes = FALSE)
            if (length(colnames(RowSideColors)) > 0) {
               axis(1, 0:(dim(rsc)[2] - 1)/(dim(rsc)[2] - 1),
                    colnames(RowSideColors), 
                    las = 2, tick = FALSE)
            }
         }
      }
   }
   
   if (!missing(ColSideColors)) {
      if (!is.null(ColSideColors)) {
         #if (!is.matrix(ColSideColors)){
         if(ncol(ColSideColors)==1) {
            par(mar = c(0.5, 0, 0, margins[2]))
            image(cbind(1:nc), col = ColSideColors[,1][colInd], axes = FALSE)
            axis(2,0,colnames(ColSideColors)[1],las=2,tick=FALSE)
         }
         else {    
            par(mar = c(0.5, 0, 0, margins[2]))
            csc = ColSideColors[colInd, ]
            csc.colors = matrix()
            csc.names = names(table(csc))
            csc.i = 1
            for (csc.name in csc.names) {
               csc.colors[csc.i] = csc.name
               csc[csc == csc.name] = csc.i
               csc.i = csc.i + 1
            }
            csc = matrix(as.numeric(csc), nrow = dim(csc)[1])
            image(csc, col = as.vector(csc.colors), axes = FALSE)
            if (length(colnames(ColSideColors)) > 0) {
               axis(2, 0:(dim(csc)[2] - 1)/(dim(csc)[2] - 1),
                    colnames(ColSideColors), 
                    las = 2, tick = FALSE)
            }
         }
      }
   }
   par(mar = c(margins[1], 0, 0, margins[2]))
   x <- t(x)
   cellnote <- t(cellnote)
   if (revC) {
      iy <- nr:1
      if (exists("ddr")) 
         ddr <- rev(ddr)
      x <- x[, iy]
      cellnote <- cellnote[, iy]
   }
   else iy <- 1:nr
   image(1:nc, 1:nr, x, xlim = 0.5 + c(0, nc), ylim = 0.5 + 
            c(0, nr), axes = FALSE, xlab = "", ylab = "", col = col, 
         breaks = breaks, ...)
   retval$carpet <- x
   if (exists("ddr")) 
      retval$rowDendrogram <- ddr
   if (exists("ddc")) 
      retval$colDendrogram <- ddc
   retval$breaks <- breaks
   retval$col <- col
   if (!checkinvalid(na.color) & any(is.na(x))) {
      mmat <- ifelse(is.na(x), 1, NA)
      image(1:nc, 1:nr, mmat, axes = FALSE, xlab = "", ylab = "", 
            col = na.color, add = TRUE)
   }
   axis(1, 1:nc, labels = labCol, las = 2, line = -0.5, tick = 0, 
        cex.axis = cexCol)
   if (!is.null(xlab)) 
      mtext(xlab, side = 1, line = margins[1] - 1.25)
   axis(4, iy, labels = labRow, las = 2, line = -0.5, tick = 0, 
        cex.axis = cexRow)
   if (!is.null(ylab)) 
      mtext(ylab, side = 4, line = margins[2] - 1.25)
   if (!missing(add.expr)) 
      eval(substitute(add.expr))
   if (!missing(colsep)) 
      for (csep in colsep) rect(xleft = csep + 0.5, 
                                ybottom = rep(0,  length(csep)), xright = csep + 0.5 + sepwidth[1], 
                                ytop = rep(ncol(x) + 1, csep), lty = 1, lwd = 1, 
                                col = sepcolor, border = sepcolor)
   if (!missing(rowsep)) 
      for (rsep in rowsep) rect(xleft = 0, 
                                ybottom = (ncol(x) + 1 - rsep) - 0.5, xright = nrow(x) + 1, 
                                ytop = (ncol(x) + 1 - rsep) - 0.5 - sepwidth[2], lty = 1, lwd = 1, 
                                col = sepcolor, border = sepcolor)
   min.scale <- min(breaks)
   max.scale <- max(breaks)
   x.scaled <- scale01(t(x), min.scale, max.scale)
   if (trace %in% c("both", "column")) {
      retval$vline <- vline
      vline.vals <- scale01(vline, min.scale, max.scale)
      for (i in colInd) {
         if (!is.null(vline)) {
            abline(v = i - 0.5 + vline.vals, col = linecol, 
                   lty = 2)
         }
         xv <- rep(i, nrow(x.scaled)) + x.scaled[, i] - 0.5
         xv <- c(xv[1], xv)
         yv <- 1:length(xv) - 0.5
         lines(x = xv, y = yv, lwd = 1, col = tracecol, type = "s")
      }
   }
   if (trace %in% c("both", "row")) {
      retval$hline <- hline
      hline.vals <- scale01(hline, min.scale, max.scale)
      for (i in rowInd) {
         if (!is.null(hline)) {
            abline(h = i + hline, col = linecol, lty = 2)
         }
         yv <- rep(i, ncol(x.scaled)) + x.scaled[i, ] - 0.5
         yv <- rev(c(yv[1], yv))
         xv <- length(yv):1 - 0.5
         lines(x = xv, y = yv, lwd = 1, col = tracecol, type = "s")
      }
   }
   if (!missing(cellnote)) 
      text(x = c(row(cellnote)), y = c(col(cellnote)), labels = c(cellnote), 
           col = notecol, cex = notecex)
   par(mar = c(margins[1], 0, 0, 0))
   if (dendrogram %in% c("both", "row")) {
      plot(ddr, horiz = TRUE, axes = FALSE, yaxs = "i", leaflab = "none")
   }
   else plot.new()
   par(mar = c(0, 0, if (!is.null(main)) 5 else 0, margins[2]))
   if (dendrogram %in% c("both", "column")) {
      plot(ddc, axes = FALSE, xaxs = "i", leaflab = "none")
   }
   else plot.new()
   if (!is.null(main)) 
      title(main, cex.main = 1.5 * op[["cex.main"]])
   if (key) {
      par(mar = c(5, 4, 2, 1), cex = 0.75)
      tmpbreaks <- breaks
      if (symkey) {
         max.raw <- max(abs(c(x, breaks)), na.rm = TRUE)
         min.raw <- -max.raw
         tmpbreaks[1] <- -max(abs(x))
         tmpbreaks[length(tmpbreaks)] <- max(abs(x))
      }
      else {
         min.raw <- min(x, na.rm = TRUE)
         max.raw <- max(x, na.rm = TRUE)
      }
      z <- seq(min.raw, max.raw, length = length(col))
      image(z = matrix(z, ncol = 1), col = col, breaks = tmpbreaks, 
            xaxt = "n", yaxt = "n")
      par(usr = c(0, 1, 0, 1))
      lv <- pretty(breaks)
      xv <- scale01(as.numeric(lv), min.raw, max.raw)
      axis(1, at = xv, labels = lv)
      if (scale == "row") 
         mtext(side = 1, "Row Z-Score", line = 2)
      else if (scale == "column") 
         mtext(side = 1, "Column Z-Score", line = 2)
      else mtext(side = 1, KeyValueName, line = 2)
      if (density.info == "density") {
         dens <- density(x, adjust = densadj, na.rm = TRUE)
         omit <- dens$x < min(breaks) | dens$x > max(breaks)
         dens$x <- dens$x[-omit]
         dens$y <- dens$y[-omit]
         dens$x <- scale01(dens$x, min.raw, max.raw)
         lines(dens$x, dens$y/max(dens$y) * 0.95, col = denscol, 
               lwd = 1)
         axis(2, at = pretty(dens$y)/max(dens$y) * 0.95, pretty(dens$y))
         title("Color Key\nand Density Plot")
         par(cex = 0.5)
         mtext(side = 2, "Density", line = 2)
      }
      else if (density.info == "histogram") {
         h <- hist(x, plot = FALSE, breaks = breaks)
         hx <- scale01(breaks, min.raw, max.raw)
         hy <- c(h$counts, h$counts[length(h$counts)])
         lines(hx, hy/max(hy) * 0.95, lwd = 1, type = "s", 
               col = denscol)
         axis(2, at = pretty(hy)/max(hy) * 0.95, pretty(hy))
         title("Color Key\nand Histogram")
         par(cex = 0.5)
         mtext(side = 2, "Count", line = 2)
      }
      else title("Color Key")
   }
   else plot.new()
   retval$colorTable <- data.frame(low = retval$breaks[-length(retval$breaks)], 
                                   high = retval$breaks[-1], color = retval$col)
   invisible(retval)
}

pv.check1 <- function(sbMatrix) {
   if(!is.null(sbMatrix)){
      if(is.null(nrow(sbMatrix))) {
         snames <- names(sbMatrix)
         sbMatrix <- matrix(sbMatrix,1,length(sbMatrix))
         colnames(sbMatrix) <- snames
      }
   }
   return(sbMatrix)
}   

pv.DBA <- function(pv,method='edgeR',bTagwise=TRUE,
                   minMembers=3,bParallel=FALSE, block) {
  
  if(bParallel) {
    setParallel <- TRUE
    bParallel <- FALSE
  } else {
    setParallel <- FALSE	
  }
  
  if(is.null(pv$contrasts)) {
    message("Adding contrasts(s)...")
    if(missing(block)) {
      pv <- pv.contrast(pv,minMembers=minMembers)
    } else {
      pv <- pv.contrast(pv,minMembers=minMembers,block=block)
    }
  }
  
  if(is.null(pv$contrasts)) {
    stop('Unable to perform analysis: no contrasts specified.')	
  }
  
  noreps <- FALSE
  for(contrast in pv$contrasts) {
    if(!is.null(contrast$group1)) {
      if(sum(contrast$group1)<2) {
        noreps <- TRUE
      }
      if(sum(contrast$group2)<2) {
        noreps <- TRUE
      }
    }
  }
  if(noreps) {
    warning("Some groups have no replicates. Results may be unreliable.",call.=FALSE)	
  }
  
  if(bParallel) {
    pv <- dba.parallel(pv)
    jobs <- NULL
    numjobs <- 0
  }
  
  pv <- pv.checkConsensusRows(pv)
  
  results <- NULL
  
  if(pv.isDesign(pv$design)) { ## establish design-based analyses
    
    pv <- pv.designAnalysis (pv, method, tagwise=bTagwise, setParallel)
    
  }
  
  if('edgeRGLM' %in% method) {
    
    if(bParallel && (pv$config$parallelPackage > 0)) {
      numjobs <- numjobs + 1
      params <- dba.parallel.params(pv$config,c('pv.allDEedgeR','pv.DEedgeR','pv.contrast','pv.listadd'))
      fdebug('submit job: pv.all')
      jobs <- pv.listadd(jobs,dba.parallel.addjob(pv$config,params,
                                                  pv.allDEedgeR,pv,
                                                  bFullLibrarySize=(pv$norm$edgeR$lib.method!=DBA_LIBSIZE_PEAKREADS),
                                                  bParallel=TRUE,
                                                  bSubControl=pv$norm$edgeR$bSubControl,
                                                  bTagwise=bTagwise,bGLM=TRUE,
                                                  filter=pv$norm$edgeR$filter.val,filterFun=pv$norm$edgeR$filter.fun))
    } else {
      results <- pv.listadd(results, pv.allDEedgeR(pv,block=block,
                                                   bSubControl=pv$norm$edgeR$bSubControl,
                                                   bFullLibrarySize=(pv$norm$edgeR$lib.method!=DBA_LIBSIZE_PEAKREADS),
                                                   bParallel=setParallel,bTagwise=bTagwise,bGLM=TRUE,
                                                   filter=pv$norm$edgeR$filter.val,filterFun=pv$norm$edgeR$filter.fun))
    }
  }
  
  if('DESeq2' %in% method) {
    if (!requireNamespace("DESeq2",quietly=TRUE)) {
      stop("Package DESeq2 not installed",call.=FALSE)
    }

    if(bParallel && (pv$config$parallelPackage > 0)) {
      numjobs <- numjobs + 1
      params <- dba.parallel.params(pv$config,c('pv.DESeq2'))
      jobs <- pv.listadd(jobs,dba.parallel.addjob(pv$config,params,pv.allDESeq2,pv,
                                                  bSubControl=pv$norm$DESeq2$bSubControl,
                                                  bFullLibrarySize=(pv$norm$DESeq2$lib.method!=DBA_LIBSIZE_PEAKREADS),
                                                  bTagwise=bTagwise,bGLM=FALSE,
                                                  bParallel=TRUE,
                                                  filter=pv$norm$DESeq2$filter.val,filterFun=pv$norm$DESeq2$filter.fun))
    } else {
      results <- pv.listadd(results,pv.allDESeq2(pv,bSubControl=pv$norm$DESeq2$bSubControl,
                                                 bFullLibrarySize=(pv$norm$DESeq2$lib.method!=DBA_LIBSIZE_PEAKREADS),
                                                 bTagwise=bTagwise,bGLM=FALSE,bParallel=setParallel,
                                                 filter=pv$norm$DESeq2$filter.val,filterFun=pv$norm$DESeq2$filter.fun))
    }
  }
  
  
  if(bParallel && (pv$config$parallelPackage > 0)) {
    results <- dba.parallel.wait4jobs(pv$config,jobs)
  }
  
  jnum <- 1
  if('edgeRGLM' %in% method) {
    edger <- results[[jnum]]
    for(i in 1:length(edger)){
      pv$contrasts[[i]]$edgeR <- edger[[i]]
    }
    jnum <- jnum+1
  }
  
  if( ('DESeq2' %in% method) || ('DESeq2GLM' %in% method) ) {
    deseq2 <- results[[jnum]]
    for(i in 1:length(deseq2)){
      pv$contrasts[[i]]$DESeq2 <- deseq2[[i]]
    }
    jnum <- jnum+1
  } 
  
  # pv$filter    <- filter
  # pv$filterFun <- filterFun
  
  fdebug(sprintf('Exit pv.DBA: %f',pv$contrasts[[1]]$edgeR$counts[7,1]))
  return(pv)
}

pv.DEinit <- function(pv,mask1,mask2,group1=1,group2=2,method='edgeR',
                      bSubControl=FALSE,bFullLibrarySize=FALSE,removeComps=0,
                      bRawCounts=FALSE,targets=NULL,
                      filter=0,filterFun=max) {
  
  fdebug('enter pv.DEinit')
  
  edgeR  <- FALSE
  DESeq2 <- FALSE
  if(method == 'edgeR') {
    edgeR <- TRUE   
  } else if (method == 'DESeq2') {
    if (requireNamespace("DESeq2",quietly=TRUE)) {
      DESeq2 <- TRUE 
    } else {
      stop("Package DESeq2 not installed",call.=FALSE)
    }    
  } else {
    warning('Invalid method: ',method,call.=FALSE)
    return(NULL)
  }
  
  srcmask <- pv.mask(pv,PV_CALLER,"source") | pv.mask(pv,PV_CALLER,"counts")
  
  fdebug(sprintf('pv.DEinit: %s %2.0f %s %2.0f srcmask %2.0f',
                 group1,sum(mask1),group2,sum(mask2),sum(srcmask)))
  g1 <- which(mask1 & srcmask)
  g2 <- which(mask2 & srcmask)
  
  s1 <- pv.get_reads(pv,g1,bSubControl=bSubControl)
  s2 <- pv.get_reads(pv,g2,bSubControl=bSubControl)
  
  counts <- cbind(s1,s2)
  
  if(is.null(filter)) {
    filter <- 0
  }
  if(filter > 0){
    scores <- apply(counts,1,filterFun)
    keep   <- scores > filter
    counts <- counts[keep,]
    rownames(counts) <- which(keep)
  } else {
    rownames(counts) <- as.character(1:nrow(counts))
  }
  
  colnames(counts) <- c(pv$class[PV_ID,mask1],pv$class[PV_ID,mask2])
  
  if(bRawCounts) {
    return(counts)	
  }
  
  groups <- factor(c(rep(group1,length(g1)),rep(group2,length(g2))))
  
  
  if(bFullLibrarySize) {
    libsize <- as.numeric(pv$class[PV_READS,c(g1,g2)])
  } else {
    libsize <- colSums(counts)
  }
  
  if(!bRawCounts) {
    
    if(edgeR) {
      
      normfacs <- NULL
      
      res <- edgeR::DGEList(counts,lib.size=libsize,norm.factors=normfacs,
                            group=groups,genes=as.character(1:nrow(counts)))
      rownames(res$counts) <- 1:nrow(res$counts)
      fdebug(sprintf('DGEList counts: %f',res$counts[7,1]))
    }
    
    if(DESeq2) {
      colnames(counts) <- NULL
      if(is.null(targets)) {     	
        res <- DESeq2::DESeqDataSetFromMatrix(counts,data.frame(groups),formula(~ groups))
      } else {
        res <- DESeq2::DESeqDataSetFromMatrix(counts,data.frame(targets),formula(~ group))     		
      }
      
      # if(!is.null(pv$norm$DESeq2)) {
      #   message("DESeq2: Using size factors from dba.normalize()")
      #   DESeq2::sizeFactors(res) <- pv$norm$DESeq2$norm.facs
      # } else {
      #   message("DESeq2: NO size factors from dba.normalize()")
      
      if(bFullLibrarySize) {
        DESeq2::sizeFactors(res) <- libsize/min(libsize)
      }  else {
        res <- DESeq2::estimateSizeFactors(res)
      }
      # }
      
    }
  }                
  return(res)
}

pv.blockFactors <- function(pv,group1,group2,label1,label2,blockList) {
  samples <- group1 | group2
  targets <- NULL
  for(block in blockList) {
    samps <- block$samples & samples &  
      (pv.mask(pv,PV_CALLER,"source") | pv.mask(pv,PV_CALLER,"counts"))
    IDs   <- pv$class[PV_ID,samps]
    groups <- NULL
    wsamps <- which(samps)
    for(sw in wsamps) {
      if(group1[sw]) {
        groups <- c(groups,label1)
      } else {
        groups <- c(groups,label2)
      }   
    }
    block <- rep(block$label, sum(samps))
    block <- cbind(groups,block)
    rownames(block) <- IDs
    targets <- rbind(targets,block)
  }
  
  snames <- c(colnames(pv$class[,group1]),colnames(pv$class[,group2]))
  if(length(unique(snames))!=sum(group1|group2)){
    warning('All samples must have unique IDs for blocking analysis',call.=FALSE)
    return(NULL)	
  }
  tnames <- rownames(targets)
  #if(length(snames)!=length(tnames)){
  #   warning('All samples must be matched for blocking analysis')
  #   return(res)	
  #}  	 
  
  newt <- targets
  for(i in 1:nrow(targets)) {
    idx <- match(tnames[i],snames)
    newt[idx,] <- targets[i,]	
  }
  targets <- newt
  rownames(targets) <- snames
  
  colnames(targets) <- c("group",blockList[[1]]$attribute)
  
  targets <- data.frame(targets)
  targets[[1]] <- factor(targets[[1]])
  targets[[2]] <- factor(targets[[2]])
  
  return(targets)
  
}

pv.normFactors <- function(pv,bMinus=FALSE,bFullLib=TRUE) {
  if(length(pv$peaks)<2) {
    warning('Unable to TMM normalize -- not enough peaksets',call.=FALSE)
    return(pv)   
  }
  g1     <- rep(FALSE,length(pv$peaks))
  g1[1]  <- TRUE
  
  savenames <- pv$class[PV_ID,]
  pv$class[PV_ID,] <- 1:ncol(pv$class)
  res    <- pv.DEedgeR(pv,g1,!g1,"1","2",bSubControl=bMinus,bFullLibrarySize=bFullLib,bNormOnly=TRUE)
  return(res$samples$norm.factors)
}

pv.stripDBA <- function(conrec) {
  if(!is.null(conrec$edgeR)) {
    conrec$edgeR  <- pv.stripEdgeR(conrec$edgeR)
  }
  
  if(!is.null(conrec$DESeq2)) {
    conrec$DESeq2 <- pv.stripDESeq2(conrec$DESeq2)
  }
  
  return(conrec)
}


pv.normLibsize <- function(pv, score) {
  
  if (score == PV_SCORE_READS_MINUS_FULL ||
      score == PV_SCORE_READS_MINUS_EFFECTIVE) {
    minus <- TRUE
  } else {
    minus <- FALSE
  }
  
  counts <- matrix(0, nrow(pv$peaks[[1]]), length(pv$peaks))
  for (i in 1:length(pv$peaks)) {
    if (minus) {
      counts[, i] <- pv$peaks[[i]]$Reads - pv$peaks[[i]]$cReads
    } else {
      counts[, i] <- pv$peaks[[i]]$Reads
    }
  }
  
  if (score == PV_SCORE_READS_MINUS_FULL ||
      score == PV_SCORE_READS_FULL) {
    libsize <- as.numeric(pv$class[PV_READS, ])
  } else {
    libsize <- colSums(counts)
  }
  
  normfacs <- libsize / min(libsize)
  counts <- t(t(counts) / normfacs)
  
  return(counts)
}

pv.designAnalysis <- function(pv, method, tagwise=TRUE, bParallel=TRUE) {
  
  reslist <- NULL
  if(bParallel && (pv$config$parallelPackage > 0)) {
    pv <- dba.parallel(pv)
    reslist <- dba.parallel.lapply(pv$config,NULL,method,
                                   pv.designAnalysis_parallel,pv,
                                   tagwise)
  } else {
    reslist <- NULL
    for(meth in method) {
      reslist <- pv.listadd(reslist,pv.designAnalysis_parallel(meth,pv,tagwise))
    }
  }
  
  for(i in 1:length(method)) {
    if(method[i] == DBA_EDGER) {
      pv$edgeR <- reslist[[i]]
    } else if(method[i] == DBA_DESEQ2) {
      pv$DESeq2 <- reslist[[i]]
    }
  }
  
  return(pv)
}

pv.designAnalysis_parallel <- function(method,pv,tagwise) {
  
  if(method == DBA_EDGER) {
    res <- pv.edgeRdesign(pv,bSubControl=pv$norm$edgeR$bSubControl,
                          bTagwise=tagwise,
                          existing=pv$edgeR,
                          filter=pv$norm$edgeR$filter.val,
                          filterFun=pv$norm$edgeR$filter.fun)
  } else if(method == DBA_DESEQ2) {
    res <- pv.DESeq2design(pv,bSubControl=pv$norm$DESeq2$bSubControl,
                           existing=pv$DESeq2,
                           filter=pv$norm$DESeq2$filter.val,
                           filterFun=pv$norm$DESeq2$filter.fun)
  }
  return(res)
}

pv.getMethod <- function(str) {   
  if (str == "DBA_EDGER" || str == DBA_EDGER) {
    ret=DBA_EDGER
  } else if (str == "DBA_EDGER_GLM" || str == DBA_EDGER_GLM) {
    ret=DBA_EDGER_GLM  
  } else  if (str == "DBA_DESEQ2" || str == DBA_DESEQ2) {
    ret=DBA_DESEQ2 
  } else ret <- NULL
  return(ret)
}

pv.checkConsensusRows <- function(pv){
  for(i in 1:length(pv$peaks)) {
    rownames(pv$peaks[[i]]) <- 1:nrow(pv$peaks[[i]])
  }
  rownames(pv$binding) <- 1:nrow(pv$binding)
  return(pv)
}

#####################################
## pv_helper.R -- support for pv   ##
## 20 October 2009                 ##
## 3 February 2011 -- packaged     ##
## Rory Stark                      ##
## Cancer Research UK              ##
#####################################

#########################
## pv HELPER FUNCTIONS ##
#########################

pv.check <- function(pv,bCheckEmpty=FALSE,bCheckSort=TRUE,bDoVectors=TRUE) {
  
  if(missing(pv)) {
    stop('DBA object missing!',call.=FALSE)
  }
  
  if(is.null(pv)) {
    return(NULL)	
  }
  
  if(is(pv,"ChIPQCexperiment")){
    saveqc <- pv
    pv <- pv@DBA
    x <- "DBA object placeholder"
    class(x) <- "DBA"
    saveqc@DBA <- x
    pv$ChIPQCobj <- saveqc
  }
  
  if(is.null(pv$peaks)) {
    return(pv)	
  }
  
  if(bCheckEmpty && sum(sapply(pv$peaks,nrow))==0) {
    stop('DBA object has no peaks.',call.=FALSE)
  }
  if(!is.null(pv$vectors)) {
    if(!is.null(pv$allvectors)) {
      pv$binding     <- pv$vectors
      pv$totalMerged <- do.nrow(pv$allvectors)
      pv$merged      <- pv$allvectors[,1:3]
    } else {
      pv$binding     <- pv$vectors
      pv$merged      <- pv$vectors[,1:3]
      pv$totalMerged <- do.nrow(pv$merged)
    }
    pv$vectors    <- NULL
    pv$allvectors <- NULL
  }
  
  if(is.null(pv$binding)) {
    if(is.null(pv$minOverlap)) {
      minOverlap=2
    } else {
      minOverlap <- pv$minOverlap
    }
    if(bDoVectors) {
      contrasts  <- pv$contrasts
      called     <- pv$called
      allcalled  <- pv$allcalled
      attributes <- pv$attributes
      for(i in 1:length(pv$peaks)) {
        if(is.factor(pv$peaks[[i]][,1])) {
          pv$peaks[[i]][,1] <- as.character(pv$peaks[[i]][,1])
        }
      }
      pv <- pv.vectors(pv,minOverlap=minOverlap,bAllSame=pv.allSame(pv),
                       merge=is.null(pv$merged))
      pv$contrasts  <- contrasts
      pv$called     <- called
      pv$allcalled  <- allcalled
      pv$attributes <- attributes
    }
  }
  
  pv <- pv.checkCalled(pv)
  
  if(is.null(pv$config$DataType)) {
    pv$config$DataType=DBA_DATA_DEFAULT
    if(!is.null(pv$config$RangedData)) {
      if(pv$config$RangedData==FALSE) {
        pv$config$DataType <- DBA_DATA_FRAME   	
      } 
    }
  }
  
  if(is.null(pv$config$bCorPlot)) {
    pv$config$bCorPlot <- FALSE
  }
  
  if(is(pv$attributes,"function")) {
    pv$attributes <- NULL
  }
  
  if(is.null(pv$config$th)){
    pv$config$th <- 0.05
  }
  if(is.null(pv$config$bUsePval)){
    pv$config$bUsePval <- FALSE
  }   
  
  if(nrow(pv$class)<PV_TREATMENT) {
    pv$class <- rbind(pv$class,'')
    rownames(pv$class)[PV_TREATMENT]='Treatment'	
  }
  
  pv$config <- as.list(pv$config)
  
  if (is.null(pv$config$mapQCth)) {
    pv$config$mapQCth <- 15   
  }
  
  if (is.null(pv$config$fragmentSize)) {
    pv$config$fragmentSize <- 125
  }   
  
  if(bCheckSort && is.unsorted(pv$chrmap)) {
    message("Older version of DBA object. Recommend running DBA <- dba(DBA).")
    message('Converting...')
    pv <- dba(pv)
  }
  
  if(nrow(pv$class) < PV_SPIKEIN) {
    pv$class <- rbind(pv$class, Spikein=NA)
  }
  
  if(pv.checkValue(pv$resultObject,FALSE)) {
    if( (sum(duplicated(colnames(pv$class))) > 0) ||
        (sum(duplicated(pv$class[DBA_ID,]))  > 0) ){
      stop("All samples much have unique SampleIDs.", call.=FALSE)
    }
  }
  
  return(pv)
}

pv.version <- function(pv,v1,v2,v3){
  
  warn <- FALSE
  if(is.null(pv$config$Version1)) {
    warn <- TRUE   	
  } else {
    if(pv$config$Version1 != v1) {
      warn <- TRUE   	
    }	
  }
  if(is.null(pv$config$Version2)) {
    warn <- TRUE   	
  } else {
    if(pv$config$Version2 != v2) {
      warn <- TRUE   	
    }	
  }
  
  if(warn) {
    warning('Loading DBA object from a previous version -- updating...',call.=FALSE)
  }
  
  if(!is.null(pv$contrasts)) {
    for(i in 1:length(pv$contrasts)) {
      if(!is.null(pv$contrasts[[i]]$DESeq) & is.null(pv$contrasts[[i]]$DESeq1)
         & is.null(pv$contrasts[[i]]$DESeq2)) {
        pv$contrasts[[i]]$DESeq1 <- pv$contrasts[[i]]$DESeq
        pv$contrasts[[i]]$DESeq  <- NULL
      }
    }   
  }
  
  if(nrow(pv$class)<PV_TREATMENT) {
    pv$class <- rbind(pv$class,'')
    rownames(pv$class)[PV_TREATMENT]='Treatment'	
  }
  
  if(is.unsorted(pv$chrmap)) {
    pv <- dba(pv)
  }
  
  pv$config$Version1 <- v1
  pv$config$Version2 <- v2
  pv$config$Version3 <- v3   	
  
  return(pv)
}

checkQCobj <- function(resQC,res) {
  ## add better checks that objects are in sync
  sampnames <- unique(c(unique(res$class[PV_ID,]),unique(res$class[PV_CONTROL,])))
  sampnames <- sampnames[!is.na(sampnames)]
  sampnames <- sampnames[sampnames!=""]
  if (sum(sampnames %in% names(resQC@Samples))==length(sampnames)) {
    if(length(sampnames) == length(names(resQC@Samples))) {
      resQC@DBA <- res
    } else resQC=NULL
  } else resQC= NULL
  if(is.null(resQC)) {
    warning("ChIPQexperiment out of sync -- returning new DBA object",call.=FALSE)
    return(res)
  } else {
    return(resQC)
  }
}

pv.whichPeaksets <- function(pv,mask) {
  
  if(missing(mask)) {
    warning('mask required',call.=FALSE)
    return(NULL)
  }
  if(is.null(mask)) {
    warning('mask required',call.=FALSE)
    return(NULL)
  }
  if(is(mask,'logical')) {
    mask <- which(mask)
  }
  
  A <- mask[1]
  B <- mask[2]
  if(length(mask) >= 3) {
    C <- mask[3]
  } else {
    C <- NULL
  }
  if(length(mask) >= 4) {
    D <- mask[4]
  } else {
    D <- NULL
  }   
  
  return(list(A=A,B=B,C=C,D=D))
}

pv.listadd <- function(a,b){
  b <- list(b)
  if (is.null(a)) return(b)
  return(c(a,b))
}

pv.listaddto <- function(a,b){
  if (is.null(a)) return(b)
  return(c(a,b))
}

fdebug <- function(str,file='debug.txt'){
  
  PV_DEBUG=FALSE
  
  if(PV_DEBUG == FALSE){
    return()
  }
  
  #write(sprintf('%s\n',str),file=file,append=TRUE)
  
}

pv.peaksort <- function(peaks,chrmap) {
  if(is.character(peaks[1,1])) {
    chrs <- TRUE
    if(missing(chrmap)) {
      chrmap <- sort(unique(peaks[,1]))
    }
    peaks[,1] <- match(peaks[,1],chrmap)
  } else chrs=FALSE
  
  if(nrow(peaks) < 2) {
    return(peaks)
  }
  
  o <- peakOrder(peaks[,1],as.integer(peaks[,2]),as.integer(peaks[,3]))
  peaks <- peaks[o,]
  if(chrs) {
    peaks[,1] <- chrmap[peaks[,1]]
  }
  pv.gc()
  return(peaks)
}

pv.contrast2 <- function(peaks,A,B,v1,v2){
  
  allpeaks <- v1 | v2
  inAll    <- v1 & v2
  onlyA    <- v1 & !v2
  onlyB    <- !v1 & v2
  
  res <- list(onlyA=data.frame(peaks[onlyA,c(1:3,(3+A))]),
              onlyB=data.frame(peaks[onlyB,c(1:3,(3+B))]),
              inAll=data.frame(peaks[inAll,c(1:3,(3+A),(3+B))]))
  
  for(i in 1:3){
    if(is.null(nrow(res[[i]]))){
      res[[i]] <- data.frame(t(res[[i]]))
    }
  }
  
  colnames(res[[1]]) <- c("chr","start","end","score")	
  colnames(res[[2]]) <- c("chr","start","end","score")	
  colnames(res[[3]]) <- c("chr","start","end","scoreA","scoreB")	
  
  return(res)   	
}

pv.contrast3 <- function(peaks,A,B,C,v1,v2,v3){
  
  allpeaks <- v1 | v2 | v3
  
  inAll  <-  v1 &  v2 &  v3
  onlyA  <-  v1 & !v2 & !v3
  onlyB  <- !v1 &  v2 & !v3 
  onlyC  <- !v1 & !v2 &  v3
  
  notA   <- !v1 &  (v2 & v3)
  notB   <- !v2 &  (v1 & v3)
  notC   <- !v3 &  (v1 & v2)    
  
  res <- list(onlyA=data.frame(peaks[onlyA,c(1:3,(3+A))]),
              onlyB=data.frame(peaks[onlyB,c(1:3,(3+B))]),
              onlyC=data.frame(peaks[onlyC,c(1:3,(3+C))]),
              notA =data.frame(peaks[notA,c(1:3,(3+B),(3+C))]),              
              notB =data.frame(peaks[notB,c(1:3,(3+A),(3+C))]), 
              notC =data.frame(peaks[notC,c(1:3,(3+A),(3+B))]), 
              inAll=data.frame(peaks[inAll,c(1:3,(3+A),(3+B),(3+C))]))
  
  for(i in 1:7){
    if(is.null(nrow(res[[i]]))){
      res[[i]] <- data.frame(t(res[[i]]))
    }
  }	
  
  colnames(res[[1]]) <- c("chr","start","end","score")	
  colnames(res[[2]]) <- c("chr","start","end","score")	
  colnames(res[[3]]) <- c("chr","start","end","score")	
  colnames(res[[4]]) <- c("chr","start","end","scoreB","scoreC")
  colnames(res[[5]]) <- c("chr","start","end","scoreA","scoreC")
  colnames(res[[6]]) <- c("chr","start","end","scoreA","scoreB")
  colnames(res[[7]]) <- c("chr","start","end","scoreA","scoreB","scoreC")
  
  return(res)
}

pv.contrast4 <- function(peaks,A,B,C,D,v1,v2,v3,v4){
  
  allpeaks <- v1 | v2 | v3 | v4
  
  inAll  <-  v1 &  v2 &  v3 & v4
  onlyA  <-  v1 & !v2 & !v3 & !v4
  onlyB  <- !v1 &  v2 & !v3 & !v4
  onlyC  <- !v1 & !v2 &  v3 & !v4
  onlyD  <- !v1 & !v2 & !v3 & v4
  
  notA   <- !v1 &  (v2 & v3 & v4)
  notB   <- !v2 &  (v1 & v3 & v4)
  notC   <- !v3 &  (v1 & v2 & v4)
  notD   <- !v4 &  (v1 & v2 & v3)      
  
  AandB  <- (v1 & v2) & !(v3 | v4)
  AandC  <- (v1 & v3) & !(v2 | v4)
  AandD  <- (v1 & v4) & !(v2 | v3)
  BandC  <- (v2 & v3) & !(v1 | v4)
  BandD  <- (v2 & v4) & !(v1 | v3)
  CandD  <- (v3 & v4) & !(v1 | v2)     
  
  res <- list(onlyA=data.frame(peaks[onlyA,c(1:3,(3+A))]),
              onlyB=data.frame(peaks[onlyB,c(1:3,(3+B))]),
              onlyC=data.frame(peaks[onlyC,c(1:3,(3+C))]),
              onlyD=data.frame(peaks[onlyD,c(1:3,(3+D))]),
              AandB=data.frame(peaks[AandB,c(1:3,(3+A),(3+B))]),
              AandC=data.frame(peaks[AandC,c(1:3,(3+A),(3+C))]),
              AandD=data.frame(peaks[AandD,c(1:3,(3+A),(3+D))]),
              BandC=data.frame(peaks[BandC,c(1:3,(3+B),(3+C))]),
              BandD=data.frame(peaks[BandD,c(1:3,(3+B),(3+D))]),
              CandD=data.frame(peaks[CandD,c(1:3,(3+C),(3+D))]),
              notA =data.frame(peaks[notA, c(1:3,(3+B),(3+C),(3+D))]),              
              notB =data.frame(peaks[notB, c(1:3,(3+A),(3+C),(3+D))]), 
              notC =data.frame(peaks[notC, c(1:3,(3+A),(3+B),(3+D))]),
              notD =data.frame(peaks[notD, c(1:3,(3+A),(3+B),(3+C))]), 
              inAll=data.frame(peaks[inAll,c(1:3,(3+A),(3+B),(3+C),(3+D))]))
  
  for(i in 1:15){
    if(is.null(nrow(res[[i]]))){
      res[[i]] <- data.frame(t(res[[i]]))
    }
  }	
  
  colnames(res[[1]])  <- c("chr","start","end","score")	
  colnames(res[[2]])  <- c("chr","start","end","score")	
  colnames(res[[3]])  <- c("chr","start","end","score")	
  colnames(res[[4]])  <- c("chr","start","end","score")
  colnames(res[[5]])  <- c("chr","start","end","scoreA","scoreB")
  colnames(res[[6]])  <- c("chr","start","end","scoreA","scoreC")
  colnames(res[[7]])  <- c("chr","start","end","scoreA","scoreD")
  colnames(res[[8]])  <- c("chr","start","end","scoreB","scoreC")   
  colnames(res[[9]])  <- c("chr","start","end","scoreB","scoreD") 
  colnames(res[[10]]) <- c("chr","start","end","scoreC","scoreD")
  colnames(res[[11]]) <- c("chr","start","end","scoreB","scoreC","scoreD")    
  colnames(res[[12]]) <- c("chr","start","end","scoreA","scoreC","scoreD")       
  colnames(res[[13]]) <- c("chr","start","end","scoreA","scoreB","scoreD")    
  colnames(res[[14]]) <- c("chr","start","end","scoreA","scoreB","scoreC")      
  colnames(res[[15]]) <- c("chr","start","end","scoreA","scoreB","scoreC","scoreD")
  
  return(res)
}


pv.analysis <- function(pv,attributes=pv$attributes,bPCA=TRUE,distMeth="pearson") {
  
  #require(amap)
  
  peaks  <- pv$binding 
  values <- matrix(as.numeric(as.matrix(peaks[,4:ncol(peaks)])),nrow(peaks),ncol(peaks)-3)
  
  if(sum(pv$binding[,4:ncol(pv$binding)] != 1) == 0) {
    return(pv)
  }
  
  if(sum(pv$binding[,4:ncol(pv$binding)] != -1) == 0) {
    return(pv)
  }
  
  if(nrow(peaks) <= length(pv$peaks) ) {
    bPCA <- FALSE
  }
  #values <- unique(values)
  cnames=NULL
  for(i in 1:ncol(pv$class)) {
    cnames <- c(cnames,pv.namestrings(pv$class[attributes,i])$tstring)
  }
  colnames(values) <- cnames
  x <- apply(values,1,pv.howmany)
  values <- values[x>1,]
  #pv$hc <- hclust(Dist(t(values),method=distMeth))
  if(bPCA) pv$pc <- princomp(values)
  #pv$values <- values
  
  return(pv)  
}

pv.howmany <- function(vals){
  return(sum(vals>0))	
}


pv.readPeaks <- function(peaks,peak.format,skipLines=0){
  if(peak.format == "macs") {
    peaks <- pv.macs(peaks)
  } 
  else if(peak.format == "bayes") {
    peaks <- pv.bayes(peaks)
  }
  else if(peak.format == "swembl") {
    peaks <- pv.swembl(peaks)
  } 
  else if(peak.format == "raw") {
    peaks <- pv.readbed(peaks,checkHeader=TRUE)
  } 
  else if(peak.format == "fp4") {
    peaks <-  pv.readbed(peaks,1)
  } 
  else if(peak.format == "bed") {
    peaks <-  pv.readbed(peaks,checkHeader=TRUE)
  } 
  else if(peak.format == "tpic") {
    peaks <-  pv.tpic(peaks)
  } 
  else if(peak.format == "sicer") {
    peaks <-  pv.sicer(peaks)
  }    
  else if(peak.format == "narrow") {
    peaks <-  pv.readbed(peaks,skipLines)
  } 
  #else if(peak.format == "raw") {
  #   peaks <-  pv.readbed(peaks,skipLines)
  #}  
  else if(peak.format == "csv") {
    peaks <-  pv.csv(peaks)
  }  else if(peak.format == "report") {
    peaks <-  pv.csv(peaks)
  } else {
    peaks <-  pv.readbed(peaks,skipLines)      
  }     
}

pv.defaultScoreCol <- function(peak.format){
  if(is.null(peak.format)) {
    return(0)
  }
  if(peak.format == "macs") {
    val <- 7
  } 
  else if(peak.format == "bayes") {
    val <- 0
  }
  else if(peak.format == "swembl") {
    val <- 4
  } 
  else if(peak.format == "raw") {
    val <- 4
  } 
  else if(peak.format == "fp4") {
    val <- 5
  } 
  else if(peak.format == "bed") {
    val <- 5
  } 
  else if(peak.format == "tpic") {
    val <- 0
  } 
  else if(peak.format == "sicer") {
    val <- 7
  }    
  else if(peak.format == "narrow") {
    val <- 8
  } 
  else if(peak.format == "raw") {
    val <- 4
  } else if(peak.format == "csv") {
    val <- 4
  } else if(peak.format == "report") {
    val <- 9
  } else {
    val <- 4 	
  } 
  return(val)    
}


FDRth=100
pv.macs <- function(fn){
  data <- read.table(fn,blank.lines.skip=TRUE,header=TRUE)
  res  <- pv.peaksort(data)
  return(res)
}

pv.swembl <- function(fn){
  data <- read.table(fn,skip=14)
  res  <- pv.peaksort(data)
  return(res) 
}

hasHeader <- function(fn) {
  line <- readLines(fn,n=1)
  flds <- strsplit(line,"\\s")
  f2 <- suppressWarnings(as.numeric(flds[[1]][2]))
  f3 <- suppressWarnings(as.numeric(flds[[1]][3]))
  return(is.na(f2) || is.na(f3))
}

pv.readbed <- function(fn,skipnum=0,checkHeader=FALSE){
  if (checkHeader) {
    skipnum <- if (hasHeader(fn)) 1 else 0
  }
  data <- read.table(fn,skip=skipnum)
  res  <- pv.peaksort(data)
  if(ncol(res)==3) {
    res=cbind(res,1)   
  }
  return(res)
}

pv.bayes <- function(fn){
  data <- read.table(fn)
  #idx <- data[,4]>0.5
  #data <- data[idx,]
  res  <- pv.peaksort(data)
  return(res)
}

pv.tpic <- function(fn){
  data <- read.table(fn)
  res  <- pv.peaksort(data)
  return(cbind(res,1))
}

pv.sicer <- function(fn){
  data <- read.table(fn)
  res  <- pv.peaksort(data)
  return(res[,c(1:3,7)]) 
}

# pv.sourcedata <- function(fn,maxval){
#    data <- read.table(fn)
#    vals <- data[,6]
#    if(!missing(maxval)) {
#       vals[vals>maxval]=maxval
#    }
#    #vals <- vals/100
#    vals <- log2(vals)
#    vals[vals<0]=0
#    data <- cbind(data[,1:3],vals,data[,4:5])
#    data <- pv.peaksort(data)
#    return(data)
# }

pv.csv <- function(fn){
  data <- read.csv(fn)
  res  <- pv.peaksort(data)
  if(ncol(res)==3) {
    res=cbind(res,1)	
  }
  return(res)
}

pv.checkCounts <- function(pv,pv2=NULL) {
  callers <- unique(pv$class[PV_CALLER,])
  if(length(callers)>1) {
    return(FALSE)
  }
  if (callers != "counts") {
    return(FALSE)
  }
  if(!is.null(pv2)) {
    if(!pv.checkCounts(pv2)) {
      return(FALSE)
    }
    if(do.nrow(pv$binding) != do.nrow(pv2$binding)) {
      return(FALSE)
    }
  }
  return(TRUE)
}

pv.peakset_all <- function(pv, addpv, minOverlap) {
  
  
  allcounts <- pv.checkCounts(pv,addpv)
  
  for(i in 1:length(addpv$peaks)) {
    
    message(addpv$class[PV_ID,i],' ',
            addpv$class[PV_TISSUE,i],' ',
            addpv$class[PV_FACTOR,i],' ',
            addpv$class[PV_CONDITION,i],' ',
            addpv$class[PV_TREATMENT,i],' ',
            addpv$class[PV_REPLICATE,i],' ',
            addpv$class[PV_CALLER,i])
    
    pv <- pv.peakset(pv,peaks=addpv$peaks[[i]],
                     sampID      = addpv$class[PV_ID,i],
                     tissue      = addpv$class[PV_TISSUE,i],
                     factor      = addpv$class[PV_FACTOR,i],
                     condition   = addpv$class[PV_CONDITION,i],
                     treatment   = addpv$class[PV_TREATMENT,i],
                     replicate   = addpv$class[PV_REPLICATE,i],
                     control     = addpv$class[PV_CONTROL,i],
                     peak.caller = addpv$class[PV_CALLER,i],
                     reads       = addpv$class[PV_READS,i],
                     consensus   = addpv$class[PV_CONSENSUS,i],
                     readBam     = addpv$class[PV_BAMREADS,i],
                     controlBam  = addpv$class[PV_BAMCONTROL,i],
                     spikein     = addpv$class[PV_SPIKEIN,i]
    )
  }
  
  if(minOverlap>0 && minOverlap<1) {
    minOverlap <- ceiling(length(pv$peaks) * minOverlap)	
  }
  if(allcounts) {
    pv <- pv.vectors(pv,minOverlap=minOverlap,
                     attributes=attributes,
                     bAllSame=TRUE)
  } else {
    pv <- dba(pv, minOverlap=minOverlap)
  }
  
  return(pv)
  
}

pv.minOverlap <- function(vec,minval){
  res <- sum(vec != -1)
  if(minval==0) {
    if (length(vec) == res) {
      return(TRUE)
    } else {
      return(FALSE)
    }
  } else {
    if(res >= minval) {
      return(TRUE)
    } else {
      return(FALSE)
    }
  }	
}

pv.countOverlap <- function(vec,minval= -1){
  res <- sum(vec > minval)
  return(res)
}

pv.domean <- function(vals){
  return(mean(vals[vals>0]))	
}

pv.do_peaks2bed <- function(peaks,chrmap=NULL,fn,numCols=4) {
  peaks <- data.frame(peaks)
  if(!is.null(chrmap)) {
    peaks[,1] <- chrmap[peaks[,1]]
  }
  if(numCols>0) {
    numCols <- max(3,numCols)
    mcols <- min(numCols, ncol(peaks))
  } else {
    mcols <- ncol(peaks)
  }
  
  if(!is.null(fn)) {
    ds <- options("scipen")
    options(scipen=8)
    write.table(peaks[,1:mcols],file=fn,#sprintf("%s.bed",fn), 
                quote=FALSE,row.names=FALSE,col.names=FALSE,sep="\t")
    options(scipen=ds$scipen)
  }
  return(peaks[,1:mcols])
}

pv.catstr <- function(strvec){
  unq <- unique(strvec)
  if(length(unq) == 1){
    return(unq)
  }
  str <- unq[1]
  for(i in 2:length(unq)){
    str <- sprintf("%s-%s",str,unq[i])	
  }
  return(str)	
}

pv.namestrings <- function(crec1,crec2,crec3,crec4) {
  s1 <- NULL
  s2 <- NULL
  s3 <- NULL
  s4 <- NULL
  t1 <- NULL
  if(missing(crec2)) {
    crec2=crec1
  }
  if(missing(crec3)) {
    crec3=crec1   
  }
  if(missing(crec4)) {
    crec4=crec1
  }
  for(i in 1:length(crec1)) {
    if( (crec1[i]==crec2[i]) && (crec1[i]==crec3[i]) && (crec1[i]==crec4[i])) {
      t1 <- pv.addstr(t1,crec1[i])
    } else {
      s1 <- pv.addstr(s1,crec1[i])
      s2 <- pv.addstr(s2,crec2[i])
      s3 <- pv.addstr(s3,crec3[i])
      s4 <- pv.addstr(s4,crec4[i])
    }
  }
  if(is.null(s1)) { s1 <- ""}
  if(is.null(s2)) { s2 <- ""}
  if(is.null(s3)) { s3 <- ""}
  if(is.null(s4)) { s4 <- ""}
  if(is.null(t1)) { t1 <- ""}
  
  return(list(n1=s1,n2=s2,n3=s3,n4=s4,tstring=t1))	
}

pv.addstr <- function(s1,a1) {
  if(is.null(a1)) {
    return(s1)
  } else if (a1 == "") {
    return(s1)
  }
  
  if(a1=="T") {
    a1 <- "TRUE"
  }
  if(a1=="F") {
    a1 <- "FALSE"
  }
  
  if(is.null(s1)){
    s1 <- a1
  } else {
    s1 <- sprintf("%s:%s",s1,a1)
  }
  return(s1)	
}

pv.merge <- function(allpeaks,peaks=NULL,classes,maxgap=-1,
                     useExternal=TRUE,useC=TRUE, defVal=0){
  
  if(!useC) {
    stop('pv.dovectors called with useC set to FALSE.')	
  }
  
  allpeaks <- as.data.frame(allpeaks)
  
  chrmap <- sort(unique(allpeaks[,1]))
  allpeaks[,1] <- match(allpeaks[,1],chrmap)
  colnames(allpeaks) <- c("CHR","START","END")
  allpeaks <- pv.peaksort(allpeaks)
  allpeaks$CHR   <- as.integer(allpeaks$CHR)
  allpeaks$START <- as.integer(allpeaks$START)
  allpeaks$END   <- as.integer(allpeaks$END)
  maxGap <- as.integer(maxgap)
  merged <- mergePeaks(allpeaks,maxGap)
  
  included     <- matrix(0,nrow(merged),length(peaks))
  result       <- matrix(defVal,nrow(merged),length(peaks)+3)
  result[,1:3] <- as.matrix(merged[,1:3])
  def <- rep(defVal,nrow(merged))
  if(length(peaks)>0) {
    for(i in 1:length(peaks)) {
      peakset <- peaks[[i]][,1:4]
      if(nrow(peakset > 0)) {
        peakset[,1] <- match(peakset[,1],chrmap)
        if(is.unsorted(unique(peakset[,1]))) {
          peakset <- pv.peaksort(peakset)
        }
        res <- mergeScores(merged,def,peakset,TRUE)
        result[,i+3] <- res$score
        included[,i] <- res$included
      }
    }
    #included <- pv.called(merged, chrmap, peaks)
  }
  
  colnames(result) <- rep("",ncol(result))
  colnames(result)[1:3] <- c("CHR","START","END")
  if(ncol(result)>3) {
    colnames(result)[4:ncol(result)] <- colnames(classes)
  }
  
  pv.gc()
  return(list(merged=result,included=included, chrmap=chrmap))
}

pv.called <- function(merged, chrmap, peaks) {
  if(!is(merged,"GRanges")) {
    colnames(merged) <- c("chr","start","end")
    merged[,1] <- chrmap[merged[,1]]
    merged <- GRanges(merged)
  }
  called <- NULL
  for(i in 1:length(peaks)) {
    called <- cbind(called, merged %over% GRanges(peaks[[i]]))
  }
  called[called==TRUE] <- 1
  return(called)
}

pv.CalledMasks <- function(pv,newpv,master) {
  master <- cbind(master[,1:3],1)
  spare <- pv.peakset(pv,master,peak.caller='raw',scoreCol=4,bLowerScoreBetter=FALSE)
  spare <- pv.model(spare)
  res   <- pv.list(spare,spare$masks$counts)
  masternum <- length(spare$peaks)
  resl <- NULL
  for(i in 1:nrow(res)) {
    sampl <- pv.matchingSamples(res[i,1],spare$class)
    sampvec <- rep(FALSE,nrow(master))
    for(samp in sampl) {
      sampvec <- sampvec | pv.whichCalled(spare,samp,masternum)
    }
    resl <- pv.listadd(resl,sampvec)      
  }
  names(resl) <- res$ID
  return(resl)
}

pv.matchingSamples <- function(id,classes) {
  res <- which(!classes[PV_CALLER,] %in% "counts" & classes[PV_ID,] %in% id)
  return(res)  
}

pv.whichCalled <- function(pv,called,master,minVal=-1) {
  called <- pv$binding[,called+3] > minVal
  master <- pv$binding[,master+3] > minVal
  res <- called[master]     	
  return(res)
}


## pv.pairs -- compare all pairs of peaksets, rank by % overlap
pv.pairs <- function(pv,mask,bPlot=FALSE,attributes=pv$attributes,bAllVecs=TRUE,
                     CorMethod="pearson",bCorOnly=FALSE,bNonZeroCors=FALSE,minVal=0,bFixConstantVecs=TRUE) {
  
  if(missing(mask)) {
    mask=rep(TRUE,ncol(pv$class))
    peaks <- pv$peaks
  } else {
    peaks <- NULL
    for(i in 1:length(mask)){
      if(mask[i]) {
        peaks <- pv.listadd(peaks,pv$peaks[[i]])
      }
    }
  }
  
  tmp <- NULL
  if(bAllVecs==TRUE) {
    if(pv$totalMerged != do.nrow(pv$binding)) {
      pv <- pv.vectors(pv,minOverlap=1)  
    }
  }
  
  tmp$binding    <- pv$binding[,c(TRUE,TRUE,TRUE,mask)]
  tmp$class      <- pv$class[,mask]
  tmp$peaks      <- peaks
  tmp$chrmap     <- pv$chrmap
  tmp$totalMerged <- pv$totalMerged
  tmp$called      <- pv$called[,mask]
  if(!is.null(tmp$allcalled)) {
    tmp$allcalled      <- pv$allcalled[,mask]
  } else {
    tmp$allcalled <- NULL
  }
  
  numSets <- sum(mask)
  resm <- NULL
  resl <- NULL
  cvecs <- NULL
  for(first in 1:(numSets-1)) {
    if(bCorOnly==FALSE){
      #cat(".")
    }
    for(second in (first+1):numSets) {
      if(!bCorOnly) {
        res  <- pv.overlap(tmp,mask=c(first,second),minVal=minVal)
        resl <- pv.listadd(resl,res)
        inall <- nrow(res$inAll)
        onlya <- nrow(res$onlyA)
        onlyb <- nrow(res$onlyB)
        prop <- inall / (inall + onlya + onlyb)
      } else {
        inall <- 0
        onlya <- 0
        onlyb <- 0
        prop  <- 0
      }
      v1 <- tmp$binding[,first+3]
      v2 <- tmp$binding[,second+3]
      if(bNonZeroCors) {
        zeros <- v1==0 & v2==0
        v1 <- v1[!zeros]
        v2 <- v2[!zeros]
      }
      if(bFixConstantVecs) {
        if(sd(v1)==0) {
          #fval <- v1[1]
          #v1[1] <- fval+.000001
          #v1[2] <- fval-.000001
          cvecs <- c(cvecs,colnames(tmp$binding)[first+3])	
        }
        if(sd(v2)==0) {
          #fval <- v2[1]
          #v2[1] <- fval+.000001
          #v2[2] <- fval-.000001
          cvecs <- c(cvecs,colnames(tmp$binding)[second+3])	
        }		
      }
      if(sd(v1) && sd(v2)) {
        corval <- cor(v1,v2,method=CorMethod)
      } else corval <- 0
      resm <- rbind(resm,c(which(mask)[first],which(mask)[second],
                           onlya,onlyb,inall,corval,prop))
    }
  }
  if(bCorOnly==FALSE) {
    #cat("\n")
  }
  cvecs <- unique(cvecs)
  if(!is.null(cvecs)) {
    cvecs <- sort(cvecs)
    for(cv in cvecs) {
      #          warning(sprintf('Scores for peakset %s are all the same -- correlations set to zero.',cv),call.=FALSE)	
    }	
  }
  
  o <- order(resm[,7],decreasing=TRUE)
  colnames(resm) <- c("A","B","onlyA","onlyB","inAll","Cor","Overlap")
  
  if(bPlot & !bCorOnly){
    warning('Plotting in pv.occupancy unsupported',call.=FALSE)
    #for(i in 1:length(o)) {
    #	 recnum <- o[i]
    #   pv.PlotContrast(pv,resl[[recnum]],resm[recnum,1],resm[recnum,2],attributes=attributes)
    #}
  }
  
  return(resm[o,])	
}

pv.overlapToLabels <- function(pv,overlap,labelatts=PV_ID) {
  for(i in 1:nrow(overlap)) {
    overlap[i,1] <- pv.namestrings(pv$class[labelatts,as.numeric(overlap[i,1])])$tstring
    overlap[i,2] <- pv.namestrings(pv$class[labelatts,as.numeric(overlap[i,2])])$tstring
  }
  #overlap <- overlap[order(overlap[,1],overlap[,2]),]
  return(data.frame(overlap))
}

pv.orderfacs <- function(facvec,decreasing=FALSE) {
  res <- order(as.numeric(as.character(facvec)),decreasing=decreasing)
  return(res)	
}

pv.normalizeScores <- function(peaks,pCol,zeroVal=-1,bLog=FALSE,bDensity=FALSE){
  if(bDensity) {
    width   <- peaks[,3] - peaks[,2]
    width[width==0]=1
    density <- peaks[,pCol]/width 
    res <- density/max(density)
  } else {
    res <- peaks[,pCol]/max(peaks[,pCol])
  }
  if(bLog) {
    res <- log2(res)
    x <- res == -Inf
    res[x] <- 1
    res <- res - min(res)
    res[x] <- zeroVal
  } else {
    res[res == 0] <- zeroVal
  }
  return(res)
}

pv.activefun <- function(x){
  if(sum(x>0)>0){
    return(TRUE)
  } else {
    return(FALSE)
  }	
}

pv.addrow <- function(x,a,y){
  if(is.null(y)) return(x)
  nm <- nrow(y)
  if(is.null(nm)) return(rbind(x,a))
  if(nm == 0)     return(x)
  ncl <- length(a)
  return(rbind(x,matrix(a,nm,ncl,byrow=TRUE)))
}

pv.reorderM <- function(ocm,dgram) {
  lab <- rownames(ocm)	
  newlab <- rev(rapply(dgram,pv.dval))
  neword <- match(newlab,lab)
  newocm <- ocm[neword,]
  newocm <- newocm[,neword]
  return(newocm)
}
pv.dval <- function(dgram) {
  att <- attributes(dgram)
  if(!is.null(att$leaf)) {
    if(!is.null(att$label)) {
      if(att$leaf==TRUE) {
        return(att$label)
      }
    }
  }
}

pv.pcmask <- function(pv,numSites, mask, sites,removeComps,cor=FALSE,bLog=TRUE){
  
  if(missing(numSites)) numSites <- do.nrow(pv$binding)
  if(is.null(numSites)) numSites <- do.nrow(pv$binding)  
  numSites <- min(numSites,do.nrow(pv$binding))
  
  if(missing(sites)) sites <- 1:numSites
  if(is.null(sites)) sites <- 1:numSites
  
  if(missing(mask)) mask <- rep(TRUE,ncol(pv$class))
  for(i in which(mask)) {
    if(nrow(pv$peaks[[i]])==0) {
      mask[i] <- FALSE
    }
  }
  if(sum(mask)<2) {
    stop('Need at least two samples for PCA.',call.=FALSE)
  }
  
  res <- NULL   
  res$class <- pv$class
  pv$values <- pv$binding[sites,c(FALSE,FALSE,FALSE,mask)]
  active   <- apply(pv$values,1,pv.activefun)
  numSites <- min(numSites,sum(active))
  
  pv$values <- pv$values[active,][1:numSites,]
  
  if(!missing(removeComps)) {
    pv$values <- pv.removeComp(pv$values,numRemove=removeComps)
  }
  
  if(bLog) {
    if(max(pv$values)>1) {
      pv$values[pv$values<=1] <- 1
      pv$values <- log2(pv$values)
    }
  }
  
  if(nrow(pv$values) >= sum(mask)) {
    #res$pc <- prcomp(pv$values) #,cor=cor)
    res$pc <- prcomp(t(pv$values))
  }
  res$mask <- mask
  
  return(res)
}


pv.Signal2Noise <- function(pv) {
  sns <- rep("",length(pv$peaks))
  for(i in 1:length(sns)) {
    rip <- sum(pv$peaks[[i]]$Reads)
    treads <- as.integer(pv$class[PV_READS,i])
    if(!is.na(treads)) {
      if(treads > 0) {
        sn  <- (rip-sum(pv$peaks[[i]]$Reads==1))/treads
        sns[i] <- sprintf("%1.2f",sn)
      }	
    }
  }
  if(sum(as.numeric(sns) > 0,na.rm=TRUE)) {
    return(sns)  	
  } else {
    return(NULL)
  }
}


pv.checkSN <- function(pv) {
  if(!is(pv,"DBA")) {
    return(NULL)
  }
  
  if(pv.checkCounts(pv)) {
    if(is.null(pv$SN)) {
      SN <- pv.Signal2Noise(pv)
    } else {
      SN <- pv$SN
    }
  } else {
    SN <- NULL
  }
  
  return(SN)
}

pv.peaksetCounts <- function(pv=NULL,peaks=NULL,counts,
                             sampID="",tissue="",factor="",condition="",treatment="",replicate) {
  
  
  if(!is.null(pv$peaks)) {
    if(sum(!pv$class[PV_CALLER,] %in% "counts")) {
      stop("DBA object can only have count peaksets",call.=FALSE)	
    }	
  }
  
  IDs <- "counts"
  froms <- NULL
  tos   <- NULL
  if(is.null(dim(counts)) && length(counts)==1) { # filename
    counts <- read.table(counts,as.is=TRUE,fill=TRUE)
    counts <- counts[!is.na(counts[,2]),]
    if(ncol(counts) == 3) {
      if(sum(is.na(counts[,3]))==nrow(counts)) {
        counts <- counts[,1:2]
      }
    }
    #annotation <- as.character(counts[,1])
    #counts[,1] <- 1:nrow(counts)
  }
  if(!is.vector(counts)) {   
    numcols <- ncol(counts)
    if(numcols>1) {
      if(numcols == 2) {
        numcounts <- nrow(counts)
        footer <- match("Assigned",counts[,1])
        if(!is.na(footer)) {
          numcounts <- footer-1
        }
        IDs <- counts[1:numcounts,1]
        counts <- counts[1:numcounts,2]
        #annotation <- annotation[1:numcounts]
      } else if(numcols == 4) {
        IDs    <- counts[,1]
        froms  <- counts[,2]
        tos    <- counts[,3]
        counts <- counts[,4]	
        peaks  <- data.frame(cbind(IDs,froms,tos))
      } else {
        stop("Counts must have 1, 2, or 4 columns.",call.=FALSE)	
      }
    } else counts <- counts[,1]
  }
  
  if(!is.null(dim(counts))) {
    stop('counts must be vector of counts',call.=FALSE)	
  }
  numcounts <- length(counts)
  #if(length(peaks)>0) {
  #   warning('Specified peaks ignored',call.=FALSE)
  #}
  if(is.null(froms)) {
    froms <- tos <- 1:numcounts	
  }
  
  if(is.null(peaks)) {
    peaks <- data.frame(cbind(IDs,froms,tos))
  } else {
    if(is.na(peaks)[1]){
      peaks <- data.frame(cbind(IDs,froms,tos))     
    } else {
      if(is.null(nrow(peaks))) {
        peaks <- data.frame(cbind(IDs,froms,tos))
      } else {
        peaks <- data.frame(peaks[,1:3])
      }
    }
  }
  
  peaks <- cbind(peaks,counts,counts,rep(0,numcounts),counts,rep(0,numcounts),rep(0,numcounts))
  colnames(peaks) <- c("Chr","Start","End", "Score", "Score","RPKM", "Reads","cRPKM","cReads")
  pv$counts <- TRUE
  
  res <- dba.peakset(pv,
                     peaks       = peaks,
                     sampID      = sampID,
                     tissue      = tissue,
                     factor      = factor,
                     condition   = condition,
                     treatment   = treatment,
                     consensus   = TRUE,
                     peak.caller = "counts",
                     reads       = NA,
                     replicate   = replicate,
                     bMerge      = FALSE)
  
  res$class[PV_READS,length(res$peaks)] <- sum(counts)
  
  if(nrow(peaks) != nrow(res$peaks[[1]])) {
    stop('Mismatch in number of intervals',call.=FALSE)
  }
  
  if(!is.null(pv$rownames)) {
    if(sum(pv$rownames %in% rownames)!=length(rownames)) {
      stop('Mismatch in interval annotations',call.=FALSE)           
    }
  }
  
  #     if(sum(as.integer(res$peaks[[1]][,1]) != as.integer(res$peaks[[length(res$peaks)]][,1]))) {
  #         stop("Mismatch in ID",call.=FALSE)	
  #     }
  if(sum(res$peaks[[1]][,1] != res$peaks[[length(res$peaks)]][,1])) {
    stop("Mismatch in ID",call.=FALSE)    
  }
  
  if(sum(res$peaks[[1]][,2] != res$peaks[[length(res$peaks)]][,2])) {
    stop("Mismatch in interval start",call.=FALSE)	
  }
  if(sum(res$peaks[[1]][,3] != res$peaks[[length(res$peaks)]][,3])) {
    stop("Mismatch in interval end",call.=FALSE)	
  }
  
  #res$annotation <- annotation
  
  return(res)
}

pv.DBA2SummarizedExperiment <- function(DBA, bAssays=TRUE, report) {
  if (!missing(report)) {
    peaks <- report[,1:9]
  } else {
    peaks <- pv.writePeakset(DBA, peaks=DBA$binding, numCols=3)
  }
  rnames <- rownames(peaks)
  peaks <- pv.peaks2DataType(peaks,DBA_DATA_GRANGES)
  meta  <- t(DBA$class)
  meta[meta==""]=NA
  meta <- meta[,apply(meta,2,function(x) {sum(is.na(x))!=length(x)})]
  meta <- DataFrame(meta[,-1])
  counts <- as.matrix(DBA$binding[,4:ncol(DBA$binding)])
  assays <- SimpleList(scores=counts)
  if(bAssays) {
    extra <- pv.assaysFromPeaks(DBA) 
    if(!is.null(extra)){
      for(newassay in extra) {
        rownames(newassay) <- rnames
        assays <- pv.listadd(assays,newassay)
      }   
      names(assays) <- c("scores",names(extra))
    }  
  }
  res <- SummarizedExperiment(assays    = assays,
                              rowRanges = peaks,
                              colData   = meta)
  colnames(res) <- colnames(DBA$class)                           
  return(res)                           
}

pv.assaysFromPeaks <- function(DBA) {
  peaks <- DBA$peaks
  numpeaks  <- nrow(peaks[[1]])
  numfields <- ncol(peaks[[1]])
  if(numfields <= 4) {
    return(NULL)
  }
  fields  <- colnames(peaks[[1]])
  samples <- length(peaks)
  assays <- NULL
  for(i in 5:numfields) {
    toadd <- matrix(0,numpeaks,samples)
    rownames(toadd) <- 1:numpeaks
    colnames(toadd) <- colnames(DBA$class)
    assays <- pv.listadd(assays,toadd)
  }   
  names(assays) <- fields[5:numfields]
  for(sampnum in 1:samples) {
    peak <- peaks[[sampnum]]
    if(numpeaks!=nrow(peak) || numfields!=ncol(peak)) {
      return(NULL)
    }
    for(i in 5:numfields) {
      assays[[i-4]][,sampnum] <- peak[,i]
    }
  }
  
  if(!is.null(DBA$called)) {
    if(nrow(DBA$called)==nrow(assays[[1]])){
      assays <- c(assays,Called=list(DBA$called))
    }
  }
  
  return(assays)
}

stripSpaces <- function(data) {
  data[is.na(data)]=""
  cnames <- names(data)
  for (cname in cnames) {
    stripped <- trimws(data[,cname])
    changed <- !(stripped == data[,cname])
    if (sum(changed) > 0) {
      rows <- seq(1,length(stripped))
      rownums <- rows[changed]
      orig <- paste(stripped[changed],sep=",",collapse=",")
      warning(sprintf("Removed white space from %s in column %s (%s %s)",
                      orig,cname,
                      if (length(rownums)==1) "row" else "rows",
                      paste(rownums,sep=",",collapse=",")),call.=FALSE)
      data[,cname] <- stripped
    }
  }
  return(data)
}

pv.gc <- function(force=FALSE){
  if(force) {
    gc(verbose=FALSE)
  }
}

pv.overlaps <- function(pv,minOverlap) {
  if(is.null(pv$called)) {
    return(NULL)
  }
  if(!is.null(pv$allcalled)) {
    pv$called <- pv$allcalled
  }
  overlaps <- apply(pv$called,1,sum)>=minOverlap
  return(overlaps)
}

pv.allSame <- function(pv) {
  callers <- unique(pv$class[DBA_CALLER,])
  if((length(callers)==1) & (callers[1]=='counts')) {
    if(length(unique(sapply(pv$peaks,nrow)))==1) {
      return(TRUE)
    }
  }
  return(FALSE)
}

pv.makeGRanges <- function(data, chrmap) {
  data <- data.frame(data)
  colnames(data)[1:3] <- c("chr","start","end")
  data[,1] <- chrmap[data[,1]]
  data <- GRanges(data)
  return(data)
}

pv.checkCalled <- function(pv){
  
  if(!is.null(pv$called)) {
    if(do.nrow(pv$called) != do.nrow(pv$binding)) {
      if(is.null(pv$allcalled)) {
        if(do.nrow(pv$called) != do.nrow(pv$merged)) {
          pv$called <- NULL
          return(pv)
        }
      }
    }
  }
  
  if(do.nrow(pv$merged) != do.nrow(pv$binding)) {
    if (!is.null(pv$called) && is.null(pv$allcalled)) {
      if(do.nrow(pv$called) == do.nrow(pv$merged)) {
        pv$allcalled <- pv$called
        pv$called <- pv$allcalled[pv.makeGRanges(pv$merged,pv$chrmap) %over% 
                                    pv.makeGRanges(pv$binding, pv$chrmap),]
      }
    }
  }
  
  if(!is.null(pv$allcalled)) {
    if(do.nrow(pv$allcalled) != do.nrow(pv$merged)) {
      pv$allcalled <- NULL
    }
  }
  
  if(!is.null(pv$called)) {
    if(do.nrow(pv$called) != do.nrow(pv$binding)) {
      pv$called <- NULL
    }
  }
  
  return(pv)
}

do.nrow <- function(m) {
  if(is.null(m)) {
    return(0)
  } else {
    return(nrow(m))
  }
}

do.ncol <- function(m) {
  if(is.null(m)) {
    return(0)
  } else {
    return(ncol(m))
  }
}

Numeric <- function(x) {
  # Return numeric is all are numeric otherwise native
  num <- suppressWarnings(as.numeric(x))
  if(all(!is.na(num))) {
    return(num)
  } else {
    return(x)
  }
}

context("Loading Sample Sheets")

collectWarnings <- function(fun,data) {
  msgs <- NULL
  wHandler <- function(w) {
    msgs <<- c(msgs,w$message)
    invokeRestart("muffleWarning")
  }
  val <- withCallingHandlers(do.call(fun,data),warning=wHandler)
  return(list("value"=val,"warnings"=msgs))
}

test_that("spaces are trimmed from sample sheets, basic sanity",{
  data <- data.frame(c('a','b','c '),c('x',' y','z'))
  ans <- data.frame(c('a','b','c'),c('x','y','z'))
  colnames(data) <- c('alpha','bravo')
  colnames(ans) <- c('alpha','bravo')
  res <- suppressWarnings(stripSpaces(data))
  expect_equal(sum(res$alpha==ans$alpha),3)
  expect_equal(sum(res$bravo==ans$bravo),3)
})

test_that("warning is generated correctly",{
  data <- data.frame(c('a','b','c '),c('x','y','z'))
  colnames(data) <- c('alpha','bravo')
  expect_warning(stripSpaces(data),
                 'Removed white space from c in column alpha (row 3)',
                 fixed=TRUE)
})

test_that("warning multiple rows is generated correctly",{
  data <- data.frame(c('a','b ','c '),c('x','y','z'))
  colnames(data) <- c('alpha','bravo')
  expect_warning(stripSpaces(data),
                 'Removed white space from b,c in column alpha (rows 2,3)',
                 fixed=TRUE)
})

test_that("warning multiple columns generates multiple warnings",{
  data <- data.frame(c('a','b ','c '),c('x ','y','z'))
  colnames(data) <- c('alpha','bravo')
  res <- collectWarnings(stripSpaces,list(data))
  msgs <- res$warnings
  expect_equal(2,length(msgs))
  expect_equal(msgs[1],"Removed white space from b,c in column alpha (rows 2,3)",fixed=TRUE)
  expect_equal(msgs[2],"Removed white space from x in column bravo (row 1)",fixed=TRUE)
})

test_that("loading csv sample sheet with spaces generates warnings",{
  wd <- getwd()
  setwd(system.file('extra','testdata',package='DiffBind'))
  res <- collectWarnings(dba,list('sampleSheet'='test_sampleSheet_Spaces.csv'))# RJS 5/6/2020 ,'bCorPlot'=FALSE))
  expect_equal(2,length(res$warnings))
  expect_equal(res$warnings[1],"Removed white space from treated in column Condition (row 3)",fixed=TRUE)
  expect_equal(res$warnings[2],"Removed white space from bed_with_header.bed.gz,bed_without_header.bed.gz,raw_with_header.raw.gz in column Peaks (rows 1,2,3)",fixed=TRUE)
  expect_equal(res$value$samples$Condition[3],"treated")
  expect_equal(res$value$samples$Condition[4],"treated")
  expect_equal(res$value$samples$Peaks[1],"bed_with_header.bed.gz")
  expect_equal(res$value$samples$Peaks[2],"bed_without_header.bed.gz")
  expect_equal(res$value$samples$Peaks[3],"raw_with_header.raw.gz")
  expect_equal(res$value$samples$Peaks[4],"raw_without_header.raw.gz")
  setwd(wd)
})

test_that("loading xlsx sample sheet with spaces generates warnings",{
  if (require(XLConnect)) {
    wd <- getwd()
    setwd(system.file('extra','testdata',package='DiffBind'))
    res <- collectWarnings(dba,list('sampleSheet'='test_sampleSheet_Spaces.csv'))# RJS 5/6/2020,'bCorPlot'=FALSE))
    expect_equal(2,length(res$warnings))
    expect_equal(res$warnings[1],"Removed white space from treated in column Condition (row 3)",fixed=TRUE)
    expect_equal(res$warnings[2],"Removed white space from bed_with_header.bed.gz,bed_without_header.bed.gz,raw_with_header.raw.gz in column Peaks (rows 1,2,3)",fixed=TRUE)
    expect_equal(res$value$samples$Condition[3],"treated")
    expect_equal(res$value$samples$Condition[4],"treated")
    expect_equal(res$value$samples$Peaks[1],"bed_with_header.bed.gz")
    expect_equal(res$value$samples$Peaks[2],"bed_without_header.bed.gz")
    expect_equal(res$value$samples$Peaks[3],"raw_with_header.raw.gz")
    expect_equal(res$value$samples$Peaks[4],"raw_without_header.raw.gz")
    setwd(wd)
  }
})

test_that("sample sheet loading does not interpret hash as a comment character",{
  wd <- getwd()
  setwd(system.file('extra','testdata',package='DiffBind'))
  fn = 'test_sampleSheet_comment_char.csv'
  dobj = dba(sampleSheet=fn)
  expect_is(dobj,"DBA")
  expect_equal(dobj$samples$SampleID[2],"bravo#")
  expect_equal(dobj$samples$SampleID[3],"char#lie")
  setwd(wd)
})

context("Reading Peaks")

test_that("bed with header is detected correctly",{
  fn <- system.file('extra','testdata','bed_with_header.bed.gz',package='DiffBind')
  expect_true(hasHeader(fn))
})

test_that("bed without header is detected correctly",{
  fn <- system.file('extra','testdata','bed_without_header.bed.gz',package='DiffBind')
  expect_false(hasHeader(fn))
})

test_that("raw with header is detected correctly",{
  fn <- system.file('extra','testdata','raw_with_header.raw.gz',package='DiffBind')
  expect_true(hasHeader(fn))
})

test_that("raw without header is detected correctly",{
  fn <- system.file('extra','testdata','raw_without_header.raw.gz',package='DiffBind')
  expect_false(hasHeader(fn))
})

test_that("bed with header is read correctly",{
  fn <- system.file('extra','testdata','bed_with_header.bed.gz',package='DiffBind')
  data <- pv.readbed(fn,checkHeader=TRUE)
  expect_equal(nrow(data),10)
  expect_equal(data[1,2],97113)
  expect_equal(data[1,3],100326)
})

test_that("bed without header is read correctly",{
  fn <- system.file('extra','testdata','bed_without_header.bed.gz',package='DiffBind')
  data <- pv.readbed(fn,checkHeader=TRUE)
  expect_equal(nrow(data),10)
  expect_equal(data[1,2],97113)
  expect_equal(data[1,3],100326)
})

test_that("raw with header is read correctly",{
  fn <- system.file('extra','testdata','raw_with_header.raw.gz',package='DiffBind')
  data <- pv.readbed(fn,checkHeader=TRUE)
  expect_equal(nrow(data),10)
  expect_equal(data[1,2],97113)
  expect_equal(data[1,3],100326)
})

test_that("raw without header is read correctly",{
  fn <- system.file('extra','testdata','raw_without_header.raw.gz',package='DiffBind')
  data <- pv.readbed(fn,checkHeader=TRUE)
  expect_equal(nrow(data),10)
  expect_equal(data[1,2],97113)
  expect_equal(data[1,3],100326)
})

#####################################
## pv_model.R -- make pv object    ##
## 20 October 2009                 ##
## 3 February 2011 -- packaged     ##
## Rory Stark                      ##
## Cancer Research UK              ##
#####################################
PV_DEBUG <- FALSE

## pv.peakset -- add a peakset to the model
pv.peakset <- function(pv = NULL,peaks, sampID, tissue, factor,condition, treatment, replicate,
                       control, peak.caller, peak.format, reads = 0, consensus =FALSE, 
                       readBam, controlBam, scoreCol = NULL, bLowerScoreBetter = NULL,
                       bRemoveM = TRUE, bRemoveRandom = TRUE,
                       minOverlap = 2,bFast = FALSE,bMakeMasks = TRUE,
                       skipLines = 1, filter = NULL, counts = NULL, spikein) {
  zeroVal <- -1
  bLog <- FALSE
  
  if (missing(peaks)) {
    peaks <- NULL
  }
  
  if(length(peaks) == 0) {
    peaks <- NULL
  }
  
  # if (!is.null(pv$peaks) && length(peaks) == 0) {
  #   peaks <- 1:length(pv$peaks)
  # }
  
  if (missing(counts))
    counts <- NULL
  if (!is.null(counts)) {
    res <- pv.peaksetCounts(
      pv = pv,peaks = peaks,counts = counts,
      sampID = sampID,tissue = tissue,factor = factor,
      condition = condition, treatment = treatment,replicate = replicate
    )
    return(res)
  }
  
  if (missing(peak.format))
    peak.format <- NULL
  if (missing(scoreCol))
    scoreCol <- NULL
  if (missing(bLowerScoreBetter))
    bLowerScoreBetter <- NULL
  if (missing(filter))
    filter <- NULL
  
  bConsensus <- FALSE
  if (is.numeric(consensus)) {
    ## Add a set of consensus peaksets
    bConsensus <- TRUE
    pv <-
      pv.consensusSets(pv,peaks = peaks,minOverlap = minOverlap,
                       attributes = consensus, tissue,factor,condition,treatment,
                       replicate,control,peak.caller, readBam, controlBam,
                       spikein)
    
  } else {
    ## add a specific consensus peakset
    if (is.vector(peaks) && length(peaks) > 1) {
      # consensus
      bConsensus <- TRUE
      pv <-
        pv.consensus(pv,peaks,minOverlap = minOverlap,bFast = bFast)
      if (!is.null(minOverlap)) {
        nset <- length(pv$peaks)
        if (!missing(sampID)) {
          pv$class[PV_ID,nset] <- sampID
          colnames(pv$class)[nset] <- sampID
        }
      }
      
      if (!missing(tissue))
        pv$class[PV_TISSUE,nset] <- tissue
      if (!missing(factor))
        pv$class[PV_FACTOR,nset] <- factor
      if (!missing(condition))
        pv$class[PV_CONDITION,nset] <- condition
      if (!missing(treatment))
        pv$class[PV_TREATMENT,nset] <- treatment
      if (!missing(replicate))
        pv$class[PV_REPLICATE,nset] <- replicate
      if (!missing(control))
        pv$class[PV_CONTROL,nset] <- control
      if (!missing(peak.caller))
        pv$class[PV_CALLER,nset] <- peak.caller
      if (!missing(readBam))
        pv$class[PV_BAMREADS,nset] <- readBam
      if (!missing(controlBam))
        pv$class[PV_BAMCONTROL,nset] <- controlBam
      if (!missing(spikein))
        pv$class[PV_SPIKEIN,nset] <- spikein
    }
  }
  if (bConsensus) {
    if (bMakeMasks) {
      pv$masks <- pv.mask(pv)
    }
    return(pv)
  }
  
  if (missing(tissue))
    tissue <- ''
  if (missing(factor))
    factor <- ''
  if (missing(condition))
    condition <- ''
  if (missing(treatment))
    treatment <- ''
  if (missing(replicate))
    replicate <- ''
  if (missing(control))
    control <- ''
  if (missing(peak.caller))
    peak.caller <- ''
  if (missing(readBam)) {
    readBam <- NA
    #warning("No bam file specified.",call.=FALSE)
  }
  if (length(readBam) == 0) {
    readBam <- NA
    #warning("No bam file specified.",call.=FALSE)
  }
  if (missing(controlBam))
    controlBam <- NA
  if (length(controlBam) == 0)
    controlBam <- NA
  if (missing(spikein))
    spikein <- NA
  if (length(spikein) == 0)
    spikein <- NA
  
  if (!is.null(peaks) && length(peaks) <= 1) {
    if (is.na(peaks) || length(peaks)==0) {
      peaks <- NULL
    } else {
      if (is.character(peaks)) {
        if (peaks == "" || peaks == " ")
          peaks <- NULL
      }
    }
  }
  if (is.null(peaks)) {
    peaks <- matrix(0,0,4)
  } else {
    if (is.character(peaks)) {
      # Read in peaks from a file
      if(file.info(peaks)$size > 0) {
        pcaller <- strtrim(peak.caller,6)
        if (is.null(peak.format)) {
          peak.format <- pcaller
        }
        if (is.null(scoreCol)) {
          scoreCol <- pv.defaultScoreCol(peak.format)
        }
        peaks <- pv.readPeaks(peaks,peak.format,skipLines)
      } else {
        peaks <- matrix(0,0,4)
        scoreSave <- scoreCol <- 0
      }
    } else {
      peaks <- pv.peaksort(peaks)
      if (is.null(scoreCol))
        scoreCol <- pv.defaultScoreCol(peak.format)
      if (is.null(bLowerScoreBetter))
        bLowerScoreBetter <- FALSE
    }
    
    scoreSave <- scoreCol
    if ( (nrow(peaks) > 0) & 
         ( (ncol(peaks) < scoreSave) | (ncol(peaks) == 3))){
      peaks <- cbind(peaks[,1:3],1)
      colnames(peaks)[ncol(peaks)] <- "score"
      scoreCol <- 0
    }
    
    if (is.null(bLowerScoreBetter)) {
      if (peak.caller == "report") {
        bLowerScoreBetter <- TRUE
      } else {
        bLowerScoreBetter <- FALSE
      }
    }
    
    if (is.null(filter) && peak.caller == "bayes") {
      filter <- 0.5
    }
    
    if (scoreCol > 0) {
      if (!missing(filter)) {
        if (!is.null(filter)) {
          if (bLowerScoreBetter) {
            tokeep <- peaks[,scoreCol] <= filter
          } else {
            tokeep <- peaks[,scoreCol] >= filter
          }
          peaks <- peaks[tokeep,]
        }
      }
      peaks[,scoreCol] <-
        pv.normalizeScores(peaks,scoreCol,zeroVal = zeroVal,bLog = bLog)
      if (bLowerScoreBetter) {
        peaks[,scoreCol] <- 1 - peaks[,scoreCol]
      }
      peaks <- peaks[,c(1:3,scoreCol)]
    }
    
    if (bRemoveM) {
      idx <- peaks[,1] != "chrM"
      peaks <- peaks[idx,]
      if (sum(!idx) > 0) {
        peaks[,1] <- as.factor(as.character(peaks[,1]))
      }
    }
    
    if (bRemoveRandom) {
      for (i in c(1:22,"X","Y")) {
        ch <- sprintf("chr%s_random",i)
        idx <- peaks[,1] != ch
        peaks <- peaks[idx,]
        if (sum(!idx) > 0) {
          peaks[,1] <- as.factor(as.character(peaks[,1]))
        }
      }
    }
    
    newchrs <- as.character(peaks[,1])
    pv$chrmap  <- sort(unique(c(pv$chrmap,newchrs)))
    #         peaks[,1] <- factor(peaks[,1],pv$chrmap)
    peaks[,1] <- as.character(peaks[,1])
  }
  
  colnames(peaks)[1:4] <- c("Chr","Start","End","Score")
  
  pv$peaks <- pv.listadd(pv$peaks,peaks)
  
  if (missing(sampID)) {
    if (is.null(pv)) {
      sampID <- 1
    } else if (is.null(pv$peaks)) {
      sampID <- 1
    } else {
      sampID <- length(pv$peaks)
    }
  }
  clascol <-
    cbind(
      NULL,c(
        sampID,tissue,factor,condition,consensus,peak.caller,control,
        reads,replicate,readBam,controlBam,treatment,spikein
      )
    )
  colnames(clascol) <- sampID
  pv$class <- cbind(pv$class,clascol)
  rownames(pv$class) <-
    c(
      "ID","Tissue","Factor","Condition", "Consensus",
      "Peak caller","Control","Reads","Replicate","bamRead",
      "bamControl","Treatment", "Spikein"
    )
  pv$merged  <- NULL
  pv$binding <- NULL
  if (bMakeMasks) {
    pv$masks <- pv.mask(pv)
  }
  return(pv)
}

## pv.vectors -- build the binding expression vectors and do clustering/PCA
pv.vectors <- function(pv,mask,minOverlap = 2,attributes,bAllSame = FALSE,
                       merge = TRUE) {
  if (missing(attributes)) {
    if (is.null(pv$attributes)) {
      attributes <- PV_ID
    } else {
      attributes <- pv$attributes
    }
  }
  
  if(missing(mask) && merge) {
    mask <- 1:length(pv$peaks)
  }
  
  if(is.null(pv$config$mergeOverlap)) {
    maxGap <- as.integer(-1)
  } else {
    maxGap <- as.integer(-pv$config$mergeOverlap)
  }
  
  called <- SN <- allcalled <- NULL
  if (!missing(mask)) {
    if (is.logical(mask)) {
      mask <- which(mask)
    }
    peaks <- NULL
    for (i in mask) {
      #if(nrow(pv$peaks[[i]]) > 0) {
      peaks <- pv.listadd(peaks,pv$peaks[[i]])
      #}
    }
    class      <- pv$class[,mask]
    chrmap     <- pv$chrmap
    config     <- pv$config
    samples    <- pv$samples
    if(!is.null(pv$called)) {
      if(length(mask) <= ncol(pv$called)) {
        called <- pv$called[,mask]
        if(!is.null(pv$allcalled)) {
          allcalled <- pv$allcalled[,mask]
        } 
      }
    }
    if(!is.null(pv$SN)) {
      if(length(mask)==length(SN)) {
        SN <- pv$SN[mask]
      }
    }
    score      <- pv$score
    summits    <- pv$summits
    minCount   <- pv$minCount
    #contrasts  <- pv$contrasts
    blacklist  <- pv$blacklist
    greylist   <- pv$greylist
    peaks.blacklisted <- pv$peaks.blacklisted
    resultObject <- pv$resultObject
    #annotation <- pv$annotation
    
    pv <- NULL
    pv$peaks      <- peaks
    pv$class      <- class
    pv$chrmap     <- chrmap
    pv$config     <- config
    pv$samples    <- samples
    pv$called     <- called
    pv$allcalled  <- allcalled
    #pv$contrasts  <- contrasts
    pv$score      <- score
    pv$SN         <- SN
    pv$summits    <- summits
    pv$minCount   <- pv$minCount
    pv$blacklist  <- blacklist
    pv$greylist   <- greylist
    pv$peaks.blacklisted <- peaks.blacklisted
    pv$resultObject <- resultObject
    #pv$annotation <- annotation
  }
  
  if (is.vector(pv$class)) {
    pv$class <- matrix(pv$class,length(pv$class),1)
    colnames(pv$class) <- pv$class[1,]
  }
  
  peaks <- pv$peaks
  
  numvecs <- length(peaks)
  ncols <- numvecs + 3
  
  if (minOverlap > 0 && minOverlap < 1) {
    minOverlap <- ceiling(numvecs * minOverlap)
  }
  
  npeaks <- 0
  defval <- -1
  
  if (!bAllSame) {
    if (sum(vapply(peaks,nrow,1)) > 0) {
      if (merge) {
        allp <-lapply(peaks,
                      function(x) {
                        y <- x[,1:3]
                        colnames(y) <- c("chr","start","end")
                        y})
        allpeaks <- NULL
        for(el in allp) { # check for empty peaksets
          if(nrow(el)>0) { 
            allpeaks <- pv.listadd(allpeaks,el)
          }
        }
        allpeaks <- bind_rows(allpeaks)
      } else {
        allpeaks <- data.frame(pv$merged)
        allpeaks[,1] <- pv$chrmap[allpeaks[,1]]
      }
    } else {
      allpeaks <- matrix(0,0,4)
    }
    allnames <- NULL
    if (nrow(allpeaks) > 0) {
      res  <- pv.merge(allpeaks,peaks,pv$class, maxgap=maxGap)
      pv$totalMerged <- do.nrow(res$merged)
      rownames(res$merged) <- 1:do.nrow(res$merged)
      allnames <- res$chrmap
      pv$called  <- res$included
      pv$allcalled <- NULL
      pv$merged <- res$merged[,1:3]
      if ((ncol(res$merged) > 4) && (minOverlap > 1)) {
        olaps <- pv.overlaps(pv,minOverlap)
        pv$binding <- res$merged[olaps,]
        pv$called  <- pv$called[olaps,]
        pv$allcalled <- res$included
      }  else {
        pv$binding <- res$merged
      }
    } else {
      pv$merged  <- matrix(0,0,3 + length(pv$peaks))
      pv$overlaps <- NULL
      colnames(pv$merged) <- colnames(allpeaks)
      pv$binding   <- pv$merge
      pv$totalMerged <- 0
      pv$called <- NULL
    }
  } else {
    ## ALL SAME
    result <- matrix(0,nrow(pv$peaks[[1]]),length(pv$peaks) + 3)
    if (is.character(pv$peaks[[1]][1,1])) {
      result[,1] <- match(pv$peaks[[1]][,1],pv$chrmap)
    }
    result[,2] <- Numeric(pv$peaks[[1]][,2])
    result[,3] <- Numeric(pv$peaks[[1]][,3])
    for (i in 1:numvecs) {
      result[,i + 3] <- pv$peaks[[i]][,4]
    }
    colnames(result) <-
      c("CHR","START","END",pv$class[PV_ID,1:numvecs])
    pv$binding <- result
    pv$merged <- pv$binding[,1:3]
    pv$totalMerged <- do.nrow(pv$binding)
    pv$called <- called
    pv$allcalled <- allcalled
    allnames <- pv$chrmap
  }
  
  pv$attributes <- attributes
  pv$minOverlap <- minOverlap
  
  if (is.null(allnames)) {
    allnames <- pv$chrmap[pv$binding[,1]]
  }
  
  pv$binding <- pv.check1(pv$binding)
  if (do.nrow(pv$binding) > 0) {
    vnames <- allnames[pv$binding[,1]]
  }
  if (!is.null(allnames)) {
    newmap <- sort(unique(allnames))
  } else {
    newmap <- NULL
  }
  if (do.nrow(pv$binding) > 0) {
    pv$binding[,1] <- match(vnames,newmap)
    if (is.unsorted(unique(pv$binding[,1]))) {
      pv$binding <- pv.peaksort(pv$binding)
    }
    rownames(pv$binding) <- 1:do.nrow(pv$binding)
  }
  
  pv$merged <- pv.check1(pv$merged)
  pv$called <- pv.check1(pv$called)
  pv$chrmap <- newmap
  
  pv$hc <- NULL
  pv$pc <- NULL
  pv$masks <- pv.mask(pv)
  pv$config <- as.list(pv$config)
  pv.gc()
  return(pv)
}

## pv.model -- build model, e.g. from sample sheet
pv.model <- function(model,mask,minOverlap=2,
                     samplesheet='sampleSheet.csv',config=data.frame(RunParallel=FALSE),
                     caller="raw",format, scorecol, bLowerBetter, skipLines=0,bAddCallerConsensus=TRUE,
                     bRemoveM=TRUE, bRemoveRandom=TRUE,filter,
                     attributes, dir) {
  
  if(missing(format))       format       <- NULL
  if(missing(scorecol))     scorecol     <- NULL
  if(missing(bLowerBetter)) bLowerBetter <- NULL
  if(missing(filter))       filter       <- NULL   
  
  if(!missing(model)){
    ChIPQCobj <- model$ChIPQCobj
  } else ChIPQCobj <- NULL
  
  if(!missing(model)) {
    if(missing(attributes)) {
      if(is.null(model$attributes)) {   
        attributes <- PV_ID
      } else {
        attributes <- model$attributes
      }
    }
    config <- as.list(model$config)
    allsame <- pv.allSame(model)
    model <- pv.vectors(model,mask=mask,minOverlap=minOverlap,
                        attributes=attributes,bAllSame=allsame)
    model$config <- as.list(config)
    model$ChIPQCobj <- ChIPQCobj
    model$class[DBA_REPLICATE,is.na(model$class[DBA_REPLICATE,])] <- ""
    if(!missing(mask)) {
      if(length(model$config$fragmentSize) > 1) {
        model$config$fragmentSize <- model$config$fragmentSize[mask]
      }
    }
    return(model)
  }
  
  if(missing(attributes)) {   
    attributes <- PV_ID
  }
  
  if(is.character(samplesheet)) {
    if(!missing(dir)) {
      samplesheet <- file.path(dir,samplesheet)
    }
    ext <- file_ext(samplesheet)
    if (ext %in% c("xls","xlsx")) {
      if (requireNamespace("XLConnect",quietly=TRUE)) {
        samples <- XLConnect::readWorksheetFromFile(samplesheet,sheet=1)
      } else {
        stop("Package XLConnect is needed to read Excel-format sample sheets.",call.=FALSE)
      }
    } else {
      samples <- read.table(samplesheet,sep=',',stringsAsFactors=FALSE,header=TRUE, 
                            comment.char="")
    }
    samples <- stripSpaces(samples)
  } else samples <- samplesheet
  
  if(is.null(samples$SampleID)){
    samples$SampleID <- 1:nrow(samples)
  }
  if(is.null(samples$Tissue)){
    samples$Tissue <- ""
  } 
  if(is.null(samples$Factor)){
    samples$Factor <- ""
  }
  if(is.null(samples$Condition)){
    samples$Condition <- ""
  }
  if(is.null(samples$Treatment)){
    samples$Treatment <- ""
  }
  if(is.null(samples$Replicate)){
    samples$Replicate <- ""
  }
  
  if(sum(is.na(samples$SampleID)))  samples$SampleID[is.na(samples$SampleID)]=""
  if(sum(is.na(samples$Tissue)))    samples$Tissue[is.na(samples$Tissue)]=""
  if(sum(is.na(samples$Factor)))    samples$Factor[is.na(samples$Factor)]=""
  if(sum(is.na(samples$Condition))) samples$Condition[is.na(samples$Condition)]=""
  if(sum(is.na(samples$Treatment))) samples$Treatment[is.na(samples$Treatment)]=""
  if(sum(is.na(samples$Replicate))) samples$Replicate[is.na(samples$Replicate)]=""
  
  # prepend working directory to file paths
  if(!missing(dir)) {
    if(!is.null(samples$Peaks)) {
      samples$Peaks <- sapply(samples$Peaks,
                              function(x){file.path(dir,x)})
    }
    if(!is.null(samples$bamReads)) {
      samples$bamReads <- sapply(samples$bamReads,
                                 function(x){file.path(dir,x)})
    }
    if(!is.null(samples$bamControl)) {
      samples$bamControl <- sapply(samples$bamControl,
                                   function(x){file.path(dir,x)})
    }
    if(!is.null(samples$Spikein)) {
      samples$Spikein <- sapply(samples$Spikein,
                                function(x){file.path(dir,x)})
    }
  }
  
  model <- NULL
  if(is.character(config)) {
    if(!is.null(config)) {
      config  <- read.table(config,colClasses='character',sep=',',header=TRUE)
      x <- config$DataType
      if(!is.null(x)) {
        if(x=="DBA_DATA_FRAME")	{
          config$DataType <- DBA_DATA_FRAME
        } else if(x=="DBA_DATA_RANGEDDATA"){
          config$DataType <- DBA_DATA_RANGEDDATA            
        } else {
          config$DataType <- DBA_DATA_GRANGES
        } 
      }
      x <- config$RunParallel
      if(!is.null(x)) {
        if(x=="FALSE") {
          config$RunParallel=FALSE
        } else {
          config$RunParallel=TRUE
        }
      }
    }
    config <- as.list(config)
  }
  if(is.null(config$parallelPackage)){
    config$parallelPackage=DBA_PARALLEL_MULTICORE
  } else if (config$parallelPackage == "DBA_PARALLEL_MULTICORE") {
    config$parallelPackage=DBA_PARALLEL_MULTICORE
  } else if (config$parallelPackage == "DBA_PARALLEL_RLSF") {
    config$parallelPackage=DBA_PARALLEL_RLSF  
  }
  
  if(is.null(config$AnalysisMethod)){
    config$AnalysisMethod <- DBA_DESEQ2
  } else if(is.character(config$AnalysisMethod[1])){
    x <- strsplit(config$AnalysisMethod[1],',')
    if(length(x[[1]])==1) {
      config$AnalysisMethod <- pv.getMethod(config$AnalysisMethod)
    }	 else if (length(x[[1]])==2) {
      #config$AnalysisMethod <- c(pv.getMethod(x[[1]][1]),pv.getMethod(x[[1]][2]))	
      config$AnalysisMethod <- pv.getMethod(x[[1]][1])
    }
  }
  
  model$config <- as.list(config)
  curcontrol=1
  for(i in 1:nrow(samples)) {
    if(is.null(samples$PeakCaller[i])) {
      peakcaller  <- caller
    } else if(is.na(samples$PeakCaller[i])) {
      peakcaller  <- caller
    } else {
      peakcaller <- as.character(samples$PeakCaller[i])
    }
    if(is.null(samples$PeakFormat[i])) {
      peakformat  <- format
    } else if(is.na(samples$PeakFormat[i])) {
      peakformat  <- format
    } else {
      peakformat <- as.character(samples$PeakFormat[i])
    } 
    if(is.null(samples$ScoreCol[i])) {
      peakscores  <- scorecol
    } else if(is.na(samples$ScoreCol[i])) {
      peakscores  <- scorecol
    } else {
      if(is.factor(samples$ScoreCol[i])) {
        peakscores <- as.integer(as.character(samples$ScoreCol[i]))	
      } else {
        peakscores <- as.integer(samples$ScoreCol[i])
      }
    }
    if(is.null(samples$LowerBetter[i])) {
      peaksLowerBetter  <- bLowerBetter
    } else if(is.na(samples$LowerBetter[i])) {
      peaksLowerBetter  <- bLowerBetter
    } else {
      peaksLowerBetter <- as.logical(samples$LowerBetter[i])
    }
    if(is.null(samples$Filter[i])) {
      peakfilter  <- filter
    } else if(is.na(samples$Filter[i])) {
      peakfilter  <- filter
    } else {
      if(is.factor(samples$Filter[i])) {
        peakfilter <- as.integer(as.character(samples$Filter[i]))	
      } else {
        peakfilter <- as.integer(samples$Filter[i])
      }
    }
    
    controlid  <- pv.controlID(samples,i,model$class,curcontrol)
    if(is.numeric(controlid)) {
      curcontrol <- controlid+1
      controlid <- sprintf("Control%d",controlid)
    }
    counts <- samples$Counts[i]
    if(!is.null(counts)) {
      if(is.na(counts)[1]) {
        counts <- NULL
      } else if (counts == "") {
        counts <- NULL
      }
    }
    if(!is.null(counts)) {
      peakcaller <- 'counts'
    }
    
    if(is.null(samples$Peaks[i])) {
      peakid <- NULL
    } else {
      peakid <- as.character(samples$Peaks[i])
    }
    
    message(as.character(samples$SampleID[i]),' ',
            as.character(samples$Tissue[i]),' ',
            as.character(samples$Factor[i]),' ',
            as.character(samples$Condition[i]),' ',
            as.character(samples$Treatment[i]),' ',
            as.integer(samples$Replicate[i]),' ',peakcaller)
    
    model <- pv.peakset(model,
                        peaks       = peakid,
                        sampID      = as.character(samples$SampleID[i]),
                        tissue      = as.character(samples$Tissue[i]),
                        factor      = as.character(samples$Factor[i]),
                        condition   = as.character(samples$Condition[i]),
                        treatment   = as.character(samples$Treatment[i]),
                        consensus   = FALSE,
                        peak.caller = peakcaller,
                        peak.format = peakformat,
                        scoreCol    = peakscores,
                        bLowerScoreBetter = peaksLowerBetter,
                        control     = controlid,
                        reads       = NA,
                        replicate   = as.integer(samples$Replicate[i]),
                        readBam     = as.character(samples$bamReads[i]),
                        controlBam  = as.character(samples$bamControl[i]),
                        spikein     = as.character(samples$Spikein[i]),
                        filter      = peakfilter,
                        counts      = counts,
                        bRemoveM=bRemoveM, bRemoveRandom=bRemoveRandom,
                        skipLines=skipLines)
  }
  
  model$samples <- samples
  
  if(bAddCallerConsensus){
    model <- pv.add_consensus(model)
  }
  
  model <- pv.vectors(model,mask=mask,minOverlap=minOverlap,
                      attributes=attributes,
                      bAllSame <- (peakcaller=="counts")) 
  
  model$config <- as.list(model$config)
  model$ChIPQCobj <- ChIPQCobj
  model$class[DBA_REPLICATE,is.na(model$class[DBA_REPLICATE,])]=""
  return(model)
}

pv.style          <- "point"
pv.nOfWindows     <- 100
pv.bin_size       <- 20
pv.distanceAround <- 1500
pv.distanceUp     <- 1000
pv.distanceDown   <- 1000


pv.plotProfile <- function(pv, mask, sites, maxSites=1000, labels,
                           scores="Score", absScores=TRUE, annotate=TRUE,
                           normalize=TRUE,merge=DBA_REPLICATE,
                           doPlot=TRUE, returnVal="profileplyr",
                           ...) {

  ## ----- TEMPORARILY DISABLED in this release -----
  ## The upstream profileplyr package does not install in the current
  ## Bioconductor release (GenomicFeatures::makeTxDbFromGFF was removed
  ## upstream; profileplyr's maintainer is unresponsive). dba.plotProfile
  ## is therefore disabled until profileplyr is restored or a replacement
  ## backend is wired in. To re-enable:
  ##   1. remove this block,
  ##   2. re-add 'profileplyr' to Suggests: in DESCRIPTION,
  ##   3. (optional) revert the getExportedValue() calls below to
  ##      direct profileplyr::xxx references for readability.
  ## The remaining body of this function is preserved and uses
  ## getExportedValue() for profileplyr symbols so it parses cleanly
  ## under R CMD check without a declared profileplyr dependency.
  message("dba.plotProfile() is currently disabled: the profileplyr ",
          "package is unavailable in this Bioconductor release. ",
          "Profile plotting will be restored in a future release.")
  return(invisible(NULL))
  ## ----- END TEMPORARY DISABLE -----

  ## requireNamespace call hidden via do.call to keep the package name
  ## opaque to R CMD check's static analyser (which would otherwise warn
  ## "namespace not declared in DESCRIPTION" because we removed
  ## profileplyr from Suggests). do.call resolves the same way at runtime.
  if (!suppressWarnings(do.call("requireNamespace",
                                list("profileplyr", quietly = TRUE)))) {
    stop("Package profileplyr not installed", call. = FALSE)
  }
  
  if(missing(sites)) {
    sites <- NULL
  }
  
  if(!is(pv,"profileplyr")) { # Need to compute profiles
    
    if(missing(mask)) {
      mask <- NULL
    }
    
    if(missing(labels)) {
      labels <- NULL
    }
    
    sitelabels <- NULL
    if(is(labels,"list")) {
      if(!is.null(labels$sites)) {
        sitelabels <- labels$sites
      }
      if(!is.null(labels$samples)) {
        labels <- labels$samples
      } else {
        labels <- NULL
      }
    }
    
    groups <- FALSE
    condition1 <- condition2 <- NULL
    
    # Check for default contrast 
    if(is.null(sites)) { 
      if(!is.null(pv$contrasts[[1]])) {
        if(pv$config$AnalysisMethod[1] == DBA_EDGER) {
          if(!is.null(pv$contrasts[[1]]$edgeR)) {
            sites <- 1
          }
        } else {
          if(!is.null(pv$contrasts[[1]]$DESeq2)) {
            sites <- 1
          }
        }
      }
    }
    
    # If sites is unspecified
    if(is.null(sites)) { 
      # Get all sites from binding matrix and scramble
      sites <- pv.peakMatrix_toGR(pv,pv$binding)
      sites <- sites[sample(1:length(sites)),]
      scores <- NULL
    }  else if(is(sites,"numeric")) {
      # Generate Report-based
      con <- sites
      sites <- dba.report(pv, contrast=con,
                          bDB=TRUE,bGain=TRUE,bLoss=TRUE,bAll=FALSE)
      #sites$peaks[[2]]$Score <- abs(sites$peaks[[2]]$Score)
      
      if(is.null(mask)) {
        if(!is.null(pv$contrasts[[con]]$group1)) {
          condition1 <- which(pv$contrasts[[con]]$group1)
          condition2 <- which(pv$contrasts[[con]]$group2)
          name1 <- pv$contrasts[[con]]$name1
          name2 <- pv$contrasts[[con]]$name2
          mask <- list(name1=condition1,name2=condition2)
          names(mask) <- c(name1,name2)
        }
      }
    }
    
    ## Which samples
    samplegroups <- NULL
    if(is.null(mask)) {
      mask <- 1:length(pv$peaks)
    } else if(is(mask,"logical")) {
      mask <- which(mask)
    } else if(is(mask,"list")) {
      samplegroups <- lapply(mask,function(x){if(is(x,"logical")){which(x)}else{x}})
      mask <- unlist(samplegroups)
    }
    
    samples <- pv$class["bamRead",mask]
    
    # Normalization factors
    normfacs <- rep(1, length(mask))
    if(is(normalize,"logical")) {
      if(normalize != FALSE) {
        normfacs <- dba.normalize(pv,bRetrieve=TRUE)$norm.factors[mask]
      }
    } else {
      if(length(normalize) == length(mask)) {
        normfacs <- normalize
      } else {
        stop("normalize must include one factor for each sample.")
      }
    }
    
    ## Sample labels
    if(is.null(labels)) {
      sampnames <- pv$class[DBA_ID,mask]
    } else if(is(labels[1],"character")) {
      sampnames  <- pv$class[DBA_ID,mask]
    } else if(length(labels) == 1) {
      if(labels > 0) {
        sampnames <- pv$class[labels,mask]
      } else {
        sampnames  <- pv$class[DBA_ID,mask]
      }
    } else {
      if(labels[1] > 0) {
        sampnames <-  apply(pv$class[labels,mask], 2, paste,collapse="_")
      } else {
        sampnames  <- pv$class[DBA_ID,mask]
      }
    }
    names(samples) <- sampnames
    
    ## Get sites
    if (is(sites,"vector")) { # specified sites
      # Get specified sites from binding matrix
      sites  <- pv.peakMatrix_toGR(pv,pv$binding[sites,])
      scores <- NULL
    } else if(is(sites, "GRanges")) { # Supplied sites
      # User supplied sites
      # just pass them through
    } else if(is(sites,"GRangesList")) { # Supplied groups of sites
      groups <- TRUE
      groupnames <- names(sites)
    } else if(is(sites,"DBA")) { # Report DBA object
      
      # check if report-based
      if(is.null(sites$resultObject)) {
        stop("sites is not a report-based DBA object.")
      } else if(sites$resultObject==FALSE) {
        stop("sites is not a report-based DBA object.")
      }
      
      # Get site groups from report DBA
      groups <- TRUE
      
      # Get each peakset, form GRangesList
      peaks <- sites$peaks
      for(i in 1:length(peaks)) {
        peaks[[i]] <- GRanges(peaks[[i]])
        #names(mcols(peaks[[i]])) <- "score"
      }
      peaks <- GRangesList(peaks)
      
      # Groupnames from report DBA $ class
      names(peaks) <- groupnames <- pv.groupNames(sites)
      sites <- peaks
    }
    
    if(is(sites,"GRanges")) {
      sites <- GRangesList(sites)
    }
    
    if(is(sites,"GRangesList")){ 
      if(!is.null(sitelabels)) {
        if(length(sitelabels) != length(sites)) {
          warning("Should be same number of site group labels as site groups",
                  .call=FALSE)
        } else {
          names(sites) <- groupnames <- sitelabels
        }
      }
    }
    
    # Limit sites
    for(i in 1:length(sites)) {
      sites[[i]] <- sites[[i]][1:min(maxSites,length(sites[[i]])),]
    }
    
    # save sites in bedfiles
    bedfiles <- NULL
    for(i in 1:length(sites)) {
      bedfile <- tempfile(as.character(Sys.getpid()))
      rtracklayer::export.bed(sites[[i]],con=bedfile)
      bedfiles <- c(bedfiles,bedfile)
    }
    
    # Generate mergelist from attributes if required
    if(!is.null(merge)) {
      merge <- pv.mergelist(pv, mask, merge, labels)
      if(!is.null(samplegroups)) {
        if(length(samplegroups) == length(merge)) {
          if(!is.null(names(samplegroups))) {
            names(merge) <- names(samplegroups)
          }
        }
      }
      sampnames <- names(merge)
    } 
    
    ## Generate profiles
    profiles <- pv.profiles(pv, samples, bedfiles,
                            mergelist = merge, normfacs = normfacs,
                            ...) 
    ## Complex assignment with a dynamic function reference (the
    ## getExportedValue() pattern used elsewhere in this file) cannot be
    ## walked by R CMD check's static analyser, AND cannot be evaluated at
    ## runtime either — R's complex-assignment rewriter requires the LHS
    ## function to be a name (or a pkg::name expression), not an arbitrary
    ## expression. eval(parse(...)) preserves the original chained
    ## assignment in a form the static analyser doesn't see, and at runtime
    ## (when re-enabled) parses fresh and executes the pkg::name form,
    ## which R's complex-assignment system handles correctly.
    eval(parse(text = paste0(
      "rownames(profileplyr::sampleData(profiles)) <- ",
      "names(assays(profiles)) <- sampnames"
    )))
    
    # Add group labels
    if(!groups) {
      groupnames <- names(sites)[1]
      if(is.null(groupnames)) {
        rowData(profiles)$sgGroup <- "Sites"
      } else {
        rowData(profiles)$sgGroup <- groupnames
      }
    } else {
      fns <- strsplit(bedfiles,"/")
      grlabels <- as.character(rowData(profiles)$sgGroup)
      for(i in 1:length(fns)) {
        fn <- fns[[i]]
        grp <- fn[length(fn)]
        grlabels[grlabels==grp] <- groupnames[i]
      }
      rowData(profiles)$"Binding Sites" <- factor(grlabels, 
                                                  levels=unique(grlabels),
                                                  labels=groupnames)
      profiles@params$rowGroupsInUse <- "Binding Sites"
    }
    
    # Add samplegroup labels
    if(!is.null(samplegroups)) {
      # convert to merged samples 
      if(!is.null(merge)) {
        if(!is.null(merge)) {
          conditions <- NULL
          sgroups <- samplegroups
          sampnum <- 1
          for(sgroup in 1:length(sgroups)) {
            sgroups[[sgroup]] <- sampnum:(sampnum+length(sgroups[[sgroup]])-1)
            sampnum <- sampnum + length(sgroups[[sgroup]])
          }
          for(tomerge in merge) {
            gnum <- which(unlist(lapply(sgroups,function(x){
              if(tomerge[1] %in% x){TRUE}else{FALSE}})))
            conditions <- c(conditions,names(sgroups)[gnum])
          }
          gnames <- NULL
          for(gname in names(samplegroups)) {
            gnames <- c(gnames,rep(gname, sum(conditions %in% gname)))
          }
          conditions <- gnames
        }
      }
      else {
        conditions <- NULL
        for(sgroup in 1:length(samplegroups)) {
          sname <- names(samplegroups)[sgroup]
          conditions <- c(conditions,rep(sname,length(samplegroups[[sgroup]])))
        }
      }
      # add samplegroup labels
      metadata(profiles) <- c(metadata(profiles),
                              list("Sample Group"=factor(conditions, 
                                                         levels=unique(conditions))))
    }
    
    # delete bedfiles
    unlink(bedfiles)
    
  } else {  # Profiles already defined -- just plotting
    profiles <- pv
    sampnames <- names(assays(profiles))
    gnames <- unique(rowData(profiles)$"Binding Sites")
    if(is.null(gnames)) {
      gnames <- unique(rowData(profiles)$sgGroup)
      groups <- FALSE
    } else {
      groups <- TRUE
    }
    groupnames <- as.character(gnames)
    
    # Normalization factors
    normfacs <- rep(1, length(sampnames))
    if(!is(normalize,"logical")) {
      if(length(normalize) == length(sampnames)) {
        normfacs <- normalize
        if(length(normfacs) != length(assays(profiles))) {
          warning("Wrong number of normalization factors, skipping.",call.=FALSE)
        } else {
          for(i in 1:length(normfacs)) {
            assay(profiles,i) <-
              assay(profiles,i) / normfacs[i]
          }
        }
      } else {
        stop("normalize must include one factor for each sample.")
      }
    }
  }
  
  
  # Scores
  profiles <- pv.siteScore(profiles, sites, scores, absScores)
  
  # Annotation
  profiles <- pv.annotate(pv, profiles, annotate)
  
  # Set up Groups
  if(groups) {
    profiles <- pv.groupProfiles(profiles)
  }
  
  # Generate plot
  if(doPlot) {
    if(returnVal=="HeatmapList") {
      return_ht_list <- TRUE
    } else {
      return_ht_list <- FALSE
    }
    doAnnotation <- annotate != FALSE
    profilehm <- pv.profileHeatmap(profiles, 
                                   samples_names=sampnames,
                                   group_names=groupnames,
                                   annotate=doAnnotation,
                                   return_ht_list,
                                   ...)
  }
  
  #return
  
  if(returnVal == "profileplyr") {
    return(profiles)
  }
  
  if(returnVal == "EnrichedHeatmap") {
    return(profilehm)
  }
  
  if(returnVal == "HeatmapLKist") {
    return(profilehm)
  }
  
}

pv.profiles <- function(pv, samples, sites, mergelist=NULL, normfacs=NULL,
                        style=pv.style, nOfWindows=pv.nOfWindows, 
                        bin_size=pv.bin_size, 
                        distanceAround=pv.distanceAround, 
                        distanceUp=pv.distanceUp, distanceDown=pv.distanceDown,
                        ...) {
  
  # check config
  if(!is.null(pv$config$pp.style)) {
    style <- pv$config$pp.style
  }
  if(!is.null(pv$config$pp.nOfWindows)) {
    nOfWindows <- pv$config$pp.nOfWindows
  }
  if(!is.null(pv$config$pp.bin_size)) {
    bin_size <- pv$config$pp.bin_size
  }
  if(!is.null(pv$config$pp.distanceAround)) {
    distanceAround <- pv$config$pp.distanceAround
  }
  if(!is.null(pv$config$pp.distanceUp)) {
    distanceUp <- pv$config$pp.distanceUp
  }
  if(!is.null(pv$config$pp.distanceDown)) {
    distanceDown <- pv$config$pp.distanceDown
  }
  
  args <- pv.sepProfilingArgs(list(...), remove=FALSE)
  if(length(args) > 0) {
    if(!is.null(args$nOfWindows)) {
      nOfWindows <- args$nOfWindows
    }
    if(!is.null(args$bin_size)) {
      bin_size <- args$bin_size
    }
    if(!is.null(args$distanceAround)) {
      distanceAround <- args$distanceAround
    }
    if(!is.null(args$distanceUp)) {
      distanceDown <- args$distanceDown
    }
  }
  
  # Check bam files: exist, PE/SE, BAI
  
  if(is.null(pv$config$singleEnd)) {
    bfile <- pv.BamFile(samples[1], bIndex=TRUE)
    pv$config$singleEnd	<- !suppressMessages(
      Rsamtools::testPairedEndBam(bfile))
  }
  paired <- !pv$config$singleEnd
  
  # Get MulticoreParam
  
  if(pv$config$RunParallel) {
    if(is.null(pv$config$cores)) {
      cores <- BiocParallel::multicoreWorkers()
    } else {
      cores <- pv$config$cores
    }
    param <- BiocParallel::MulticoreParam(workers=cores)
  } else {
    param <-  BiocParallel::SerialParam()
  }
  
  # Call profileplyr
  message("Generating profiles...")
  profiles <- NULL
  if(is.null(profiles)) { # NULL check for debugging
    res <- tryCatch(
      suppressMessages(
        profiles <- bplapply(samples,
                             getExportedValue("profileplyr", "BamBigwig_to_chipProfile"),
                             sites,
                             format="bam", paired=paired,
                             style=style,nOfWindows=nOfWindows,
                             bin_size=bin_size, 
                             distanceAround=distanceAround,
                             distanceUp=distanceUp, distanceDown=distanceDown,
                             BPPARAM=param)),
      error=function(x){stop("profileplyr error: ",x)}
    )
  }
  
  # Normalize
  if(!is.null(normfacs)) {
    if(length(normfacs) != length(profiles)) {
      warning("Wrong number of normalization factors, skipping.",call.=FALSE)
    } else {
      for(i in 1:length(normfacs)) {
        assay(profiles[[i]],1) <-
          assay(profiles[[i]],1) / normfacs[i]
      }
    }
  }
  
  if(!is.null(mergelist)) {
    profiles <- pv.mergeProfiles(profiles, mergelist)
  }
  
  if(length(profiles) > 1) {
    profileobjs <- getExportedValue("profileplyr", "as_profileplyr")(profiles[[1]])
    for(i in 2:length(profiles) ) {
      profileobjs <- c(profileobjs, getExportedValue("profileplyr", "as_profileplyr")(profiles[[i]]))
    }
    proplyrObject <- profileobjs
  } else {
    proplyrObject <- profiles
  }
  
  if(!is(proplyrObject,"profileplyr")) {
    proplyrObject <- getExportedValue("profileplyr", "as_profileplyr")(proplyrObject)
  }
  
  return(proplyrObject)
}

pv.siteScore <- function(profiles, sites, scores, absScores) {
  
  if(!is.null(sites)) { # Add metadata
    psites <- mcols(profiles)$name
    if(is(sites,"GRangesList")) {
      names(sites) <- NULL
    }
    sites  <- unlist(sites)
    ssites <- names(sites)
    
    matches <- match(psites, ssites)
    if(sum(is.na(matches)) > 0) {
      mcols(profiles) <- cbind(mcols(profiles), mcols(sites))      
    } else {
      mcols(profiles) <- cbind(mcols(profiles),
                               mcols(sites[match(psites, ssites),]))
    }
  }
  
  profiles@params$mcolToOrderBy <- NULL
  if(!is.null(scores)) {
    if(!scores %in% names(mcols(profiles))) {
      if(!is.null(profiles@params$mcolToOrderBy)) {
        message(scores," not a valid score column, using mean signal.")
      }
    } else {
      profiles@params$mcolToOrderBy <- "score"
      whichscore <- match(scores, names(mcols(profiles)))
      mcols(profiles)$score <- mcols(profiles)[whichscore][,1]   
      if(absScores) {
        mcols(profiles)$score <- abs(mcols(profiles)$score)
      } 
    }
  } 
  
  profiles <- getExportedValue("profileplyr", "orderBy")(profiles,profiles@params$mcolToOrderBy)
  
  return(profiles)
}

pv.annotate <- function(pv, profiles, annotate) {
  
  if(!is.null(rowData(profiles)$Features)) {
    return(profiles)
  }
  
  if(is(annotate,"logical")){
    if(!annotate) {
      return(profiles)
    } else {
      annotate <- pv.genomes(pv$class["bamRead",1],pv$chrmap)
      if(annotate=="BSgenome.Hsapiens.UCSC.hg19") {
        annotate <- "hg19"
      } else if(annotate=="BSgenome.Hsapiens.UCSC.hg38") {
        annotate <- "hg38"
      } else if(annotate=="BSgenome.Mmusculus.UCSC.mm9") {
        annotate <- "mm9"
      } else if(annotate=="BSgenome.Mmusculus.UCSC.mm10") {
        annotate <- "mm10"
      } else {
        message("Must specify transcriptome")
        return(profiles)
      }
      message("Annotate using: ",annotate)
    }
  }
  
  meta <- metadata(profiles)
  
  message("Annotating...")
  suppressMessages(
    profiles <- getExportedValue("profileplyr", "annotateRanges")(profiles, TxDb=annotate,
                                            verbose=FALSE)
  )
  profiles <- pv.setAnno(profiles)
  
  metadata(profiles) <- c(meta,list(annotate=annotate))
  
  return(profiles)
  
}

pv.setAnno <- function(dataset) {
  Features <-  as.character(rowData(dataset)$annotation_short)
  Features[Features=="3p UTR"] <- "Gene Body"
  Features[Features=="5p UTR"] <- "Gene Body"
  Features[Features=="Downstream"] <- "Gene Body"
  Features[Features=="Exon"] <- "Gene Body"
  Features[Features=="Intron"] <- "Gene Body"
  Features[Features=="Distal Intergenic"] <- "Intergenic"
  Features <- factor(Features,levels=c("Promoter","Gene Body","Intergenic"))
  rowData(dataset)$Features <- Features
  
  Distances <- rowData(dataset)$distanceToTSS
  Distances[Distances < -100000] <- -1000000
  Distances[Distances > 100000]  <- 1000000
  rowData(dataset)$"TSS Distance" <- Distances
  
  return(dataset)
}

pv.groupColors <- c(crukBlue,crukCyan,crukMagenta, crukGrey, 
                    "green", "forestgreen")

pv.conditionColors <- list(c("white",crukMagenta), 
                           c("white",crukBlue), 
                           c("white",crukGrey), 
                           c("white",crukCyan))

pv.profileHeatmap <- function(profiles, samples_names, group_names,
                              annotate=FALSE,
                              ret_ht_list=FALSE, ...){
  message("Plotting...")
  
  if(is.null(group_names)) {
    include_group_annotation <- FALSE
    group_anno_color <- NULL
  } else {
    include_group_annotation <- TRUE
    group_anno_color <- pv.groupColors[1:length(group_names)]
  }
  
  if(is.null(rowData(profiles)$Features)) {
    annotate <- FALSE
  }
  if(annotate) {
    extra_annotation_columns <- c("Features","TSS Distance" )
    extra_anno_color = list(c(crukBlue,crukCyan,crukMagenta),
                            colorRampPalette(c("red", grDevices::rgb(.99,.99,.99), 
                                               "green"))(n =9))
  } else {
    extra_annotation_columns <- NULL
    extra_anno_color <- NULL
  }
  
  arguments <- list(profiles)
  
  args <- list(...)
  args <- pv.sepProfilingArgs(args, remove=TRUE)
  addarg <- NULL
  
  if(!"matrices_color" %in% names(args)) {
    conditions <- metadata(profiles)$"Sample Group"
    if(!is.null(conditions)) {
      addarg <- pv.addArg(addarg, "matrices_color",
                          pv.conditionColors[conditions])
    }
  }
  
  addarg <- pv.addArg(addarg, "matrices_pos_line",FALSE, args)
  addarg <- pv.addArg(addarg, "decreasing",TRUE, args)
  addarg <- pv.addArg(addarg, "sample_names",samples_names, args)
  addarg <- pv.addArg(addarg, "include_group_annotation",
                      include_group_annotation, args)
  addarg <- pv.addArg(addarg, "group_anno_color",
                      group_anno_color, args)
  addarg <- pv.addArg(addarg, "group_anno_column_names_gp",
                      grid::gpar(col="white"), args)
  addarg <- pv.addArg(addarg, "extra_annotation_columns",
                      extra_annotation_columns, args)
  addarg <- pv.addArg(addarg, "extra_anno_color", extra_anno_color, args)
  addarg <- pv.addArg(addarg, "return_ht_list",ret_ht_list, args)
  addarg <- pv.addArg(addarg, "raster_device","png", args)
  addarg <- pv.addArg(addarg, "raster_quality","10", args)
  
  
  if(!is.null(addarg)){
    arguments <- c(arguments, addarg)
  }  
  
  hm <- do.call(getExportedValue("profileplyr", "generateEnrichedHeatmap"), c(arguments,args))
  
  return(hm)
}


pv.addArg <- function(addarg, param, val, args=NULL) {
  
  if(!is.null(args)) {
    if(param %in% names(args)) {
      return(addarg)
    }
  }
  
  if(is.null(addarg)) {
    addarg <- list(x=val)
    names(addarg) <- param
  } else {
    addarg <- pv.listadd(addarg, val)
    names(addarg)[length(addarg)] <- param
  }
  return(addarg)
}

pv.groupNames <- function(pv) {
  if(length(unique(pv$class[DBA_ID,])) == ncol(pv$class)) {
    return(pv$class[DBA_ID,])
  }
  
  labels <- NULL
  for(i in c(DBA_ID,DBA_TISSUE, DBA_FACTOR, 
             DBA_CONDITION, DBA_TREATMENT)) {
    if(length(unique(pv$class[i,])) > 1) {
      labels <- paste(labels,pv$class[i,],sep="_")
    }
  }
  
  labels <- sub('.', '',labels)
  
  return(labels)
}

pv.groupProfiles <- function(profiles) {
  return(profiles)
}

pv.mergelist <- function(pv, samples, merge, labels=NULL){
  
  if(!is(merge,"list")) { # Make list from excluded attributes
    attributes <- c(DBA_TISSUE,DBA_FACTOR,DBA_CONDITION,DBA_TREATMENT,DBA_REPLICATE)
    atts <- pv$class[attributes[! attributes %in% merge],samples]
    allmerge <- apply(atts,2,paste,collapse="")
    tomerge  <- unique(allmerge)
    if(is.null(labels)) {
      labels <- -merge
    }
    
    merge <- NULL
    for(val in tomerge) {
      merge <- pv.listadd(merge,which(allmerge %in% val))
    }
  }
  
  # Attach labels to mergelist
  
  names(merge) <- pv.makeMergeLabel(pv, merge, samples,labels)
  
  # check uniqueness of labels
  names(merge) <- make.unique(as.character(names(merge)))
  
  # return list of merge groups with label names
  return(merge)
}

pv.makeMergeLabel <- function(pv, merge, samples, labels=NULL) {
  
  if(is(labels[1],"character")) {
    if(length(labels) != length(merge)) {
      warning("Should be same number of sample labels as samples.",call.=FALSE)
    } else {
      return(labels)
    }
  }
  
  if(is.null(names(merge))) {
    
    atts <- c(DBA_TISSUE,DBA_FACTOR,DBA_CONDITION,DBA_TREATMENT,DBA_REPLICATE)
    
    #samples <- samples[unlist(merge)]
    
    if(is.null(labels)) {
      labels <- atts
    }
    
    if(labels[1] < 0) { # labels are negative, remove
      
      labels <-  atts[which(!atts %in% abs(labels))]
      
      # Strip common attributes as well
      if(length(labels) > 1) {
        uatts <- apply(pv$class[labels,samples],1,unique)
        for(i in length(labels):1) {
          if(length(uatts[[i]])==1) {
            labels <- labels[-i]
          }
        }
      }
    }
    
    res <- lapply(merge, pv.doMakeMergeLabel, pv$class, samples, labels)
    
    return(res)
  }
}

pv.doMakeMergeLabel <- function(tomerge, meta, samples, labels) {
  res <- NULL
  for(label in labels) {
    res <- c(res, unique(meta[label,samples[tomerge]]))
  }
  if(length(res) > 1) {
    res <- paste(res, collapse="_")
  }
  return(res)
}


pv.mergeProfiles <- function(profiles, mergelist, bMean=TRUE) {
  
  totalsamps <- length(profiles)
  mergelist <- mergelist[order(unlist(lapply(mergelist,min)))]
  mergesamps <- sort(unlist(mergelist))
  if(length(mergesamps) != totalsamps) {
    toadd <- which(!(1:totalsamps %in% mergesamps))
  } else toadd <- NULL
  
  resultlist <- NULL
  
  for(tomerge in mergelist) {
    
    if(length(tomerge) > 1) {
      
      adding <- TRUE
      while(adding){
        if(length(toadd) > 0) {
          if(toadd[1] < tomerge[1]) {
            resultlist <- pv.listadd(resultlist, profiles[[toadd[1]]])
            toadd <- toadd[-1]
          } else {
            adding <- FALSE
          }
        } else adding <- FALSE
      }
      
      profile <- profiles[[tomerge[1]]]
      
      merged <- assay(profile)
      for(i in 2:length(tomerge)) {
        merged <- merged + assay(profiles[[tomerge[i]]])
      }
      
      if(bMean) {
        merged <- merged / length(tomerge)
      }
      
      assay(profile) <- merged
      
    } else {
      profile <- profiles[[tomerge[1]]]
    }
    
    resultlist <- pv.listadd(resultlist, profile)
  }
  
  
  while(length(toadd) > 0) {
    resultlist <- pv.listadd(resultlist, profiles[[toadd[1]]])
    toadd <- toadd[-1]
  }
  
  return(resultlist)
  
}

pv.ProfilingArgs <- c("style","nOfWindows","bin_size",
                      "distanceAround","distanceUp","distanceDown")

pv.sepProfilingArgs <- function(arglist, remove=FALSE) {
  profiling <- which(names(arglist) %in% pv.ProfilingArgs)
  if(length(profiling) > 0) {
    proargs <- arglist[profiling]
    plotargs <- arglist[!profiling]
  } else {
    proargs <- NULL
    plotargs <- arglist
  }
  
  if(remove) {
    return(plotargs)
  } else {
    return(proargs)
  }
}

################################################
## cpp_wrapper.R -- wrap C/C++ functions in R ##
## first created: 2014 03 12                  ##
## Gord Brown                                 ##
## CR-UK Cambridge Institute                  ##
################################################

################################################
## Entry Points to C/C++ Routines             ##
################################################

## cpp_count_reads -- count reads on intervals

cpp_count_reads <- function(bamfile,insertLength,fileType,bufferSize,
                            intervals,bWithoutDupes,summits,minMappingQual=0,
                            minVal=1) {
  icount <- length(intervals[[1]])
  counts <- vector(mode="integer",length=icount)
  if (summits >= 0) { # RJS 2/7/2020: change from !missing(summits)) {
    summits.vec <- vector(mode="integer",length=icount)
    heights.vec <- vector(mode="integer",length=icount)
    bSummits = TRUE
  } else {
    summits.vec <- vector()
    heights.vec <- vector()
    bSummits = FALSE
  }
  bamfile <- path.expand(bamfile)
  libsize <- .Call("croi_count_reads",PACKAGE='DiffBind',
                   bamfile,
                   as.integer(insertLength),
                   as.integer(fileType),
                   as.integer(bufferSize),
                   as.integer(minMappingQual),
                   as.character(intervals[[1]]),
                   as.integer(intervals[[2]]),
                   as.integer(intervals[[3]]),
                   as.integer(icount),
                   as.logical(bWithoutDupes),
                   as.logical(bSummits),
                   counts,
                   summits.vec,
                   heights.vec)
  
  # RJS 10 July 2020 -- Added minVal parameter  
  mincounts <- counts
  mincounts[mincounts<minVal] <- minVal
  
  widths = intervals[,3] - intervals[,2]
  rpkm = (mincounts/(widths/1000))/(libsize/1E6)
  
  result <- list(counts=counts,rpkm=rpkm,libsize=libsize)
  if (bSummits==TRUE) {
    result$summits <- summits.vec;
    result$heights <- heights.vec;
  }
  return(result)
}

pv.DBAreport <- function(pv,contrast=1,method='edgeR',th=0.05,bUsePval=FALSE,
                         bCalled=FALSE,bCounts=FALSE,bCalledDetail=FALSE,
                         file,initString='reports/DBA',bNormalized=TRUE,
                         ext="csv",minFold=0,bSupressWarning=FALSE,
                         bFlip=FALSE, precision=2:3, lfc=minFold) {
  
  
  if(length(contrast)>1){
    stop('Can only specify one contrast unless requesting a report-based DBA.',
         call.=FALSE)
  }
  
  if(contrast > length(pv$contrasts)) {
    stop('Specified contrast number is greater than number of contrasts',
         call.=FALSE)
    return(NULL)
  }
  con <- pv$contrasts[[contrast]]
  
  if(is.null(con$group1)) {
    groups <- FALSE
  } else {
    groups <- TRUE
  } 
  
  group1 <- con$group1
  name1  <- con$name1
  group2 <- con$group2
  name2  <- con$name2
  facs   <- 1:(sum(group1)+sum(group2))
  if(bFlip) {
    group1 <- con$group2
    name1  <- con$name2
    group2 <- con$group1
    name2  <- con$name1
    facs   <- (sum(group2)+1):length(facs)
    facs   <- c(facs,1:sum(group2))
  }
  
  if(method=='edgeR' || method=='edgeRGLM'){
    if(is.null(con$edgeR) || is(con$edgeR,"try-error")) {
      stop('edgeR analysis has not been run for this contrast',call.=FALSE)
      return(NULL)
    }
    
    filter <- pv$norm$edgeR$filter.val
    filterFun <- pv$norm$edgeR$filter.fun
    
    normalized <- FALSE
    if(!is.null(con$contrast)) {
      
      if(is.null(pv$edgeR$DEdata)) {
        
        message('edgeR analysis missing -- re-running...')
        
        if(is.null(pv$config$edgeR$bTagwise)) {
          bTagwise <- TRUE
        } else {
          bTagwise <- pv$config$edgeR$bTagwise 
        }
        
        edger <- pv.edgeRdesign(pv,bSubControl=pv$norm$edgeR$bSubControl,
                                bTagwise=bTagwise,
                                existing=pv$edgeR,
                                filter=pv$norm$edgeR$filter.val,
                                filterFun=pv$norm$edgeR$filter.fun)
        pv$edgeR$DEdata <- edger$DEdata
      }
      
      counts <- pv.edgeRCounts(pv,method,bNormalized)
      normalized <- TRUE
      
      if(groups) {
        facs <-  c(which(group1),which(group2))
        counts <- counts[,facs]
      } else {
        facs <- 1:ncol(counts)
      }
      
    } else {
      if(is.null(con$edgeR$counts)) {
        counts <- pv.DEinit(pv,group1,group2,name1,name2,
                            method='edgeR',
                            bSubControl=con$edgeR$bSubControl,
                            bFullLibrarySize=con$edgeR$bFullLibrarySize,
                            bRawCounts=TRUE,
                            filter=filter, filterFun=filterFun)
      } else {
        counts <- con$edgeR$counts	
      }
    }
    if("id" %in% names(con$edgeR$de)) {
      siteCol <- 1
      pvCol   <- 2
      fdrCol  <- 3
      data <- con$edgeR$de   
      if(is.null(pv$edgeR$DEdata$pseudo.lib.size)) {
        sizes <-  pv$edgeR$DEdata$samples$norm.factors[facs]
        pls <- 1
      } else {
        sizes <- pv$edgeR$DEdata$samples$lib.size[facs] * 
          pv$edgeR$DEdata$samples$norm.factors[facs]
        pls <- pv$edgeR$DEdata$pseudo.lib.size[facs]
      }
    } else {
      if(!is.null(con$edgeR$LRT)) {
        siteCol <- 1
        pvCol   <- 5
        fdrCol  <- 6
        data <- edgeR::topTags(con$edgeR$LRT,nrow(counts))$table   	  	
      } else {
        siteCol <- 1
        pvCol   <- 4
        fdrCol  <- 5
        data <- edgeR::topTags(con$edgeR$db,nrow(counts))$table
      }
      sizes <- con$edgeR$samples$lib.size[facs] * 
        con$edgeR$samples$norm.factors[facs]
      pls <- con$edgeR$pseudo.lib.size
    }
    if(bNormalized && !normalized){
      counts <- t(t(counts)/sizes)
      counts <- counts * pls
    }
    
    if(lfc > 0) {
      if(!is.null(con$contrast)) {
        data <- pv.edgeRContrastResults(pv, con, lfc=lfc)$de
      } else {
        warning("Contrast has no explicit design; assuming fold=0.",
                call.=FALSE) 
      }
    }
    
  } else if(method=='edgeRlm'){
    
    filter <- pv$norm$edgeR$filter.val
    filterFun <- pv$norm$edgeR$filter.fun
    
    if(is.null(con$edgeR$counts)) {
      counts <- pv.DEinit(pv,group1,group2,name1,name2,
                          method='edgeR',
                          bSubControl=con$edgeR$block$bSubControl,
                          bFullLibrarySize=con$edgeR$block$bFullLibrarySize,
                          bRawCounts=TRUE,
                          filter=filter, filterFun=filterFun)
    } else {
      counts <- con$edgeR$counts	
    }
    
    siteCol <- 1
    pvCol   <- 5  
    fdrCol  <- 6
    data <- edgeR::topTags(con$edgeR$block$LRT,nrow(counts))$table
    
    if(bNormalized){
      sizes <- con$edgeR$samples$lib.size[facs] * 
        con$edgeR$samples$norm.factors[facs]
      counts <- t(t(counts)/sizes)
      counts <- counts * con$edgeR$pseudo.lib.size
    } 
  } else if (method=='DESeq2' || method=='DESeq2Block') {
    if (!requireNamespace("DESeq2",quietly=TRUE)) {
      stop("Package DESeq2 not installed",call.=FALSE)
    }
    if(is.null(con$DESeq2) || is(con$DESeq2,"try-error")) {
      stop('DESeq2 analysis has not been run for this contrast',call.=FALSE) 
      return(NULL) 
    }
    
    filter <- pv$norm$DESeq2$filter.val
    filterFun <- pv$norm$DESeq2$filter.fun
    
    siteCol <- 1
    pvCol   <- 2
    fdrCol <-  3
    
    if(!is.null(con$contrast)) {
      
      if(is.null(pv$DESeq2$DEdata)) {
        message('DESeq2 analysis missing -- re-running...')
        deseq2 <- pv.DESeq2design(pv,
                                  bSubControl=pv$norm$DESeq2$bSubControl,
                                  existing=pv$DESeq2,
                                  filter=pv$norm$DESeq2$filter.val,
                                  filterFun=pv$norm$DESeq2$filter.fun)
        pv$DESeq2$DEdata <- deseq2$DEdata
      }
      
      counts <- DESeq2::counts(pv$DESeq2$DEdata, 
                               normalized = bNormalized)
      
      data     <- con$DESeq2$de
      normfacs <- pv$DESeq2$facs
      
      if(groups) {
        counts   <- cbind(counts[,group1],counts[,group2])
        normfacs <- c(normfacs[group1],normfacs[group2])
      }
      
      if(lfc > 0) {
        data <- pv.DESeq2ContrastResults(pv, con, lfc=lfc)$de
      }
      
    } else {
      
      counts <- pv.countsMA(pv, method=DBA_DESEQ2, contrast=NULL, 
                            bNormalized=bNormalized, bCountsOnly=TRUE, filter=0,
                            noSub=!pv$norm$DESeq2$bSubControl)
      counts <- cbind(counts[,group1],counts[,group2])
      
      if(method=='DESeq2Block') {
        data <- con$DESeq2$block$de
        normfacs <- con$DESeq2$block$facs[facs]
      } else {
        data <- con$DESeq2$de
        normfacs <- con$DESeq2$facs[facs]
      }
      
      if(minFold > 0) {
        warning("Contrast has no explicit design; assuming fold=0.",
                call.=FALSE)
      }
    }
  } else {
    stop('Unknown DE method: ',method,call.=FALSE)
    return(NULL)
  }
  
  if(bUsePval) {
    thCol <- pvCol	
  } else {
    thCol <- fdrCol	
  }
  
  x <- which(is.na(data[,pvCol]))
  if(length(x)>0){
    data[x,pvCol] <- 1
  }
  x <- which(is.na(data[,fdrCol]))
  if(length(x)>0){
    data[x,fdrCol] <- 1
  }
  
  keep <-  data[,thCol] <= th
  sites <- as.numeric(data[keep,siteCol])
  sites <- match(sites,as.integer(rownames(counts)))
  if(sum(keep)==0) {
    if(!bSupressWarning) {
      warning('No sites above threshold',call.=FALSE)
    }
    return(NULL)
  } else if(sum(keep)==1) {
    cnames <- colnames(counts)
    counts <- matrix(counts[sites,],nrow=1,ncol=ncol(counts))
    colnames(counts) <- cnames
    rownames(counts) <- sites
  } else {
    counts <- counts[sites,]
  }
  
  siteids <- as.numeric(rownames(counts))[1:length(sites)]
  
  if(groups) {
    if(length(sites)==1) {
      conc <- log2(mean(counts))
      if(sum(group1)>1) {
        con1 <- log2(mean(counts[,1:sum(group1)]))
      } else {
        con1 <- log2(counts[,1])
      }
      if(sum(group2)>1) {
        con2 <- log2(mean(counts[,(sum(group1)+1):ncol(counts)]))
      } else {
        con2 <- log2(counts[,sum(group1)+1])
      }        
    } else {
      conc <- log2(apply(counts,1,mean))
      if(sum(group1)>1) {
        con1 <- log2(apply(counts[,1:sum(group1)],1,mean))
      } else {
        con1 <- log2(counts[,1])
      }
      if(sum(group2)>1) {
        con2 <- log2(apply(counts[,(sum(group1)+1):ncol(counts)],1,mean))
      } else {
        con2 <- log2(counts[,sum(group1)+1])
      }
    }
    con1[con1<0] <- 0
    con2[con2<0] <- 0
    conc[conc<0] <- 0
    
    if(!bNormalized || is.null(data$fold)) {
      fold <- con1 - con2
    } else {
      fold <- data$fold[keep]
      if(bFlip==TRUE) {
        fold <- fold * -1
      }
    }
    data <- cbind(pv.getsites(pv,siteids),conc,con1,con2,fold,data[keep,c(pvCol,fdrCol)])
    conc1 <- sprintf('Conc_%s',name1)
    conc2 <- sprintf('Conc_%s',name2)
    colnames(data) <- c('Chr','Start','End','Conc',conc1,conc2,'Fold','p-value','FDR')
    
  } else {
    conc <- log2(apply(counts,1,mean))
    conc[conc<0] <- 0
    fold <- data$fold[keep]
    data <- cbind(pv.getsites(pv,siteids),conc,fold,data[keep,c(pvCol,fdrCol)])
    colnames(data) <- c('Chr','Start','End','Conc','Fold','p-value','FDR')
  }
  
  if(bCounts) {
    counts <- round(counts,2)
    if(groups) {
      colnames(counts) <- c(pv$class[PV_ID,group1],pv$class[PV_ID,group2])
    } else {
      colnames(counts) <- pv$class[PV_ID,]
    }
    if(length(sites)>1){
      data <- cbind(data,counts)
    } else {
      dnames <- colnames(data)
      cnames <- colnames(counts)
      data <- cbind(data,matrix(counts,1,ncol(counts)))
      colnames(data) <- c(dnames,cnames)
    }
  }
  
  if(groups) {
    
    if(is.null(pv$called) & (bCalled || bCalledDetail)) {
      warning("No Called information available.",
              call.=FALSE)
    } else {
      
      if(bCalled && !is.null(pv$called)) {
        Called1 <- apply(pv$called[siteids,group1],1,sum)
        Called2 <- apply(pv$called[siteids,group2],1,sum)
        data <- cbind(data,Called1,Called2)
      }
      
      if(bCalledDetail && !is.null(pv$called)) {
        newd <- pv$called[siteids,c(which(group1),which(group2))]
        newd[newd==1] <- '+'
        newd[newd==0] <- '-'
        colnames(newd) <- c(pv$class[PV_ID,group1],pv$class[PV_ID,group2])
        data <- cbind(data,newd)
      }
    }
  }
  
  if(minFold>0) {
    data <- data[abs(data$Fold)>=minFold,]
  }
  
  if(bUsePval) {
    data <- data[order(data$'p-value'),]
  } else {
    data <- data[order(data$FDR,data$'p-value'),]
  }
  
  if(length(precision==1) && precision[1]>0) {
    precision <- c(precision,precision)
  }
  
  if(length(precision)==2) {
    if(groups) {
      data[,4:7] <- round(data[,4:7],precision[1])
      data[,8:9] <- signif(data[,8:9],precision[2])
    } else {
      data[,4:5] <- round(data[,4:5],precision[1])
      data[,6:7] <- signif(data[,6:7],precision[2])
    }
  }
  
  if(!missing(file)) {
    if(!is.null(initString)) {
      initString <- sprintf("%s_",initString)
    } else {
      initString <- ""
    }
    if(is.null(file)) {
      file=sprintf("%s%s_vs_%s_%s.%s",initString,name1,name2,method,ext)
    } else {
      file=sprintf("%s%s.%s",initString,file,ext)
    }
    write.csv(data,row.names=FALSE,file=file)
  }
  
  return(data)
  
}

pv.getsites <- function(pv,sites){
  if(is.logical(sites)) {
    sites <- which(sites)
  }
  siteNum <- as.integer(sites)
  idx   <- match(siteNum,rownames(pv$binding))
  sites <- data.frame(pv$binding[idx,1:3])
  if(length(idx)==1) {
    sites <- data.frame(t(sites))
    rownames(sites) <- siteNum
  }
  sites[,1] <- pv$chrmap[sites[,1]]
  return(sites)
}

pv.getPlotData <- 
  function(pv,attributes=PV_GROUP,contrast=1,method=DBA_DESEQ2,th=0.05,
           bUsePval=FALSE,bNormalized=TRUE,report,
           bPCA=FALSE,bLog=TRUE,minval,maxval,mask,fold=0,
           bFlip=FALSE, precision=2:3) {
    
    if(contrast > length(pv$contrasts)) {
      stop('Specified contrast number is greater than number of contrasts',call.=FALSE)
      return(NULL)
    }
    
    con <- pv$contrasts[[contrast]]
    
    if(is.null(con$group1)) {
      pv <- pv.getPlotDataComplexContrast(pv=pv,attributes-attributes, contrast=contrast,
                                          method=method, bUsePval=bUsePval,mask=mask,
                                          bNormalized=bNormalized,report=report,
                                          bLog=bLog,minval=minval,maxval=maxval,
                                          fold=fold, precision=precision)
      return(pv)
    }
    
    if(missing(report)) {
      report <- pv.DBAreport(pv,contrast=contrast,method=method,th=th,bUsePval=bUsePval,
                             bNormalized=bNormalized,bCounts=TRUE,bSupressWarning=TRUE,
                             minFold=fold,bFlip=bFlip,precision=precision)
      if(is.null(report)) {
        stop('Unable to plot -- no sites within threshold',call.=FALSE)	
      }
    } else {
      report <- report[abs(report$Fold)>=fold,]
    }
    
    if(nrow(report)==1) {
      stop("Only one site to plot -- need at least 2!",call.=FALSE)   
    }
    
    if(!missing(mask)){
      if (!is.logical(mask)) {
        if (max(mask) > length(pv$peaks)) {
          stop("Invalid sample number in mask.",call.=FALSE)
        }
        temp <- rep(FALSE, length(pv$peaks))
        temp[mask] <- TRUE
        mask <- temp
      }
      if(!bFlip) {
        group1 <- con$group1 & mask
        group2 <- con$group2 & mask
      } else {
        group1 <- con$group2 & mask
        group2 <- con$group1 & mask
      }
      sites <- as.numeric(rownames(report))
      extra <- mask & !(group1 | group2)
      allsamps <- c(which(group1), which(group2), which(extra))
      numsamps <- length(allsamps)
      domap <- matrix(0,length(sites),0)
      if(sum(group1)) {     
        domap <- cbind(domap,pv$binding[sites,3+which(group1)])
      }
      if(sum(group2)) {
        domap <- cbind(domap,pv$binding[sites,3+which(group2)])
      }
      if(sum(extra)) {
        domap <- cbind(domap,pv$binding[sites,3+which(extra)])
      }
      rownames(domap) <- rownames(report)
      colnames(domap) <- pv$class[PV_ID,allsamps] 
      con$group1 <- group1
      con$group2 <- group2
      peaks <- pv$peaks[allsamps]
      for(i in 1:length(peaks)){
        peaks[[i]] <- peaks[[i]][sites,]
      }  
    } else {
      if(!bFlip) {
        group1 <- con$group1 
        group2 <- con$group2 
      } else {
        group1 <- con$group2 
        group2 <- con$group1 
      }
      allsamps <- c(which(group1),which(group2))
      extra <- rep(FALSE,ncol(pv$class)) 
      repcols <- colnames(report)
      numsamps <- sum(group1)+sum(group2)
      if(length(repcols) < (numsamps+9)) {
        stop('Report does not have count data, re-run dba.report with bCounts=TRUE',call.=FALSE)
      }
      first <- 10
      if(repcols[10]=="Called1") {
        if(length(repcols) < (numsamps+11)) {
          stop('Report does not have count data, re-run dba.report with bCounts=TRUE',call.=FALSE)
        }
        first <- 12	 
      }
      domap <- report[,first:(first+numsamps-1)]
      group1 <- rep(FALSE,numsamps)
      group2 <- rep(TRUE,numsamps)
      group1[1:sum(con$group1)] <- TRUE
      group2[1:sum(con$group1)] <- FALSE
      con$group1 <- group1
      con$group2 <- group2
      
      sites <- as.numeric(rownames(report))
      peaks <- pv$peaks[allsamps]
      for(i in 1:length(peaks)){
        peaks[[i]] <- peaks[[i]][sites,]
      }  
    }
    
    if(bLog) {
      domap[domap<=0]=1
      domap <- log2(domap)
      if(missing(minval)) {
        minval <- 0
      } else {
        minval <- max(0,minval)
      }
    }
    
    if(!missing(minval)) {
      domap[domap< minval]= minval
    }
    if(!missing(maxval)) {
      domap[domap>maxval] <- maxval
    }
    
    pv$binding <- cbind(report[,1:3],domap)
    pv$class <- pv$class[,allsamps]
    pv$peaks <- peaks
    pv$called <- pv$called[sites,allsamps]
    pv$merged <- pv$binding[,1:3]
    pv$totalMerged <- do.nrow(pv$merged)
    pv$contrasts <- list(pv$contrasts[[contrast]])
    pv$contrasts[[1]]$group1 <- rep(FALSE,ncol(pv$class))
    pv$contrasts[[1]]$group2 <- rep(FALSE,ncol(pv$class))
    if(sum(con$group1)) {
      pv$contrasts[[1]]$group1[1:sum(con$group1)] <- TRUE
    }
    if(sum(con$group2)) {
      pv$contrasts[[1]]$group2[(sum(con$group1)+1):(sum(con$group1)+sum(con$group2))] <- TRUE 
    }
    
    if(bPCA)  {
      
      #pv$pc <- princomp(domap,cor=bPCAcor)
      
      if(attributes[1] == PV_GROUP) {
        pv$class[PV_ID,] <- c( rep(con$name1,sum(con$group1)), rep(con$name2,sum(con$group2)), rep("other",sum(extra)) )
      }
    } 
    
    return(pv)     
  }

pv.getPlotDataComplexContrast <- 
  function(pv,attributes=PV_GROUP,contrast=1,method=DBA_DESEQ2,th=0.05,
           bUsePval=FALSE,mask,bNormalized=TRUE,report,
           bLog=TRUE,minval,maxval,fold=0,
           precision=2:3) {
    
    if(contrast > length(pv$contrasts)) {
      stop('Specified contrast number is greater than number of contrasts',call.=FALSE)
      return(NULL)
    }
    
    con <- pv$contrasts[[contrast]]
    
    if(missing(report)) {
      report <- pv.DBAreport(pv,contrast=contrast,method=method,th=th,bUsePval=bUsePval,
                             bNormalized=bNormalized,bCounts=TRUE,bSupressWarning=TRUE,
                             minFold=fold,precision=precision)
      if(is.null(report)) {
        stop('Unable to plot -- no sites within threshold',call.=FALSE)	
      }
    } else {
      report <- report[abs(report$Fold)>=fold,]
    }
    
    if(nrow(report)==1) {
      stop("Only one site to plot -- need at least 2!",call.=FALSE)   
    }
    
    sites <- as.numeric(rownames(report))
    
    if(missing(mask)){
      numsamps <- ncol(pv$class)
      allsamps <- 1:numsamps
    } else {
      if (!is.logical(mask)) {
        if (max(mask) > length(pv$peaks)) {
          stop("Invalid sample number in mask.",call.=FALSE)
        }
        temp <- rep(FALSE, length(pv$peaks))
        temp[mask] <- TRUE
        mask <- temp
      }
      
      allsamps <- which(mask)
      numsamps <- length(allsamps)
      
      repmask <- rep(TRUE,ncol(report))
      repmask[(length(repmask)-length(mask)+1):length(repmask)] <- mask
      report <- report[,repmask]
    } 
    
    repcols <- colnames(report)
    if(length(repcols) < (numsamps+7)) {
      stop('Report does not have count data, re-run dba.report with bCounts=TRUE',call.=FALSE)
    }
    
    first <- match("FDR",repcols) + 1
    if(repcols[first]=="Called1") {
      if(length(repcols) < (numsamps+first-1)) {
        stop('Report does not have count data, re-run dba.report with bCounts=TRUE',call.=FALSE)
      }
      first <- first+2	 
    }
    
    domap <- report[,first:(first+numsamps-1)]
    rownames(domap) <- rownames(report)
    colnames(domap) <- pv$class[PV_ID,allsamps]
    
    peaks <- pv$peaks[allsamps]
    for(i in 1:length(peaks)){
      peaks[[i]] <- peaks[[i]][sites,]
    }  
    
    if(bLog) {
      domap[domap<=0]=1
      domap <- log2(domap)
      if(missing(minval)) {
        minval <- 0
      } else {
        minval <- max(0,minval)
      }
    }
    
    if(!missing(minval)) {
      domap[domap< minval]= minval
    }
    if(!missing(maxval)) {
      domap[domap>maxval] <- maxval
    }
    
    pv$binding <- cbind(report[,1:3],domap)
    pv$class <- pv$class[,allsamps]
    pv$peaks <- peaks
    pv$called <- pv$called[sites,allsamps]
    pv$merged <- pv$binding[,1:3]
    pv$totalMerged <- do.nrow(pv$merged)
    pv$contrasts <- list(pv$contrasts[[contrast]])
    
    return(pv)     
  }

pv.resultsDBA <- function(DBA,contrasts,methods=DBA$config$AnalysisMethod,
                          th=0.05,bUsePval=FALSE,fold=0,
                          bDB=TRUE,bNotDB=FALSE,bUp=FALSE,bDown=FALSE,bAll=TRUE,
                          bFlip=FALSE) {
  
  if(missing(contrasts)) {
    contrasts <- 1:length(DBA$contrasts)
  }
  
  res <- NULL
  for(contrast in contrasts) {
    for(method in methods) {
      res <- pv.doResults(res,DBA,contrast,method,th,bUsePval,fold,
                          bDB=bDB,bNotDB=bNotDB,bUp=bUp,bDown=bDown,bAll=bAll,
                          bFlip=bFlip)		
    }
  }
  
  if(is.null(res)) {
    stop('No valid contrasts/methods specified.', call.=FALSE)	
  }
  
  res$config <- DBA$config
  res$config$id        <- "Contrast"
  res$config$factor    <- "DB"
  res$config$tissue    <- "Direction"
  res$config$condition <- "Method"
  res$config$treatment <- "Block"
  
  res <- pv.model(res, minOverlap=1)
  res <- pv.ResetScores(res, ones=FALSE)
  res$resultsObject <- TRUE
  res$score <- DBA_SCORE_FOLD
  
  class(res) <- "DBA"
  
  return(res)	
  
}

pv.doResults <- function(res,DBA,contrast,method,
                         th,bUsePval,fold=0,
                         bDB=TRUE,bNotDB=FALSE,bAll=FALSE,
                         bUp=FALSE,bDown=FALSE,
                         bFlip=FALSE) {
  
  if(method=='edgeR' || method=="edgeRGLM") {
    if(is.null(DBA$contrasts[[contrast]]$edgeR) && is.null(DBA$edgeR)) {
      return(res)	
    }
    methname <- "edgeR"
    block <- ""
  }
  if (method=='edgeRlm') {
    if(is.null(DBA$contrasts[[contrast]]$edgeR$block)) {
      return(res)	
    }
    methname="edgeR"
    block="block"	
  }
  if(method=='DESeq2' || method=='DESeq2GLM') {
    if(is.null(DBA$contrasts[[contrast]]$DESeq2) && is.null(DBA$DEseq2)) {
      return(res)  
    }      
    methname <- "DESeq2"
    block <- ""
  }
  if (method=='DESeq2Block') {
    if(is.null(DBA$contrasts[[contrast]]$DESeq2$block)) {
      return(res)	
    }           
    methname="DESeq2"
    block="block"	
  }
  
  if(bNotDB) {
    useth <- 1
  } else {
    useth <- th
  }
  
  rep <- suppressWarnings(pv.DBAreport(pv=DBA,contrast=contrast,method=method,
                                       th=useth,bUsePval=bUsePval,
                                       minFold=0, lfc=fold,
                                       bFlip=bFlip, precision=2:3))
  
  if(is.null(rep)) {
    return(res)	
  }
  
  rep <- rep[order(as.integer(rownames(rep))),]
  
  id <- pv.getContrastString(DBA$contrast[[contrast]], bFlip) 
  
  if(bUsePval) {
    scores <- rep$"p-value"
  } else {
    scores <- rep$FDR
  }    
  
  db <- (scores <= th) & (abs(rep$Fold) >= fold)
  up <- rep$Fold >= 0
  peaks <- cbind(rep[,1:3],rep$Fold,rep[,4:ncol(rep)])
  
  if(bDB) {
    if(bAll) {
      if(sum(db)) {
        res <- pv.peakset(res,peaks=peaks[db,],sampID=id,factor="DB",tissue="All",
                          condition=methname,treatment=block,bMakeMasks=FALSE)	
      }
    }
    if(bUp) {
      if(sum(db&up)) {	
        res <- pv.peakset(res,peaks=peaks[db&up,],sampID=id, factor ="DB", tissue ="Gain",
                          condition=methname,treatment=block,bMakeMasks=FALSE)	
      }
    }
    if(bDown) {
      if(sum(db&!up)) {
        res <- pv.peakset(res,peaks=peaks[db&!up,],sampID=id, factor ="DB", tissue ="Loss",
                          condition=methname,treatment=block,bMakeMasks=FALSE)	
      }
    }		
  }
  if(bNotDB) {
    if(bAll) {
      if(sum(!db)) {
        res <- pv.peakset(res,peaks=peaks[!db,],sampID=id, factor ="!DB", tissue ="All",
                          condition=methname,treatment=block,bMakeMasks=FALSE)	
      }
    }
    if(bUp) {
      if(sum(!db&up)) {
        res <- pv.peakset(res,peaks=peaks[!db&up,],sampID=id, factor ="!DB", tissue ="Gain",
                          condition=methname,treatment=block,bMakeMasks=FALSE)	
      }
    }
    if(bDown) {
      if(sum(!db&!up)) {
        res <- pv.peakset(res,peaks=peaks[!db&!up,],sampID=id, factor ="!DB", tissue ="Loss",
                          condition=methname,treatment=block,bMakeMasks=FALSE)	
      }
    }		
  }    
  
  if(is.null(res$masks)) {
    res$masks <- pv.mask(res)
  }
  
  return(res)	
}

pv.ResetScores <- function(pv, ones=FALSE){
  
  return(pv)
  
  binding <- pv$binding[,1:3]
  binding[,1] <- pv$chrmap[binding[,1]]
  binding <- GRanges(data.frame(binding))
  GenomicRanges::mcols(binding) <- pv$binding[,4:ncol(pv$binding)]
  
  for(i in 1:length(pv$peaks)) {
    peaks <- GRanges(data.frame(pv$peaks[[i]]))
    matches <- which(binding %over% peaks)
    keep <- which(peaks %over% binding)
    if(length(matches) != length(keep)) {
      return(pv)
    }
    scores <- pv$peaks[[i]]$Score
    if(ones==TRUE) {
      scores[scores<1] <- -1
      scores[scores>1] <-  1
    }
    GenomicRanges::mcols(binding)[matches,i] <- scores[keep]
  }
  
  pv$binding[,4:ncol(pv$binding)] <- as.matrix(GenomicRanges::mcols(binding))
  return(pv)
}

PV_SCORE_FOLD             <- "score_fold"
PV_SCORE_CONCENTRATION    <- "score_conc"
PV_SCORE_CONC_NUMERATOR   <- "score_num"
PV_SCORE_CONC_DENOMINATOR <- "score_denom"
PV_SCORE_PVAL             <- "score_pval"
PV_SCORE_FDR              <- "score_fdr"

pv.ResetResultScores <- function(pv, score) {
  
  if(score == pv$score) {
    return(pv)
  }
  
  if(score == PV_SCORE_FOLD) {
    pv <- pv.changeScore(pv, 4)
  } else if(score == PV_SCORE_CONCENTRATION) {
    pv <- pv.changeScore(pv, 1)      
  } else if(score == PV_SCORE_CONC_NUMERATOR) {
    pv <- pv.changeScore(pv, 2)      
  } else if(score == PV_SCORE_CONC_DENOMINATOR) {
    pv <- pv.changeScore(pv, 3)      
  } else if(score == PV_SCORE_PVAL) {
    pv <- pv.changeScore(pv, 5)      
  } else if(score == PV_SCORE_FDR) {
    pv <- pv.changeScore(pv, 6)      
  } else {
    message("Invalid score")
    return(pv)
  }
  
  config <- pv$config
  pv <- pv.model(pv, minOverlap=pv$minOverlap) 
  pv$config <- config
  pv$resultsObject <- TRUE
  pv$score <- score
  
  class(pv) <- "DBA"
  
  return(pv)
}

pv.changeScore <- function(pv, colnum=1) {
  for(i in 1:length(pv$peaks)) {
    colnum <- 4+colnum
    pv$peaks[[i]]$Score <- pv$peaks[[i]][,colnum]
  }
  return(pv)
}

#############################################
## DBA.R -- Differential Binding Analysis  ##
## 20 April 2011                           ##
## Rory Stark                              ##
## Cancer Research UK                      ##
#############################################

## dba	            Construct a dba object

## dba.peakset	    Add a peakset to a dba object
## dba.overlap	    Compute binding site overlaps
## dba.blacklist    apply/generate blacklists and greylists

## dba.count  	    Count reads in binding sites
## dba.normalize    Normalize dataset

## dba.contrast	    Establish contrast(s) for analysis
## dna.analyze  	  Execute affinity analysis
## dba.report	      Generate report for a contrast analysis

## dba.plotClust	  Cluster dendrogram plo
## dba.plotHeatmap	Heatmap plot
## dba.plotPCA	    Principal Components plot
## dba.plotBox	    Boxplots
## dba.plotMA	      MA/scatter plot
## dba.plotVenn	    2, 3, or 4-way Venn diagram plot
## dba.plotVolcano	Volcano plots
## dba.plotProfile  Profile heatmaps

## dba.show	        List dba metadata
## dba.mask	        Mask samples or sites 

## dba.save	        Save dba object
## dba.load	        Load dba object

### NOTE: DBA is a front-end to a package formerly known as pv, with most DBA
### functions being simple pass-throughs to pv functions

##########################
### CONSTANT VARIABLES ###
##########################
DBA_GROUP     <- PV_GROUP
DBA_ID        <- PV_ID 
DBA_TISSUE    <- PV_TISSUE 
DBA_FACTOR    <- PV_FACTOR
DBA_CONDITION <- PV_CONDITION
DBA_TREATMENT <- PV_TREATMENT
DBA_CONSENSUS <- PV_CONSENSUS
DBA_CALLER    <- PV_CALLER
DBA_CONTROL   <- PV_CONTROL
DBA_READS     <- PV_READS
DBA_REPLICATE <- PV_REPLICATE
DBA_INTERVALS <- PV_INTERVALS
DBA_FRIP      <- PV_SN_RATIO
DBA_ALL_ATTRIBUTES <- c(DBA_ID,DBA_TISSUE,DBA_FACTOR,
                        DBA_CONDITION,DBA_TREATMENT,
                        DBA_REPLICATE,DBA_CALLER)

DBA_EDGER_BLOCK   <- 'edgeRlm'
DBA_EDGER_GLM     <- 'edgeRGLM'
DBA_EDGER         <- DBA_EDGER_GLM

DBA_DESEQ2        <- 'DESeq2'
DBA_DESEQ2_BLOCK  <- 'DESeq2Block'

DBA_ALL_METHODS <- c(DBA_EDGER,DBA_DESEQ2)
DBA_ALL_BLOCK   <- c(DBA_EDGER_BLOCK,DBA_DESEQ2_BLOCK)
DBA_ALL_METHODS_BLOCK <- c(DBA_ALL_METHODS, DBA_ALL_BLOCK)

DBA_DATA_FRAME                    <- 0
DBA_DATA_RANGEDDATA               <- 1
DBA_DATA_GRANGES                  <- 2
DBA_DATA_SUMMARIZED_EXPERIMENT    <- 3
DBA_DATA_DBAOBJECT                <- 4
DBA_DATA_DEFAULT                  <- DBA_DATA_GRANGES

#########################################################
## dba -- construct DBA object, e.g. from sample sheet ##
#########################################################
dba <- function(DBA,mask, minOverlap=2,
                sampleSheet="dba_samples.csv", 
                config=data.frame(AnalysisMethod=DBA_DESEQ2,th=0.05,
                                  DataType=DBA_DATA_GRANGES, RunParallel=TRUE, 
                                  minQCth=15, fragmentSize=125, 
                                  bCorPlot=FALSE, reportInit="DBA", 
                                  bUsePval=FALSE, design=TRUE,
                                  doBlacklist=TRUE, doGreylist=TRUE),
                peakCaller="raw", peakFormat, scoreCol, bLowerScoreBetter, 
                filter, skipLines=0, bAddCallerConsensus=FALSE, 
                bRemoveM=TRUE, bRemoveRandom=TRUE, bSummarizedExperiment=FALSE,
                attributes, dir) 
{
  if(!missing(DBA)){
    if(is(DBA,"character")) {
      stop("DBA object is a character string; perhaps meant to be argument \'sampleSheet\'?")	
    }
    DBA <- pv.check(DBA,bCheckSort=FALSE)	
  } 
  
  res <- pv.model(DBA, mask=mask, minOverlap=minOverlap, samplesheet=sampleSheet, 
                  config=config, caller=peakCaller, format=peakFormat, 
                  scorecol=scoreCol,bLowerBetter=bLowerScoreBetter,
                  skipLines=skipLines,bAddCallerConsensus=bAddCallerConsensus, 
                  bRemoveM=bRemoveM, bRemoveRandom=bRemoveRandom,
                  filter=filter, attributes=attributes, dir)
  
  res$contrasts <- NULL
  
  if(nrow(res$peaks[[1]])>0) {
    if(sum(res$peaks[[1]]$Score<0)>0) {
      res <- pv.ResetScores(res,ones=FALSE)
    }
  }
  
  if(is.null(res$config$DataType)) {
    res$config$DataType <- DBA_DATA_DEFAULT
  }
  
  
  if(Sys.info()["sysname"] == "Windows") {
    res$config$RunParallel <- FALSE
    res$config$parallelPackage <- 0
  } 
  
  if(is.null(res$config$RunParallel)){
    res$config$RunParallel <- TRUE
    if(is.null(res$config$parallelPackage)){
      res$config$parallelPackage <- DBA_PARALLEL_MULTICORE
    }
  }
  
  if(is.null(res$config$parallelPackage)){
    res$config$parallelPackage <- 0
  }
  
  if(is.null(res$config$AnalysisMethod)){
    res$config$AnalysisMethod <- DBA_DESEQ2
  }
  if(is.null(res$config$bCorPlot)){
    res$config$bCorPlot <- FALSE
  } 
  if(is.null(res$config$th)){
    res$config$th <- 0.05
  }
  if(is.null(res$config$bUsePval)){
    res$config$bUsePval <- FALSE
  }
  
  if(is.null(res$config$cores)){
    res$config$cores <- dba.multicore.setCores()
  }
  
  if(is.null(res$config$doBlacklist)){
    res$config$doBlacklist <- TRUE
  }
  if(is.null(res$config$doGreylist)){
    res$config$doGreylist <- TRUE
  }
  
  if(missing(DBA)){
    DBA <- NULL
  } 
  if(is.null(DBA$config$reportInit)){
    res$config$reportInit <- "DBA"
  } else {
    res$config$reportInit <- DBA$config$reportInit
  }
  if(!is(res,"DBA")){
    class(res) <- "DBA"
  }
  
  if(is(res,"DBA")) {
    res$SN <- pv.checkSN(res)
  }
  
  if(res$config$bCorPlot) {
    try(dba.plotHeatmap(res),silent=TRUE)      
  }
  
  if(bSummarizedExperiment) {
    res <- pv.DBA2SummarizedExperiment(res)
  } else {
    if(!is.null(DBA$ChIPQCobj)) {
      #          resQC <- DBA$ChIPQCobj
      #          resQC@DBA <- res
      #          res <- resQC
      warning('Returning new DBA object (not ChIPQCexperiment object)')
    }
    res$ChIPQCobj <- NULL   
  }
  
  pv.gc(force=FALSE)
  
  return(res)                 
}

###############################################
## dba.peakset -- add a peakset to the model ##
###############################################

dba.peakset <- function(DBA=NULL, peaks, sampID, tissue, factor, 
                        condition, treatment, replicate,control, peak.caller, 
                        peak.format, reads=0, consensus=FALSE, 
                        bamReads, bamControl, spikein,
                        scoreCol, bLowerScoreBetter, filter, counts, 
                        bRemoveM=TRUE, bRemoveRandom=TRUE,
                        minOverlap=2, bMerge=TRUE,
                        bRetrieve=FALSE, writeFile, numCols=4,
                        DataType=DBA$config$DataType)
{
  res <- NULL
  
  if(!missing(peaks)){
    if(!is(peaks,"DBA")) {
      peaks <- pv.DataType2Peaks(peaks)
    } else {
      peaks <- pv.check(peaks,bDoVectors=FALSE)	
    }
  }
  
  if(missing(DataType)) {
    DataType <- DBA_DATA_DEFAULT
  }
  
  if(bRetrieve==TRUE || !missing(writeFile)) { ## RETRIEVE/WRITE PEAKSETS
    
    if(missing(writeFile)) {
      writeFile <- NULL
    }
    
    if(missing(peaks)) {
      if(!is.null(DBA)) {
        DBA <- pv.check(DBA,bCheckEmpty=TRUE,bDoVectors=FALSE)
      } else {
        stop("DBA object is NULL; can't retrieve peakset.")	
      }	
    } else {
      if(is.vector(peaks)) {
        if(is.null(DBA)) {
          stop("DBA object is NULL; can't retrieve peakset.")	
        }	
        if(length(peaks) > 1) {
          if(minOverlap > length(peaks)) {
            stop('minOverlap is greater than number of specified peaks.')	
          } else {
            saveCorPlot <- DBA$config$bCorPlot
            DBA$config$bCorPlot <- FALSE
            DBA <- dba(DBA,mask=peaks,minOverlap=minOverlap)
            peaks <- NULL
            DBA$config$bCorPlot<- DBA$config$bCorPlot
          }
        }      
      }	
    }
    
    res <- pv.writePeakset(DBA, fname=writeFile, peaks=peaks, numCols=numCols)     
    
    if(DataType!=DBA_DATA_FRAME) {
      res <- pv.peaks2DataType(res,DataType)
    }    
    
  } else { ## ADD PEAKSET(S)
    
    bCheckS <- TRUE
    bDoV <- TRUE
    
    if(!is.null(DBA)) {
      DBA <- pv.check(DBA,bDoVectors=FALSE)
    }
    if(!missing(peaks)) {
      if(is(peaks,"DBA")) {
        res <- pv.peakset_all(DBA, addpv=peaks, minOverlap=minOverlap)
        bCheckS <- FALSE
        bDoV <- FALSE
      }
    }
    if(is.null(res)) {
      if(!missing(consensus) && pv.isConsensus(DBA)) {
        if(consensus != TRUE) {
          stop("DBA object is already formed from a consensus peakset!")
        }
      }
      res <- pv.peakset(DBA, peaks=peaks, 
                        sampID=sampID, tissue=tissue, factor=factor,
                        condition=condition,treatment=treatment,
                        replicate=replicate,control=control,
                        peak.caller=peak.caller, peak.format=peak.format, 
                        reads=reads, consensus=consensus, 
                        readBam=bamReads, controlBam=bamControl,
                        scoreCol=scoreCol, bLowerScoreBetter=bLowerScoreBetter, 
                        bRemoveM=bRemoveM, bRemoveRandom=bRemoveRandom,
                        minOverlap=minOverlap, filter=filter, counts=counts, 
                        spikein=spikein)
    }
    
    if(!is(res,"DBA")) {
      class(res) <- "DBA"
    }
    
    if(is.null(res$config$DataType)) {
      res$config$DataType <- DBA_DATA_DEFAULT
    }
    
    if(Sys.info()["sysname"] == "Windows") {
      res$config$RunParallel <- FALSE
      res$config$parallelPackage <- 0
    } 
    
    if(is.null(res$config$RunParallel)){
      res$config$RunParallel <- TRUE
      if(is.null(res$config$parallelPackage)){
        res$config$parallelPackage <- DBA_PARALLEL_MULTICORE
      }
    }
    
    if(is.null(res$config$parallelPackage)){
      res$config$parallelPackage <- 0
    }
    
    if(is.null(res$config$th)){
      res$config$th <- 0.05
    }
    if(is.null(res$config$bUsePval)){
      res$config$bUsePval <- FALSE
    }
    
    if(is.null(DBA$config$reportInit)){
      res$config$reportInit <- "DBA"
    } else {
      res$config$reportInit <- DBA$config$reportInit
    }
    if(is.null(res$config$AnalysisMethod)){
      res$config$AnalysisMethod <- DBA_DESEQ2
    }
    if(is.null(res$config$bCorPlot)){
      res$config$bCorPlot <- FALSE
    } 
    
    if(is.null(res$config$cores)){
      res$config$cores <- dba.multicore.setCores()
    }
    
    if(is.null(res$config$doBlacklist)){
      res$config$doBlacklist <- TRUE
    }
    if(is.null(res$config$doGreylist)){
      res$config$doGreylist <- TRUE
    }
    
    if(bMerge) {
      res <- pv.check(res,bCheckSort=bCheckS,bDoVectors=bDoV)
      pv.gc(force=FALSE)
    }
    
    if(!is.null(DBA$ChIPQCobj)) {
      #          resQC <- DBA$ChIPQCobj
      #          resQC@DBA <- res
      #          res <- resQC
      warning('Returning new DBA object (not ChIPQCexperiment object)')
    }   
    
    numpeaks <- length(res$peaks)
    if(numpeaks > 1) {
      if(is.null(res$called)) {
        if(is.null(res$counts)) {
          res <- dba(res)
        }
      } else 
        if(numpeaks != ncol(res$called)) {
          res <- dba(res)
        }
    }
    
    if(!is(res,"DBA")) {
      res <- dba(res)
    }
    
  }
  
  return(res)                       
}                      

##################################################
## dba.overlap -- compute binding site overlaps ##
##################################################

DBA_OLAP_PEAKS <- 1 # Return list of peaksets (common/unique peaks) 
DBA_OLAP_ALL   <- 2 # Return overlap report with statstics for peakset pairs
DBA_OLAP_RATE  <- 3 # Return vector of number of peaks in overlap for all values of minOverlap

DBA_OLAP  <- PV_OLAP
DBA_COR   <- PV_COR
DBA_INALL <- PV_INALL

dba.overlap <- function(DBA, mask, mode=DBA_OLAP_PEAKS, 
                        contrast, method=DBA$config$AnalysisMethod, 
                        th=DBA$config$th, bUsePval=DBA$config$bUsePval, report,
                        byAttribute, bCorOnly=TRUE, CorMethod="pearson", 
                        DataType=DBA$config$DataType)
{                      
  DBA <- pv.check(DBA,bCheckEmpty=TRUE)
  
  if( (mode == DBA_OLAP_ALL) | (!missing(contrast)) | (!missing(report)) ) {
    
    if( (!missing(contrast)) | (!missing(report)) ) {
      
      if(missing(report)) {
        report   <- dba.report(DBA,method=method, contrast=contrast,th=th,
                               bUsePval=bUsePval,DataType=DBA_DATA_FRAME)
      } else {
        if(!is(report,"data.frame")) {
          stop('Class not supported for report parameter. Call dba.report with DataType=DBA_DATA_FRAME.')	
        }
        if(!missing(contrast)) {
          DBA <- pv.getOverlapData(DBA,contrast,report)
        }
      }
      
      sites <- as.numeric(rownames(report))
      
      if(missing(mask)) {
        if(missing(contrast)) {
          mask <- 1:length(DBA$peaks)
        } else {
          mask  <- DBA$contrasts[[contrast]]$group1 | DBA$contrasts[[contrast]]$group2
        }   
      }  else if (length(mask)==1) {
        mask <- 1:length(DBA$peaks)         
      }
      
      res <- pv.occupancy(DBA, mask=mask, sites=sites, byAttribute=byAttribute, 
                          Sort='cor', CorMethod=CorMethod,
                          bCorOnly=bCorOnly)         
      
    } else {
      
      res <- pv.occupancy(DBA, mask=mask, byAttribute=byAttribute, 
                          Sort='cor', CorMethod=CorMethod,
                          bCorOnly=bCorOnly)
    } 
    
  }  else if(mode == DBA_OLAP_RATE) {
    
    res <- pv.overlapRate(DBA,mask=mask)
    
  }  else {
    
    res <- pv.overlap(DBA,mask=mask)
    
    if(DataType!=DBA_DATA_FRAME) {
      res <- lapply(res,pv.peaks2DataType,DataType)
    }   
    if(DataType == DBA_DATA_GRANGES) {
      for(i in 1:length(res)) {
        if(!is.null(res[[i]])) {
          if(is.null(res[[i]]$score)) {
            res[[i]]$score <- rowMeans(data.frame(mcols(res[[i]])), 
                                       na.rm=TRUE)
          }
        } else {
          res[[i]] <- GRanges(NULL)
        }
      }
      res <- GRangesList(res)
    }
  }                       
  
  return(res)
}

##############################################################
## dba.blacklist -- apply/generate blacklists and greylists ##
##############################################################

DBA_BLACKLIST_HG19    <- PV_BLACKLIST_HG19
DBA_BLACKLIST_HG38    <- PV_BLACKLIST_HG38 
DBA_BLACKLIST_GRCH37  <- PV_BLACKLIST_GRCH37 
DBA_BLACKLIST_GRCH38  <- PV_BLACKLIST_GRCH38 
DBA_BLACKLIST_MM9     <- PV_BLACKLIST_MM9
DBA_BLACKLIST_MM10    <- PV_BLACKLIST_MM10   
DBA_BLACKLIST_CE10    <- PV_BLACKLIST_CE10  
DBA_BLACKLIST_CE11    <- PV_BLACKLIST_CE11  
DBA_BLACKLIST_DM3     <- PV_BLACKLIST_DM3   
DBA_BLACKLIST_DM6     <- PV_BLACKLIST_DM6   
DBA_BLACKLIST         <- "blacklist"
DBA_GREYLIST          <- "greylist"
DBA_BLACKLISTED_PEAKS <- "blacklisted peaks"

dba.blacklist <- function(DBA, blacklist=DBA$config$doBlacklist, 
                          greylist=DBA$config$doGreylist, 
                          Retrieve, cores=DBA$config$cores) {
  
  DBA <- pv.check(DBA)
  
  if(is.null(blacklist)) {
    if(pv.noControls(DBA$class["bamRead",])) {
      blacklist <- FALSE
    } else {
      blacklist <- TRUE
    }
  }
  
  if(is.null(greylist)) {
    if(pv.noControls(DBA$class["bamControl",])) {
      greylist <- FALSE
    } else {
      greylist <- TRUE
    }
  }
  
  res <- pv.BlackGreyList(DBA=DBA, blacklist=blacklist, greylist=greylist,
                          Retrieve=Retrieve, cores=cores)
  
  
  if(is(res,"DBA")) {
    res$SN <- pv.checkSN(res)
  }
  
  return(res)
  
}

###############################################  
## dba.count -- count reads in binding sites ##
###############################################   

DBA_SCORE_NORMALIZED          <- PV_SCORE_NORMALIZED
DBA_SCORE_RPKM                <- PV_SCORE_RPKM
DBA_SCORE_RPKM_FOLD           <- PV_SCORE_RPKM_FOLD
DBA_SCORE_RPKM_MINUS          <- PV_SCORE_RPKM_MINUS
DBA_SCORE_READS               <- PV_SCORE_READS
DBA_SCORE_CONTROL_READS       <- PV_SCORE_CONTROL_READS
DBA_SCORE_READS_FOLD          <- PV_SCORE_READS_FOLD
DBA_SCORE_READS_MINUS         <- PV_SCORE_READS_MINUS
DBA_SCORE_READS_FULL          <- PV_SCORE_READS_FULL
DBA_SCORE_READS_EFFECTIVE     <- PV_SCORE_READS_EFFECTIVE
DBA_SCORE_READS_MINUS_FULL    <- PV_SCORE_READS_MINUS_FULL
DBA_SCORE_READS_MINUS_EFFECTIVE <- PV_SCORE_READS_MINUS_EFFECTIVE
DBA_SCORE_TMM_MINUS_FULL      <- PV_SCORE_TMM_MINUS_FULL
DBA_SCORE_TMM_MINUS_EFFECTIVE <- PV_SCORE_TMM_MINUS_EFFECTIVE
DBA_SCORE_TMM_READS_FULL      <- PV_SCORE_TMM_READS_FULL
DBA_SCORE_TMM_READS_EFFECTIVE <- PV_SCORE_TMM_READS_EFFECTIVE
DBA_SCORE_TMM_MINUS_FULL_CPM      <- PV_SCORE_TMM_MINUS_FULL_CPM
DBA_SCORE_TMM_MINUS_EFFECTIVE_CPM <- PV_SCORE_TMM_MINUS_EFFECTIVE_CPM
DBA_SCORE_TMM_READS_FULL_CPM      <- PV_SCORE_TMM_READS_FULL_CPM
DBA_SCORE_TMM_READS_EFFECTIVE_CPM <- PV_SCORE_TMM_READS_EFFECTIVE_CPM
DBA_SCORE_SUMMIT              <- PV_SCORE_SUMMIT
DBA_SCORE_SUMMIT_ADJ          <- PV_SCORE_SUMMIT_ADJ
DBA_SCORE_SUMMIT_POS          <- PV_SCORE_SUMMIT_POS

DBA_READS_DEFAULT <- PV_READS_DEFAULT
DBA_READS_BAM     <- PV_READS_BAM
DBA_READS_BED     <- PV_READS_BED

DBA_SCORE_FOLD             <- PV_SCORE_FOLD 
DBA_SCORE_CONCENTRATION    <- PV_SCORE_CONCENTRATION  
DBA_SCORE_CONC_NUMERATOR   <- PV_SCORE_CONC_NUMERATOR 
DBA_SCORE_CONC_DENOMINATOR <- PV_SCORE_CONC_DENOMINATOR
DBA_SCORE_PVAL             <- PV_SCORE_PVAL    
DBA_SCORE_FDR              <- PV_SCORE_FDR  

dba.count <- function(DBA, peaks, minOverlap=2, score=DBA_SCORE_NORMALIZED,
                      fragmentSize=DBA$config$fragmentSize, summits=200, 
                      filter=1, bRemoveDuplicates=FALSE,
                      bScaleControl=TRUE, bSubControl = is.null(DBA$greylist), 
                      mapQCth=DBA$config$mapQCth, filterFun=max, minCount=0, 
                      bLog=FALSE, bUseSummarizeOverlaps=TRUE,  
                      readFormat=DBA_READS_DEFAULT,bParallel=DBA$config$RunParallel) 
{
  DBA <- pv.check(DBA, missing(peaks))
  
  if(!is.null(DBA$resultObject)) {
    if(DBA$resultObject == TRUE) {
      return(pv.ResetResultScores(DBA,score))
    }
  }
  
  if(minOverlap > length(DBA$peaks) && missing(peaks)) {
    minOverlap <- length(DBA$peaks)
  }
  
  if(is.null(DBA$config$mergeOverlap)) {
    maxGap <- as.integer(-1)
  } else {
    maxGap <- as.integer(-DBA$config$mergeOverlap)
  }
  
  bUseLast <- FALSE
  
  res <- NULL
  resetContrasts <- TRUE
  
  if(is.logical(summits)) {
    if(summits==FALSE) {
      DBA$summits=NULL
      summits <- -1
    } else {
      summits <- 0
    }
  }
  
  if(!missing(peaks)) {
    if(is.null(peaks) && missing(summits)) { # don't recenter if summits not specified
      summits <- -1
    } else if(is.null(peaks) && summits == 0) { # don't recenter if summit amount not specified
      summits <- -1
    }
  }
  
  if( (summits > -1) && missing(peaks) && !is.null(DBA$summits)) {
    if(DBA$summits == 0 ) {
      peaks=NULL
    } else {
      if(summits != DBA$summits) {
        stop('Can not change value of summits. Re-run from peaks.')
      } else {
        warning('No action taken, returning passed object...')
        res <- DBA
      }
    }
  }
  
  if(!missing(peaks)) {
    if(is.null(peaks)) {
      if(!is.null(DBA$minCount)) {
        if(DBA$minCount != minCount) {
          warning("Unable to reset minCount without re-counting (peaks can not be NULL).",
                  call.=FALSE)
        } 
      } else {
        DBA$minCount <- minCount 
      }
    }
  }
  
  if(!missing(peaks) || length(filter)>1) {
    if(is.null(peaks) || length(filter)>1) {
      callers <- unique(DBA$class[DBA_CALLER,])
      if((length(callers)==1) & (callers[1]=='counts')) {
        DBA <- pv.check(DBA)
        if(summits != -1) {
          if(summits>0) {
            res <- pv.Recenter(DBA,summits,1:length(DBA$peaks),DBA$called)
            res <- pv.counts(res,peaks=res$merged,
                             defaultScore=score, bLog=bLog, 
                             insertLength=fragmentSize, bOnlyCounts=TRUE,
                             bCalledMasks=TRUE, minMaxval=filter,
                             bParallel=bParallel, bUseLast=bUseLast,
                             bWithoutDupes=bRemoveDuplicates,
                             bScaleControl=bScaleControl,filterFun=filterFun,
                             bLowMem=bUseSummarizeOverlaps,
                             readFormat=readFormat,summits=0,
                             minMappingQuality=mapQCth,bRecentered=TRUE,
                             minCount=minCount, bSubControl=bSubControl, 
                             maxGap=maxGap)
            res$summits <- summits
            res$norm <- DBA$norm
            res <- pv.reNormalize(res)
          } 
        } else {
          if(length(filter)>1) {
            DBA <- pv.setScore(DBA,score=score,bLog=bLog,minMaxval=0,
                               filterFun=filterFun)
            res <- pv.filterRate(DBA,filter,filterFun=filterFun)	
          } else {
            res <- pv.setScore(DBA,score=score,bLog=bLog,minMaxval=filter,
                               filterFun=filterFun)
          }
          resetContrasts=FALSE	
        }
      } else {
        stop('DBA object must contain only counts')	
      }	
    } else {
      peaks <- pv.DataType2Peaks(peaks)
    }
  }
  
  if(is.null(res)) {
    res <- pv.counts(DBA, peaks=peaks, minOverlap=minOverlap, 
                     defaultScore=score, bLog=bLog, insertLength=fragmentSize, 
                     bOnlyCounts=TRUE, bCalledMasks=TRUE, minMaxval=filter,
                     bParallel=bParallel, bUseLast=bUseLast,
                     bWithoutDupes=bRemoveDuplicates,bScaleControl=bScaleControl,
                     filterFun=filterFun,
                     bLowMem=bUseSummarizeOverlaps,readFormat=readFormat,
                     summits=summits,
                     minMappingQuality=mapQCth,
                     minCount=minCount, bSubControl=bSubControl,
                     maxGap=maxGap)
    if(summits != -1) {
      res$summits <- summits
    }
    res$norm <- DBA$norm
    res <- pv.reNormalize(res)
  }
  if(resetContrasts && length(res$contrasts)>0) {
    for(i in 1:length(res$contrasts)) {
      res$contrasts[[i]]$edgeR <- NULL
      res$contrasts[[i]]$DESeq <- NULL         	
    }
  }
  
  if(!is(res,"integer")) {
    
    if(DBA$config$bCorPlot){
      try(dba.plotHeatmap(res,correlations=TRUE),silent=TRUE)
    }
    
    if(is(res,"DBA")) {
      res$SN <- pv.checkSN(res)
    }
    
    if(!is(res,"DBA")) {
      class(res) <- "DBA"
    }
    
    if(!is.null(DBA$ChIPQCobj)) {
      res <- checkQCobj(DBA$ChIPQCobj,res)
    }
  }
  
  pv.gc(force=FALSE)
  
  return(res)
}

########################################  
## dba.normalize -- normalize dataset ##
######################################## 

DBA_LIBSIZE_DEFAULT    <- PV_LIBSIZE_DEFAULT
DBA_LIBSIZE_FULL       <- PV_LIBSIZE_FULL
DBA_LIBSIZE_PEAKREADS  <- PV_LIBSIZE_PEAKREADS
DBA_LIBSIZE_BACKGROUND <- PV_LIBSIZE_CHRREADS
DBA_LIBSIZE_USER       <- PV_LIBSIZE_USER

DBA_NORM_DEFAULT        <- PV_NORM_DEFAULT
DBA_NORM_LIB            <- PV_NORM_LIB
DBA_NORM_TMM            <- PV_NORM_TMM 
DBA_NORM_RLE            <- PV_NORM_RLE
DBA_NORM_NATIVE         <- PV_NORM_NATIVE
DBA_NORM_SPIKEIN        <- PV_NORM_SPIKEIN
DBA_NORM_USER           <- PV_NORM_USER
DBA_NORM_OFFSETS        <- PV_NORM_OFFSETS
DBA_NORM_OFFSETS_ADJUST <- PV_NORM_OFFSETS_ADJUST

DBA_OFFSETS_LOESS     <- PV_OFFSETS_LOESS 
DBA_OFFSETS_USER      <- PV_OFFSETS_USER      

dba.normalize <- function(DBA, method = DBA$config$AnalysisMethod,
                          normalize   = DBA_NORM_DEFAULT,
                          library     = DBA_LIBSIZE_DEFAULT, 
                          background=FALSE, spikein=FALSE, offsets=FALSE, 
                          libFun=mean, bRetrieve=FALSE, ...) {
  
  DBA <- pv.check(DBA,TRUE)
  
  ### SET DEFAULTS ###
  pre3 <- FALSE
  if(is.null(DBA$design) && !is.null(DBA$contrasts)) {
    pre3 <- TRUE
  }
  if(!is.null(DBA$config$design)) {
    if(DBA$config$design == FALSE) {
      pre3 <- TRUE
    }
  }
  
  if(pre3 == TRUE) {
    # defaults are pre-3.0
    deflib  <- DBA_LIBSIZE_FULL
    defnorm <- DBA_NORM_DEFAULT
    defback <- FALSE   
  } else {
    # defaults are 3.0+    
    deflib  <-  DBA_LIBSIZE_BACKGROUND
    if(is(background,"logical")) {
      if(background == FALSE) {
        deflib  <- DBA_LIBSIZE_FULL
      }
    } 
    defnorm <- DBA_NORM_LIB
    defback <- FALSE    
  }
  
  if(length(library)==1 && library[1]==DBA_LIBSIZE_DEFAULT) {
    library <- deflib
  }
  
  if(length(normalize)==1 && normalize[1]==DBA_NORM_DEFAULT) {
    normalize <- defnorm
    missnorm <- TRUE
  } else {
    missnorm <- FALSE
  }
  
  if(missing(background)) {
    background <- defback
  }
  
  if(!missing(spikein)) {
    if(missnorm) {
      if(is(spikein,"logical")) {
        if(spikein != FALSE) {
          normalize <- DBA_NORM_NATIVE
        }
      } else {
        normalize <- DBA_NORM_NATIVE
      }
    }
  }
  
  res <- pv.normalize(DBA, method=method, 
                      libSizes=library, normalize=normalize,
                      libFun=libFun,
                      background=background, spikein=spikein, offsets=offsets, 
                      bRetrieve=bRetrieve, filter=0, ...)
  
  if(bRetrieve == FALSE) {
    if(res$score == DBA_SCORE_NORMALIZED) {
      res <- pv.doResetScore(res)
    }
    if(is(res,"DBA")) {
      res$SN <- pv.checkSN(res)
    }
  }
  
  return(res)
}

########################################################
## dba.contrast -- establish contrast(s) for analysis ##
########################################################

dba.contrast <- function(DBA, design=missing(group1), contrast,
                         group1, group2=!group1, name1, name2,
                         minMembers=3, block, bNot = FALSE, bComplex = FALSE,
                         categories=c(DBA_TISSUE,DBA_FACTOR,DBA_CONDITION,DBA_TREATMENT), 
                         bGetCoefficients=FALSE, reorderMeta)
{
  if(minMembers < 2) {
    stop('minMembers must be at least 2. Use of replicates strongly advised.')	
  }
  
  DBA <- pv.check(DBA,TRUE)
  
  if(missing(design) && design) {
    if(!is.null(DBA$config$design)) {
      design <- DBA$config$design 
    }
  }
  
  res <- pv.contrast(DBA, group1=group1, group2=group2, name1=name1, name2=name2,
                     minMembers=minMembers, categories=categories,block=block, 
                     bMulti = bComplex, bNot=bNot,
                     design=design, contrast=contrast, 
                     bGetNames=bGetCoefficients, reorderMeta=reorderMeta)
  
  if(!bGetCoefficients) {
    if(!is(res,"DBA")) {
      class(res) <- "DBA"
    }
    
    if(!is.null(DBA$ChIPQCobj)) {
      res <- checkQCobj(DBA$ChIPQCobj,res)
    }
  }
  
  return(res)                       	
}

###################################################################
##  -- perform differential binding affinity analysis ##
###################################################################

dba.analyze <- function(DBA, method=DBA$config$AnalysisMethod, design,
                        bBlacklist=DBA$config$doBlacklist,
                        bGreylist=DBA$config$doGreylist,
                        bRetrieveAnalysis=FALSE, bReduceObjects=TRUE, 
                        bParallel=DBA$config$RunParallel)
{
  
  if(!is(DBA,"DBA") && !is(DBA,"list")) {
    if(is(DBA,"character") || is(DBA,"data.frame")) {
      message("Loading sample sheet...")
      DBA <- dba(sampleSheet = DBA) 
    }
  }
  
  DBA <- pv.check(DBA,bCheckEmpty=TRUE)
  
  if(bRetrieveAnalysis!=FALSE) {
    if(bRetrieveAnalysis==TRUE || bRetrieveAnalysis==DBA_DESEQ2) {
      if(!is.null(DBA$DESeq2$DEdata)){
        return(DBA$DESeq2$DEdata)
      }
    }
    if (bRetrieveAnalysis==TRUE || bRetrieveAnalysis==DBA_EDGER){
      if(!is.null(DBA$edgeR$DEdata)) {
        return(DBA$edgeR$DEdata)
      } 
    }
    if(is.null(DBA$design)) {
      stop("Unable to return DEObject: design must be present, and analysis run.")
    } else {
      stop("Unable to return DEObject: run dba.analyze() with bRetrieveAnalysis=FALSE first.")
    }
  }
  
  if(is.null(bBlacklist)) {
    bBlacklist <- TRUE
  }
  if(is.null(bGreylist)) {
    bGreylist <- TRUE
  }
  
  doblacklist <- dogreylist <-  FALSE
  if(is.null(DBA$blacklist)) {
    if(bBlacklist == TRUE) {
      if(!pv.noControls(DBA$class["bamRead",])) {
        doblacklist <- TRUE
      }
    }
  }
  
  if(is.null(DBA$greylist)) {
    if(bGreylist == TRUE) {
      if(!pv.noControls(DBA$class["bamControl",])) {
        dogreylist <- TRUE
      }
    } 
  }
  
  res <- NULL
  
  if(doblacklist || dogreylist) {
    message("Applying Blacklist/Greylists...")
    res <- tryCatch(
      dba.blacklist(DBA, blacklist=doblacklist, greylist=dogreylist),
      error=function(x){message("Blacklist error: ",x);NULL}
    )
    if(is.null(res)){
      message("Unable to apply Blacklist/Greylist.")
      return(DBA)
    } else {
      DBA <- res
    }
  }
  
  if(sum(DBA$class[DBA_CALLER,] %in% c("source","counts"))==0) {
    message("Forming consensus peakset and counting reads...")
    res <- tryCatch(
      dba.count(DBA, bParallel=bParallel),
      error=function(x){message("Count error: ",x);NULL}
    ) 
    if(is.null(res)){
      message("Unable to count overlapping reads.")
      return(DBA)
    } else {
      DBA <- res
    }
  }
  
  
  if (DBA_EDGER %in% method) {
    if(is.null(DBA$norm$edgeR)) {
      message("Normalize edgeR with defaults...")
      res <- tryCatch(
        dba.normalize(DBA, method=DBA_EDGER),
        error=function(x){message("Normalize error: ",x);NULL}
      )
      if(is.null(res)){
        message("Unable to normalize datset with edgeR.")
        return(DBA)
      } else {
        DBA <- res
      }
    }
  }
  
  if (DBA_DESEQ2 %in% method) {
    if(is.null(DBA$norm$DESeq2)) {
      message("Normalize DESeq2 with defaults...")
      res <- tryCatch(
        dba.normalize(DBA, method=DBA_DESEQ2),
        error=function(x){message("Normalize error: ",x);NULL}
      )
      if(is.null(res)){
        message("Unable to normalize datset with DESeq2.")
        return(DBA)
      } else {
        DBA <- res
      }
    }
  }
  
  if(!missing(design)) {
    message("Setting design...")
    res <- tryCatch(
      dba.contrast(DBA, design=design),
      error=function(x){message("Contrast error: ",x);NULL}
    )
    if(is.null(res)){
      message("Unable to set design.")
      return(DBA)
    } else {
      DBA <- res
    }
  }
  
  if(is.null(DBA$contrasts)) {
    if(missing(design) && is.null(DBA$design)) {
      message("Forming default model design and contrast(s)...")
    } else {
      message("Setting default contrast(s)...")      
    }
    res <- tryCatch(
      dba.contrast(DBA),
      error=function(x){message("Contrast error: ",x);NULL}
    )
    if(is.null(res)){
      message("Unable to establish model design and contrasts(s). 
Check that here are at least two groups each with at least three samples, 
and that the default model is of full rank, and call dba.contrast() explicitly.")
      return(DBA)
    } else {
      DBA <- res
    }
  }
  
  if(is.null(DBA$config$edgeR$bTagwise)) {
    bTagwise <- TRUE
  } else {
    bTagwise <- DBA$config$edgeR$bTagwise 
  }
  
  message("Analyzing...")
  res <- tryCatch(
    pv.DBA(DBA, method,bTagwise=bTagwise,
           minMembers=3, bParallel=bParallel),
    error=function(x){message("Analyze error: ",x);NULL}
  )
  if(is.null(res)){
    message("Unable to complete analysis.")
    return(DBA)
  } 
  
  if(bReduceObjects) {
    if(!is.null(res$contrasts)) {
      res$contrasts <- lapply(res$contrasts,pv.stripDBA)
    }      	
  }
  
  if(DBA$config$bCorPlot){
    warn <- TRUE
    rep <- pv.DBAreport(res,contrast=1,method=method[1],th=0.05,bSupressWarning=TRUE)
    if(!is.null(rep)) {
      if(!is.null(dim(rep))) {
        if(nrow(rep)>1) {
          warn=FALSE
          x <- try(dba.plotHeatmap(res,contrast=1,method=method[1],
                                   correlations=TRUE),silent=TRUE)
        }	
      }
    }
    if(warn) {
      warning('No correlation heatmap plotted -- contrast 1 does not have enough differentially bound sites.')	
    }
  }
  
  if(!is(res,"DBA")) {
    class(res) <- "DBA"
  }
  
  if(!is.null(DBA$ChIPQCobj)) {
    res <- checkQCobj(DBA$ChIPQCobj,res)
  }
  
  pv.gc(force=FALSE)
  
  return(res)
}

###########################################################
## dba.report -- generate report for a contrast analysis ##
###########################################################

dba.report <- function(DBA, contrast, method=DBA$config$AnalysisMethod, 
                       th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
                       fold=0, bNormalized=TRUE, bFlip=FALSE, precision,
                       bCalled=FALSE, bCounts=FALSE, bCalledDetail=FALSE,
                       bDB, bNotDB, bAll=TRUE, bGain=FALSE, bLoss=FALSE,
                       file,initString=DBA$config$reportInit,ext='csv',
                       DataType=DBA$config$DataType) 
  
{
  
  DBA <- pv.check(DBA,bCheckEmpty=TRUE) 
  
  if(DataType==DBA_DATA_SUMMARIZED_EXPERIMENT) {
    bCounts <- TRUE
  }
  
  if(!missing(bDB) | !missing(bNotDB) | bGain | bLoss) {
    if(missing(bDB)) {
      if(bGain | bLoss) {
        bDB <- TRUE
      } else {
        bDB <- FALSE
      }
    }
    if(missing(bNotDB)) {
      bNotDB <- FALSE
    }
    message("Generating report-based DBA object...")
    res <- pv.resultsDBA(DBA,contrasts=contrast,methods=method,
                         th=th,bUsePval=bUsePval,fold=fold,
                         bDB=bDB,bNotDB=bNotDB,bUp=bGain,bDown=bLoss,bAll=bAll,
                         bFlip=bFlip)
    res$resultObject <- TRUE
    return(res)                    
  }
  
  if(missing(contrast)) {
    contrast=1
  }
  
  if(missing(precision)) {
    if(DataType==DBA_DATA_SUMMARIZED_EXPERIMENT) {
      precision <- 0
    } else {
      precision <- 2:3
    }
  }
  
  res <- pv.DBAreport(pv=DBA,contrast=contrast,method=method,th=th,bUsePval=bUsePval,
                      bCalled=bCalled,bCounts=bCounts,bCalledDetail=bCalledDetail,
                      file=file,initString=initString,bNormalized=bNormalized,
                      ext=ext,minFold=fold,
                      bFlip=bFlip, precision=precision) 
  
  if(DataType==DBA_DATA_SUMMARIZED_EXPERIMENT) {
    DBA <- pv.getPlotData(DBA,contrast=contrast,report=res,
                          method=method,th=th,bUsePval=bUsePval,bNormalized=TRUE,
                          bFlip=bFlip, precision=0)
    res <- pv.DBA2SummarizedExperiment(DBA,report=res)
    return(res)
  }
  
  if(DataType!=DBA_DATA_FRAME) {
    res <- pv.peaks2DataType(res,DataType)
  }
  
  return(res)	
  
}                      

################################################
## dba.plotHeatmap -- Heatmap with clustering ##
################################################

dba.plotHeatmap <- function(DBA, attributes=DBA$attributes, maxSites=1000,
                            minval, maxval,
                            contrast, method=DBA$config$AnalysisMethod, 
                            th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
                            report, score, bLog=TRUE, mask, sites, sortFun=sd, 
                            correlations=TRUE, olPlot=DBA_COR, 
                            ColAttributes, RowAttributes, colSideCols, 
                            rowSideCols=colSideCols,
                            margin=10, colScheme="Greens", distMethod="pearson",
                            ...)
{
  DBA <- pv.check(DBA,bCheckEmpty=TRUE)
  
  if( (missing(contrast) || !missing(mask)) && !missing(score) ) {
    saveCorPlot <- DBA$config$bCorPlot
    DBA$config$bCorPlot <- FALSE
    DBA <- dba.count(DBA,peaks=NULL,score=score)	
    DBA$config$bCorPlot <- saveCorPlot
  }
  
  #mask <- pv.setMask(DBA,mask,contrast)
  
  if(!missing(contrast)) {
    if(!missing(report)) {
      report <- pv.DataType2Peaks(report)
    }   	
    DBA <- pv.getPlotData(DBA,attributes=attributes,contrast=contrast,report=report,
                          method=method,th=th,bUsePval=bUsePval,bNormalized=TRUE,
                          bPCA=FALSE,bLog=FALSE,minval=minval,maxval=maxval,mask=mask)
    contrast <- 1
    mask <- NULL                     
  }
  
  if(bLog) {
    vectors <- as.matrix(DBA$binding[,4:ncol(DBA$binding)])
    vectors <- matrix(as.numeric(vectors),ncol=ncol(vectors))
    vectors[is.na(vectors)] <- 0
    if(max(vectors) > 1) { # must have positive counts to do log
      vectors[vectors<1]=1
      if(missing(minval)) {
        minval <- 0
      } else {
        minval <- max(0,minval)
      }
      vectors <- log2(vectors)
      DBA$binding[,4:ncol(DBA$binding)] <- vectors
    }
  }
  
  if(length(correlations)==1 & ((correlations[1] == DBA_OLAP_ALL) | 
                                (correlations[1] == TRUE)))  {
    if(nrow(DBA$binding)>1) {
      if(!missing(sites)) {
        if(is.logical(sites)) {
          sites <- which(sites)	
        }	   
      } 	
      correlations <- pv.occupancy(DBA, mask=mask, sites=sites, Sort='cor', 
                                   bCorOnly=TRUE,CorMethod=distMethod)
    } else {
      warning('No correlation heatmap plotted -- contrast does not have enough differentially bound sites.')	
      return(NULL)   	     	
    }
  }
  
  if(correlations[1]!=FALSE) {
    res <- pv.plotHeatmap(DBA, attributes=attributes, overlaps=correlations, 
                          olPlot=olPlot, mask=mask,
                          ColScheme=colScheme, distMeth=distMethod, 
                          bReorder=TRUE, contrast=contrast,
                          RowAttributes=RowAttributes,ColAttributes=ColAttributes,
                          rowSideCols=rowSideCols,colSideCols=colSideCols,
                          minval=minval, maxval=maxval, margins=c(margin,margin),
                          ...)
  } else {
    
    if(!missing(contrast)) {
      if(nrow(DBA$binding)<2) { 	
        warning('No heatmap plotted -- contrast does not have enough differentially bound sites.')	
        return(NULL)   	     	
      }
      res <- pv.plotHeatmap(DBA, numSites=maxSites, attributes=attributes,
                            contrast=contrast,
                            RowAttributes=RowAttributes,ColAttributes=ColAttributes,
                            rowSideCols=rowSideCols,colSideCols=colSideCols,
                            ColScheme=colScheme, distMeth=distMethod, 
                            margins=c(margin,margin), ...)
      maxSites <- min(maxSites, nrow(DBA$binding))
      res <- data.frame(DBA$binding[1:maxSites,][res$rowInd,c(1:3,3+res$colInd)])
      if(!is.character(res[1,1])) {
        res[,1] <- DBA$chrmap[res[,1]]
      }
      res <- pv.peaks2DataType(res,datatype=DBA_DATA_GRANGES) 
    } else {
      
      if(is(sortFun,"function")) {
        savevecs <- DBA$binding
        DBA <- pv.sort(DBA, sortFun, mask=mask)
      } else savevecs <- NULL
      
      res <- pv.plotHeatmap(DBA, numSites=maxSites, attributes=attributes, 
                            mask=mask, sites=sites,
                            RowAttributes=RowAttributes,ColAttributes=ColAttributes,
                            rowSideCols=rowSideCols,colSideCols=colSideCols,
                            minval=minval, maxval=maxval, ColScheme=colScheme, 
                            distMeth=distMethod, 
                            margins=c(margin,margin),...)
      maxSites <- min(maxSites, nrow(DBA$binding))
      res <- data.frame(DBA$binding[1:maxSites,][res$rowInd,c(1:3,3+res$colInd)])
      if(!is.character(res[1,1])) {
        res[,1] <- DBA$chrmap[res[,1]]
      }
      res <- pv.peaks2DataType(res,datatype=DBA_DATA_GRANGES) 
      if(!is.null(savevecs)) {
        DBA$binding <- savevecs
      }
    }
  }
  
  invisible(res)	
}

#######################################################
## dba.plotPCA -- Principal Components Analysis plot ##
#######################################################

dba.plotPCA <- function(DBA, attributes, minval, maxval,
                        contrast, method=DBA$config$AnalysisMethod, 
                        th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
                        report, score, bLog=TRUE, mask, sites, label, cor=FALSE,
                        b3D=FALSE, vColors, dotSize, labelSize, labelCols, 
                        components=1:3, ...)
  
{
  DBA <- pv.check(DBA,bCheckEmpty=TRUE)
  
  mask <- pv.setMask(DBA,mask,contrast)
  
  if(missing(contrast) && !missing(score)) {
    saveCorPlot <- DBA$config$bCorPlot
    DBA$config$bCorPlot <- FALSE
    DBA <- dba.count(DBA,peaks=NULL,score=score)	
    DBA$config$bCorPlot <- saveCorPlot
  } else if (!missing(score)) {
    warning('score parameter ignored when contrast is specified')	
  }  
  
  if(missing(label)) {
    label <- NULL
  } else {
    if(missing(labelSize)) {
      labelSize=.8
    }
    if(missing(labelCols)) {
      labelCols="black"
    }
  }
  
  if(!missing(contrast)){
    if(missing(attributes)) {
      attributes <- DBA_GROUP
    }
    if(missing(dotSize)) {
      dotSize <- NULL
    }
    if(!missing(report)) {
      report <- pv.DataType2Peaks(report)
    }  	  
    DBA <- pv.getPlotData(DBA,attributes=attributes,contrast=contrast,report=report,
                          method=method,th=th,bUsePval=bUsePval,bNormalized=TRUE,
                          bPCA=TRUE,minval=minval,maxval=maxval,mask=mask,bLog=FALSE)                     
    if(attributes[1] == PV_GROUP) {
      if( length(unique(DBA$class[PV_ID,])) != ncol(DBA$class) ){
        attributes <- PV_ID
      } else {
        attributes <- pv.attributePCA(DBA)
      }
    }
    res <- pv.plotPCA(DBA,attributes=attributes,size=dotSize,cor=cor,
                      b3D=b3D,vColors=vColors,label=label,bLog=bLog,
                      labelSize=labelSize,labelCols=labelCols,
                      comps=components,...)
  } else {
    if(missing(attributes)) {
      attributes <- pv.attributePCA(DBA)
    }
    
    res <- pv.plotPCA(DBA, attributes=attributes, size=dotSize, mask=mask, 
                      sites=sites, b3D=b3D, vColors=vColors, label=label,
                      bLog=bLog,labelSize=labelSize,labelCols=labelCols,
                      comps=components,...)  
  }
  
  invisible(res)	
}

#############################
## dba.plotBox --Boxplots  ##
#############################

dba.plotBox <- function(DBA, contrast=1, method=DBA$config$AnalysisMethod, 
                        th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
                        bNormalized=TRUE, attribute=DBA_GROUP, mask,
                        bAll=FALSE, bAllIncreased=FALSE, bAllDecreased=FALSE, 
                        bDB=TRUE, bDBIncreased=TRUE, bDBDecreased=TRUE,
                        pvalMethod=wilcox.test,  bReversePos=FALSE, attribOrder, 
                        vColors, varwidth=TRUE, notch=TRUE, ...) 
  
{
  DBA <- pv.check(DBA,bCheckEmpty=TRUE)
  
  if(contrast > length(DBA$contrasts)) {
    stop('Supplied contrast greater than number of contrasts')	
  }
  
  res <- pv.plotBoxplot(DBA, contrast=contrast, method=method, th=th, 
                        bUsePval=bUsePval, bNormalized=bNormalized,
                        attribute=attribute,mask=mask,bAll=bAll, 
                        bAllIncreased=bAllIncreased, bAllDecreased=bAllDecreased, 
                        bDB=bDB, bDBIncreased=bDBIncreased, 
                        bDBDecreased=bDBDecreased,
                        pvalMethod=pvalMethod,  bReversePos=bReversePos, 
                        attribOrder=attribOrder, vColors=vColors, 
                        varwidth=varwidth, notch=notch, ...)
  
  invisible(res)	
}

#########################################
## dba.plotMA -- MA or XY scatter plot ##
#########################################

dba.plotMA <- function(DBA, contrast=1, method=DBA$config$AnalysisMethod, 
                       th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
                       fold=0, bNormalized=TRUE,
                       factor="", bFlip=FALSE, bXY=FALSE, dotSize=.45, 
                       bSignificant=TRUE, highlight=NULL,
                       bSmooth=TRUE, bLoess=TRUE, xrange, yrange, ...)
  
{
  DBA <- pv.check(DBA,bCheckEmpty=TRUE)
  
  res <- pv.DBAplotMA(DBA, contrast=contrast, method=method, bMA=!bXY, bXY=bXY,
                      th=th, bUsePval=bUsePval, fold=fold,
                      facname=factor, bNormalized=bNormalized, cex=dotSize, 
                      bSignificant=bSignificant, bSmooth=bSmooth,bFlip=bFlip,
                      highlight=highlight, xrange=xrange, yrange=yrange,
                      bLoess=bLoess,...)
  
  invisible(res)
}

#####################################
## dba.plotVolcano -- Volcano plot ##
#####################################

dba.plotVolcano <- function(DBA, contrast=1, method=DBA$config$AnalysisMethod, 
                            th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
                            fold=0, factor="", bFlip=FALSE, 
                            bLabels=FALSE, maxLabels=50, dotSize=1,
                            bReturnSites=TRUE)
  
{
  DBA <- pv.check(DBA,bCheckEmpty=TRUE)
  
  res <- pv.DBAplotVolcano(DBA, contrast=contrast, method=method, 
                           th=th, bUsePval=bUsePval, fold=fold,
                           facname=factor, dotSize=dotSize,
                           bFlip=bFlip, bLabels=bLabels, maxLabels=maxLabels,
                           bReturnPlot=!bReturnSites)
  
  if(is(res,"ggplot")) {
    invisible(res)
  } else {
    invisible(pv.peaks2DataType(res,datatype=DBA_DATA_GRANGES))
  }
}


#############################################
## dba.plotProfile -- Profile heatmap plot ##
#############################################

dba.plotProfile <- function(Object, samples, sites,
                            scores="Score", labels, # annotate=TRUE, 
                            normalize=TRUE, merge=DBA_REPLICATE,
                            maxSites=1000, absScores=TRUE, 
                            doPlot=is(Object,"profileplyr"),
                            ...)
{
  Object <- pv.check(Object,bCheckEmpty=TRUE)
  
  res <- pv.plotProfile(pv=Object, mask=samples, sites=sites, maxSites=maxSites, 
                        scores=scores, annotate=FALSE, labels=labels,
                        normalize=normalize,merge=merge, absScores=absScores,
                        doPlot=doPlot, returnVal="profileplyr",
                        ...) 
  
  pv.gc(force=TRUE)
  invisible(res)
}


####################################################
## dba.plotVenn -- Venn diagram plots of overlaps ##
####################################################

dba.plotVenn <- function(DBA, mask, overlaps, label1, label2, label3, label4,
                         main, sub, 
                         contrast, method=DBA$config$AnalysisMethod, 
                         th=DBA$config$th, bUsePval=DBA$config$bUsePval,
                         bDB=TRUE, bNotDB, bAll=TRUE, bGain=FALSE, bLoss=FALSE,
                         labelAttributes, DataType=DBA$config$DataType)
{
  DBA <- pv.check(DBA,bCheckEmpty=TRUE)
  
  newDBA <- NULL
  
  if (!missing(overlaps)){
    
    if(missing(label1)) {
      label1 <- "A"
    }
    if(missing(label2)) {
      label2 <- "B"
    }
    if(missing(label3)) {
      label3 <- "C"
    }
    if(missing(label4)) {
      label4 <- "D"
    }
    
    overlaps <- lapply(overlaps,pv.DataType2Peaks)
    
  } else if(!missing(contrast)){
    if(max(contrast)>length(DBA$contrasts)) {
      stop('Contrast greater than number of contrasts.')   
    }
    newDBA <- dba.report(DBA,contrast=contrast,method=method,th=th,bUsePval=bUsePval,
                         bDB=bDB, bNotDB=bNotDB,bAll=bAll, bGain=bGain, bLoss=bLoss)
    
    if(is.null(newDBA$peaks)){
      stop('No peaksets meet specified criteria.')   
    }
    if(missing(mask)) {
      mask <- 1:length(newDBA$peaks)
      if(length(mask)>4){
        stop('Too many peaksets meet specified criteria.')
      }
      if(length(mask)==1) {
        stop('Only one peakset meets specified criteria.')
      }
    } else {
      if(is.logical(mask)) {
        if(length(mask)!=length(newDBA$peaks)) {
          stop('Logical mask doe not have same number of elements as there are peaksets.')
        }
        if(sum(mask)>4) {
          stop('Too many peaksets in mask.')
        } else if(length(mask)>4){
          stop('Too many peaksets in mask.')
        }
        mask <- which(mask)
      }
      if(length(mask)>length(newDBA$peaks) | max(mask)>length(newDBA$peaks) ) {
        stop('Peakset specified in mask is out of range.')
      }
    }
    
    overlaps <- dba.overlap(newDBA,mask,mode=DBA_OLAP_PEAKS,DataType=DBA_DATA_FRAME)
    
    res <- pv.whichPeaksets(newDBA,mask)
    
    if(missing(labelAttributes)) {
      labelAttributes=c(DBA_ID,DBA_FACTOR,DBA_TISSUE,DBA_CONDITION,DBA_TREATMENT)  
    }
    crec <- matrix(newDBA$class[labelAttributes,mask],length(labelAttributes),length(mask))
    if(length(mask)==2) {
      labels <- pv.namestrings(crec[,1],crec[,2])
    } else if (length(mask)==3) {
      labels <- pv.namestrings(crec[,1],crec[,2],crec[,3])         
    } else {
      labels <- pv.namestrings(crec[,1],crec[,2],crec[,3],crec[,4])         
    }
    
    if(missing(label1)) {
      label1 <- labels$n1
    }
    if(missing(label2)) {
      label2 <- labels$n2
    }
    if(missing(label3)) {
      label3 <- labels$n3
    }
    if(missing(label4)) {
      label4 <- labels$n4
    }
    
    if (missing(sub)) {
      sub <- labels$tstring
    }
    
  } else if(!missing(mask)) {
    
    if(is.logical(mask)) {
      if(length(mask)!=length(DBA$peaks)) {
        stop('Logical mask does not have same number of elements as there are peaksets.')
      }
      if(sum(mask)>4) {
        stop('Too many peaksets in mask.')
      }
      mask <- which(mask)
    } else if(length(mask)>4){
      stop('Too many peaksets in mask.')
    }      
    
    overlaps <- dba.overlap(DBA,mask,mode=DBA_OLAP_PEAKS,DataType=DBA_DATA_FRAME)
    
    res <- pv.whichPeaksets(DBA,mask)
    if(missing(labelAttributes)) {
      if(pv.checkValue(DBA$resultObject,TRUE)) {
        labelAttributes <- c(DBA_ID,DBA_FACTOR,DBA_TISSUE,DBA_CONDITION,DBA_TREATMENT)  
      } else {
        labelAttributes <- DBA_ID
      }
    }
    crec <- matrix(DBA$class[labelAttributes,mask],length(labelAttributes),length(mask))
    if(length(mask)==2) {
      labels <- pv.namestrings(crec[,1],crec[,2])
    } else if (length(mask)==3) {
      labels <- pv.namestrings(crec[,1],crec[,2],crec[,3])         
    } else {
      labels <- pv.namestrings(crec[,1],crec[,2],crec[,3],crec[,4])         
    }
    if(missing(label1)) {
      label1 <- labels$n1
    }
    if(missing(label2)) {
      label2 <- labels$n2
    }
    if(missing(label3)) {
      label3 <- labels$n3
    }
    if(missing(label4)) {
      label4 <- labels$n4
    }
    if (missing(sub)) {
      sub <- labels$tstring
    }
  } else {
    stop("Must specify one of mask, overlaps, or contrast.")
  }
  
  if(missing(main)) {
    main <- "Binding Site Overlaps"
  }
  if (missing(sub)) {
    sub <- ""
  }
  
  pv.plotVenn(overlaps,label1=label1,label2=label2,label3=label3,label4=label4,
              main,sub)
  
  if(DataType == DBA_DATA_DBAOBJECT) {
    if(!is.null(newDBA)) {
      return(newDBA)
    } else {
      warning('No DBA object to return.')
    }
  } else {
    overlaps <- lapply(overlaps, pv.peaks2DataType, DataType)
    if(DataType == DBA_DATA_GRANGES) {
      for(i in 1:length(overlaps)) {
        if(!is.null(overlaps[[i]])) {
          if(is.null(overlaps[[i]]$score)) {
            overlaps[[i]]$score <- rowMeans(data.frame(mcols(overlaps[[i]])), 
                                            na.rm=TRUE)
          }
        }
        else {
          overlaps[[i]] <- GRanges(NULL)
        }
      }
      overlaps <- GRangesList(overlaps)
    }
    invisible(overlaps)
  }   
}

###################################
## dba.show -- List DBA metadata ##
###################################

dba.show <- function(DBA, mask, attributes, bContrasts=FALSE, bDesign=FALSE,
                     th=DBA$config$th) 
{
  DBA <- pv.check(DBA)
  
  res <- pv.list(DBA, mask=mask, bContrasts=bContrasts, bDesign=bDesign,
                 attributes=attributes, th=th)
  
  return(res)
}

#######################################
## dba.mask -- mask samples or sites ##
#######################################

dba.mask <- function(DBA, attribute, value, combine='or', mask, merge='or', 
                     bApply=FALSE,peakset, minValue=-1)
  
{
  DBA <- pv.check(DBA)
  
  if(missing(peakset)) {
    
    res <- pv.mask(DBA, attribute=attribute, value=value, combine=combine,
                   mask=mask, merge=merge, bApply=bApply)
    
  } else {
    
    res <- pv.whichSites(DBA, pnum=peakset, combine=combine, minVal=minValue)
    
  }
  
  return(res)
  
}

###################################
## dba.save -- save a DBA object ##
###################################

dba.save <- function(DBA, file='DBA', dir='.', pre='dba_', ext='RData',
                     bRemoveAnalysis=FALSE, bRemoveBackground=FALSE, 
                     bCompress=FALSE)
{
  
  if(is(DBA,"ChIPQCexperiment")) {
    saveChIPQC <- DBA
    DBA <- DBA@DBA
  } else saveChIPQC <- NULL
  
  if(nrow(DBA$class)<DBA_TREATMENT) {
    DBA$class <- rbind(DBA$class,'')
    rownames(DBA$class)[DBA_TREATMENT] <- 'Treatment'	
  }
  
  
  DBA$binding <- NULL	
  DBA$values  <- NULL
  DBA$hc      <- NULL
  DBA$pc      <- NULL
  
  DBA$config$lsfInit      <- NULL
  DBA$config$parallelInit <- NULL
  DBA$config$initFun      <- NULL
  DBA$config$paramFun     <- NULL
  DBA$config$addjobFun    <- NULL
  DBA$config$lapplyFun    <- NULL
  DBA$config$wait4jobsFun <- NULL
  DBA$config$parallelInit <- NULL
  
  version <- strsplit(as.character(packageVersion("DiffBind")),".",fixed=TRUE)[[1]]
  
  DBA$config$Version1 <- version[1]
  DBA$config$Version2 <- version[2]
  DBA$config$Version3 <- version[3]
  
  if(bRemoveAnalysis) {
    DBA$DESeq2$DEdata <- NULL
    DBA$edgeR$DEdata <- NULL
  }
  
  if(bRemoveBackground) {
    DBA$norm$background$binned <- NULL
  }
  if(!is.null(saveChIPQC)) {
    saveChIPQC@DBA <- DBA
    DBA <- saveChIPQC
  }
  res <- pv.save(DBA,file=file ,
                 dir=dir, pre=pre, ext=ext,
                 compress=bCompress)
  
  return(res)
} 

###################################
## dba.load -- load a DBA object ##
###################################

dba.load <- function(file='DBA', dir='.', pre='dba_', ext='RData')
{
  
  res <- pv.load(file=file, dir=dir, pre=pre, ext=ext)
  
  if(is(res,"ChIPQCexperiment")) {
    saveChIPQC <- res
    res <- res@DBA
  } else saveChIPQC <- NULL
  
  if(!is.null(res$vectors)) {
    if(!is.null(res$allvectors)) {
      res$binding     <- res$vectors
      res$totalMerged <- nrow(res$allvectors)
      res$merged      <- res$allvectors[,1:3]
    } else {
      res$binding     <- res$vectors
      res$merged      <- res$vectors[,1:3]
      res$totalMerged <- nrow(res$merged)
    }
    res$vectors    <- NULL
    res$allvectors <- NULL
  }
  
  if(is.null(res$binding)) {
    if(is.null(res$minOverlap)) {
      minOverlap=2
    } else {
      minOverlap <- res$minOverlap
    }
    contrasts  <- res$contrasts
    called     <- res$called
    allcalled  <- res$allcalled
    attributes <- res$attributes
    for(i in 1:length(res$peaks)) {
      if(is.factor(res$peaks[[i]][,1])) {
        res$peaks[[i]][,1] <- as.character(res$peaks[[i]][,1])
      }
    }
    res <- pv.vectors(res,minOverlap=minOverlap,bAllSame=pv.allSame(res),
                      merge=is.null(res$merged))
    res$contrasts  <- contrasts
    if(is.null(res$called)) {
      res$called <- called
    }
    if(is.null(res$allcalled)) {
      res$allcalled <- allcalled
    }
    res$attributes <- attributes
  }
  
  res <- pv.checkCalled(res)
  
  if(is.null(res$config$DataType)) {
    res$config$DataType=DBA_DATA_DEFAULT
    if(!is.null(res$config$RangedData)) {
      if(res$config$RangedData==FALSE) {
        res$config$DataType=DBA_DATA_FRAME   	
      } 
    }
  }
  
  if(is.null(res$config$savePrefix)) {
    res$config$savePrefix <- "dba_"
  }
  
  if(is.null(res$config$saveExt)) {
    res$config$saveExt <- "RData"
  }
  
  if(is.null(res$config$reportInit)) {
    res$config$reportInit <- "reports/DBA"
  }
  if(is.null(res$config$AnalysisMethod)){
    res$config$AnalysisMethod <- DBA_DESEQ2
  }
  
  if(is.null(res$config$bCorPlot)){
    res$config$bCorPlot <- FALSE
  }
  
  if(is(res$attributes,"function")) {
    res$attributes <- NULL
  }
  
  if(is.null(res$config$th)){
    res$config$th=0.05
  }
  if(is.null(res$config$bUsePval)){
    res$config$bUsePval <- FALSE
  }   
  
  
  
  res$config$lsfInit      <- NULL
  res$config$parallelInit <- NULL
  res$config$initFun      <- NULL
  res$config$paramFun     <- NULL
  res$config$addjobFun    <- NULL
  res$config$lapplyFun    <- NULL
  res$config$wait4jobsFun <- NULL
  res$config$parallelInit <- NULL
  res$config$multicoreInit <- NULL
  
  res$config <- as.list(res$config)
  
  if (is.null(res$config$mapQCth)) {
    res$config$mapQCth <- 15   
  }
  
  if (is.null(res$config$fragmentSize)) {
    res$config$fragmentSize <- 125
  }   
  version <- strsplit(as.character(packageVersion("DiffBind")),".",fixed=TRUE)[[1]]
  res <- pv.version(res,version[1],version[2], version[3])
  
  if(!is(res,"DBA")) {
    class(res) <- "DBA"
  }
  
  if(!is.null(saveChIPQC)) {
    saveChIPQC@DBA <- res
    res <- saveChIPQC
  }
  pv.gc(force=FALSE)
  return(res)
} 

##########################
## DBA object functions ##
##########################

print.DBA <- function(x,...){
  x <- pv.check(x)
  cat(sprintf("%s:\n",summary(x)))
  toshow <- dba.show(x)
  
  if(nrow(toshow) > 1) {
    
    if(!is.null(toshow$FRiP)) {
      if(all(toshow$FRiP >= .99)) {
        toshow$FRiP <- NULL
      }
    }
    
    if(length(unique(toshow$Reads))==1) {
      delcol <- which(colnames(toshow) %in% 'Reads')
      toshow <- toshow[,-delcol]
    }
    if(length(unique(toshow$Intervals))==1) {
      delcol <- which(colnames(toshow) %in% 'Intervals')
      toshow <- toshow[,-delcol]
    }
    if(length(unique(toshow$Caller))==1) {
      delcol <- which(colnames(toshow) %in% 'Caller')
      toshow <- toshow[,-delcol]
    }
  } else {
    toshow <-  toshow[,which(toshow[1,] != "")]
    toshow <-  toshow[,which(toshow[1,] != 0)]
  }
  print(toshow)
  
  if(!is.null(x$contrasts)){
    cat("\n")
    if(!is.null(x$design)) {
      cat(sprintf("Design: [%s] | ",dba.show(x,bDesign=TRUE)))
    }
    if(length(x$contrasts) == 1) {
      cat(sprintf("1 Contrast:") )
    } else {
      cat(sprintf("%d Contrasts:",length(x$contrasts)))
    }
    cat("\n")
    print(dba.show(x,bContrasts=TRUE,th=x$config$th))
  } else {
    if(!is.null(x$design)) {
      cat(sprintf("\nDesign: [%s]\n",dba.show(x,bDesign=TRUE)))
    }
  }
}

summary.DBA <- function(object,...) {
  if(is.null(object$binding)) {
    cat('Run dba first\n')
    return()
  }
  res <- sprintf("%d Samples, %d sites in matrix",
                 length(object$peaks),nrow(object$binding))
  if(do.nrow(object$binding) != object$totalMerged) {
    res <- sprintf("%s (%d total)",res,object$totalMerged)
  }
  return(res)
}

plot.DBA <- function(x,...){
  DBA <- pv.check(x)
  res <- dba.plotHeatmap(x,...)
}

.onAttach <- function(libname, pkgname) {
  packageStartupMessage(paste(" >>> DiffBind",
                              as.character(packageVersion("DiffBind"))))
}

test_that("normalizing data",{
  
  if(Sys.info()["sysname"] != "Windows") {
    data(tamoxifen_counts)
    tamoxifen <- dba.contrast(tamoxifen)
    tamoxifen <- dba.contrast(tamoxifen,design="~Tissue + Condition")
    
    for (nf in c(DBA_NORM_DEFAULT, DBA_NORM_LIB, DBA_NORM_TMM, DBA_NORM_RLE)) {
      tam <- dba.normalize(tamoxifen,method = DBA_ALL_METHODS,
                           library = DBA_LIBSIZE_PEAKREADS, normalize = nf)
      set.seed(3793)
      tam <- dba.analyze(tam,method=DBA_ALL_METHODS)
      rep1.e <- dba.report(tam,method=DBA_EDGER,bCounts=TRUE, 
                           bCalled=TRUE, bCalledDetail=TRUE)
      rep1.d <- dba.report(tam,method=DBA_DESEQ2,bCounts=TRUE, 
                           bCalled=TRUE, bCalledDetail=TRUE)
      
      expect_true(length(rep1.e) > 500)
      expect_true(length(rep1.d) > 500)
      
      norm <- dba.normalize(tam, bRetrieve=TRUE, method=DBA_ALL_METHODS)
      tam$norm <- NULL
      tam <- dba.normalize(tam,method = DBA_EDGER,
                           library = norm$edgeR$lib.sizes, 
                           normalize = norm$edgeR$norm.factors,
                           background=FALSE)
      tam <- dba.normalize(tam,method = DBA_DESEQ2,
                           library = norm$DESeq2$lib.sizes, 
                           normalize = norm$DESeq2$norm.factors,
                           background=FALSE)
      set.seed(3793)
      tam <- dba.analyze(tam,method=DBA_ALL_METHODS)
      rep2.e <- dba.report(tam,method=DBA_EDGER,bCounts=TRUE, 
                           bCalled=TRUE, bCalledDetail=TRUE)
      rep2.d <- dba.report(tam,method=DBA_DESEQ2,bCounts=TRUE, 
                           bCalled=TRUE, bCalledDetail=TRUE)
      
      expect_equal(sum(rep1.e != rep2.e),0)
      expect_equal(sum(rep1.d != rep2.d),0)
      
      if(nf==DBA_NORM_LIB) {
        tam <- dba.normalize(tamoxifen,method = DBA_ALL_METHODS,
                             library = DBA_LIBSIZE_FULL, 
                             normalize = nf, offsets=FALSE)
        set.seed(3793)
        tam <- dba.analyze(tam,method=DBA_ALL_METHODS)
        rep1.e <- dba.report(tam,method=DBA_EDGER,bCounts=TRUE, 
                             bCalled=TRUE, bCalledDetail=TRUE)
        rep1.d <- dba.report(tam,method=DBA_DESEQ2,bCounts=TRUE, 
                             bCalled=TRUE, bCalledDetail=TRUE)
        
        expect_true(length(rep1.e) > 500)
        expect_true(length(rep1.d) > 500)
        
        norm <- dba.normalize(tam, bRetrieve=TRUE, method=DBA_ALL_METHODS)
        tam$norm <- NULL
        tam <- dba.normalize(tam,method = DBA_EDGER,
                             library = norm$edgeR$lib.sizes, 
                             normalize = norm$edgeR$norm.factors,
                             background=FALSE)
        tam <- dba.normalize(tam,method = DBA_DESEQ2,
                             library = norm$DESeq2$lib.sizes, 
                             normalize = norm$DESeq2$norm.factors,
                             background=FALSE)
        set.seed(3793)
        tam <- dba.analyze(tam,method=DBA_ALL_METHODS)
        rep2.e <- dba.report(tam,method=DBA_EDGER,bCounts=TRUE, 
                             bCalled=TRUE, bCalledDetail=TRUE)
        rep2.d <- dba.report(tam,method=DBA_DESEQ2,bCounts=TRUE, 
                             bCalled=TRUE, bCalledDetail=TRUE)
        
        expect_equal(sum(rep1.e != rep2.e),0)
        expect_equal(sum(rep1.d != rep2.d),0)
        
        tam <- dba.normalize(tamoxifen,method = DBA_ALL_METHODS,
                             library = DBA_LIBSIZE_PEAKREADS, 
                             normalize = nf, offsets=TRUE)
        set.seed(3793)
        tam <- dba.analyze(tam,method=DBA_ALL_METHODS)
        rep1.e <- dba.report(tam,method=DBA_EDGER,bCounts=TRUE, 
                             bCalled=TRUE, bCalledDetail=TRUE)
        rep1.d <- dba.report(tam,method=DBA_DESEQ2,bCounts=TRUE, 
                             bCalled=TRUE, bCalledDetail=TRUE)
        
        expect_true(length(rep1.e) > 500)
        expect_true(length(rep1.d) > 500)
        
        norm <- dba.normalize(tam, bRetrieve=TRUE, method=DBA_ALL_METHODS)
        tam$norm <- NULL
        tam <- dba.normalize(tam,method = DBA_EDGER,
                             library = norm$edgeR$lib.sizes, 
                             offsets   = norm$offsets$offsets,
                             normalize = DBA_NORM_OFFSETS_ADJUST,
                             background=FALSE)
        tam <- dba.normalize(tam,method = DBA_DESEQ2,
                             library = norm$DESeq2$lib.sizes, 
                             normalize = DBA_NORM_OFFSETS_ADJUST,
                             offsets   = norm$offsets$offsets,
                             background=FALSE)
        set.seed(3793)
        tam <- dba.analyze(tam,method=DBA_ALL_METHODS)
        rep2.e <- dba.report(tam,method=DBA_EDGER,bCounts=TRUE, 
                             bCalled=TRUE, bCalledDetail=TRUE)
        rep2.d <- dba.report(tam,method=DBA_DESEQ2,bCounts=TRUE, 
                             bCalled=TRUE, bCalledDetail=TRUE)
        
        expect_equal(sum(rep1.e != rep2.e),0)
        expect_equal(sum(rep1.d != rep2.d),0)
      }
    }
  }
})

test_that("saving and loading returns same object",{
  
  data(tamoxifen_greylist)
  data(tamoxifen_peaks)
  dba.save(tamoxifen,"testDBA")
  testDBA <- dba.load("testDBA")
  expect_is(testDBA,"DBA")
  expect_equal(sum(!(names(testDBA) %in% names(tamoxifen))),0)
  tamoxifen <- dba.blacklist(testDBA, blacklist=DBA_BLACKLIST_HG19,
                             greylist=tamoxifen.greylist$master)
  dba.save(tamoxifen,"testDBA")
  testDBA <- dba.load("testDBA")
  expect_is(testDBA,"DBA")
  expect_equal(sum(!(names(testDBA) %in% names(tamoxifen))),0)
  x <- dba.blacklist(testDBA,Retrieve=DBA_BLACKLIST)
  x <- dba.blacklist(testDBA,Retrieve=DBA_GREYLIST)
  expect_equal(sum(x != tamoxifen.greylist$master),0)
  x <- dba.blacklist(testDBA,Retrieve=DBA_BLACKLISTED_PEAKS)
  
  expect_identical(dim(tamoxifen$merged),  dim(testDBA$merged)) 
  expect_identical(dim(tamoxifen$binding), dim(testDBA$binding)) 
  expect_identical(dim(tamoxifen$called),  dim(testDBA$called)) 
  expect_identical(dim(testDBA$called),    dim(testDBA$binding[,-c(1:3)]))   
  expect_identical(nrow(testDBA$allcalled), nrow(testDBA$merged)) 
  
  rm(tamoxifen)
  data(tamoxifen_counts)
  dba.save(tamoxifen,"testDBA")
  testDBA <- dba.load("testDBA")
  expect_is(testDBA,"DBA")
  expect_equal(sum(!(names(testDBA) %in% names(tamoxifen))),0)
  tamoxifen <- dba.blacklist(testDBA, blacklist=DBA_BLACKLIST_HG19,
                             greylist=tamoxifen.greylist$master)
  dba.save(tamoxifen,"testDBA")
  testDBA <- dba.load("testDBA")
  expect_is(testDBA,"DBA")
  expect_equal(sum(!(names(testDBA) %in% names(tamoxifen))),0)
  x <- dba.blacklist(testDBA,Retrieve=DBA_BLACKLIST)
  x <- dba.blacklist(testDBA,Retrieve=DBA_GREYLIST)
  expect_equal(sum(x != tamoxifen.greylist$master),0)
  x <- dba.blacklist(testDBA,Retrieve=DBA_BLACKLISTED_PEAKS)
  
  expect_identical(dim(tamoxifen$merged),  dim(testDBA$merged)) 
  expect_identical(dim(tamoxifen$binding), dim(testDBA$binding)) 
  expect_identical(dim(tamoxifen$called),  dim(testDBA$called)) 
  expect_identical(dim(testDBA$called),    dim(testDBA$binding[,-c(1:3)]))  
  
  rm(tamoxifen)
  data(tamoxifen_counts)
  tamoxifen <- dba.contrast(tamoxifen,design="~Tissue+Condition")
  tamoxifen <- dba.analyze(tamoxifen,method=DBA_ALL_METHODS)
  rep1 <- dba.report(tamoxifen)
  showsamps1 <- dba.show(tamoxifen) 
  showcons1  <- dba.show(tamoxifen,bContrast=TRUE) 
  showdes1   <- dba.show(tamoxifen,bDesign=TRUE)
  dba.save(tamoxifen,"testDBA")
  testDBA <- dba.load("testDBA")
  expect_is(testDBA,"DBA")
  expect_equal(sum(!(names(testDBA) %in% names(tamoxifen))),0)
  rep2 <- dba.report(testDBA)
  expect_equal(sum(rep1!=rep2),0)  
  showsamps2 <- dba.show(testDBA) 
  showcons2  <- dba.show(testDBA,bContrast=TRUE) 
  showdes2   <- dba.show(testDBA,bDesign=TRUE)
  expect_equal(sum(showsamps1!=showsamps2),0) 
  expect_equal(sum(showcons1!=showcons2),0) 
  expect_equal(sum(showdes1!=showdes2),0) 
  
  expect_identical(dim(tamoxifen$merged),  dim(testDBA$merged)) 
  expect_identical(dim(tamoxifen$binding), dim(testDBA$binding)) 
  expect_identical(dim(tamoxifen$called),  dim(testDBA$called)) 
  expect_identical(dim(testDBA$called),    dim(testDBA$binding[,-c(1:3)]))  
  
  unlink("dba_testDBA.RData")
})

PV_BLACKLIST_HG19   <- "BSgenome.Hsapiens.UCSC.hg19"
PV_BLACKLIST_HG38   <- "BSgenome.Hsapiens.UCSC.hg38"
PV_BLACKLIST_GRCH37 <- "BSgenome.Hsapiens.NCBI.GRCh37"
PV_BLACKLIST_GRCH38 <- "BSgenome.Hsapiens.NCBI.GRCh38"
PV_BLACKLIST_MM9    <- "BSgenome.Mmusculus.UCSC.mm9"
PV_BLACKLIST_MM10   <- "BSgenome.Mmusculus.UCSC.mm10"
PV_BLACKLIST_CE10   <- "BSgenome.Celegans.UCSC.ce10"
PV_BLACKLIST_CE11   <- "BSgenome.Celegans.UCSC.ce11"
PV_BLACKLIST_DM3    <- "BSgenome.Dmelanogaster.UCSC.dm3"
PV_BLACKLIST_DM6    <- "BSgenome.Dmelanogaster.UCSC.dm6"

pv.BlackGreyList <- function (DBA, blacklist, greylist,
                              Retrieve, cores) {
  
  isConsensus <- pv.isConsensus(DBA) 
  
  if(!missing(Retrieve)) {
    
    if(Retrieve==DBA_BLACKLIST){
      if(is.null(DBA$blacklist)) {
        stop("No blacklist.",call.=FALSE)
      }
      return(DBA$blacklist)
    } else if(Retrieve==DBA_GREYLIST) {
      if(is.null(DBA$greylist)) {
        stop("No greylist",call.=FALSE)
      }
      return(DBA$greylist)
    } else if(Retrieve==DBA_BLACKLISTED_PEAKS) {
      if(is.null(DBA$peaks.blacklisted)) {
        stop("No blacklisted peaks.",call.=FALSE)
      }
      return(DBA$peaks.blacklisted)
    } else {
      stop("Invalid value for Retrieve parameter.",call.=FALSE)
    }
  }
  
  if(isConsensus) {
    originalPeaks    <- nrow(DBA$binding)
  } else {
    originalPeaks     <- sum(unlist(lapply(DBA$peaks,nrow)))
    originalMerged    <- nrow(DBA$merged)
    originalConsensus <- nrow(DBA$binding)
  }
  
  doblacklist <- dogreylist <- getgenome <- FALSE
  genome <- NULL
  if(is(blacklist,"logical")) {
    if(blacklist == TRUE) {
      doblacklist <- TRUE
      getgenome <- TRUE
    } 
  } else {
    genome <- blacklist
    doblacklist <- TRUE
  }
  
  havegreylist <- FALSE
  if(is(greylist,"logical")) {
    if(greylist == TRUE) {
      dogreylist <- TRUE
      getgenome <- TRUE
    } 
  } else if (is(greylist,"list") ||
             is(greylist,"GRanges") || is(greylist,"GRangesList")) {
    havegreylist <- TRUE
    dogreylist   <- TRUE
    if(is.null(genome)) {
      genome <- FALSE
    }
  } else {
    if(is.null(genome)) {
      genome <- greylist
    }
    dogreylist <- TRUE
  }
  
  if(getgenome) {
    if(doblacklist) {
      blacklist <- genome <- pv.genomes(DBA$class["bamRead",],DBA$chrmap)
    } 
    if(dogreylist) {
      if(!havegreylist) {
        if(is.null(genome)) {
          greylist <- genome <- pv.genomes(DBA$class["bamControl",],DBA$chrmap)
        } else {
          greylist <- genome
        }
      }
    }
  } 
  
  if(doblacklist || dogreylist) {
    if(is.null(genome)) {
      message("No genome detected.")
      return(DBA)
    } else {
      if(is(genome,"character")) {
        message("Genome detected: ",strsplit(genome,"BSgenome.")[[1]][2])
      }
    }
  }
  
  if(doblacklist) {
    message("Applying blacklist...")
    DBA <- pv.blacklist(DBA, blacklist=blacklist, isConsensus=isConsensus)
  }
  
  if(dogreylist) {
    DBA <- pv.greylist(DBA, greylist=greylist, isConsensus=isConsensus, cores=cores)
  }
  
  if(isConsensus) {
    endPeaks <- nrow(DBA$peaks[[1]])
  } else {
    endPeaks     <- sum(unlist(lapply(DBA$peaks,nrow)))
  }
  
  if(endPeaks < originalPeaks) {
    
    if(isConsensus) {
      DBA <- pv.removeBlacklistedPeaks(DBA)
      reDBA <- dba(DBA)
      reDBA$norm <- DBA$norm
      DBA <- pv.restoreContrasts(reDBA,DBA)
      DBA <- pv.reNormalize(DBA)
    } else {
      DBA <- dba(DBA)
    } 
    
    endMerged    <- nrow(DBA$merged)
    endConsensus <- nrow(DBA$binding)
    
    if(!missing(blacklist) && !missing(greylist)) {
      if(isConsensus) {
        DBA$peaks.blacklisted <- GRangesList(lapply(DBA$peaks.blacklisted,
                                                    function(x){
                                                      x[,c("cReads","Reads","Score")]
                                                    }))
        msgstring <- sprintf("Removed %d (of %d) consensus peaks.",
                             originalPeaks-endPeaks,originalPeaks)
        DBA$SN <- pv.Signal2Noise(DBA)
      } else {
        mergedRemoved    <- originalMerged - endMerged
        consensusRemoved <- originalConsensus - endConsensus
        msgstring <- sprintf("Removed: %d merged (of %d) and %d (of %d) consensus.",
                             mergedRemoved, originalMerged, 
                             consensusRemoved, originalConsensus)
      }
      message(msgstring)
    }
  } else {
    message("No intervals removed.")
  }
  
  return(DBA)
  
}

pv.blacklist <- function(pv, blacklist, isConsensus=FALSE) {
  
  if(missing(blacklist)) {
    pv$config$blacklist <- NULL
    return(pv)
  }
  
  if(!is(blacklist,"GRanges")) {
    
    ce10.blacklist   <- dm3.blacklist    <- NULL
    grch37.blacklist <- grch38.blacklist <- NULL
    hg19.blacklist   <- hg38.blacklist   <- NULL
    mm10.blacklist   <- mm9.blacklist    <- NULL
    ce11.blacklist   <- dm6.blacklist    <- NULL
    
    if(blacklist==PV_BLACKLIST_HG19) {
      load(system.file("data/hg19.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- hg19.blacklist
    } else if(blacklist==PV_BLACKLIST_HG38) {
      load(system.file("data/hg38.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- hg38.blacklist
    } else if(blacklist==PV_BLACKLIST_GRCH37) {
      load(system.file("data/grch37.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- grch37.blacklist
    } else if(blacklist==PV_BLACKLIST_GRCH38) {
      load(system.file("data/grch38.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- grch38.blacklist
    } else if(blacklist==PV_BLACKLIST_MM9) {
      load(system.file("data/mm9.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- mm9.blacklist
    } else if(blacklist==PV_BLACKLIST_MM10) {
      load(system.file("data/mm10.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- mm10.blacklist
    } else if(blacklist==PV_BLACKLIST_CE10) {
      load(system.file("data/ce10.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- ce10.blacklist
    } else if(blacklist==PV_BLACKLIST_CE11) {
      load(system.file("data/ce11.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- ce11.blacklist
    } else if(blacklist==PV_BLACKLIST_DM3) {
      load(system.file("data/dm3.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- dm3.blacklist
    } else if(blacklist==PV_BLACKLIST_DM6) {
      load(system.file("data/dm6.blacklist.RData",package="GreyListChIP"),
           envir = environment())
      blacklist <- dm6.blacklist
    } else {
      message("No blacklist found for ",blacklist)
      pv$blacklist <- NULL
      return(pv)
    }
  }
  
  # check that at least one chr matches
  snames <- as.character(unique(seqnames(blacklist)))
  if(sum(pv$chrmap %in% snames)==0) {
    warning('Blacklist does not overlap any peak chromosomes!',call.=FALSE)
  }
  
  # Apply blacklist to peaksets
  
  if(isConsensus) {
    totalPeaks <- nrow(pv$peaks[[1]])
  } else {
    totalPeaks <- sum(unlist(lapply(pv$peaks,nrow)))
  }
  
  pv <- pv.applyBlacklist(pv, blacklist)
  
  if(isConsensus) {
    totalRemoved   <- totalPeaks - nrow(pv$peaks[[1]])
  } else {
    totalRemoved   <- totalPeaks - sum(unlist(lapply(pv$peaks,nrow)))
  }
  msgstring <- sprintf("Removed: %d of %d intervals.",
                       totalRemoved, totalPeaks)
  message(msgstring)
  
  pv$blacklist <- blacklist
  
  return(pv)
  
}

pv.applyBlacklist <- function(pv, blacklist) {
  
  blacklisted <- GRangesList(lapply(lapply(pv$peaks,pv.doBlacklist,
                                           blacklist,bReturnFiltered=TRUE),
                                    GRanges))
  names(blacklisted) <- pv$class[PV_ID,]
  if(is(pv$peaks.blacklisted,"GRangesList")) {
    for(i in 1:length(blacklisted)) {
      if(length(blacklisted[[i]]) != 0) {
        if(length(pv$peaks.blacklisted[[i]]) == 0) {
          suppressWarnings(pv$peaks.blacklisted[[i]] <- blacklisted[[i]])
        } else {
          pv$peaks.blacklisted[[i]] <- 
            sort(
              suppressWarnings(c(pv$peaks.blacklisted[[i]], blacklisted[[i]]))
            )
        }
      }
    }
  } else {
    pv$peaks.blacklisted <- blacklisted
  }
  
  pv$peaks <- lapply(pv$peaks,pv.doBlacklist,
                     blacklist,bReturnFiltered=FALSE)
  return(pv)
}

pv.doBlacklist <- function(peakset, blacklist, bReturnFiltered=FALSE){
  peakset <- GRanges(peakset)
  if(!bReturnFiltered) {
    suppressWarnings(peakset <- peakset[!peakset %over% blacklist])
  } else {
    suppressWarnings(peakset <- peakset[peakset %over% blacklist])
  }
  peakset <- data.frame(peakset)
  if(nrow(peakset)==0) {
    return(NULL)
  }
  peakset <- peakset[,-c(4,5)]
  peakset[,1] <- as.character(peakset[,1])
  return(peakset)
}

pv.greylist <- function(pv, greylist, isConsensus=FALSE, 
                        cores=pv$config$cores) {
  
  if(is(greylist,"list")) {
    greylist <- greylist$master
  }
  
  if(!is(greylist,"GRanges")) {
    controls <- pv$class[PV_BAMCONTROL,]
    if(pv.noControls(controls)) {
      message("No control reads specified, unable to generate greylist.")
      return(pv)
    }
    whichcontrols <- !duplicated(controls)
    whichcontrols <- whichcontrols & !is.na(controls)
    whichcontrols <- whichcontrols & controls != ""
    controls      <- controls[whichcontrols]
    controlnames  <- pv$class[PV_CONTROL,whichcontrols]
    if(length(unique(controlnames))==1 && is.na(unique(controlnames))) {
      controlnames <- controls
    } else {
      if(length(unique(controls))==1 && controls[1]=="") {
        controlnames <- controls      
      }
    }
    
    if(is(greylist,"BSgenome")){
      ktype <- seqinfo(greylist)
    } else if(is(greylist,"Seqinfo")) {
      ktype <- greylist
    } else {
      
      dba.ktypes <- NULL
      load(system.file("extra/ktypes.rda", package="DiffBind"),
           envir = environment())
      
      ktype <- match(greylist,names(dba.ktypes))
      if(is.na(ktype)[1]) {
        message("No known BSgenome: ",greylist)
        pv$greylist <- NULL
        return(pv)
      }
      ktype <- dba.ktypes[[ktype]]
      
      rm(dba.ktypes)
    }
    
    ## GreyListChIP for each control    
    controllist <- pv.makeGreylists(pv,ktype,controls,cores,
                                    pval=pv$config$greylist.pval)
    
    ## Merge
    if(length(controllist)==1) {
      greylist <- controllist[[1]]
      controllist <- NULL
    } else {
      names(controllist) <- controlnames
      greylist <- pv.mergeGreyLists(controllist)
    }
    
    gc(verbose=FALSE)
    
  } else {
    controls <- controllist <- NULL 
  }
  
  message(sprintf("Master greylist: %d ranges, %d bases",
                  length(greylist),sum(width(greylist))))   
  
  # check that at least one chr matches
  snames <- as.character(unique(seqnames(greylist)))
  if(sum(pv$chrmap %in% snames)==0) {
    warning('Greylist does not overlap any peak chromosomes!',call.=FALSE)
  }
  
  # Apply greylist to peaksets
  
  if(isConsensus) {
    totalPeaks <- nrow(pv$peaks[[1]])
  } else {
    totalPeaks <- sum(unlist(lapply(pv$peaks,nrow)))
  }
  
  pv <- pv.applyBlacklist(pv, greylist)
  
  if(isConsensus) {
    totalRemoved   <- totalPeaks - nrow(pv$peaks[[1]])
  } else {
    totalRemoved   <- totalPeaks - sum(unlist(lapply(pv$peaks,nrow)))
  }
  msgstring <- sprintf("Removed: %d of %d intervals.",
                       totalRemoved, totalPeaks)
  message(msgstring)
  
  if(length(controls)<=1 || is.null(controllist)) {
    pv$greylist <- greylist
  } else {
    pv$greylist  <- list(master=greylist,controls=controllist)
    pv$greylist$controls <- GRangesList(pv$greylist$controls)
  }
  
  return(pv)
}

pv.makeGreylists <- function(pv,ktype,bamfiles,parallel,pval=.999){
  
  if(Sys.info()["sysname"] == "Windows") {
    parallel <- NULL
  }
  
  usecores <- 1
  if(!is.null(parallel)) {
    if(parallel != FALSE) {
      usecores <- parallel
    }
  }
  
  if (!requireNamespace("BiocParallel",quietly=TRUE)) {
    usecores <- 1
  }
  
  if(usecores > 1) {
    param <- BiocParallel::MulticoreParam(workers = usecores)
  } else {
    param <-  BiocParallel::SerialParam()
  }
  
  suppressMessages(defparam <- BiocParallel::registered())
  if(length(defparam)==0) {
    defparam <- param
  } else {
    defparam <- defparam[[1]]
  }
  
  suppressMessages(BiocParallel::register(param,default=TRUE))
  
  message("Counting control reads for greylist...")
  res <- tryCatch(
    suppressMessages(
      gllist <- bplapply(bamfiles,
                         pv.countGreylist,
                         pv, ktype, 
                         BPPARAM=param)),
    error=function(x){stop("GreyListChIP error: ",x)}
  )
  
  controllist <- NULL
  for (i in 1:length(gllist)) {
    message(sprintf("Building greylist: %s",bamfiles[i]))
    greylist <- pv.makeGreylist(pv,ktype,gllist[[i]],usecores,
                                pval=pv$config$greylist.pval)
    controllist <- pv.listadd(controllist, greylist)
  }
  
  BiocParallel::register(defparam, default=TRUE)
  
  return(controllist)
}

pv.countGreylist <- function(bamfile,pv,ktype) {
  gl <- new("GreyList",karyotype=ktype[pv$chrmap,])
  gl <- GreyListChIP::countReads(gl, bamfile)
  return(gl)
}

pv.makeGreylist <- function(pv,ktype,gl,usecores,pval=.999){
  if(is.null(pval)) {
    pval=.999
  }
  gl <- GreyListChIP::calcThreshold(gl,p=pval,cores=usecores)
  gl <- GreyListChIP::makeGreyList(gl)
  
  res <- gl@regions
  rm(gl)
  return(res)
}

pv.mergeGreyLists <- function(controllist) {
  
  greylist <- controllist[[1]]
  
  message(sprintf("%s: %d ranges, %d bases", names(controllist)[1],
                  length(greylist),sum(width(greylist))))    
  
  for(i in 2:length(controllist)) {
    gl <- controllist[[i]]
    message(sprintf("%s: %d ranges, %d bases",
                    names(controllist)[i],length(gl), sum(width(gl))))
    greylist <- union(greylist,gl)
  }
  
  return(greylist)
}

pv.removeBlacklistedPeaks <- function(DBA) {
  bl <- data.frame(DBA$peaks.blacklisted[[1]])[,1:3]
  bl[,1] <- match(bl[,1],DBA$chrmap)
  toremove    <- which(GRanges(data.frame(DBA$merged)) %over% GRanges(bl))
  
  if(do.nrow(DBA$merged) != do.nrow(DBA$binding)) {
    stop("Internal error removing blacklisted regions (merged != binding).")
  }
  
  DBA$merged  <- DBA$merged[-toremove,]
  DBA$binding <- DBA$binding[-toremove,]  
  DBA$called  <- DBA$called[-toremove,]    
  
  return(DBA)
}

pv.noControls <- function(controls) {
  if(sum(is.na(controls))==length(controls)) {
    return(TRUE)
  } else {
    if(length(unique(controls))==1 && controls[1]=="") {
      return(TRUE)        
    }
  }
  return(FALSE)
}

pv.genome <- function(bamfile, chrmap=NULL, ref=NULL, dba.ktypes=NULL) {
  
  header <- Rsamtools::scanBamHeader(bamfile)[[1]]$targets
  
  if(is.null(chrmap)) {
    chrmap <- names(header)
  }
  chrs <- match(chrmap,names(header))
  if(is.na(chrs[1])) {
    message('No matching chromosomes found for file: ',bamfile)
    return(NULL)
  }
  chrnames <- names(header)[chrs]
  
  if(is.null(dba.ktypes)) {
    load(system.file("extra/ktypes.rda", package="DiffBind"),
         envir = environment())
    remove.ktypes <- TRUE
  } else {
    remove.ktypes <- FALSE    
  }
  
  if(!is.null(ref)) {
    dba.ktypes <- list(dba.ktypes[[match(ref,names(dba.ktypes))]])
    names(dba.ktypes) <- ref
  }
  
  res <- NULL
  for(knum in 1:length(dba.ktypes)) {
    matches <- mismatches <- 0
    ktype <- dba.ktypes[[knum]]
    matchChrs <- match(chrnames, names(ktype)) 
    if(!is.na(matchChrs[1])) {
      for(chr in chrs) {
        bamlen <- header[chr]
        krec   <- ktype[names(header)[chr],]
        klen <- GenomeInfoDb::seqlengths(krec)
        if(!is.na(klen)) {
          if(bamlen == klen ) {
            matches <- matches + 1
          } else {
            mismatches <- mismatches + 1
          }
        }
      }
    }
    if(matches > 0 && mismatches == 0) {
      res <- names(dba.ktypes)[knum]
    }
  }
  
  if(remove.ktypes) {
    dba.ktypes <- NULL
  }
  
  return(res)
}

pv.genomes <- function(bamfiles, chrmap=NULL) {
  dba.ktypes <- NULL
  
  load(system.file("extra/ktypes.rda", package="DiffBind"),
       envir = environment())
  
  ref <- NULL
  for(bamfile in bamfiles) {
    newref <- pv.genome(bamfile, chrmap, ref, dba.ktypes)
    if(is.null(ref)) {
      ref <- newref
    } else if(is.null(newref)) {
      return(NULL)      
    }  else if (ref != newref) {
      message("bam files match different reference genomes:",ref," ", newref)
      return(NULL)
    }
  }
  
  dba.ktypes <- NULL
  return(ref)
}


pv.restoreContrasts <- function(reDBA,DBA){
  reDBA$design <- DBA$design
  
  if(!is.null(DBA$contrasts)) {
    reDBA$contrasts <- DBA$contrasts
    for(i in 1:length(reDBA$contrasts)) {
      reDBA$contrasts[[i]]$DESeq2 <- NULL
      reDBA$contrasts[[i]]$edgeR  <- NULL
    }
  }
  
  if(!is.null(DBA$DESeq2)) {
    reDBA$DESeq2 <- NULL
    reDBA$DESEq2$names <- DBA$names
  }
  
  reDBA$edgeR <- NULL
  
  return(reDBA)
}

pv.DEedgeR <- function(pv,group1,group2,label1="Group 1",label2="Group 2",blockList=NULL,
                       bSubControl=FALSE,bFullLibrarySize=FALSE,bTagwise=TRUE,bGLM=TRUE,bNormOnly=FALSE,
                       bWeighting=FALSE, filter=0,filterFun=max) {
  
  fdebug('Enter pv.DEedgeR')
  
  #require(edgeR)
  
  res <- pv.DEinit(pv,group1,group2,label1,label2,method='edgeR',
                   bSubControl=bSubControl,bFullLibrarySize=bFullLibrarySize,
                   filter=filter, filterFun=filterFun)
  
  # if(is.null(pv$norm$edgeR))  {
  # message("edgeR: re-calc norm.factors")
  res <- edgeR::calcNormFactors(res,method="TMM",doWeighting=bWeighting)
  fdebug(sprintf('calcNormFactors: %f',res$counts[7,1]))
  # }  else {
  #   message("edgeR: DONT re-calc norm.factors (use  dba.normalize())")
  # }
  
  if(bNormOnly) {
    return(res)	
  }
  
  if(is.null(blockList)) {
    fdebug('blockList is NULL')
  } else {
    fdebug('blockList is not NULL')
  }
  fdebug('pv.DEedgeR: check for blocking factor')
  if(is.null(blockList)) {
    fdebug('pv.DEedgeR: NO blocking factor')
    res <- edgeR::estimateCommonDisp(res)
    fdebug(sprintf('estimateCommonDisp: %f',res$counts[7,1]))
    if(bGLM){
      res$design <- model.matrix(~res$samples$group)
      if(bTagwise) {
        res <- edgeR::estimateGLMCommonDisp(res,res$design)
        res <- edgeR::estimateGLMTagwiseDisp(res,res$design)
      } else {
        res <- edgeR::estimateGLMCommonDisp(res,res$design)
      }
      res$GLM <- edgeR::glmFit(res,res$design)
      res$LRT <- edgeR::glmLRT(res$GLM,2)
    } else {
      if(bTagwise){
        res <- edgeR::estimateTagwiseDisp(res,prior.df=50,trend="none")
        #res <- edgeR::estimateTagwiseDisp(res,prior.n=getPriorN(res),trend="movingave")
        res$db     <- edgeR::exactTest(res,dispersion='tagwise')
      } else {
        res$db     <- edgeR::exactTest(res,dispersion='common')	
      }
    }
    fdebug(sprintf('Fit and test: %f',res$counts[7,1]))
    fdebug('pv.DEedgeR: estimateTagwiseDisp complete')
    
    fdebug(sprintf('pv.DEedgeR: exactTest complete:%s-%s',res$db$comparison[1],res$db$comparison[2]))
    #res$db$fdr <- edgeR::topTags(res$db,nrow(res$db$counts))
  } else {
    fdebug('pv.DEedgeR: BLOCKING FACTOR')
    
    targets <- pv.blockFactors(pv,group1,group2,label1,label2,blockList)
    if(is.null(targets)){
      return(res)	
    }
    res$samples <- data.frame(cbind(targets,res$samples[,2:3]))
    
    attr <-  blockList[[1]]$attribute
    if(attr=='Replicate') {
      res$designmatrix <- model.matrix(~ Replicate + group,data = targets)
    } else if(attr=='Tissue') {
      res$designmatrix <- model.matrix(~ Tissue + group,data = targets)
    } else if(attr=='Factor') {
      res$designmatrix <- model.matrix(~ Factor + group,data = targets)
    } else if(attr=='Condition') {
      res$designmatrix <- model.matrix(~ Condition + group,data = targets)
    } else if(attr=='Caller') {
      res$designmatrix <- model.matrix(~ Caller + group,data = targets)
    } else if(attr=='Treatment') {
      res$designmatrix <- model.matrix(~ Treatment + group,data = targets)
    } else if(attr=='Block') {
      res$designmatrix <- model.matrix(~ Block + group,data = targets)
    } else {
      warning('Unsupported blocking attribute: ',attr,call.=FALSE)
      return(NULL)	
    }
    message('edgeR multi-factor analysis.')
    
    # if(is.null(pv$norm$edgeR))  {
    # message("edgeR: re-calc norm.factors")
    # res <- edgeR::calcNormFactors(res,method="TMM",doWeighting=bWeighting)
    # fdebug(sprintf('calcNormFactors: %f',res$counts[7,1]))
    # }  else {
    #   message("edgeR: DONT re-calc norm.factors (use  dba.normalize())")
    # }
    
    res <- edgeR::estimateGLMCommonDisp(res,res$designmatrix)
    if(bTagwise) {
      res <- edgeR::estimateGLMTagwiseDisp(res,res$designmatrix)
    }
    res$GLM <- edgeR::glmFit(res,res$designmatrix)
    res$LRT <- edgeR::glmLRT(res$GLM,ncol(res$designmatrix))
    res$counts <- NULL	 
    #res$fdr <- edgeR::topTags(res$LRT,nrow(res$counts))
  }
  
  res$bSubControl      <- bSubControl
  res$bFullLibrarySize <- bFullLibrarySize
  
  fdebug(sprintf('Exit pv.DEedgeR: %f',res$counts[7,1]))
  return(res)	
  
}

pv.DEedgeR_parallel <- function(contrast,pv,blockList,bSubControl,
                                bFullLibrarySize,bTagwise,bGLM,
                                filter=0,filterFun=max) {
  crec <- pv$contrasts[[contrast]]
  if(!is.null(blockList)) {
    blockList <- crec$blocklist
  }
  if(!is.null(crec$contrast)){
    res <- pv.edgeRContrastResults(pv,crec)
  } else {
    res <- pv.DEedgeR(pv,crec$group1,crec$group2,crec$name1,crec$name2,
                      blockList=blockList,
                      bSubControl=bSubControl,bFullLibrarySize=bFullLibrarySize,
                      bTagwise=bTagwise,bGLM=bGLM,
                      filter=filter,filterFun=filterFun)
    
    fdebug(sprintf('Exit pv.DEedgeR_parallel: %f',res$counts[7,1]))
    pv.gc()
  }
  return(res)
}


pv.allDEedgeR <- function(pv,block,bFullLibrarySize=FALSE,bParallel=FALSE,bSubControl=FALSE,
                          bTagwise=TRUE,bGLM=FALSE,filter=filter,filterFun=filterFun) {
  
  fdebug('ENTER pv.allDEedgeR')
  #require(edgeR)
  
  if(is.null(pv$contrasts)) {
    if(missing(block)) {
      pv$contrasts <- pv.contrast(pv)
    } else {
      pv$contrasts <- pv.contrast(pv,block=block)
    }
  }
  
  if(bParallel) {
    pv <- dba.parallel(pv)
    jobs <- NULL
    blocks <- NULL
  }
  
  fdebug('pv.allDEedgeR: for each contrast')
  reslist <- NULL
  
  if(bParallel && (pv$config$parallelPackage > 0)) {
    params <- dba.parallel.params(pv$config,c('pv.DEedgeR_parallel','pv.DEedgeR',
                                              'pv.DEinit','calcNormFactors',
                                              'edgeR::estimateCommonDisp',
                                              'edgeR::estimateTagwiseDisp',
                                              'edgeR::estimateGLMCommonDisp',
                                              'edgeR::estimateGLMTagwiseDisp',
                                              'edgeR::exactTest','edgeR::topTags',
                                              'edgeR::glmFit','edgeR::glmLRT'))
    reslist <- dba.parallel.lapply(pv$config,params,1:length(pv$contrasts),pv.DEedgeR_parallel,pv,
                                   NULL,bSubControl,bFullLibrarySize,bTagwise,bGLM=bGLM,
                                   filter=filter,filterFun=filterFun)
    
    fdebug(sprintf('Return from parallel call to pv.DEedgeR_parallel: %f',reslist[[1]]$counts[7,1]))
    
    blist <- NULL
    for(i in 1:length(pv$contrasts)) {
      if(!is.null(pv$contrasts[[i]]$blocklist)) {
        blist <- c(blist,i)
      }
    }
    if(length(blist > 0)) {
      bres <-  dba.parallel.lapply(pv$config,params,blist,pv.DEedgeR_parallel,pv,
                                   TRUE,bSubControl,bFullLibrarySize,bTagwise,
                                   filter=filter,filterFun=filterFun)
      for(i in 1:length(blist)) {
        reslist[[blist[i]]]$block <- bres[[i]]
      }    
    }     
  } else { #SERIAL
    for(i in 1:length(pv$contrast)) { 	
      if(!is.null(pv$contrasts[[i]]$contrast)){
        res <- pv.edgeRContrastResults(pv,pv$contrasts[[i]])
      } else {
        res <- pv.DEedgeR(pv,pv$contrasts[[i]]$group1,pv$contrasts[[i]]$group2,
                          pv$contrasts[[i]]$name1,pv$contrasts[[i]]$name2,
                          bSubControl=bSubControl,
                          bFullLibrarySize=bFullLibrarySize,bTagwise=bTagwise,
                          bGLM=bGLM,filter=filter,filterFun=filterFun)
        
        if(!is.null(pv$contrasts[[i]]$blocklist)) {
          res$block <- pv.DEedgeR(pv,pv$contrasts[[i]]$group1,pv$contrasts[[i]]$group2,
                                  pv$contrasts[[i]]$name1,pv$contrasts[[i]]$name2,
                                  pv$contrasts[[i]]$blocklist,
                                  bSubControl=bSubControl,
                                  bFullLibrarySize=bFullLibrarySize,
                                  bTagwise=bTagwise,filter=filter,filterFun=filterFun)   
        }
      }
      reslist <- pv.listadd(reslist,res)   
    }
  }
  
  fdebug(sprintf('Exit pv.allDEedgeR: %f',reslist[[1]]$counts[7,1]))
  return(reslist)
}

pv.edgeRdesign <- function(pv,
                           bSubControl=TRUE,
                           bTagwise=TRUE, bWeighting=FALSE,
                           existing=NULL,
                           filter=0, filterFun=max){
  
  if (!requireNamespace("edgeR",quietly=TRUE)) {
    stop("Package edgeR not installed",call.=FALSE)
  }
  
  #Can we avoid re fitting model?
  if(!is.null(existing$DEdata)) {
    if(bTagwise != existing$bTagwise) {
      existing <- NULL
    } else if(bSubControl != existing$bSubControl) {
      existing <- NULL
    } 
    # else if(bFullLibrarySize != existing$bFullLibrarySize) {
    #   existing <- NULL
    # }
  }
  
  res <- existing
  
  if(is.null(existing$DEdata)) {
    
    res$DEdata <- pv.DEinitedgeR(pv,
                                 bSubControl=bSubControl,
                                 # bFullLibrarySize=bFullLibrarySize,
                                 filter=filter, filterFun=filterFun)
    
    if(is.null(pv$norm$edgeR))  {
      # message("edgeR: re-calc norm.factors")
      res$DEdata <- edgeR::calcNormFactors(res$DEdata,method="TMM",
                                           doWeighting=bWeighting)
      fdebug(sprintf('calcNormFactors: %f',res$counts[7,1]))
    }  else {
      # message("edgeR: DONT re-calc norm.factors (use  dba.normalize())")
    }
    
    design <- pv$design
    design.matrix <- pv.edgeRdesign.matrix(pv,design)
    
    res$DEdata <- edgeR::estimateGLMTrendedDisp(res$DEdata,design=design.matrix)
    if(bTagwise) {
      res$DEdata <- edgeR::estimateGLMTagwiseDisp(res$DEdata,design=design.matrix)
    }
    res$DEdata <- edgeR::glmQLFit(res$DEdata,design=design.matrix)
    
    res$bSubControl      <- bSubControl
    # res$bFullLibrarySize <- bFullLibrarySize
    res$bTagwise         <- bTagwise
    res$design           <- design.matrix
    
  } else {
    res <- existing
  }
  
  return(res)
}

pv.edgeRdesign.matrix <- function(pv,design){
  meta <- pv.getMeta(pv)
  design.matrix <- model.matrix(formula(design),data=meta)
  return(design.matrix)
}

pv.DEinitedgeR <- function(pv,
                           bSubControl=FALSE,
                           bFullLibrarySize,
                           bRawCounts=FALSE,
                           filter=0,filterFun=max,
                           numReads) {
  
  if (!requireNamespace("edgeR",quietly=TRUE)) {
    stop("Package edgeR not installed",call.=FALSE)
  }    
  
  srcmask <- pv.mask(pv,PV_CALLER,"source") | pv.mask(pv,PV_CALLER,"counts")
  if(sum(srcmask)==0) {
    stop('No samples present with read counts',call.=FALSE)
  }
  
  counts  <- pv.get_reads(pv, srcmask, bSubControl=bSubControl,numReads=numReads)
  
  if(is.null(filter)) {
    filter <- 0
  }
  if(filter > 0){
    scores <- apply(counts,1,filterFun)
    keep   <- scores > filter
    counts <- counts[keep,]
    rownames(counts) <- which(keep)
  } else {
    rownames(counts) <- as.character(1:nrow(counts))
  }
  
  colnames(counts) <- pv$class[PV_ID,]
  
  if(bRawCounts) {
    return(counts)	
  }
  
  if(!is.null(pv$norm$edgeR)) {
    # message("edgeR: Using lib.sizes from dba.normalize()")
    libsize <- pv$norm$edgeR$lib.size
  } else {
    if(missing(bFullLibrarySize)) {
      stop('Internal error: bFullLibrarySize missing.')
    }
    # message("edgeR: NO lib.sizes from dba.normalize()")
    if(!is(bFullLibrarySize,"logical")) {
      libsize <- bFullLibrarySize
    } else {
      if(bFullLibrarySize) {
        libsize <- as.numeric(pv$class[PV_READS,srcmask])
      } else {
        libsize <- colSums(counts)
      }
    }
  }
  
  offsets <- NULL
  if(!is.null(pv$norm$edgeR)) {
    # message("edgeR: Using norm.factors from dba.normalize()")
    normfacs <- pv$norm$edgeR$norm.facs
    if(pv$norm$edgeR$norm.method == PV_NORM_OFFSETS ||
       pv$norm$edgeR$norm.method == PV_NORM_OFFSETS_ADJUST) {
      if(!is.null(pv$norm$offsets$offsets)) {
        # message("edgeR: use offsets")
        offsets <- assay(pv$norm$offsets$offsets, "offsets")
      } else {
        stop('Internal error: no offsets available.',call.=FALSE)
      }
    }
  } else {
    # message("edgeR: NO norm.factors from dba.normalize()")
    normfacs <- NULL
  }
  
  meta <- pv.getMeta(pv)
  res <- #suppressMessages(
    edgeR::DGEList(counts,lib.size=libsize, norm.factors=normfacs,
                   samples=meta,genes=as.character(1:nrow(counts)))
  #)
  
  if(!is.null(offsets)) {
    if(pv$norm$edgeR$norm.method == PV_NORM_OFFSETS_ADJUST) {
      res <- edgeR::scaleOffset(res,offsets)
    } else {
      res$offset <- offsets
    }
  }
  
  return(res)
}


pv.edgeRContrastResults <- function(pv, contrast, shrink=TRUE, lfc=0) {
  
  if(is.null(pv$edgeR)) {
    stop("Can not test contrast: model has not been run",call.=FALSE)
  }
  
  res <-  de <- coeffs <- NULL
  
  coeffs <- pv.getCoeffs(contrast,pv)
  
  if(is.null(coeffs)) {
    stop("edgeR: unsupported contrast.",call.=FALSE)
  }
  
  if(lfc == 0) {
    de <- edgeR::glmQLFTest(pv$edgeR$DEdata,contrast=coeffs)
  } else {
    de <- edgeR::glmTreat(pv$edgeR$DEdata, contrast=coeffs, lfc=lfc)
  }
  
  if(is.null(de)) {
    stop("edgeR: unsupported contrast.",call.=FALSE)
  }
  
  res$de <- edgeR::topTags(de,nrow(de))$table
  
  res$de$PValue[is.na(res$de$PValue)]=1
  res$de$FDR[is.na(res$de$FDR)]=1
  res$de <- res$de[order(res$de$FDR),]
  res$de <- cbind(as.numeric(rownames(res$de)),res$de$PValue,
                  res$de$FDR,res$de$logFC, res$de$logCPM)
  colnames(res$de) <- c("id","pval","padj","fold","logCPM")
  
  rownames(res$de) <- res$de[,1]
  res$de <- data.frame(res$de)
  res$coeffs <- coeffs
  
  return(res)
}

pv.getCoeffs <- function(contrast,pv) {
  
  coef1 <- coef2 <- coeffs <- NULL
  if(contrast$contrastType=="bycolumn") {
    coeffs <- contrast$contrast
  } else if(contrast$contrastType=="simple") {
    coef1 <- pv.getCoef(contrast$contrast, pv)
  } else if(contrast$contrastType=="byname") {
    coef1 <- pv.getCoef(contrast$contrast, pv)
  } else if(is(contrast$contrast,"list")) {
    coef1 <- pv.getCoef(contrast$contrast[[1]], pv)
    if(contrast$contrastType=="byresults2") {
      coef2 <- pv.getCoef(contrast$contrast[[2]], pv)
    }
  } 
  
  if(!is.null(coef1)) {
    if(!is.null(coef2)) {
      coeffs <- coef1 - coef2
    } else {
      coeffs <- coef1
    }
  } 
  
  return(coeffs)
}

pv.getCoef <- function(contrast, pv) {
  
  coefs <- pv$DESeq2$names
  
  if(is(contrast,"vector")) {
    vals <- c(contrast[1],contrast[2],"vs",contrast[3])
    contrast <- paste(contrast[1],contrast[2],"vs",
                      contrast[3],sep="_")
  } else {
    vals  <- strsplit(contrast,"_")[[1]]
  }
  
  res   <- rep(0,length(coefs))
  
  coef  <- pv.matchCoefs(contrast,coefs)
  
  if(is.na(coef)[1]) {
    contrast <- paste(vals[1],vals[4],vals[3],vals[2],sep="_")
    coef <- pv.matchCoefs(contrast,coefs)
    if(!is.na(coef)) {
      res[coef] <- -1
      return(res)
    }
  } else {
    res[coef] <- 1
    return(res)
  }
  
  coefs <- colnames(pv$edgeR$design)
  num <- paste(vals[1],vals[2],sep="")
  den <- paste(vals[1],vals[4],sep="")
  num <- match(num,coefs)
  den <- match(den,coefs)
  
  
  if(is.na(num) && is.na(den)) {
    return(NULL)
  }
  
  if(!is.na(num)) {
    res[num] <- 1
  }
  
  if(!is.na(den)) {
    res[den] <- -1
  }
  
  return(res)
}

pv.matchCoefs <- function(contrast,coefs) {
  
  coef <- match(contrast, coefs)
  if(!is.na(coef)) {
    return(coef)
  }
  
  coef <- match(make.names(contrast), coefs)
  
  return(coef)
  
}

pv.checkIntercept <- function(pv, facname, valname) {
  fac <- match(facname, names(pv$meta))
  if(pv$meta[[fac]][1] ==  valname) {
    return(TRUE)
  } else {
    return(FALSE)
  }
}

pv.normTMM <- function(pv,bMinus=TRUE,bFullLib=FALSE,bCPM=FALSE,bReturnFactors=FALSE){
  
  if(length(pv$peaks)<2) {
    warning('Unable to TMM normalize -- not enough peaksets',call.=FALSE)
    return(pv)	
  }
  
  vColors <- pv.colsv
  
  g1     <- rep(FALSE,length(pv$peaks))
  g1[1]  <- TRUE
  
  savenames <- pv$class[PV_ID,]
  pv$class[PV_ID,] <- 1:ncol(pv$class)
  res    <- pv.DEedgeR(pv,g1,!g1,"1","2",bSubControl=bMinus,bFullLibrarySize=bFullLib,bNormOnly=TRUE)
  #res    <- estimateCommonDisp(res)
  counts <- res$counts
  sizes  <- res$samples$lib.size * res$samples$norm.factors
  
  if(bReturnFactors) {
    return(list(libsize=res$samples$lib.size,normfactors=res$samples$norm.factors))
  }
  
  counts <- t(t(counts)/sizes)
  
  if(bCPM) {
    counts <- counts * 1E06     
  } else {
    counts <- counts * mean(res$samples$lib.size)
  }
  
  colnames(counts) <- savenames
  return(counts)
  
}
pv.stripEdgeR <- function(erec) {
  if(!is.null(erec)) {
    
    if(is(erec,"DGEList")) {
      erec$counts     <- NULL
      erec$pseudo.alt <- NULL
      erec$conc       <- NULL
      #erec$genes      <- NULL
      erec$all.zeros  <- NULL
      erec$tagwise.dispersion <- NULL
    }
    
    if(!is.null(erec$GLM)) {
      erec$GLM <- pv.stripEdgeRGLM(erec$GLM)
    }
    if(!is.null(erec$LRT)) {
      erec$LRT <- pv.stripEdgeRLRT(erec$LRT)
    }
    if(!is.null(erec$block)) {
      erec$block <- pv.stripEdgeR(erec$block)
    }
    if(!is.null(erec$db)) {
      erec$db <- pv.stripEdgeR(erec$db)
    }      
  }
  return(erec)
}

pv.stripEdgeRGLM <- function(grec) {
  if(!is.null(grec)) {
    grec$counts       <- NULL
    grec$fitted.values= NULL
    grec$offset       <- NULL
    grec$coefficients <- NULL
    grec$deviance     <- NULL
    grec$df.residual  <- NULL
    grec$abundance    <- NULL
    #grec$genes        <- NULL
  }
  return(grec)
}

pv.stripEdgeRLRT <- function(lrec) {
  if(!is.null(lrec)) {
    lrec <- pv.stripEdgeR(lrec)
    lrec <- pv.stripEdgeRGLM(lrec)
    lrec$GLM <- pv.stripEdgeRGLM(lrec$GLM)
    
    lrec$dispersion.used   <- NULL
  }
  return(lrec)
}      

PV_NORM_LIB            <- "lib"
PV_NORM_TMM            <- "TMM" 
PV_NORM_RLE            <- "RLE"
PV_NORM_DEFAULT        <- "default"
PV_NORM_NATIVE         <- "native"
PV_NORM_SPIKEIN        <- "spike-in"
PV_NORM_USER           <- "user"
PV_NORM_OFFSETS        <- "offsets"
PV_NORM_OFFSETS_ADJUST <- "adjust offsets"

PV_LIBSIZE_DEFAULT     <- "default"
PV_LIBSIZE_FULL        <- "full"
PV_LIBSIZE_PEAKREADS   <- "RiP"
PV_LIBSIZE_CHRREADS    <- "background"
PV_LIBSIZE_USER        <- "user"

PV_OFFSETS_LOESS       <- "loess"
PV_OFFSETS_USER        <- "user"

PV_BACKGROUND_BINSIZE  <- 15000
PV_NORM_LIBFUN         <- mean

pv.normalize <- function(pv, 
                         method    = DBA_ALL_METHODS,
                         libSizes  = PV_LIBSIZE_FULL,
                         normalize = PV_NORM_DEFAULT,
                         filter=0, filterFun=max, 
                         background=FALSE, offsets=FALSE, spikein=FALSE,
                         libFun=PV_NORM_LIBFUN,
                         bRetrieve=FALSE, ...) {
  
  if(bRetrieve==TRUE) {
    res <- pv.normalizeRetrieve(pv, method)
    return(res)
  }
  
  if(is.null(pv$score)) {
    pv$score <- DBA_SCORE_NORMALIZED
  }
  
  dospikein <- TRUE
  back.calc <- ""
  if(is(spikein,"logical")) {
    if(spikein[1] == FALSE) {
      dospikein <- FALSE
    }
  } else if (is(spikein,"GRanges")) {
    libSizes <- DBA_LIBSIZE_BACKGROUND
  } else if(is(spikein,"list")) {
    if(!is.null(spikein$back.calc)) {
      if(spikein$back.calc == "Spike-in bins" ||
         spikein$back.calc == "Spike-in chromosomes" ||
         spikein$back.calc == "Parallel factor") {
        background <- spikein
        spikein <- TRUE
      } else {
        stop("spikein: invalid background record.", call.=FALSE)
      }
    } else {
      stop("spikein: invalid background record.", call.=FALSE)
    }
  }
  if(dospikein) {
    libSizes <- DBA_LIBSIZE_BACKGROUND
  }
  
  dobackground <- TRUE
  if(is(background,"logical")) {
    if(background[1] == FALSE) {
      if(dospikein) {
        background <- TRUE
        libSizes <- DBA_LIBSIZE_BACKGROUND
      } else {
        dobackground <- FALSE
      }
    } else {
      libSizes <- DBA_LIBSIZE_BACKGROUND
    }
  } else if(is(background,"list")) {
    if(!is.null(background$binned)) {
      pv$norm$background <- background
      background <- TRUE
    } else {
      stop("Invalid background record.", call.=FALSE)
    }    
  }
  
  if(all(method == DBA_ALL_METHODS)) {
    
    if(dobackground) {
      pv$norm$background <- pv.getBackground(pv, background, spikein)
    }
    
    for(method in c(DBA_DESEQ2, DBA_EDGER)) {
      pv <- pv.normalize(pv, method=method,
                         libSizes=libSizes,normalize=normalize,
                         filter=filter, filterFun=filterFun, 
                         background=background, 
                         offsets=offsets, spikein=spikein,
                         libFun=libFun, bRetrieve=FALSE)
    }
    return(pv)
  } else if(method == DBA_DESEQ2) {
    pv$norm$DESeq2 <- NULL
  } else if(method == DBA_EDGER) {
    pv$norm$edgeR  <- NULL
  } else {
    stop('Invalid method.',call.=FALSE)
  }
  
  norm <- NULL
  if(is.null(pv$bSubControl)) {
    norm$bSubControl <- is.null(pv$greylist)
  } else {
    norm$bSubControl <- pv$bSubControl 
  }
  bSubControl <- norm$bSubControl
  
  if(is.null(pv$maxFilter)) {
    norm$filter.val <- PV_DEFAULT_FILTER
  } else {
    norm$filter.val <- pv$maxFilter
  }
  filter <- norm$filter.val
  
  if(filter > 0) {
    if(is.null(pv$filterFun)) {
      norm$filter.fun <- max
    } else {
      norm$filter.fun <- pv$filterFun
    }
    filterFun <- norm$filter.fun
  } 
  
  norm$lib.method <- libSizes
  norm$background <- FALSE
  
  doOffsets <- FALSE
  if(is(offsets,"logical")) {
    if(offsets) {
      doOffsets <- TRUE
    }
  } else if(is(offsets,"matrix")) {
    doOffsets <- TRUE
  } else if(is(offsets,"SummarizedExperiment")) {
    if("offsets" %in% names(assays(offsets))) {
      offsets <- assay(offsets,"offsets")
      doOffsets <- TRUE      
    } else {
      stop("No assay named offsets in passes SummarizedExperiment",call.=FALSE)
    }
  }  else {
    stop("offsets must be a logical, matrix, or SummarizedExperiment",call.=FALSE)
  }
  
  if(dobackground) {
    
    norm.background <- pv.getBackground(pv, background, spikein) 
    binned    <- norm.background$binned
    bin.size  <- norm.background$bin.size
    back.calc <- norm.background$back.calc
    
  } else {
    
    binned    <- pv$norm$background$binned
    bin.size  <- pv$norm$background$bin.size
    back.calc <- pv$norm.background$back.calc
    
  }
  if (length(normalize) == 1) {
    if(normalize == PV_NORM_DEFAULT) {
      if(method == DBA_EDGER) {
        normalize <- PV_NORM_TMM
      } else if (method == DBA_DESEQ2) {
        if(norm$lib.method != "Reads in peaks") {
          normalize <- PV_NORM_LIB        
        } else {
          normalize <- PV_NORM_RLE                  
        }
      }
    } else if (normalize == PV_NORM_NATIVE) {
      if(method == DBA_EDGER) {
        normalize <- PV_NORM_TMM
      } else if (method == DBA_DESEQ2) {
        normalize <- PV_NORM_RLE                  
      }
    }
    
    if(normalize == DBA_NORM_TMM ||
       normalize == DBA_NORM_RLE ||
       doOffsets == TRUE) {
      if(is(libSizes,"character")) {
        if(libSizes == DBA_LIBSIZE_FULL) {
          #message("library sizes will use RiP.")
          libSizes <- DBA_LIBSIZE_PEAKREADS
        }
      }
    }
    
    norm$lib.method <- libSizes
    norm$background <- FALSE
  }
  
  if(is.null(back.calc)) {
    back.calc <- ""
  }
  
  if(length(libSizes) == ncol(pv$class)) {
    norm$lib.calc  <- "User supplied"
    norm$lib.sizes <- libSizes
    norm$lib.method <- PV_LIBSIZE_USER
  } else if (length(libSizes) == 1) {
    if(libSizes==PV_LIBSIZE_FULL) {
      norm$lib.calc  <- "Full library"
      norm$lib.sizes <- as.numeric(pv$class[PV_READS,]) 
    } else if(libSizes==PV_LIBSIZE_PEAKREADS) {
      norm$lib.calc  <- "Reads in peaks"
      norm$lib.sizes <- pv.readsInPeaks(pv, bSubControl=bSubControl,
                                        filter=filter, filterFun=filterFun)
    }  else if(libSizes==PV_LIBSIZE_CHRREADS) {
      norm$lib.calc  <- "Reads in Background"
      if(back.calc == "Spike-in bins") {
        norm$lib.sizes <- binned$totals + as.numeric(pv$class[PV_READS,]) 
      } else if(back.calc == "Spike-in chromosomes") {
        norm$lib.sizes <- as.numeric(pv$class[PV_READS,]) 
      } else {
        norm$lib.sizes <- binned$totals
      }
    } else {
      stop('Invalid libSizes',call.=FALSE)      
    }
  } else {
    stop('libSizes invalid length',call.=FALSE)
  }
  
  
  if(doOffsets) {
    if(normalize != DBA_NORM_OFFSETS_ADJUST) {
      norm$norm.method <- DBA_NORM_OFFSETS
    } else {
      norm$norm.method <- DBA_NORM_OFFSETS_ADJUST
    }
    pv <- pv.normalizeOffsets(pv, offsets=offsets, norm,
                              method=method, bSubControl=bSubControl,
                              filter=filter, filterFun=filterFun,
                              libFun=libFun)  
    return(pv)
  }
  
  if(length(normalize) == ncol(pv$class)) {
    norm$norm.calc <- "User supplied"
    norm$norm.facs <- normalize
    norm$norm.method <- PV_NORM_USER
  } else if (length(normalize) == 1) {
    norm$norm.method <- normalize
    if(normalize == PV_NORM_LIB) {
      norm$norm.calc  <- "Library size"
      if(back.calc == "Spike-in bins" ||
         back.calc == "Spike-in chromosomes") {
        spikelibs <- binned$totals
      } else {
        spikelibs <- NULL
      }
      norm <- pv.normfacsLIB(pv, norm=norm, method=method,
                             libFun=libFun, background=background,
                             spikes=spikelibs)
    } else if(normalize == PV_NORM_TMM) {
      norm$norm.calc  <- "edgeR/TMM"
      norm <- pv.normfacsTMM(pv,norm=norm,method=method,
                             bSubControl=bSubControl,
                             filter=filter, filterFun=filterFun,
                             libFun=libFun, binned=binned,
                             background=background)
      
    } else if(normalize == PV_NORM_RLE) {
      norm$norm.calc  <- "DESeq2/RLE"
      norm <- pv.normfacsRLE(pv,norm=norm,method=method,
                             bSubControl=bSubControl,
                             filter=filter, filterFun=filterFun,
                             libFun=libFun, binned=binned,
                             background=background)
    } else {
      stop('Invalid normalization',call.=FALSE)      
    }
  } else {
    stop('normalize invalid length',call.=FALSE)
  }
  
  if(method==DBA_DESEQ2) {
    pv$norm$DESeq2 <- norm
    pv <- pv.removeResults(pv, DBA_DESEQ2)
    
  } else if(method==DBA_EDGER) {
    pv$norm$edgeR <- norm
    pv <- pv.removeResults(pv, DBA_EDGER)
  } 
  
  if(!is.null(binned)){
    pv$norm$background$binned    <- binned
    pv$norm$background$bin.size  <- bin.size
    pv$norm$background$back.calc <- back.calc
  }
  
  return(pv)
}

pv.readsInPeaks <- function(pv, bSubControl=bSubControl,
                            filter=filter, filterFun=filterFun) {
  
  counts <- pv.DEinitedgeR(pv,bSubControl=bSubControl,
                           bRawCounts=TRUE,
                           filter=filter,filterFun=filterFun)
  return(colSums(counts))
}

pv.normfacsTMM <- function(pv,norm,method,bSubControl=FALSE,
                           filter=0, filterFun=max,libFun=PV_NORM_LIBFUN,
                           binned=NULL, background=FALSE) {
  
  if(background[1] != FALSE) {
    if(!is.null(binned)) {# TMM on Background bins
      binned$totals <- norm$lib.sizes
      norm$norm.facs <- csaw::normFactors(binned, se.out=FALSE)
    }  else {
      stop("No binned counts for background TMM",call.=FALSE)
    }
    norm$background <- TRUE
  } else { # edgeR TMM
    
    edger <- pv.DEinitedgeR(pv,bSubControl=bSubControl,
                            bFullLibrarySize=norm$lib.sizes,
                            filter=filter,filterFun=filterFun)
    edger <- edgeR::calcNormFactors(edger,method="TMM", 
                                    lib.size=norm$lib.sizes, doWeighting=FALSE)
    norm$norm.facs <- edger$samples$norm.factors
    
  }
  
  if(method==DBA_DESEQ2) { # Convert from edgeR to DESeq2 factors
    norm$norm.facs <- pv.edgeRtoDESeq2norm(norm, libFun=libFun)
  }
  
  return(norm)
}

pv.normfacsRLE <- function(pv,norm,method,bSubControl=FALSE,
                           filter=0, filterFun=max,libFun=PV_NORM_LIBFUN,
                           binned=NULL, background=FALSE){
  
  if(background[1] != FALSE) {
    if(!is.null(binned)) {# RLE on Background bins
      binned$totals <- norm$lib.sizes
      if(method==DBA_DESEQ2) {
        mode(assay(binned)) <- "integer"
        norm$norm.facs <- 
          DESeq2::sizeFactors(
            DESeq2::estimateSizeFactors(
              DESeq2::DESeqDataSet(binned, design=formula("~ 1"))))
      }
      if(method==DBA_EDGER) {
        norm$norm.facs <-
          edgeR::calcNormFactors(
            edgeR::DGEList(assay(binned)), method="RLE")$samples$norm.factors
      } 
    } else {
      stop("No binned counts for background RLE",call.=FALSE)
    }
    norm$background <- TRUE
  } else if(method == DBA_DESEQ2 && norm$lib.calc == "Reads in peaks") {
    
    deseq <- pv.DEinitDESeq2(pv,bSubControl=bSubControl,
                             bFullLibrarySize=FALSE,
                             filter=filter,filterFun=filterFun)
    norm$norm.facs <- DESeq2::sizeFactors(deseq)
  } else {
    edger <- pv.DEinitedgeR(pv,bSubControl=bSubControl,
                            bFullLibrarySize=norm$lib.sizes,
                            filter=filter,filterFun=filterFun)
    edger <- edgeR::calcNormFactors(edger,method="RLE",
                                    lib.size=norm$lib.sizes, doWeighting=FALSE)
    norm$norm.facs <- edger$samples$norm.factors
    
    if(method==DBA_DESEQ2) {
      norm$norm.facs <- pv.edgeRtoDESeq2norm(norm, libFun=libFun)
    }
  }
  
  return(norm)
}

pv.normfacsLIB <- function(pv, norm=norm, method=method,
                           libFun=libFun, background=background,
                           spikes=""){
  
  norm$lib.fun <- libFun
  
  if(background[1] != FALSE) {
    norm$background <- TRUE
  } 
  
  if(method==DBA_DESEQ2) {
    if(is.null(spikes)) {
      norm$norm.facs  <- norm$lib.sizes/libFun(norm$lib.sizes)
    } else {
      norm$norm.facs <- spikes/libFun(spikes)
    }
  } else if(method==DBA_EDGER) {
    if(is.null(spikes)) {
      norm$norm.facs <- rep(1,length(norm$lib.sizes))
    } else {
      stop(paste("Library normalization invalid for edgeR when using spike-ins.",
                 "Try normalize=DBA_NORM_TMM."),call.=FALSE)
    }
    # norm$norm.facs  <- 1/(norm$lib.sizes/libFun(norm$lib.sizes))
    # norm$norm.facs <- pv.makeProd1(norm$norm.facs)
  }
  
  return(norm)
}

pv.makeProd1 <- function(f){
  return(f/exp(mean(log(f))))
}

pv.edgeRtoDESeq2norm <- function(norm, libFun) {
  efflib <- norm$norm.facs * norm$lib.sizes
  norm.facs <- efflib / libFun(norm$lib.sizes)
  return(norm.facs)
}

pv.getBackground <- function(pv,background=PV_BACKGROUND_BINSIZE, 
                             spikein=FALSE) {
  
  if(is(background,"logical")) {
    if(!is.null(pv$norm$background)) {
      background <- pv$norm$background$bin.size
    } else {
      background <- PV_BACKGROUND_BINSIZE
    }
  } 
  
  binned <- NULL
  
  if(!is.null(pv$norm$background)) {
    if(pv$norm$background$bin.size==background) {
      binned    <- pv$norm$background$binned
      back.calc <- pv$norm$background$back.calc
      
    }
  }
  
  if(is.null(binned)) {
    bamfiles <- pv$class[PV_BAMREADS,] 
    restrict <- pv$chrmap
    if(is(spikein,"logical")) {
      if(spikein == TRUE) {
        if(nrow(pv$class) >= PV_SPIKEIN) {
          if(sum(is.na(pv$class[PV_SPIKEIN,]) == 0)) {
            message("Generating counts for spike-ins...")
            bamfiles <- pv$class[PV_SPIKEIN,]
            restrict <- NULL
            back.calc <- "Spike-in bins"
          } else {
            stop("Spike-in reads not available for all samples.", call.=FALSE)
          }
        } else {
          stop("Spike-in reads not available for all samples.", call.=FALSE)
        }
      } else {
        message("Generating background bins...")
        back.calc <- "Background bins"
      }
    } else if(is(spikein,"GRanges")) {
      message("Generating counts for parallel factor...")
      res <- pv.parallelFactor(pv, spikein)
      return(list(binned=res,
                  bin.size=0,
                  back.calc="Parallel factor"))
    } else {
      restrict <- spikein
      back.calc <- "Spike-in chromosomes"
    }
    
    if (!requireNamespace("csaw",quietly=TRUE)) {
      stop("Package csaw not installed",call.=FALSE)
    }
    
    rParams <- pv.readParams(pv, restrict)
    if(pv$config$RunParallel) {
      if(!is.null(pv$config$parallelPackage)) {
        if(pv$config$parallelPackage == DBA_PARALLEL_MULTICORE) {
          if(is.null(pv$config$cores)) {
            cores <- BiocParallel::multicoreWorkers()
          } else {
            cores <- pv$config$cores
          }
          mcparam <- BiocParallel::MulticoreParam(workers=cores)
        }
      }
    } else {
      mcparam <- BiocParallel::SerialParam()
    }
    
    binned <- suppressWarnings(suppressMessages(
      csaw::windowCounts(bamfiles, bin=TRUE,
                         width=background, param=rParams,
                         BPPARAM=mcparam)))
  }
  
  return(list(binned=binned,bin.size=background,back.calc=back.calc))
}

pv.readParams <- function(pv, restrict) {
  
  pe <- "none"
  if(is.null(pv$config$singleEnd)) {
    bfile <- pv.BamFile(pv$class[PV_BAMREADS,1], bIndex=TRUE)
    pv$config$singleEnd <- !suppressMessages(
      Rsamtools::testPairedEndBam(bfile))
  }
  if(!pv$config$singleEnd) {
    pe <- "both"
  }
  
  minq <- 15
  if(!is.null(pv$config$minQCth)) {
    minq <- pv$config$minQCth
  }
  if(is.null(restrict)) {
    rp <- csaw::readParam(pe=pe,minq=minq)    
  } else {
    rp <- csaw::readParam(pe=pe,minq=minq,restrict=restrict)
  }
  
  return(rp)
}

pv.parallelFactor <- function(pv, spikein) {
  if(nrow(pv$class) >= PV_SPIKEIN) {
    if(sum(is.na(pv$class[PV_SPIKEIN,]) == 0)) {
      pv$class[PV_BAMREADS,]   <- pv$class[PV_SPIKEIN,]
      pv$class[PV_BAMCONTROL,] <- NA
      pv$class[PV_CONTROL,]    <- NA
      pv$chrmap <- sort(unique(as.character(seqnames(spikein))))
      pv <- dba.count(pv, peaks=spikein,summits=FALSE,filter=0,
                      bSubControl=FALSE, score=DBA_SCORE_READS)
      data <- pv$binding[,4:ncol(pv$binding)]
      peaks <-  pv$binding[,1:3]
      peaks[,1] <- pv$chrmap[peaks[,1]]
      peaks <- GRanges(data.frame(peaks))
      res <- SummarizedExperiment(list(counts=data),rowRanges=peaks)
      res$totals <- round(colSums(data))
    } else {
      stop("Spike-in reads not available for all samples.", call.=FALSE)
    }
  } else {
    stop("Spike-in reads not available for all samples.", call.=FALSE)
  }
  return(res)
}

pv.normalizeOffsets <- function(pv, offsets=offsets, norm,
                                method=method, bSubControl=bSubControl,
                                filter=filter, filterFun=filterFun, libFun,
                                ...) {
  
  if (!requireNamespace("csaw",quietly=TRUE)) {
    stop("Package csaw not installed",call.=FALSE)
  }
  
  counts <- pv.DEinitedgeR(pv,bSubControl=bSubControl,
                           bRawCounts=TRUE,
                           filter=filter,filterFun=filterFun)
  
  offset.meth <- PV_OFFSETS_LOESS
  
  if(is(offsets,"matrix")) {
    if(sum(dim(counts) != dim(offsets))) {
      stop("offsets matrix must have same dimensions as binding matrix (after filtering).",
           call.=FALSE)
    }
    offset.meth <- PV_OFFSETS_USER
    offsets <- SummarizedExperiment(list(offsets=offsets))
  } else if(!is.null(pv$norm$offsets)) {
    if (pv$norm$offsets$offset.method == PV_OFFSETS_LOESS) {
      offsets <- pv$norm$offsets$offset
    }
  }
  if(!is(offsets,"SummarizedExperiment")) {
    counts <- SummarizedExperiment(list(counts=counts))
    counts$totals <- norm$lib.sizes
    offsets <- csaw::normOffsets(counts, se.out=FALSE, ...)
    offsets <- SummarizedExperiment(list(offsets=offsets))
    counts$totals <- norm$lib.sizes
  }
  
  if(offset.meth == PV_OFFSETS_LOESS) {
    norm$norm.method <- PV_NORM_OFFSETS_ADJUST
  }
  
  norm$norm.calc   <- "Use offsets"
  norm$lib.fun     <- libFun
  
  pv <- pv.setNorm(pv, norm, method)
  
  pv$norm$offsets$offsets <- offsets
  pv$norm$offsets$offset.method <- offset.meth
  
  return(pv)
}

pv.offsetsAdjust <- function(pv, offsets, deobj) {
  libs <- pv$norm$DESeq2$lib.sizes 
  eobj <- edgeR::DGEList(assay(deobj), 
                         lib.size=rep(pv$norm$DESeq2$lib.fun(libs),
                                      ncol(offsets)))
  offsets <- edgeR::scaleOffset(eobj,offsets)$offset
  offsets <- offsets / exp(rowMeans(log(offsets)))
  nf   <- libs/pv$norm$DESeq2$lib.fun(libs)
  nfs  <- matrix(nf, nrow(offsets), ncol(offsets), byrow=TRUE)
  offsets <- offsets * nfs 
  return(offsets)
}

pv.getNorm <- function(pv,method) {
  if(method==DBA_EDGER) {
    return(pv$norm$edgeR)
  } else if (method==DBA_DESEQ2) {
    return(pv$norm$DESeq2)
  } else {
    stop("Internal error: Invalid method.")
  }
}

pv.setNorm <- function(pv,norm,method) {
  if(method==DBA_EDGER) {
    pv$norm$edgeR <- norm
    pv$edgeR$DEdata <- NULL
  } else if (method==DBA_DESEQ2) {
    pv$norm$DESeq2 <- norm
    pv$DESeq2$DEdata <- NULL
  } else {
    stop("Internal error: Invalid method.")
  }
  return(pv)
}

pv.reNormalize <- function(pv) {
  
  if(is.null(pv$norm)) {
    return(pv)
  }
  
  if(!is.null(pv$norm$offsets)){
    if(pv$norm$offsets$offset.method == PV_OFFSETS_USER) {
      warning("Re-run dba.normalize() to add user-supplied offsets.",
              call.=FALSE)
      pv$norm$offsets$offsets <- NULL
    } 
  }
  
  if(!is.null(pv$norm$DESeq2) || !is.null(pv$norm$edgeR)) {
    message("Re-normalizing...")
    pv$norm$DESeq2 <- pv.doRenormalize(pv,DBA_DESEQ2)$norm$DESeq2
    pv$norm$edgeR  <- pv.doRenormalize(pv,DBA_EDGER)$norm$edgeR
    
    if(pv$score == DBA_SCORE_NORMALIZED) {
      pv <- pv.doResetScore(pv)
    }
  }
  
  return(pv)
}

pv.doResetScore <- function(pv) {
  
  pv$score <- NULL
  pv <- pv.setScore(pv,score=DBA_SCORE_NORMALIZED,bLog=FALSE)
  
  return(pv)
}

pv.doRenormalize <- function(pv, method) {
  
  if(method == DBA_EDGER) {
    norm <- pv$norm$edgeR
  }
  
  if(method == DBA_DESEQ2) {
    norm <- pv$norm$DESeq2
  }
  
  if(is.null(norm)) {
    return(NULL)
  }
  
  if(norm$lib.method==PV_LIBSIZE_USER) {
    libsizes <- norm$lib.sizes
  } else {
    libsizes <- norm$lib.method
  }
  
  if(norm$norm.method==PV_LIBSIZE_USER) {
    normfacs <- norm$norm.facs
  } else {
    normfacs <- norm$norm.method
  }
  
  # if(is.null(norm$filter.fun)) {
  #   filterfun <- max
  # } else {
  #   filterfun <- norm$filter.fun
  # }
  
  if(is.null(norm$lib.fun)) {
    libfun <- PV_NORM_LIBFUN
  } else {
    libfun <- norm$lib.fun
  }
  
  offsets <- FALSE
  if(norm$norm.method == PV_NORM_OFFSETS) {
    if(is.null(pv$norm$offsets)) {
      offsets <- TRUE
    } else if(pv$norm$offsets$offset.method == PV_OFFSETS_USER) {
      pv <- pv.setNorm(pv, NULL, method)
      return(pv)
    } else {
      offsets <- TRUE
    }
  }
  
  pv <- pv.normalize(pv,
                     method    = method,
                     libSizes  = libsizes,
                     normalize = normfacs,
                     bSubControl = norm$bSubControl,
                     libFun=libfun, 
                     background=norm$background, offsets=offsets)
  return(pv)
}

pv.edgeRCounts <- function(pv,method,bNormalized=TRUE) {
  
  if(is.null(pv$edgeR$DEdata)) {
    stop('No edgeR data object -- re-run dba.analyze with method=DBA_EDGER',
         call.=FALSE)
  } 
  
  counts <- pv$edgeR$DEdata$counts
  
  if(bNormalized) {
    
    counts <- pv$edgeR$DEdata$fitted.values
    
    # if(pv$norm$edgeR$norm.method == PV_NORM_OFFSETS ||
    #    pv$norm$edgeR$norm.method == PV_NORM_OFFSETS_ADJUST) {
    #   counts <- edgeR::cpm(counts, normalized.lib.sizes=TRUE, 
    #                        lib.size=pv$edgeR$DEdata$samples$lib.size,
    #                        offset=pv$edgeR$DEdata$offset)
    # } else  {
    #   counts <- edgeR::cpm(counts, normalized.lib.sizes=TRUE, 
    #                        lib.size=pv$edgeR$DEdata$samples$lib.size)
    # } 
  }
  
  return(counts)
}

pv.normalizeRetrieve <- function(pv, method) {
  res <- NULL
  
  if(is.null(pv$norm)) {
    return(NULL)
  }
  
  if(all(method==DBA_DESEQ2)) {
    res <- pv.formatNorm(pv$norm$DESeq2)
  }
  if(all(method==DBA_EDGER)) {
    res <- pv.formatNorm(pv$norm$edgeR)
  }
  if(all(method==DBA_ALL_METHODS)) {
    res$edgeR      <- pv.formatNorm(pv$norm$edgeR)
    res$DESeq2     <- pv.formatNorm(pv$norm$DESeq2)
    res$background <- pv$norm$background
    res$offsets    <- pv$norm$offsets
  }    
  
  return(res)
}

pv.formatNorm <- function(norm) {
  
  res <- NULL
  
  if(!is.null(norm)) {
    
    if(norm$background) {
      res$background <- norm$background
    }
    
    res$norm.method    <- norm$norm.method
    res$norm.factors   <- norm$norm.facs
    res$lib.method     <- norm$lib.method
    res$lib.sizes      <- norm$lib.sizes
    
    if(norm$bSubControl) {
      res$control.subtract <- norm$bSubControl
    }
    
    if(norm$filter.val > 0) {
      res$filter.value <- norm$filter.val
    }
    
  }
  
  return(res)
}

pv.removeResults <- function(pv, method) {
  
  if(DBA_DESEQ2 %in% method) {
    pv$DESeq2$DEdata <- NULL
  }
  
  if(DBA_EDGER %in% method) {
    pv$edgeR$DEdata <- NULL
  }
  
  if(!is.null(pv$contrasts)) {
    for(con in 1:length(pv$contrasts)) {
      if(DBA_DESEQ2 %in% method) {
        pv$contrasts[[con]]$DESeq2 <- NULL
      }
      if(DBA_EDGER %in% method) {
        pv$contrasts[[con]]$edgeR <- NULL
      }
    }
  }
  
  return(pv)
  
}

pv.DESeq2 <- function(pv,group1,group2,label1="Group 1",label2="Group 2",
                      bSubControl=TRUE,bFullLibrarySize=FALSE,bTagwise=TRUE,
                      bGLM=TRUE,blockList=NULL,filter=0, filterFun=max){
  
  if (!requireNamespace("DESeq2",quietly=TRUE)) {
    stop("Package DESeq2 not installed",call.=FALSE)
  }
  res <- NULL
  
  targets <- NULL
  if(!is.null(blockList)) {
    targets <- pv.blockFactors(pv,group1,group2,label1,label2,blockList)
    if(is.null(targets)){
      return(res)	
    }
  } 
  res$DEdata <- pv.DEinit(pv,group1,group2,label1,label2,method='DESeq2',
                          bSubControl=bSubControl,
                          bFullLibrarySize=bFullLibrarySize,targets=targets,
                          filter=filter, filterFun=filterFun)
  res$counts <- DESeq2::counts(res$DEdata)
  
  if (!is.null(blockList)) {
    message('DESeq2 multi-factor analysis')
    attr <-  blockList[[1]]$attribute
    if(attr=='Replicate') {
      DESeq2::design(res$DEdata) <- formula(~Replicate + group)
    } else if(attr=='Tissue') {
      DESeq2::design(res$DEdata) <- formula(~Tissue + group)    
    } else if(attr=='Factor') {
      DESeq2::design(res$DEdata) <- formula(~Factor + group)
    } else if(attr=='Condition') {
      DESeq2::design(res$DEdata) <- formula(~Condition + group)
    } else if(attr=='Caller') {
      DESeq2::design(res$DEdata) <- formula(~Caller + group)
    } else if(attr=='Treatment') {
      DESeq2::design(res$DEdata) <- formula(~Treatment + group)
    } else if(attr=='Block') {
      DESeq2::design(res$DEdata) <- formula(~Block + group)
    } else {
      warning('Unsupported blocking attribute: ',attr,call.=FALSE)
      return(NULL)  
    }
    fdebug(sprintf('pv.DESeq blocking analysis: %d db (%s/%s)',
                   sum(res$de$padj<0.05),label1,label2))
  } 
  
  # if(!is.null(pv$norm$DESeq2)) {
  #   message("DESeq2: Using size factors from dba.normalize()")
  #   DESeq2::sizeFactors(res$DEdata) <- pv$norm$DESeq2$norm.facs
  # } else {
  #   message("DESeq2: NO size factors from dba.normalize()")
  if(!bFullLibrarySize) {
    res$DEdata <- DESeq2::estimateSizeFactors(res$DEdata)
  }
  # }
  
  res$facs   <- DESeq2::sizeFactors(res$DEdata)
  res$DEdata <- DESeq2::estimateDispersions(res$DEdata,fitType='local')
  res$DEdata <- DESeq2::nbinomWaldTest(res$DEdata)
  res$de     <- DESeq2::results(res$DEdata)
  
  res$de$pvalue[is.na(res$de$pvalue)]=1
  res$de$padj[is.na(res$de$padj)]=1
  
  res$de <- res$de[order(res$de$padj),]
  res$de <- cbind(as.numeric(rownames(res$de)),res$de$pvalue,res$de$padj)
  colnames(res$de) <- c("id","pval","padj")
  rownames(res$de) <- res$de[,1]
  res$de <- data.frame(res$de)
  
  res$bSubControl      <- bSubControl
  res$bFullLibrarySize <- bFullLibrarySize
  
  return(res)
  
}

pv.DESeq2design <- function(pv,
                            bSubControl=TRUE,bFullLibrarySize=TRUE,
                            existing=NULL,
                            filter=0, filterFun=max){
  
  if (!requireNamespace("DESeq2",quietly=TRUE)) {
    stop("Package DESeq2 not installed",call.=FALSE)
  }
  res <- NULL
  res$design <- pv$design
  
  res$DEdata <- pv.DEinitDESeq2(pv,
                                bSubControl=bSubControl,
                                bFullLibrarySize=bFullLibrarySize,
                                filter=filter, filterFun=filterFun)
  
  res$facs   <- DESeq2::sizeFactors(res$DEdata)
  
  #Can we avoid re fitting model?
  if(!is.null(existing$DEdata)) {
    if(!identical(existing$facs, res$facs)) {
      existing <- NULL
    } else if(bSubControl != existing$bSubControl) {
      existing <- NULL
    } else if(!is.null(pv$config$DESeq2$fitType)) {
      if(pv$config$DESeq2$fitType != existing$fitType) {
        existing <- NULL
      }
    }
  }
  
  if(is.null(existing$DEdata)) {
    if(!is.null(pv$config$DESeq2$fitType)) {
      fittype <- pv$config$DESeq2$fitType
    } else {
      fittype <- 'local'
    }
    res$DEdata <- DESeq2::estimateDispersions(res$DEdata,fitType=fittype)
    res$DEdata <- DESeq2::nbinomWaldTest(res$DEdata)
    res$bSubControl      <- bSubControl
    res$bFullLibrarySize <- bFullLibrarySize
    res$fitType          <- fittype
  } else {
    res <- existing
  }
  
  res$names <- DESeq2::resultsNames(res$DEdata)
  
  return(res)
}

pv.DEinitDESeq2 <- function(pv,
                            bSubControl=FALSE,bFullLibrarySize=FALSE,
                            bRawCounts=FALSE,
                            filter=0,filterFun=max,
                            numReads) {
  
  if (requireNamespace("DESeq2",quietly=TRUE)) {
    DESeq2 <- TRUE 
  } else {
    stop("Package DESeq2 not installed",call.=FALSE)
  }    
  
  srcmask <- pv.mask(pv,PV_CALLER,"source") | pv.mask(pv,PV_CALLER,"counts")
  if(sum(srcmask)==0) {
    stop('No samples present with read counts',call.=FALSE)
  }
  counts  <- pv.get_reads(pv, srcmask,bSubControl=bSubControl,numReads=numReads)
  
  if(is.null(filter)) {
    filter <- 0
  }
  if(filter > 0){
    scores <- apply(counts,1,filterFun)
    keep   <- scores > filter
    counts <- counts[keep,]
    rownames(counts) <- which(keep)
  } else {
    rownames(counts) <- as.character(1:nrow(counts))
  }
  
  colnames(counts) <- pv$class[PV_ID,]
  
  if(bRawCounts) {
    return(counts)	
  }
  
  if(is(bFullLibrarySize,"logical")) {
    if(bFullLibrarySize) {
      libsize <- as.numeric(pv$class[PV_READS,])
    } else {
      libsize <- colSums(counts)
    }
  } else {
    libsize <- bFullLibrarySize
    bFullLibrarySize <- TRUE
  }
  
  meta <- pv.getMeta(pv)
  if(!pv.isDesign(pv$design)) {
    designstr <- "~ 1"
  } else {
    designstr <- pv$design
  }
  res <- suppressMessages(
    DESeq2::DESeqDataSetFromMatrix(counts,meta,formula(designstr))
  )
  
  if(!is.null(pv$norm$DESeq2)) {
    # message("DESeq2: Using size factors from dba.normalize()")
    if(!is.null(pv$norm$DESeq2$norm.facs)) {
      DESeq2::sizeFactors(res) <- pv$norm$DESeq2$norm.facs
    }
    if(pv$norm$DESeq2$norm.method == PV_NORM_OFFSETS ||
       pv$norm$DESeq2$norm.method == PV_NORM_OFFSETS_ADJUST) {
      if(!is.null(pv$norm$offsets$offsets)) {
        # message("DESeq2: use offsets")
        offsets <- assay(pv$norm$offsets$offsets, "offsets")
        if(pv$norm$offsets$offset.method == PV_OFFSETS_LOESS ||
           pv$norm$DESeq2$norm.method == PV_NORM_OFFSETS_ADJUST) {
          offsets <- pv.offsetsAdjust(pv, offsets, res)
        }
        offsets <- offsets[1:nrow(res),]
        DESeq2::normalizationFactors(res) <- offsets
      } else {
        stop('Internal error: no offsets available.',call.=FALSE)
      }
    }
  } else {
    # message("DESeq2: NO size factors from dba.normalize()")
    if(!bFullLibrarySize) {
      res <- DESeq2::estimateSizeFactors(res)
    } else {
      DESeq2::sizeFactors(res) <- libsize/min(libsize)
    }
  }
  
  return(res)
}

pv.allDESeq2 <- function(pv,block,bSubControl=FALSE,bFullLibrarySize=FALSE,
                         bTagwise=TRUE,bGLM=FALSE,bParallel=FALSE,
                         filter=0,filterFun=max) {
  
  if (!requireNamespace("DESeq2",quietly=TRUE)) {
    stop("Package DESeq2 not installed",call.=FALSE)
  }
  
  if(is.null(pv$contrasts)) {
    if(missing(block)) {
      pv <- pv.contrast(pv)
    } else {
      pv <- pv.contrast(pv,block=block)
    }
  }
  
  if(bParallel) {
    pv <- dba.parallel(pv)
    jobs <- NULL
    blocks <- NULL
  }
  
  fdebug('pv.allDESeq2: for each contrast')
  reslist <- NULL
  
  if(bParallel && (pv$config$parallelPackage > 0)) {   
    params <- dba.parallel.params(pv$config,c('pv.DESeq2_parallel','pv.DESeq2'))
    
    reslist  <- dba.parallel.lapply(pv$config,params,1:length(pv$contrasts),
                                    pv.DESeq2_parallel,pv,NULL, 
                                    bSubControl,bFullLibrarySize,
                                    bTagwise=bTagwise,bGLM=bGLM,
                                    filter=filter,filterFun=filterFun)
    blist <- NULL
    for(i in 1:length(pv$contrasts)) {
      if(!is.null(pv$contrasts[[i]]$blocklist)) {
        blist <- c(blist,i)
      }
    }
    if(length(blist > 0)) {
      bres <-  dba.parallel.lapply(pv$config,params,blist,
                                   pv.DESeq2_parallel,pv,TRUE, 
                                   bSubControl,bFullLibrarySize,
                                   bTagwise=bTagwise,bGLM=bGLM,
                                   filter=filter,filterFun=filterFun)
      for(i in 1:length(blist)) {
        fdebug(sprintf('pv.allDESeq2: contrast %d gets bres %d (%d db)',
                       blist[i],i,sum(bres[[i]]$de$padj<0.05)))
        reslist[[blist[i]]]$block <- bres[[i]]
      }    
    }     
  } else { # SERIAL
    for(i in 1:length(pv$contrast)) { 	
      if(!is.null(pv$contrasts[[i]]$contrast)){
        res <- pv.DESeq2ContrastResults(pv,pv$contrasts[[i]])
      } else {
        res <- pv.DESeq2(pv,pv$contrasts[[i]]$group1,pv$contrasts[[i]]$group2,
                         pv$contrasts[[i]]$name1,pv$contrasts[[i]]$name2,
                         bSubControl=bSubControl,
                         bFullLibrarySize=bFullLibrarySize,bTagwise=bTagwise,
                         bGLM=bGLM, filter=filter,filterFun=filterFun)
        
        if(!is.null(pv$contrasts[[i]]$blocklist)) {
          res$block <- pv.DESeq2(pv,pv$contrasts[[i]]$group1,pv$contrasts[[i]]$group2,
                                 pv$contrasts[[i]]$name1,pv$contrasts[[i]]$name2,
                                 bSubControl=bSubControl,
                                 bFullLibrarySize=bFullLibrarySize,bTagwise=bTagwise,
                                 blockList=pv$contrasts[[i]]$blocklist,
                                 filter=filter,filterFun=filterFun)   
        }
      }
      reslist <- pv.listadd(reslist,res)   
    }
  }  
  
  return(reslist)
}

pv.DESeq2_parallel <- function(contrast,pv,blockList,bSubControl,
                               bFullLibrarySize,bTagwise=TRUE,bGLM=FALSE,
                               filter=0,filterFun=max) {
  crec <- pv$contrasts[[contrast]]
  if(!is.null(blockList)) {
    blockList <- crec$blocklist
  }
  if(!is.null(crec$contrast)){
    res <- pv.DESeq2ContrastResults(pv,crec)
  } else {
    res <- pv.DESeq2(pv,crec$group1,crec$group2,crec$name1,crec$name2,
                     bSubControl=bSubControl,bFullLibrarySize=bFullLibrarySize,
                     bTagwise=bTagwise,bGLM=bGLM,blockList=blockList,
                     filter=filter,filterFun=filterFun)
    pv.gc()
  }
  return(res)
}

pv.DESeq2ContrastResults <- function(pv, contrast, shrink=TRUE, lfc=0) {
  
  if(is.null(pv$DESeq2)) {
    stop("Can not test contrast: model has not been run",call.=FALSE)
  }
  
  res <- NULL
  if(contrast$contrastType!="byname") {
    res$de     <- DESeq2::results(pv$DESeq2$DEdata, contrast=contrast$contrast,
                                  lfcThreshold=lfc)
  } else {
    res$de     <- DESeq2::results(pv$DESeq2$DEdata, name=contrast$contrast,
                                  lfcThreshold=lfc)
  }
  
  if(shrink) {
    if(contrast$contrastType=="byname") {
      res$de <- suppressMessages(DESeq2::lfcShrink(pv$DESeq2$DEdata,
                                                   coef=contrast$contrast,
                                                   lfcThreshold=lfc,
                                                   res=res$de,type="apeglm"))
    } else  if(contrast$contrastType=="results1") {
      res$de <- suppressMessages(DESeq2::lfcShrink(pv$DESeq2$DEdata,
                                                   coef=contrast$contrast[[1]],
                                                   lfcThreshold=lfc,
                                                   res=res$de,type="apeglm"))
    } else {
      res$de <- suppressMessages(DESeq2::lfcShrink(pv$DESeq2$DEdata,
                                                   contrast=contrast$contrast,
                                                   lfcThreshold=lfc,
                                                   res=res$de,type="ashr"))
    }
  }
  
  res$de$pvalue[is.na(res$de$pvalue)]=1
  res$de$padj[is.na(res$de$padj)]=1
  res$de <- res$de[order(res$de$padj),]
  res$de <- cbind(as.numeric(rownames(res$de)),
                  res$de$pvalue,res$de$padj,
                  res$de$log2FoldChange)
  colnames(res$de) <- c("id","pval","padj","fold")
  
  rownames(res$de) <- res$de[,1]
  res$de <- data.frame(res$de)
  
  return(res)
  
}

pv.stripDESeq2 <- function(drec) {
  if(!is.null(drec)) {
    drec$counts     <- NULL
    drec$DEdata     <- NULL
    drec$fullFit    <- NULL
    drec$reducedFit <- NULL
    
    if(!is.null(drec$block)) {
      drec$block <- pv.stripDESeq2(drec$block)	
    }	
  }
  return(drec)
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

mergePeaks <- function(data, maxGap) {
    .Call('_DiffBind_mergePeaks', PACKAGE = 'DiffBind', data, maxGap)
}

mergeScores <- function(sMerged, sScore, sPeaks, abs = NULL) {
    .Call('_DiffBind_mergeScores', PACKAGE = 'DiffBind', sMerged, sScore, sPeaks, abs)
}

peakOrder <- function(schrom, sleft, sright) {
    .Call('_DiffBind_peakOrder', PACKAGE = 'DiffBind', schrom, sleft, sright)
}

context("Interval Sorting")

is_sorted <- function(peaks) {
  for (i in 1:(nrow(peaks)-1)) {
    if (peaks[i,1] > peaks[i+1,1] ||
        (peaks[i,1] == peaks[i+1,1] &&
         (peaks[i,2] > peaks[i+1,2] ||
          (peaks[i,2] == peaks[i+1,2] && peaks[i,3] > peaks[i+1,3])))) {
      return(FALSE)
    }
  }
  return(TRUE)
}
                
test_that("basic sanity of sorting",{
  x <- data.frame(c(4,3,2,1),c(5,3,2,7),c(7,5,2,7))
  y <- peakOrder(x[,1],x[,2],x[,3])
  z <- c(4,3,2,1)
  expect_equal(y,z)
})

test_that("sort large set of peaks",{
  chromNames = seq(1,95)
  n <- 1000
  chroms <- sample(chromNames,n,replace=TRUE)
  starts <- sample.int(200000,n,replace=TRUE)
  widths <- sample.int(1000,n,replace=TRUE)
  peaks <- data.frame(chroms,
                      starts,
                      starts + widths)
  names(peaks) <- c('chrom','left','right')
  ord <- peakOrder(peaks[,1],peaks[,2],peaks[,3])
  sorted <- peaks[ord,]
  expect_true(is_sorted(sorted))
})

test_that("sort equal chromosomes",{
  x = data.frame(c(6,6,6,6,6),c(6,3,9,1,3),c(3,8,3,9,9))
  y = peakOrder(x[,1],x[,2],x[,3])
  z = c(4,2,5,1,3)
  expect_equal(y,z)
})

test_that("sort equal left endpoints",{
  x = data.frame(c(6,6,6,6,6),c(9,9,9,9,9),c(3,8,1,7,9))
  y = peakOrder(x[,1],x[,2],x[,3])
  z = c(3,1,4,2,5)
  expect_equal(y,z)
})

#test_that("sort non-numeric chromosomes",{
#  x = data.frame(c("chr1","chr2","chr1","chr2","chr3"),c(9,9,9,9,9),c(3,8,1,7,9))
#  y = peakOrder(x[,1],x[,2],x[,3])
#  z = c(3,1,4,2,5)
#  expect_equal(y,z)
#})

test_that("test incomplete data",{
  x = data.frame(c(6,6,6,6,6),c(9,9,9,9,9))
  expect_error(peakOrder(x[,1],x[,2],x[,3]),"undefined columns selected")
})

test_that("test no data",{
  x = data.frame()
  expect_error(peakOrder(x[,1],x[,2],x[,3]),"undefined columns selected")
})

test_that("test no data",{
  x = NA
  expect_error(peakOrder(x[,1],x[,2],x[,3]),"incorrect number of dimensions")
})

test_that("test no data",{
  x = NA
  expect_error(peakOrder(x[,1],x[,2],x[,3]),"incorrect number of dimensions")
})

#####################################
## pv_core.R -- Peak Vectorization ##
## 20 October 2009                 ##
## 3 February 2011 -- packaged     ##
## Rory Stark                      ##
## Cancer Research UK              ##
#####################################

############################
## Top Level Entry Points ##
############################

## pv.list          -- list peaksets w/ attributes in model
## pv.consensus     -- add a consensus peakset based on peaksets already in model

## pv.mask          -- create a mask to define a subset of peaksets in a model
## pv.whichSites    -- create a mask of sites belonging to specific peakset(s)

## pv.plotClust     -- hierarchical cluster plot
## pv.sort          -- sort binding sites (e.g. for heatmap)

## pv.overlap       -- generate overlapping/unique peaksets

## pv.occupancy     -- generate occupancy statistics for peaksets in a model
## pv.plotScatter   -- scatter plots of contrasts


################
## Constants  ##
################
PV_GROUP      <- 0
PV_ID         <- 1
PV_TISSUE     <- 2
PV_FACTOR     <- 3
PV_CONDITION  <- 4
PV_CONSENSUS  <- 5
PV_CALLER     <- 6
PV_CONTROL    <- 7
PV_READS      <- 8
PV_REPLICATE  <- 9
PV_BAMREADS   <- 10
PV_BAMCONTROL <- 11
PV_TREATMENT  <- 12
PV_INTERVALS  <- 13
PV_SN_RATIO   <- 14
PV_SPIKEIN    <- 13

PV_DEBUG <- FALSE

###########################################



## pv.list -- list attributes of samples in model
pv.deflist <- c(
  PV_ID,PV_TISSUE,PV_FACTOR,PV_CONDITION,PV_TREATMENT,
  PV_REPLICATE,PV_CALLER,PV_INTERVALS,PV_READS,PV_SN_RATIO
)

pv.list <- function(pv,mask,bContrasts = FALSE, bDesign=FALSE,
                    attributes = pv.deflist, th = 0.05) {
  
  if (!missing(mask)) {
    if (!is.logical(mask)) {
      tmp  <- rep (FALSE,length(pv$peaks))
      tmp[mask] <- TRUE
      mask <- tmp
    }
  }
  
  if (bContrasts) {
    return(pv.listContrasts(pv,th = th))
  }
  
  if (bDesign) {
    if(is.null(pv$design)) {
      warning("No design present.",call.=FALSE)
      return(NULL)
    } else {
      return(pv$design)
    }
  }
  
  if (missing(attributes)) {
    attributes <- pv.deflist
  }
  
  if (missing(mask)) {
    mask <- rep(TRUE,ncol(pv$class))
  }
  
  if (!is.logical(mask)) {
    newm <- rep(FALSE,length(pv$peaks))
    for (ps in mask) {
      newm[ps] <- TRUE
    }
    mask <- newm
  }
  
  if (PV_INTERVALS %in% attributes) {
    attributes <- attributes[-which(attributes %in% PV_INTERVALS)]
    bIntervals <- TRUE
  } else
    bIntervals <- FALSE
  
  if (PV_SN_RATIO %in% attributes) {
    attributes <- attributes[-which(attributes %in% PV_SN_RATIO)]
    bSN <- TRUE
  } else
    bSN <- FALSE
  
  
  res <- matrix(pv$class[attributes,mask], sum(mask), length(attributes),
                byrow=TRUE)
  colnames(res) <- sapply(attributes,pv.attname,pv)
  rownames(res) <- which(mask)
  
  if (bIntervals) {
    intervals <- NULL
    for (i in 1:length(mask)) {
      if (mask[i]) {
        intervals <- c(intervals,nrow(pv$peaks[[i]]))
      }
    }
    res <- cbind(res,intervals)
    colnames(res)[ncol(res)] <- 'Intervals'
  }
  
  if(PV_READS %in% attributes) {
    movecol <- which(attributes %in% PV_READS)
    cols <- colnames(res)
    res <- cbind(res,res[,movecol])
    res <- res[,-movecol]
    if(is.null(dim(res))) {
      cols <- cols[-movecol]
      cols <- c(cols, "Reads")
      res <- matrix(res,1,length(res))
      colnames(res) <- cols
    }
    colnames(res)[ncol(res)] <- "Reads"
  }
  
  if (bSN) {
    if (!is.null(pv$SN)) {
      res <- cbind(res,pv$SN[mask])
      colnames(res)[ncol(res)] <- 'FRiP'
    }
  }
  
  j <- ncol(res)
  if (nrow(res) > 1) {
    for (i in j:1) {
      x <- unique(res[,i])
      if (colnames(res)[i] == 'Peak caller') {
        if (all.equal(attributes,pv.deflist) == TRUE) {
          if (length(x) == 1) {
            res <- res[,-i]
          }
        }
      } else if (length(x) == 1) {
        if (is.na(x)) {
          res <- res[,-i]
        } else if (x[1] == "") {
          res <- res[,-i]
        }
      }
    }
  }
  
  res <- data.frame(res)
  
  if("Reads" %in% names(res)) {
    res$Reads <- as.numeric(res$Reads)
  }
  
  if("FRiP" %in% names(res)) {
    res$FRiP <- as.numeric(res$FRiP)
  }
  
  if("Intervals" %in% names(res)) {
    res$Intervals <- as.numeric(res$Intervals)
  }
  
  return(res)
}

## pv.consensus -- add a consensus peakset based on peaksets already in model
pv.consensus <- function(pv,sampvec,minOverlap = 2,
                         bFast = FALSE,sampID) {
  if (missing(sampvec)) {
    sampvec <- 1:length(pv$peaks)
  }
  if (is.null(sampvec)) {
    sampvec <- 1:length(pv$peaks)
  }
  if (is(sampvec,"logical")) {
    sampvec <- which(sampvec)
  }
  
  tmp <- NULL
  if (bFast & (max(sampvec) <= ncol(pv$class)))  {
    if ((length(sampvec) < length(pv$peaks)) ||
        (pv$totalMerged != do.nrow(pv$binding))) {
      pv <- pv.vectors(pv,sampvec,minOverlap = 1)
      sampvec <- 1:length(pv$peaks)
    } else {
      pv <- pv.check(pv)
    }
    sites <- pv.whichSites(pv,sampvec,bUseAllvecs = FALSE)
    tmp$binding <- pv$binding[sites,c(1:3,(sampvec + 3))]
  } else {
    peaklist  <- NULL
    classlist <- NULL
    chrs <- NULL
    for (samp in sampvec) {
      peaklist  <- pv.listadd(peaklist,pv$peaks[[samp]])
      chrs <- sort(unique(c(chrs,unique(pv$peaks[[samp]][,1]))))
    }
    tmp$peaks  <- peaklist
    tmp$class  <- pv$class[, sampvec]
    tmp$chrmap <- chrs
    tmp <- pv.vectors(tmp,minOverlap = minOverlap)
  }
  
  if (do.nrow(tmp$binding) == 0) {
    message(">> zero peaks in consensus, skipping.")
    return(pv)
  }
  
  if (minOverlap > 0 && minOverlap < 1) {
    minOverlap <- ceiling(length(tmp$peaks) * minOverlap)
  }
  
  if(do.nrow(tmp$binding) == 1) {
    pscores <- matrix(tmp$binding[,4:ncol(tmp$binding)],1)
  } else {
    pscores <- tmp$binding[,4:ncol(tmp$binding)]
  }
  
  goodvecs <-
    apply(pscores,1,pv.minOverlap,minOverlap)
  
  tmp$binding  <- matrix(tmp$binding[goodvecs,],sum(goodvecs))
  pscores      <- matrix(pscores[goodvecs,],sum(goodvecs))
  
  mean.density <- apply(pscores,1,pv.domean)
  if(do.nrow(tmp$binding) == 1) {
    tmp$binding <- matrix(c(tmp$binding[1,1:3],mean.density),1)
  } else {
    tmp$binding  <- cbind(tmp$binding[,1:3],mean.density)
  }
  
  #kludge to get peakset in correct format
  tmpf <- tempfile(as.character(Sys.getpid())) #tmpdir='.')
  pv.do_peaks2bed(tmp$binding, tmp$chrmap,tmpf)
  tmp$binding <- pv.readbed(tmpf)
  unlink(tmpf)
  
  if (length(unique(pv$class[PV_REPLICATE, sampvec])) == 1) {
    replicate <- unique(pv$class[PV_REPLICATE, sampvec])
  } else {
    replicate <- pv.catstr(pv$class[PV_REPLICATE, sampvec])
  }
  if (missing(sampID)) {
    sampID <- pv.catstr(pv$class[PV_ID, sampvec])
  }
  pv <- pv.peakset(
    pv, peaks = tmp$binding,
    sampID       =  sampID,
    tissue       =  pv.catstr(pv$class[PV_TISSUE, sampvec]),
    factor       =  pv.catstr(pv$class[PV_FACTOR, sampvec]),
    condition    =  pv.catstr(pv$class[PV_CONDITION, sampvec]),
    treatment    =  pv.catstr(pv$class[PV_TREATMENT, sampvec]),
    peak.caller  =  pv.catstr(pv$class[PV_CALLER, sampvec]),
    control      =  pv.catstr(pv$class[PV_CONTROL, sampvec]),
    reads        =  mean(as.numeric(pv$class[PV_READS, sampvec])),
    replicate    =  replicate,
    consensus    =  TRUE,
    readBam      =  pv.getoneorNA(pv$class[PV_BAMREADS, sampvec]),
    controlBam   =  pv.getoneorNA(pv$class[PV_BAMCONTROL, sampvec]),
    spikein      =  pv.getoneorNA(pv$class[PV_SPIKEIN, sampvec]),
    scoreCol     =  0
  )
  
  pv$binding    <- NULL
  pv$hc         <- NULL
  pv$pc         <- NULL
  
  return(pv)
}

pv.consensusSets <- function(pv,peaks = NULL,minOverlap,attributes,
                             tissue,factor,condition,treatment,replicate,control,peak.caller,
                             readBam, controlBam, spikein)	{
  if (is.character(peaks)) {
    stop(
      "\"peaks\" parameter can not be a filename when \"consensus\" specifies attributes",
      call. =FALSE
    )
  } 
  
  if (is.null(peaks)) {
    peaks <- rep(TRUE,ncol(pv$class))
  }
  
  include <- FALSE
  exclude <- FALSE
  if (sum(attributes < 0))
    exclude <- TRUE
  if (sum(attributes > 0))
    include <- TRUE
  
  if (include & exclude) {
    stop(
      'Consensus attributes must be all inclusive (positive) or all exclusive (negative)',
      call. = FALSE
    )
  }
  
  if (exclude) {
    atts <- NULL
    if (!(-PV_TISSUE    %in% attributes))
      atts <- c(atts,PV_TISSUE)
    if (!(-PV_FACTOR    %in% attributes))
      atts <- c(atts,PV_FACTOR)
    if (!(-PV_CONDITION %in% attributes))
      atts <- c(atts,PV_CONDITION)
    if (!(-PV_TREATMENT %in% attributes))
      atts <- c(atts,PV_TREATMENT)
    if (!(-PV_REPLICATE %in% attributes))
      atts <- c(atts,PV_REPLICATE)
    if (!(-PV_CALLER    %in% attributes))
      atts <- c(atts,PV_CALLER)
    attributes <- atts
  }
  
  numatts <- length(attributes)
  class <- pv$class[attributes,]
  if (is.vector(class)) {
    class <- matrix(class,1,length(class))
  }
  sampids <- pv$class[PV_ID,]
  
  specs <- unique(class[,peaks],MARGIN = 2)
  if (is.vector(specs)) {
    specs <- matrix(specs,1,length(specs))
  }
  
  if (ncol(specs) == ncol(class)) {
    warning(
      'All peaksets unique for specified attributes; no consensus peaksets added.',
      call. = FALSE
    )
    return(pv)
  }
  for (i in 1:ncol(specs)) {
    cand <- class %in% specs[,i]
    if (is.vector(cand)) {
      cand <- matrix(cand,numatts,ncol(class))
    }
    samples <-
      apply(cand,MARGIN = 2,function(x) {
        sum(x) == numatts
      }) & peaks
    diffatts <-
      apply(class,MARGIN = 1,function(x) {
        length(unique(x)) > 1
      })
    if (sum(samples) > 1) {
      message('Add consensus: ',paste(specs[diffatts,i],collapse = " "))
      if (length(unique(sampids[samples])) == 1) {
        sampid <- sampids[samples][1]
      } else
        sampid <- paste(specs[diffatts,i],collapse = ":")
      pv <-
        pv.consensus(pv,samples,sampID = sampid,minOverlap = minOverlap)
      sampnum <- ncol(pv$class)
      if (pv$class[PV_ID,sampnum] == "")
        pv$class[PV_ID,sampnum] <- "ALL"
      if (!missing(tissue))
        pv$class[PV_TISSUE,sampnum]     <- tissue
      if (!missing(factor))
        pv$class[PV_FACTOR,sampnum]     <- factor
      if (!missing(condition))
        pv$class[PV_CONDITION,sampnum]  <- condition
      if (!missing(treatment))
        pv$class[PV_TREATMENT,sampnum]  <- treatment
      if (!missing(replicate))
        pv$class[PV_REPLICATE,sampnum]  <- replicate
      if (!missing(control))
        pv$class[PV_CONTROL,sampnum]    <- control
      if (!missing(peak.caller))
        pv$class[PV_CALLER,sampnum]     <- peak.caller
      if (!missing(readBam))
        pv$class[PV_BAMREADS,sampnum]   <- readBam
      if (!missing(controlBam))
        pv$class[PV_BAMCONTROL,sampnum] <- controlBam
      if (!missing(spikein))
        pv$class[PV_SPIKEIN,sampnum]    <- spikein
    }
  }
  
  return(pv)
}


## pv.mask -- create a mask to define a subset of peaksets in a model
pv.mask <-
  function(pv,attribute,value,combine = 'or',mask,merge = 'or',bApply = FALSE) {
    numsamps <- ncol(pv$class)
    
    if (missing(mask)) {
      if ((merge == 'or') | (merge == 'and')) {
        mask <- rep(FALSE, numsamps)
      } else {
        mask <- rep(TRUE, numsamps)
      }
    }
    
    if (missing(attribute)) {
      masks <- NULL
      for (att in c(PV_TISSUE,PV_FACTOR,PV_CONDITION,PV_TREATMENT,PV_CALLER)) {
        vals <- unique(pv$class[att,])
        for (v in vals) {
          res <- list(x = pv.mask(pv,att,v))
          names(res) <- v
          masks <- c(masks,res)
        }
      }
      res <- list(x = pv.mask(pv,PV_CONSENSUS,TRUE))
      if (sum(res[[1]])) {
        names(res) <- "Consensus"
        masks <- c(masks,res)
      }
      reps <- unique(pv$class[PV_REPLICATE,])
      reps <- reps[!is.na(reps)]
      if (length(reps > 1)) {
        for (rep in reps) {
          res <- list(x = pv.mask(pv,PV_REPLICATE,rep))
          names(res) <- sprintf("Replicate.%s",rep)
          masks <- c(masks,res)
        }
      }
      
      masks$All  <- rep(TRUE,ncol(pv$class))
      masks$None <- rep(FALSE,ncol(pv$class))
      
      return(masks)
    }
    
    curmask <- NULL
    for (v in value) {
      newmask <- pv$class[attribute,] == v
      if (is.null(curmask))
        curmask <- newmask
      if ((combine == 'or') | (combine == 'nor')) {
        curmask <- curmask | newmask
      }
      if ((combine == 'and') | (combine == 'nand')) {
        curmask <- curmask & newmask
      }
    }
    
    if ((combine == 'nor') | (combine == 'nand')) {
      curmask <- !curmask
    }
    
    if (merge == 'or') {
      mask <- mask | curmask
    }
    
    if (merge == 'and') {
      mask <- mask & curmask
    }
    
    if (merge == 'nor') {
      mask <- !(mask | curmask)
    }
    
    if (merge == 'nand') {
      mask <- !(mask & curmask)
    }
    if (bApply) {
      pv <- dba(pv, mask)
      return(pv)
    } else {
      return(mask)
    }
  }

## pv.whichSites -- return index vector of sites belonging to a specific peakset
pv.whichSites <-
  function(pv,pnum,combine = "or",minVal = -1,bUseAllvecs = FALSE) {
    if (bUseAllvecs) {
      stop("Internal error: bUseAllvecs=FALSE in pv.whichsites, please report.")
    } else {
      vecs <- pv$binding
    }
    if (length(pnum) == 1) {
      res <- vecs[,pnum + 3] > minVal
    } else {
      res <- vecs[,pnum[1] + 3] > minVal
      for (p in 2:length(pnum)) {
        newvec <- vecs[,pnum[p] + 3] > minVal
        if (combine == 'or') {
          res <- res | newvec
        }
        if (combine == 'and') {
          res <- res & newvec
        }
        if (combine == 'nor') {
          res <- !(res | newvec)
        }
        if (combine == 'nand') {
          res <- !(res & newvec)
        }
      }
    }
    return(res)
  }

## pv.plotClust  -- hierarchical cluster plot
pv.plotClust <-
  function(pv,mask,numSites,sites,attributes = pv$attributes,distMeth = "pearson") {
    if (missing(mask)) {
      mask <- rep(TRUE,ncol(pv$class))
    }
    if (missing(sites)) {
      sites <- rep(TRUE,nrow(pv$binding))
    }
    if (missing(numSites)) {
      numSites <- length(sites)
    }
    pv$binding <- pv$binding[sites,mask][1:numSites,]
    pv$class   <- pv$class[,mask]
    pv         <-
      pv.analysis(pv,attributes,bPCA = FALSE,distMeth = distMeth)
    plot(pv$hc)
    return(pv$hc)
  }


## pv.overlap -- generate overlapping/unique peaksets
pv.overlap <- function(pv,mask,bFast = FALSE,minVal = 0) {
  if (!missing(mask)) {
    if (!is.logical(mask)) {
      peaksets <- mask
    }	else {
      peaksets <- which(mask)
    }
    if (length(peaksets) <= 4) {
      A <- peaksets[1]
      B <- peaksets[2]
      if (length(peaksets) >= 3) {
        C <- peaksets[3]
      }
      if (length(peaksets) == 4) {
        D <- peaksets[4]
      }
    } else {
      warning('Too many peaksets in mask.',call.=FALSE)
      return(NULL)
    }
  } else {
    stop('Must specify mask for peaksets to overlap.',call. = FALSE)
  }
  
  if (pv$totalMerged != do.nrow(pv$binding)) {
    pv <- pv.vectors(pv,mask = peaksets,minOverlap=1)
    peaksets <- 1:length(peaksets)
    A <- 1; B <- 2; C <- 3; D <- 4
  }
  if (is.null(pv$called)) {
    stop("Called masks not present; re-run dba.count",call.=FALSE)
  }
  maskA <- pv$called[,A]
  maskB <- pv$called[,B]
  if (length(peaksets) >= 3)
    maskC <- pv$called[,C]
  if (length(peaksets) == 4)
    maskD <- pv$called[,D]
  
  pv$binding <- data.frame(pv$binding)
  pv$binding[,1] <- pv$chrmap[pv$binding[,1]]
  if (length(peaksets) < 4) {
    if (length(peaksets) < 3) {
      res <- pv.contrast2(pv$binding,A,B,v1 = maskA,v2 = maskB)
    } else {
      res <-
        pv.contrast3(pv$binding,A,B,C,v1 = maskA,v2 = maskB,v3 = maskC)
    }
  } else {
    res <-
      pv.contrast4(
        pv$binding,A,B,C,D,v1 = maskA,v2 = maskB,v3 = maskC,v4 = maskD
      )
  }
  
  return(res)
}


## pv.sort  - sort binding sites (e.g. for heatmap)
pv.sort <- function(pv,fun = sd,mask,...) {
  if (missing(mask)) {
    mask <- rep(TRUE,ncol(pv$class))
  }
  
  scores <- apply(pv$binding[,c(FALSE,FALSE,FALSE,mask)],1,fun,...)
  ranked <- order(scores,decreasing = TRUE)
  
  pv$binding   <- pv$binding[ranked,]
  
  return(pv)
}

pv.overlapRate <- function(pv,mask = mask) {
  if (!missing(mask)) {
    if (!is.null(mask)) {
      pv <- dba(pv,mask)
    }
  }
  if (is.null(pv$called)) {
    stop("No peak overlap information available",call.=FALSE)
  }
  if(!is.null(pv$allcalled)) {
    pv$called <- pv$allcalled
  }
  sums <- apply(pv$called,1,sum)
  res <- sapply(1:length(pv$peaks),function(x)
    sum(sums >= x))
  return(res)
}


## pv.occupancy-- generate co-occupancy stats from peaksets in a model
pv.occupancy <-
  function(pv,mask,sites,byAttribute,Sort = 'inall',CorMethod = "pearson",
           labelAtts = pv$attributes,bPlot = FALSE,minVal = 0,bCorOnly = FALSE,
           bNonZeroCors = FALSE,chrmask) {
    pv <- pv.check(pv)
    
    vecs <- pv$binding
    
    if (missing(mask)) {
      mask <- rep(TRUE,ncol(pv$class))
    } else if (is.null(mask)) {
      mask <- rep(TRUE,ncol(pv$class))
    } else {
      if (!is.logical(mask)) {
        tmp  <- rep (FALSE,length(pv$peaks))
        tmp[mask] <- TRUE
        mask <- tmp
      }
    }
    if (missing(sites)) {
      sites <- 1:nrow(vecs)
    }
    
    res <- NULL
    if (missing(byAttribute)) {
      if (length(sites) < nrow(vecs)) {
        pv$binding <- vecs[sites,]
      }
      if (!missing(chrmask)) {
        chrindex <- match(chrmask,pv$chrmap)
        vecindex <- pv$binding[,1] == chrmask
        pv$binding <- pv$binding[vecindex,]
      }
      res <-
        pv.pairs(
          pv,mask=mask,CorMethod=CorMethod,bPlot=bPlot,minVal=minVal,bCorOnly =
            bCorOnly,bNonZeroCors=bNonZeroCors
        )
      if (!is.null(nrow(res))) {
        if (!missing(labelAtts)) {
          res <- pv.overlapToLabels(pv,res,labelAtts)
        }
      }
    } else {
      ## by attribute
      vals <- unique(pv$class[byAttribute,mask])
      for (i in 1:length(vals)) {
        comps <- which(pv$class[byAttribute,] %in% vals[i])
        vmask <- rep(FALSE,length(mask))
        vmask[comps] <- TRUE
        if (sum(vmask) > 1) {
          res <- rbind(
            res,pv.occupancy(
              pv,mask=vmask,sites=sites,
              Sort=Sort,CorMethod=CorMethod,minVal =
                minVal,bCorOnly=bCorOnly
            )
          )
        }
      }
    }
    
    if (!is.null(nrow(res))) {
      if (Sort == 'cor') {
        res <- res[pv.orderfacs(res[,6],decreasing=TRUE),]
      } else if (Sort == 'percent') {
        res <- res[pv.orderfacs(res[,7],decreasing=TRUE),]
      } else {
        res <- res[pv.orderfacs(res[,5],decreasing=TRUE),]
      }
    }
    
    return(res)
  }


pv.isConsensus <- function(DBA) {
  if(is.null(DBA$class)) {
    return(FALSE)
  }
  if(sum(DBA$class[DBA_CALLER, ]=="counts") != length(DBA$peaks)) {
    return(FALSE)
  } 
  if(is.null(DBA$peaks)) {
    return(FALSE)
  }   
  
  if(length(unique(sapply(DBA$peaks,nrow))) > 1) {
    return(FALSE)
  }
  
  return(TRUE)
}

pv.save <- function(DBAobject,file='model',dir='Robjects',pre='pv_',ext='RData',
                    compress=TRUE,ascii=FALSE) {
   fn <- sprintf('%s/%s%s.%s',dir,pre,file,ext)
   
   if(is(compress,"logical")) {
      if(compress==TRUE) {
         compress_level <- 9
      } 
   } else {
      compress_level <- compress
      compress <- TRUE
   }
   
   save(DBAobject,file=fn,compress=compress,
        compression_level=compress_level,ascii=ascii)
   return(fn)
}

pv.load <- function(file='model',dir='Robjects',pre='pv_',ext='RData') {
   DBAobject <- NULL
   pv <- NULL
   load(sprintf('%s/%s%s.%s',dir,pre,file,ext))
   if(is.null(DBAobject)) {
      DBAobject <- pv
   } else {
      if(!is.null(DBAobject$config$Version1)) {
         if(as.numeric(DBAobject$config$Version1) < 3) {
            if(as.numeric(DBAobject$config$Version2) < 99) {
               DBAobject <- pv.loadPre3(DBAobject)
            }
         }
      }
   }
   
   if(nrow(DBAobject$class) < PV_SPIKEIN) {
      DBAobject$class <- rbind(DBAobject$class, Spikein=NA)
   }
   
   return(DBAobject)
}


pv.loadPre3 <- function(pv) {
   
   # Make sure it is a DBA object
   if(!is(pv,"DBA")) {
      class(pv) <- "DBA"
   }
   
   # If it already has normalization don't do anything
   if(!is.null(pv$norm)) {
      return(pv)
   }
   
   # If no counts available don't do anything
   srcmask <- pv.mask(pv,PV_CALLER,"source") | pv.mask(pv,PV_CALLER,"counts")
   if(sum(srcmask)==0) {
      return(pv)
   }
   
   # Set minimum count to 1 (default is 0 in 3.0)
   if (is.null(pv$minCount)) {
      pv$minCount <- 1
   }
   
   # If an analysis has been run,  check for normalization parameters
   bSubControlD <- bSubControlE <- TRUE
   bFullLibrarySizeD <- bFullLibrarySizeE <- TRUE
   con <- pv$contrasts[[1]]
   if(!is.null(con)) {
      if(!is.null(con$DESeq2)) {
         bSubControlD <- con$DESeq2$bSubControl
         bFullLibrarySizeD <- con$DESeq2$bFullLibrarySize 
      }
      if(!is.null(con$edgeR)) {
         bSubControlE <- con$edgeR$bSubControl
         bFullLibrarySizeE <- con$edgeR$bFullLibrarySize 
      }
   }
   # Set mode to pre-2.0
   if(is.null(pv$design)) {
      if(!is.null(pv$contrasts)) {
         pv$design <- FALSE
      }
   }
   
   # Normalize
   filtval <- 0
   filtFun <- max
   if(!is.null(pv$filter)) {
      filtval <- pv$filter
   }
   if(!is.null(pv$filterFun)) {
      filtFun <- pv$filterFun
   }
   
   # if(bFullLibrarySizeD) {
   #    pv <- dba.normalize(pv, method = DBA_DESEQ2, 
   #                        normalize = DBA_NORM_LIB,
   #                        library = DBA_LIBSIZE_FULL, 
   #                        bSubControl = bSubControlD, 
   #                        filter = filtval,filterFun = filtFun)
   # } else {
   #    pv <- dba.normalize(pv, method = DBA_DESEQ2, 
   #                        normalize = DBA_NORM_RLE,
   #                        library = DBA_LIBSIZE_PEAKREADS, 
   #                        bSubControl = bSubControlD,
   #                        filter = filtval,filterFun = filtFun)      
   # }
   # 
   # if(bFullLibrarySizeE) {
   #    pv <- dba.normalize(pv, method = DBA_EDGER, 
   #                        normalize = DBA_NORM_TMM,
   #                        library = DBA_LIBSIZE_FULL, 
   #                        bSubControl = bSubControlE, 
   #                        filter = filtval,filterFun = filtFun)
   # } else {
   #    pv <- dba.normalize(pv, method = DBA_EDGER,
   #                        normalize = DBA_NORM_TMM,
   #                        library = DBA_LIBSIZE_PEAKREADS, 
   #                        bSubControl = bSubControlE,
   #                        filter = filtval,filterFun = filtFun)      
   # }
   
   # Turn off blacklists and greylists by default
   if(is.null(pv$config$doBlacklist)) {
      pv$config$doBlacklist <- FALSE
   }
   if(is.null(pv$config$doGreylist)) {
      pv$config$doGreylist <- FALSE
   }
   
   return(pv)
}


## pv.writePeakset --- write out vectorized peaks as a bed file for external 
pv.writePeakset <- function(pv,fname,peaks,numCols=4){
   
   if(missing(peaks)) {
      peaks <- rep(T,do.nrow(pv$binding))
   } else {
      if(sum(class(peaks)=='logical')) {
         peaks <- which(peaks)[1]	
      }	
   }
   
   if(missing(fname)) {
      fname <- NULL
   }
   
   if(sum((class(peaks)=='numeric')) || sum((class(peaks)=='integer'))) {
      peaks=pv$peaks[[peaks]]
   }           
   
   if(!is.null(dim(peaks))) {
      if(is(peaks[1,1],"character")) {
         bed <- pv.do_peaks2bed(peaks,NULL,fname,numCols=numCols)
      } else {
         bed <- pv.do_peaks2bed(peaks,pv$chrmap,fname,numCols=numCols)
      }
   } else {
      bed <- pv.do_peaks2bed(pv$binding,pv$chrmap,fname,numCols=ncol(pv$binding))
   }
   
   return(bed)
}

pv.contrast <- function(pv,group1,group2=!group1,name1,name2,
                        minMembers=3,categories,bMulti=FALSE,block, bNot=FALSE,
                        design=TRUE, contrast, bGetNames=FALSE, reorderMeta) {
   
   numStart <- length(pv$contrasts)
   
   pv <- pv.orderMetaFacs(pv, reorderMeta)
   
   if(bGetNames) {
      if(!is.logical(design)) {
         pv$design <- design
         pv$DESeq2 <- pv$edgeR <- NULL
      }
      return(pv.DESeq2ResultsNames(pv))
   }
   
   if(!missing(reorderMeta) && missing(group1) && 
      missing(contrast) && !is.null(pv$contrasts) &&
      is(design,"logical") ) {
      pv <- pv.CheckReleveledContrasts(pv)
      return(pv)
   }
   
   if(missing(block)) {
      doBlock <- FALSE
   } else {
      doBlock <- TRUE
   }
   
   generateDesign <- FALSE
   if(design!=FALSE) {
      if(design[1] == TRUE) {
         if (!missing(group1)) {
            stop("Can not specify groups when design is TRUE, specify contrast.",call.=FALSE)
         } else {
            if (bMulti) {
               warning("bComplex ignored when design is TRUE.",call.=FALSE)
               bMulti <- FALSE
            }
            if(bNot) {
               warning("bNot ignored when design is TRUE",call.=FALSE)
               bNot <- FALSE
            }
            generateDesign <- TRUE
         }
      }
      
      if(!missing(block)) {
         warning("block ignored when design is used.",call.=FALSE)
         doBlock <- FALSE
      }
      
      if(!missing(group1)) {
         warning("groups ignored when design is used.",call.=FALSE)
      }
      
      if(!generateDesign || !missing(contrast)) {
         res <- pv.contrastDesign(pv=pv, design=design, contrast=contrast, 
                                  name1=name1, name2=name2, 
                                  bGetNames=bGetNames)
         if(!missing(reorderMeta)) {
            res <- pv.CheckReleveledContrasts(res)
         }
         return(res)
      }
   }
   
   if(missing(name1)) {
      name1="Group1"
   }
   if(missing(name2)) {
      name2="Group2"
   }
   
   if(missing(group1)) { # Automatically Generate Contrasts}
      
      if( (sum(pv.mask(pv,PV_CALLER,'source'))==0) &
          (sum(pv.mask(pv,PV_CALLER,'counts'))==0) ) {
         warning('Model must include count data for contrasts.',call.=FALSE)
         return(pv)
      }
      
      if(pv.isDesign(pv$design)) {
         varnames <- all.vars(formula(pv$design))
         categories <- pv.FactorVals[match(varnames,pv.FactorNames)]
      }
      
      if(!is.null(pv$contrasts)) {
         message("Clearing existing contrasts.")
         pv$contrasts <- NULL # clear existing contrasts
      }
      
      olddesign <- pv$design
      oldDESeq2 <- pv$DESeq2
      pv$design <-  pv$DESeq2 <- pv$edgeR <- NULL
      
      if(missing(categories)) {
         attributes <- c(PV_TISSUE,PV_FACTOR,PV_CONDITION,PV_TREATMENT)
      } else {
         attributes <- categories
      }
      if(!doBlock) {
         res <- pv.getContrasts(pv,minMembers=minMembers,attributes=attributes,
                                bNot=bNot)
         if(bMulti) {
            res <- pv.listaddto(res,pv.contrastPairs(pv,minMembers=minMembers,
                                                     attributes=attributes,
                                                     conlist=res,bNot=bNot))  
         }
      } else {
         res <- pv.getContrasts(pv,minMembers=minMembers,attributes=attributes,
                                block=block,bNot=bNot)
         if(bMulti) {
            res <- pv.listaddto(res,pv.contrastPairs(pv,minMembers=minMembers,
                                                     attributes=attributes,
                                                     block=block,bNot=bNot))   
         }
      }
      if(!is.null(res)) {
         res <- pv.contrastDups(res)
      } else {
         warning("No contrasts added. There must be at least two sample groups with at least three replicates.",
                 call.=FALSE)	
      }
      if(pv.isDesign(olddesign) || generateDesign) {
         res <- pv.checkContrastOrder(res, pv$meta)
      }
      if(doBlock){
         problem <- NULL
         issues <- 0
         for(i in 1:length(res)){
            if(!pv.checkBlock(res[[i]],bWarning=FALSE)){
               #warning("Blocking factor has unmatched sample(s).")
               issues <- issues+1
               problem <- res[[i]]
               res[[i]]$blocklist <- NULL   		
            }
         }
         if(issues > 0) {
            if(issues < length(res)) {
               warning('Blocking factor not used for some contrasts:',call.=FALSE)	
            } else {
               warning('Blocking factor invalid for all contrasts:',call.=FALSE)
            }
            x <- pv.checkBlock(problem)		
         }      	
      }
      
      if(generateDesign && !is.null(res)) {
         pv$contrasts <- res
         pv <- pv.generateDesignFromContrasts(pv, attributes=attributes,
                                              bGetNames=FALSE)
         if(is.null(olddesign)){
            pv$edgeR  <- NULL
            oldDESeq2 <- NULL
         } else {
            if(olddesign != pv$design) {
               pv$design <- pv.compareDesigns(olddesign, pv$design)
               if(olddesign != pv$design) {
                  pv$edgeR  <- NULL
                  oldDESeq2 <- NULL
               }
            }
         }
         pv$DESeq2 <- oldDESeq2
         pv$DESeq2$names <- pv.DESeq2ResultsNames(pv)
         if(!missing(reorderMeta)) {
            pv <- pv.CheckReleveledContrasts(pv)
         }
         if(bGetNames) {
            return(pv$DESeq2$names)
         } else {
            return(pv)
         }
      }
      
   } else {
      res <- pv.addContrast(pv,group1,group2,name1,name2)
      if(doBlock) {
         res$contrasts[[length(res$contrasts)]]$blocklist <- pv.BlockList(pv,block)
         if(!pv.checkBlock(res$contrasts[[length(res$contrasts)]])) {
            #warning("Blocking factor has unmatched sample(s).")
            res$contrasts[[length(res$contrasts)]]$blocklist <- NULL   	
         }
      }
      if(!is.null(res$contrasts)) {
         res$contrasts <- pv.contrastDups(res$contrasts)	
      }
      if(length(res$contrasts) == numStart) {
         warning('Unable to add redundant contrast.',call.=FALSE)  	
      }
      return(res)
   }
   
   pv$contrasts <- pv.listaddto(pv$contrasts,res)
   
   return(pv)
   
}

pv.getContrasts <- function(pv,minMembers=3,
                            attributes=c(PV_TISSUE,PV_FACTOR,PV_CONDITION,PV_TREATMENT),
                            block,bNot=FALSE){
   
   srcidx <-  pv.mask(pv,PV_CALLER,"source") | pv.mask(pv,PV_CALLER,"counts")
   mdata <- pv$class[,srcidx]
   
   if(!missing(block)) {
      #if(block != PV_REPLICATE) {
      #   warning('Unsupported blocking attribute')
      #}
      block <- pv.BlockList(pv,block)
   } else block <- NULL
   
   mcats <- attributes
   jobs <- NULL
   for(mcat in mcats) {
      vals <- unique(mdata[mcat,])
      if (length(vals)>1) {
         members <- NULL
         for(i in 1:length(vals)) {
            members <- c(members,sum(mdata[mcat,]== vals[i]))            
         }
         for(i in 1:length(vals)) {
            if(members[i] >= minMembers) {
               if(i < length(vals)){
                  for(j in (i+1):length(vals)) {
                     if(members[j] >= minMembers) {
                        job <- NULL
                        job$group1 <- pv.mask(pv,mcat,vals[i]) & srcidx
                        job$group2 <- pv.mask(pv,mcat,vals[j]) & srcidx
                        job$name1  <- vals[i]
                        job$name2  <- vals[j]
                        job$blocklist <- block
                        jobs <- pv.listadd(jobs,job)  
                     }
                  }      
               }
               if(bNot && ( (sum(members)-members[i]) >= minMembers) ) {
                  job <- NULL
                  job$group1 <- pv.mask(pv,mcat,vals[i]) & srcidx
                  job$group2 <- pv.mask(pv,mcat,vals[i],merge='nand') & srcidx
                  job$name1  <- vals[i]
                  job$name2  <- sprintf("!%s",vals[i])
                  job$blocklist <- block
                  jobs <- pv.listadd(jobs,job)                 
               }   
            }
         }     
      }
   }
   return(jobs)   
}

pv.contrastPairs <- function(pv,minMembers=3,
                             attributes=c(PV_TISSUE,PV_FACTOR,PV_CONDITION,PV_TREATMENT),
                             block=NULL,conlist=NULL, bNot=TRUE) {
   
   if(length(attributes)==1) {
      return(pv$contrasts)
   }
   
   clist <- conlist
   srcmask <- pv.mask(pv,PV_CALLER,"source") | pv.mask(pv,PV_CALLER,"counts")
   numatts <- length(attributes)
   res <- NULL
   for(a1 in 1:(numatts-1)) {
      att1 <- attributes[a1]
      val1 <- unique(pv$class[att1,])
      if(length(val1)>1) {
         for(i in 1:length(val1)) {
            for (a2 in (a1+1):numatts) {
               att2 <- attributes[a2]
               val2 <- unique(pv$class[att2,])
               if(length(val2)>1) {
                  for(j in 1:length(val2)) {
                     res <- pv.listadd(res,list(a1=att1,v1=val1[i],a2=att2,v2=val2[j]))
                  }
               }
            }
         }
      }
   }
   
   if(!missing(block)) {
      block <- pv.BlockList(pv,block)
   } else block <- NULL
   
   if(!is.null(res)) {
      for(i in 1:length(res)) {
         m1 <- pv.mask(pv,res[[i]]$a1,res[[i]]$v1,mask=srcmask,merge='and')
         m1 <- pv.mask(pv,res[[i]]$a2,res[[i]]$v2,mask=m1,merge='and')
         if(sum(m1)>=minMembers) {
            if(i < length(res)) {
               for(j in (i+1):length(res)) {
                  m2 <- pv.mask(pv,res[[j]]$a1,res[[j]]$v1,mask=srcmask,merge='and')
                  m2 <- pv.mask(pv,res[[j]]$a2,res[[j]]$v2,mask=m2,merge='and') 
                  if( (sum(m2)>=minMembers) && (sum(m1 & m2) == 0) ) {
                     crec <- NULL
                     crec$group1 <- m1
                     crec$group2 <- m2
                     crec$name1  <- sprintf("%s:%s",res[[i]]$v1,res[[i]]$v2)
                     crec$name2  <- sprintf("%s:%s",res[[j]]$v1,res[[j]]$v2)
                     crec$blocklist <- block
                     clist <- pv.listadd(clist,crec)
                  }
               }                      
            }
            if(bNot && (sum((!m1)&srcmask) >= minMembers)) {
               crec <- NULL
               crec$group1 <- m1
               crec$group2 <- (!m1) & srcmask
               crec$name1  <- sprintf("%s:%s",res[[i]]$v1,res[[i]]$v2)
               crec$name2  <- sprintf("!%s:%s",res[[i]]$v1,res[[i]]$v2)
               crec$blocklist <- block
               clist <- pv.listadd(clist,crec)	
            }     
         }
      }	
   }
   #if(!is.null(block)){
   #   for(i in 1:length(clist)){
   #      if(!pv.checkBlock(clist[[i]])){
   #         warning("Unable to add blocking factor: unmatched samples.")
   #         clist[[i]]$blocklist <- NULL   		
   #      }
   #   }      	
   #} 
   return(clist)
}


pv.addContrast <- function(pv,group1,group2=!group1,name1="group1",name2="group2") {
   
   if(is.null(group1) | is.null(group2)) {
      stop('Null group, can not add contrast',call.=FALSE)	
   }
   
   if(!is.logical(group1)) {
      if(max(group1) > length(pv$peaks)) {
         stop('Invalid sample number in first group.',call.=FALSE)	
      }
      temp <- rep(FALSE,length(pv$peaks))
      temp[group1] <- TRUE
      group1 <- temp
   }
   
   if(!is.logical(group2)) {
      if(max(group2) > length(pv$peaks)) {
         stop('Invalid sample number in second group.',call.=FALSE)	
      }  	
      temp <- rep(FALSE,length(pv$peaks))
      temp[group2] <- TRUE
      group2 <- temp
   }
   
   if(sum(group1)==0) {
      return(pv)
   }
   if(sum(group2)==0) {
      return(pv)
   }
   
   if( length(group1) != length(pv$peaks) || length(group2) != length(pv$peaks) ) {
      stop('Length of vector specifying groups greater than number of samples.',call.=FALSE)
   }
   
   crec <- NULL
   crec$name1  <- name1
   crec$name2  <- name2
   crec$group1 <- group1
   crec$group2 <- group2
   pv$contrasts <- pv.listadd(pv$contrasts,crec)
   return(pv)	
}

pv.contrastDups <- function(clist) {
   numc <- length(clist)
   if(numc <= 1) {
      return(clist)
   }
   res <- rep(TRUE,numc)
   for(i  in 1:(numc-1)) {
      crec <- clist[[i]]
      for(j in (i+1):numc) {
         rec2 <- clist[[j]]
         if(!is.null(crec$contrast) && !is.null(rec2$contrast)) {
            if(identical(crec$contrast,rec2$contrast)) {
               res[j] <- FALSE
            }
         } else if (is.null(crec$contrast) && is.null(rec2$contrast)) {
            if ( (identical(crec$group1,rec2$group1) && identical(crec$group2,rec2$group2)) ||
                 (identical(crec$group1,rec2$group2) && identical(crec$group2,rec2$group1)) ){
               res[j] <- FALSE   
            }
         }
      }      	
   }
   newc <- NULL
   for(i in 1:numc) {
      if (res[i]) {
         newc <- pv.listadd(newc,clist[[i]])
      }	
   }
   return(newc)	
}


pv.BlockList <- function(pv,attribute=PV_REPLICATE) {
   
   if(is.numeric(attribute)) {
      if(length(attribute)>1) {
         vec <- rep(FALSE,length(pv$peaks))
         vec[attribute]=TRUE
         attribute=vec	
      }
   }
   if(is(attribute,'numeric')) {   
      vals    <- sort(unique(pv$class[attribute,]))
      attname <- rownames(pv$class)[attribute]
      if(attname == 'Peak caller') {
         attname <- 'Caller'
      }
      res <- NULL
      for(val in vals) {
         newmask <- pv.mask(pv,attribute,val)
         res <- pv.listadd(res,list(attribute=attname,label=val,samples=newmask))   
      }
   } else { #logical vector(s)
      if(is(attribute,'logical')) {
         if(length(attribute)!=length(pv$peaks)) {
            stop('Length of attribute vector must equal total number of peaksets.',call.=FALSE)	
         }
         attribute <- list(true=attribute,false=!attribute)	
      }
      if(!is(attribute,'list')) {
         stop('attribute must be a DBA_ attribute, a logical vector, or a list of logical vectors.',call.=FALSE)	
      }
      attname <- 'Block'
      if(is.null(names(attribute))) {
         names(attribute) <- 1:length(attribute)
      }
      res <- NULL
      hasatt <- rep(FALSE,length(pv$peaks))
      for (i in 1:length(attribute)) {
         att <- attribute[[i]]
         if(is.numeric(att)) {
            att <- rep(FALSE,length(pv$peaks))
            att[attribute[[i]]]=TRUE
         }
         hasatt <- hasatt | att
         res <- pv.listadd(res,list(attribute=attname,label=names(attribute)[i],samples=att))	
      }
      if(sum(!hasatt)>0) {
         res <- pv.listadd(res,list(attribute=attname,label="other",samples=!hasatt))	
      }
   }
   
   return(res)	
}

pv.checkBlock <- function(contrast,bCheckBalanced=FALSE,bCheckMultiple=TRUE,bCheckCross=TRUE,
                          bCheckUnique=TRUE,bCheckAllInOne=TRUE,bWarning=TRUE) {
   
   if(bCheckBalanced){
      if(sum(contrast$group1)!=sum(contrast$group2)) {
         if(bWarning) warning("Blocking factor has unmatched sample(s).",call.=FALSE)
         return(FALSE)	
      }
      
      for(att in contrast$blocklist) {
         if(sum(contrast$group1 & att$samples) != sum(contrast$group2 & att$samples)) {
            if(bWarning) warning("Blocking factor has unmatched sample(s).",call.=FALSE)
            return(FALSE)
         }
      }
   }
   
   if(bCheckMultiple) {
      if(length(contrast$blocklist)<2) {
         if(bWarning) warning('Blocking factor has only one value',call.=FALSE)
         return(FALSE)	
      }	
   }
   
   if(bCheckCross || bCheckAllInOne) {
      cross  <- FALSE
      allone <- FALSE
      for(att in contrast$blocklist) {
         if(sum(contrast$group1 & att$samples) & sum(contrast$group2 & att$samples)) {
            cross <- TRUE
         }
         if(sum(att$samples & (contrast$group1 | contrast$group2)) ==
            sum(contrast$group1 | contrast$group2))
            allone=TRUE
      }
      if(!cross && bCheckCross) {
         if(bWarning) warning('No blocking values are present in both groups',call.=FALSE)	
         return(FALSE)
      }
      if(allone && bCheckAllInOne) {
         if(bWarning) warning('A blocking value applies to all samples in both groups',call.=FALSE)	
         return(FALSE)
      }
   }
   
   if(bCheckUnique) {
      unique <- rep(0,length(contrast$group1)) 	
      for(att in contrast$blocklist) {
         unique <- unique + (contrast$group1 & att$samples)
         unique <- unique + (contrast$group2 & att$samples)	
      }
      if(sum(unique>1)>0) {
         if(bWarning) warning('Some sample(s) have more than one value for blocking factor',call.=FALSE)	
         return(FALSE)
      }
   }
   
   return(TRUE)
}

pv.listContrasts <- function(pv,th=0.05,bUsePval=FALSE) {
   
   if(is.null(pv$contrasts)) {
      return(NULL)
   } else {
      clist <- pv$contrasts
   }
   
   types  <- pv.contrastTypes(clist)
   groups <- pv.contrastGroups(clist)
   coeffs <- pv.contrastCoeffs(clist, pv)
   blocks <- pv.contrastBlocks(clist)
   sdbs   <- pv.contrastSDBs(clist,th=th)
   
   res <- NULL
   if(!is.null(types)) {
      res <- matrix(types,length(types),1)
      colnames(res) <- "Factor"
      res <- cbind(res,groups)
   } else {
      res <- groups
   }
   if(!is.null(coeffs)) {
      res <- cbind(res,coeffs)
   }
   if(!is.null(blocks)) {
      res <- cbind(res,blocks)
   }
   if(!is.null(sdbs)) {
      res <- cbind(res,sdbs)
   }
   
   rownames(res) <- 1:nrow(res)
   return(data.frame(res))
   
}

pv.contrastTypes <- function(contrasts) {
   res <- NULL
   for(cres in contrasts) {
      type <- cres$contrastType
      if(is.null(type)) {
         type <- ""
      } else if (type =="simple") {
         type <- cres$contrast[1]
      } else if (type =="byname") {
         type <- "Name"
      } else if (type =="byresults1" || type=="byresults2") {
         type <- "Results"
      } else if (type =="bycolumn") {
         type <- "Coefficient"
      }
      res <- c(res,type)
   }
   if(sum(res==rep("",length(res))) != length(res)) {
      return(res)
   } else {
      return(NULL)
   }
}

pv.contrastGroups <- function(contrasts) {
   
   res <- NULL
   for(crec in contrasts) {
      simple <- FALSE
      if(!is.null(crec$contrastType)) {
         if(crec$contrastType == 'simple') {
            simple <- TRUE
         }
      } else {
         simple <- TRUE
      }
      
      if(simple) {
         newrec <- c(crec$name1,sum(crec$group1),crec$name2,sum(crec$group2))
      } else { # complex contrast
         if(crec$contrastType=='byname') {
            newrec <- crec$contrast
         } else if(crec$contrastType=="byresults1") {
            newrec <- c(crec$contrast[[1]])
         } else if(crec$contrastType=="byresults2") {
            newrec <- c(crec$contrast[[1]],"",crec$contrast[[2]])
         } else if(crec$contrastType=="bycolumn") {
            newrec <- paste(crec$contrast,collapse=",")
         } else {
            stop('Invalid contrast type',call.=FALSE)
         }
         while(length(newrec)<4){
            newrec <- c(newrec,"")
         }
      }
      
      if(!is.null(res)) {
         if(length(newrec)>ncol(res)) {
            res <- cbind(res,matrix("-",nrow(res),length(newrec)-ncol(res)))	
         } else if (length(newrec)<ncol(res)) {
            newrec <- c(newrec,rep("-",ncol(res)-length(newrec)))	
         }
      }
      res <- rbind(res,newrec)
   }
   
   numCons <- length(contrasts)
   rownames(res) <- 1:numCons
   colnames(res) <- c("Group","Samples","Group2","Samples2")
   
   res <- pv.keepMeta(res, "")
   
   return(res)
}

pv.contrastCoeffs <- function(contrasts, pv) {
   coeffs <- cons <- NULL
   for(i in 1:length(contrasts)) {
      if(!is.null(contrasts[[i]]$contrastType)) {
         if(contrasts[[i]]$contrastType == "bycolumn") {
            coeffs <- c(coeffs,i)
         } else {
            cons <- c(cons,i)
         }
      }   
   }
   if(is.null(coeffs)) {
      return(NULL)
   }
   
   numContrasts <- length(contrasts)
   
   coeffNames <- dba.contrast(pv,bGetCoefficients=TRUE)
   
   res <- matrix("_",numContrasts,length(coeffNames))
   colnames(res) <- coeffNames
   rownames(res) <- 1:numContrasts
   
   for(i in coeffs) {
      res[i,] <- contrasts[[i]]$contrast
   }  
   
   if(!is.null(cons)) {
      edgeRsave <- pv$edgeR
      pv$edgeR$design <- pv.edgeRdesign.matrix(pv,pv$design)
      for(i in cons) {
         con <- contrasts[[i]]
         coeffs <- pv.getCoeffs(con,pv)
         if(!is.null(coeffs)){
            res[i,] <- coeffs
         }
      }
      pv$edgeR <- edgeRsave
   }
   
   return(res)
}

pv.contrastBlocks <- function(contrasts) {
   
   res <- NULL
   maxbvals <- 0
   for(crec in contrasts) {
      bvals <- 0
      newrec <- NULL
      if(!is.null(crec$blocklist)) {
         for(brec in crec$blocklist) {
            bvals <- bvals+1
            newrec <- c(newrec,brec$label,sum(brec$samples&(crec$group1|crec$group2)))
         }
      }
      if(is.null(newrec)) {
         newrec <- "_"
      }
      maxbvals <- max(bvals,maxbvals)
      if(!is.null(res)) {
         if(length(newrec)>ncol(res)) {
            res <- cbind(res,matrix("-",nrow(res),length(newrec)-ncol(res)))
         } else if (length(newrec)<ncol(res)) {
            newrec <- c(newrec,rep("-",ncol(res)-length(newrec)))
         }
      }
      res <- rbind(res,newrec)
   }
   
   if(maxbvals==0) {
      return(NULL)
   } else {
      cvec <- NULL
      for(i in 1:maxbvals) {
         cvec <- c(cvec,paste("Block",i,sep=""),paste("Blk",i,"Samps",sep=""))
      }
      colnames(res) <- cvec
      return(res)
   }
}

EDGER_COL_PVAL <- 4
EDGER_COL_FDR  <- 5
pv.contrastSDBs <- function(contrasts,th=th) {
   res  <- NULL
   cvec <- NULL
   eres <- NULL
   for(crec in contrasts) {
      if(!is.null(names(crec$edgeR))){
         if(!is(crec$edgeR,"DGEList")) {
            eres <- c(eres,sum(crec$edgeR$de$padj <= th))
         } else {
            if(is.null(crec$edgeR$LRT)) {
               eres <- c(eres,sum(edgeR::topTags(crec$edgeR$db,
                                                 nrow(crec$edgeR$db$counts))$table[,EDGER_COL_FDR] <= th,na.rm=TRUE))
            } else {
               eres <- c(eres,sum(edgeR::topTags(crec$edgeR$LRT,
                                                 nrow(crec$edgeR$db$counts))$table[,EDGER_COL_FDR+1] <= th,na.rm=TRUE))
            }
         }
      } else {
         eres <- c(eres,"-")
      }
   }
   res <- cbind(res,eres)
   cvec <- c(cvec,'DB edgeR')
   
   eres <- NULL
   for(crec in contrasts) {
      if(!is.null(names(crec$edgeR$block))){
         eres <- c(eres,sum(edgeR::topTags(crec$edgeR$block$LRT,
                                           nrow(crec$edgeR$block$counts))$table[,EDGER_COL_FDR+1] <= th,na.rm=TRUE))
      } else {
         eres <- c(eres,"-")
      }
   }
   res <- cbind(res,eres)
   cvec <- c(cvec,'DB edgeR-block')
   
   eres <- NULL
   for(crec in contrasts) {
      if(!is.null(names(crec$DESeq2)) && 
         (!is(crec$DESeq2,"try-error")) ){
         eres <- c(eres,sum(crec$DESeq2$de$padj <= th,na.rm=TRUE))
      } else {
         eres <- c(eres,"-")
      }
   }
   res <- cbind(res,eres)
   cvec <- c(cvec,'DB DESeq2')
   
   eres<- NULL
   for(crec in contrasts) {
      if(!is.null(names(crec$DESeq2$block)) && 
         (!is(crec$DESeq2,"try-error")) ){
         eres <- c(eres,sum(crec$DESeq2$block$de$padj <= th,na.rm=TRUE))
      } else {
         eres <- c(eres,"-")
      }
   }
   res <- cbind(res,eres)
   cvec <- c(cvec,'DB DESeq2-block')
   colnames(res) <- cvec
   
   res <- pv.keepMeta(res,"-")
   
   return(res)
}

pv.keepMeta <- function(res, noval="")
{
   numContrasts <- nrow(res)
   cvec <- colnames(res)
   
   keep  <- NULL
   keepc <- NULL
   for(i in 1:ncol(res)) {
      if(sum(res[,i]==rep(noval,numContrasts)) != numContrasts) {
         keep  <- cbind(keep,res[,i])
         keepc <- c(keepc,cvec[i])
      }
   }
   
   if(is.null(keep)) {
      return(NULL)
   }
   
   res <- data.frame(keep)
   rownames(res) <- 1:numContrasts
   colnames(res) <- keepc
   
   return(res)
}

pv.design <- function(DBA,categories=c(DBA_CONDITION,DBA_TREATMENT,DBA_TISSUE,DBA_FACTOR,DBA_REPLICATE)) {
   
   facs <- NULL
   for(cond in categories) {
      if(length(unique(DBA$class[cond,]))>1) {
         facs <- c(facs,cond)
      } else {
         catname <- "UNKNOWN"
         if(cond == DBA_CONDITION) {
            catname <- "DBA_CONDITION"
         }	
         if(cond == DBA_TREATMENT) {
            catname <- "DBA_TREATMENT"
         }	
         if(cond == DBA_TISSUE) {
            catname <- "DBA_TISSUE"
         }	
         if(cond == DBA_FACTOR) {
            catname <- "DBA_FACTOR"
         }	
         if(cond == DBA_REPLICATE) {
            catname <- "DBA_REPLICATE"
         }
         warning(sprintf("Category %s lacks multiple unique values, ignored in design",catname),call.=FALSE)	
      }	
   }
   
   red <- DBA$class[facs,]
   if(is.null(nrow(red))) {
      red <- matrix(red,1,length(red))
      rownames(red) <- rownames(DBA$class)[facs]
      colnames(red) <- colnames(DBA$class)
   }
   dmatrix <- data.frame(t(red))
   terms <- colnames(dmatrix)
   form <- "~"
   for(term in terms) {
      form <- sprintf("%s+%s",form,term)	
   }
   
   design <- model.matrix(as.formula(form),data=dmatrix)
   
   return(design)   	
}

pv.FactorNames <- c("Tissue","Factor","Condition","Treatment","Caller","Replicate")
pv.FactorVals  <- c(PV_TISSUE, PV_FACTOR, PV_CONDITION,PV_TREATMENT,PV_CALLER,PV_REPLICATE)

pv.contrastDesign <- function(pv, design, contrast, name1, name2, bGetNames=FALSE){
   
   # Check if contrast already exists
   if(!missing(contrast)) {
      for(con in pv$contrasts){
         if(identical(con$contrast,contrast)) {
            message("Contrast already present.")
            return(pv)
         }
      }
   }
   
   # Check if design already exists
   newdesign <- FALSE
   if(!missing(design)) {
      if(is.logical(design)) {
         if(is.character(contrast) && length(contrast)==3) {
            design <- pv.generateSimpleDesign(pv,addfactor=contrast[1])
         } else {
            design <- pv$design
         }
      } 
      if(pv.isDesign(pv$design)) {
         if(design != pv$design) {
            if(!is.null(pv$DESeq2)) {
               newdesign <- TRUE
               if(!is.null(pv$DESeq2$DEdata)) {
                  message("Replacing design and removing analysis.")
               } else {
                  message("Replacing design.")
               }
               pv$DESeq2 <- pv$edgeR <- NULL
            } else {
               message("Replacing design.")
            }
         }
      }
   } else {
      if(is.null(pv$design)) {
         stop("No design specified.",call.=FALSE)
      } else {
         design <- pv$design
      }
   }
   
   varnames <-  pv.checkDesign(design)
   pv$design <- design
   
   if(is.null(pv$DESeq2$names)) {
      pv$DESeq2$names <- pv.DESeq2ResultsNames(pv)
   }
   
   # Check if contrasts exist and are compatible with design
   if(!is.null(pv$contrasts)) {
      for(i in 1:length(pv$contrasts)) {
         if(!is.null(pv$contrasts[[i]]$contrast)) {
            pv$contrasts[[i]]$contrastType <- 
               pv.checkContrast(pv,varnames,pv$contrasts[[i]]$contrast)
            if(newdesign) {
               pv$contrasts[[i]]$DESeq2 <- NULL
               pv$contrasts[[i]]$edgeR  <- NULL
            }
         }
      }
   }
   
   if(bGetNames) {
      if(is.null(pv$design)) {
         stop("Can't get names: no design.",call.=FALSE)
      }
      return(pv$DESeq2$names)
   }
   
   # Check new contrast and add   
   if(!missing(contrast)) {
      crec <- NULL
      crec$contrastType <- pv.checkContrast(pv,varnames,contrast)
      if(!is.null(crec$contrastType)) {
         crec$contrast <- contrast
         if(missing(name1)) {
            if(crec$contrastType=='simple') {
               crec$name1 = contrast[2]
            } else if(crec$contrastType=='byname') {
               crec$name1 = contrast[1]
            } else if(crec$contrastType=='byresults1' || crec$contrastType=='byresults2') {
               crec$name1 = contrast[[1]]
            }
         } else crec$name1 <- name1
         if(missing(name2)) {
            if(crec$contrastType=='simple') {
               crec$name2 = contrast[3]
            } else if(crec$contrastType=='byresults2') {
               crec$name2 = contrast[[2]]
            }
         } else crec$name2 <- name2
         if(crec$contrastType=='simple') {
            crec$group1 <- pv.getSamplesForFactorVal(pv,contrast[1],contrast[2])
            crec$group2 <- pv.getSamplesForFactorVal(pv,contrast[1],contrast[3])    
            if(sum(crec$group1)<=1 || sum(crec$group2)<=1) {
               stop("Invalid contrast: no replicates in one group.")
            }
         }   
         pv$contrasts <- pv.listadd(pv$contrasts,crec) 
      } else {
         warning("Empty contrast",call.=FALSE)
      }
   }
   
   # Return DBA object
   return(pv)
}

pv.checkDesign <- function(design) {
   if(is.null(design)) {
      return(NULL)
   }
   varnames <- all.vars(formula(design))
   matches <- varnames %in% pv.FactorNames
   if(sum(matches) != length(varnames)) {
      message <- paste("Invalid factors in design:",paste(varnames[!matches],collapse=','))
      stop(message,call.=FALSE)
   }
   return(varnames)
}

pv.compareDesigns <- function(oldd, newd){
   oldv <-  all.vars(formula(oldd))
   newv <-  all.vars(formula(newd))
   if(all(newv %in% oldv)) {
      return(oldd)
   } else {
      return(newd)
   }
}

pv.DESeq2ResultsNames <- function(pv) {
   if(is.null(pv$design)) {
      stop('No design specified',call.=FALSE)
   }
   if(is.null(pv$DESeq2$names)) {
      message("Computing results names...")
      res <- suppressMessages(pv.DEinitDESeq2(pv,numReads=10))
      DESeq2::sizeFactors(res) <- rep(1,ncol(res))
      res <- suppressWarnings(suppressMessages(
         DESeq2::estimateDispersionsGeneEst(res,quiet=TRUE,maxit=10)))
      DESeq2::dispersions(res) <- S4Vectors::mcols(res)$dispGeneEst
      res <- suppressWarnings(suppressMessages(
         DESeq2::nbinomWaldTest(res, maxit=10, quiet=TRUE,useOptim=FALSE)))      
      names <- DESeq2::resultsNames(res)
   } else {
      names <- pv$DESeq2$names
   }
   return(names)
}

pv.checkContrast <- function(pv,varnames,contrast) {
   
   # What type of contrast description is this?
   simple <- byname <- bycolumn <- byresults1 <- byresults2 <- FALSE
   if(is(contrast,"character")) {
      if(length(contrast) == 3) {
         simple <- TRUE
      } else if (length(contrast)== 1) {
         byname <- TRUE
      } else {
         stop('Invalid contrast. Character vector must be length 1 or 3.',call.=FALSE)
      }
   } else if(is(contrast,"numeric") || is(contrast,"integer")) {
      bycolumn <- TRUE
   } else if(is(contrast,"list")) { 
      if(length(contrast)==1) {
         byresults1 <- TRUE    
      } else if (length(contrast)==2) {
         byresults2 <- TRUE
      } else {
         stop('Invalid contrast. List must be length 1 or 2.',call.=FALSE)
      }
   } else {
      stop('Invalid contrast.',call.=FALSE)
   }
   
   if(simple) {
      facName <- contrast[1]
      if(!facName %in% varnames) {
         message <- paste("Contrast factor not present in design:",contrast[1])
         stop(message,call.=FALSE)
      }
      for(facVal in contrast[2:3]) {
         if (!sum(facVal %in% pv$class[facName,])) {
            message <- paste("Contrast value not valid for factor:",facVal)
         }
      }
      return('simple')
   } else {
      names <- pv.DESeq2ResultsNames(pv)
      if(byname) {
         if (!contrast %in% names ) {
            stop('Invalid contrast. Single name must match one of design column names.',call.=FALSE)
         }
         return('byname')
      } else if(bycolumn) {
         if(length(contrast) != length(names)) {
            stop('Invalid contrast. Numeric vector must be same length as number of columns in design.',call.=FALSE)
         }
         return('bycolumn')
      } else if(byresults1 || byresults2) {
         if(!contrast[[1]] %in% names) {
            stop('Invalid contrast. Names in list must match one of design column names.',call.=FALSE)
         }  
         if(byresults1) {
            return('byresults1')
         } else if(byresults2) {
            if(!contrast[[2]] %in% names) {
               stop('Invalid contrast. Names in list must match one of design column names.',call.=FALSE)
            }  
            return('byresults2')
         } 
      }
   }
   
   return(NULL)
}

pv.getSamplesForFactorVal <- function(pv,facID,facVal){
   samples <-  pv$class[facID,] %in% facVal
   names(samples) <- pv$class[PV_ID,]
   return(samples)
}

pv.generateDesignFromContrasts <- function(pv,attributes=pv.FactorVals,
                                           bGetNames=FALSE,addfac=NULL) {
   factors <- addfac
   for(con in 1:length(pv$contrasts)) {
      cont <- pv$contrasts[[con]]
      factor1 <- NULL
      factor2 <- NULL
      for(fac in attributes) {
         if(cont$name1 %in% pv$class[fac,]) {
            factor1 <- fac
         }
         if(cont$name2 %in% pv$class[fac,]) {
            factor2 <- fac
         }
      }
      if(is.null(factor1) || is.null(factor2)) {
         stop('Unable to generate design, unknown values',call.=FALSE)
      }
      if(factor1 != factor2) {
         stop('Unable to generate design, unknown values',call.=FALSE)            
      }
      factors <- unique(c(factors,factor1))
      pv$contrasts[[con]]$contrast <- c(pv.FactorNames[match(factor1,pv.FactorVals)],
                                        cont$name1,cont$name2)
      pv$contrasts[[con]]$contrastType <- 'simple'
   }
   
   factors <- pv.FactorNames[match(factors,pv.FactorVals)]
   pv$design <- paste("~",paste(factors,collapse =" + "),sep="")
   if(bGetNames) {
      pv$DESeq2$names <- pv.DESeq2ResultsNames(pv)
   }
   return(pv)
}

pv.generateSimpleDesign <- function(pv,addfactor) {
   if(!is.null(pv$design)) {
      varnames <- pv.checkDesign(pv$design)
   } else {
      varnames <- NULL
   }
   if(addfactor %in% varnames) {
      return(pv$design)
   }
   varnames <- unique(c(varnames,addfactor))
   design <- paste("~",paste(varnames,collapse =" + "),sep="")
   return(design)
}

pv.getContrastString <- function(conrec, bFlip=FALSE) {
   if(!is.null(conrec$contrastType)) {
      constr <- conrec$contrast
      if(conrec$contrastType=='bycolumn') {
         constr <- paste(constr,collapse=":")
      } else if(conrec$contrastType=='byresults1') {
         constr <- constr[[1]]
      } else if(conrec$contrastType=='byresults2') {
         if(bFlip==TRUE) {
            constr <- paste(constr[[2]],"vs.",constr[[3]])
         } else {
            constr <- paste(constr[[1]],"vs.",constr[[2]])
         }
      } else if(length(constr) == 2) {
         if(bFlip==TRUE) {
            constr <- paste(constr[2],"vs.",constr[1 ])   
         } else {
            constr <- paste(constr[1],"vs.",constr[2])      
         }
      } else if(length(constr) == 3)  {
         if(bFlip==TRUE) {
            constr <- paste(constr[3],"vs.",constr[2])   
         } else {
            constr <- paste(constr[2],"vs.",constr[3])    
         }
      }
   } else {
      if(bFlip==TRUE) {
         constr <- paste(conrec$name2, "vs.", conrec$name1)         
      } else {
         constr <- paste(conrec$name1, "vs.", conrec$name2)
      }
   }
   return(constr)
}


pv.orderMetaFacs <- function(pv, reorderMeta) {
   meta <- pv$class[pv.FactorVals,]
   meta <- data.frame(t(meta),stringsAsFactors = TRUE)
   
   if(is.null(pv$meta)) { # First time
      for(facname in pv.FactorNames) {
         if(facname=="Caller") {
            facname <- "Peak.caller"
         }
         mfactor <- match(facname,names(meta))
         vals <- as.character(meta[,mfactor])
         pv$meta <- pv.listadd(pv$meta,unique(vals))
      }
      names(pv$meta) <- pv.FactorNames
   }
   
   if(!missing(reorderMeta)) {
      if(is(reorderMeta,"list")) {
         for(i in 1:length(reorderMeta)) {
            facname <- names(reorderMeta)[i]
            mfactor <- match(facname,names(pv$meta))
            if(is.na(mfactor)[1]) {
               stop("Unknown metadata factor: ",facname,call.=FALSE)
            }
            vals <- unique(as.character(meta[,mfactor]))
            facs <- reorderMeta[[i]]
            matches <- match(facs,vals)
            if(sum(is.na(matches))) {
               stop("Invalid values for factor ",facname,call.=FALSE)
            }
            if(length(vals) > length(facs)) {
               vals <- vals[-matches]
               facs <- c(facs,vals)
            }
            pv$meta[[mfactor]] <- facs
         }
         pv$DESeq2 <- pv$edgeR <- NULL
         #pv <- pv.CheckReleveledContrasts(pv)
      } else {
         stop("reorderMeta must be a list.",call.=FALSE)
      }
   }
   return(pv)
}

pv.getMeta <- function(pv) {
   
   if(is.null(pv$meta)) {
      pv <- pv.orderMetaFacs(pv)
   }
   
   meta <- pv$class[pv.FactorVals,]
   meta <- data.frame(t(meta),stringsAsFactors = TRUE) 
   
   for(i in 1:ncol(meta)) {
      meta[,i] <- factor(as.character(meta[,i]),pv$meta[[i]])
   }
   
   return(meta)
}

pv.CheckReleveledContrasts <- function(pv) {
   
   if(is.null(pv$contrasts) || !pv.isDesign(pv$design)) {
      return(pv)
   }
   
   pv$DESeq2$names <- names <- pv.DESeq2ResultsNames(pv)
   toremove <- NULL
   for(i in 1:length(pv$contrasts)) {
      con <- pv$contrasts[[i]]
      if(!is.null(con$contrastType)) {
         if(con$contrastType=="bycolumn") {
            toremove <- c(toremove,i)   
         } else if(con$contrastType=="byname") {
            if (!con$contrast %in% names ) {
               toremove <- c(toremove,i)
            }
         } else if(con$contrastType=="byresults1" || con$contrastType=="byresults2") {
            if(!con$contrast[[1]] %in% names) {
               toremove <- c(toremove,i)
            } else if(con$contrastType=="byresults2") {
               if(!con$contrast[[2]] %in% names) {
                  toremove <- c(toremove,i)
               }
            }
         }
      }
   }
   
   if(length(toremove)>0) {
      toremove <- sort(unique(toremove))
      for(i in toremove) {
         warning("Removing contrast: ",i,call.=FALSE)
      }
      pv$contrasts <- pv$contrasts[-toremove]
   }
   
   return(pv)
} 

pv.isDesign <- function(design) {
   if(is.null(design)) {
      return(FALSE)
   }
   
   if(is(design,"logical")) {
      return(design)
   }
   
   return(TRUE)
}

pv.checkContrastOrder <- function(contrasts, meta) {
   for(i in length(contrasts)) {
      con <- contrasts[[i]]
      for(fac in meta) {
         n1 <- fac %in% con$name1
         n2 <- fac %in% con$name2
         if(sum(n1) && sum(n2)) {
            if(which(n2) > which(n1)) {
               g1 <- con$group1
               n1 <- con$name1
               con$group1 <- con$group2
               con$name1  <- con$name2
               con$group2 <- g1
               con$name2  <- n1
               contrasts[[i]] <- con
            }
         }
      }
   }
   return(contrasts)
}

\name{DiffBind -- DBA global constant variables}
\alias{DBA_ID}
\alias{DBA_FACTOR}
\alias{DBA_TISSUE}
\alias{DBA_CONDITION}
\alias{DBA_TREATMENT}
\alias{DBA_REPLICATE}
\alias{DBA_CALLER}
\alias{DBA_CONSENSUS}
\alias{DBA_CONTROL}
\alias{DBA_READS}
\alias{DBA_ALL_ATTRIBUTES}
\alias{DBA_INTERVALS}
\alias{DBA_FRIP}
\alias{DBA_GROUP}
\alias{DBA_OLAP_PEAKS}
\alias{DBA_OLAP_ALL}
\alias{DBA_OLAP_RATE}
\alias{DBA_COR}
\alias{DBA_OLAP}
\alias{DBA_INALL}
\alias{DBA_SCORE_READS}
\alias{DBA_SCORE_CONTROL_READS}
\alias{DBA_SCORE_READS_MINUS}
\alias{DBA_SCORE_READS_FULL}
\alias{DBA_SCORE_READS_MINUS_FULL}
\alias{DBA_SCORE_READS_EFFECTIVE}
\alias{DBA_SCORE_READS_MINUS_EFFECTIVE}
\alias{DBA_SCORE_READS_FOLD}
\alias{DBA_SCORE_RPKM}
\alias{DBA_SCORE_NORMALIZED}
\alias{DBA_SCORE_RPKM_FOLD}
\alias{DBA_SCORE_RPKM_MINUS}
\alias{DBA_SCORE_TMM_READS_FULL}
\alias{DBA_SCORE_TMM_READS_EFFECTIVE}
\alias{DBA_SCORE_TMM_MINUS_FULL}
\alias{DBA_SCORE_TMM_MINUS_EFFECTIVE}
\alias{DBA_SCORE_TMM_READS_FULL_CPM}
\alias{DBA_SCORE_TMM_READS_EFFECTIVE_CPM}
\alias{DBA_SCORE_TMM_MINUS_FULL_CPM}
\alias{DBA_SCORE_TMM_MINUS_EFFECTIVE_CPM}
\alias{DBA_SCORE_SUMMIT}
\alias{DBA_SCORE_SUMMIT_ADJ}
\alias{DBA_SCORE_SUMMIT_POS}
\alias{DBA_READS_DEFAULT}
\alias{DBA_READS_BAM}
\alias{DBA_READS_BED}
\alias{DBA_EDGER}
\alias{DBA_DESEQ2}
\alias{DBA_EDGER_BLOCK}
\alias{DBA_DESEQ2_BLOCK}
\alias{DBA_EDGER_GLM}
\alias{DBA_ALL_METHODS}
\alias{DBA_ALL_BLOCK}
\alias{DBA_ALL_METHODS_BLOCK}
\alias{DBA_DATA_FRAME}
\alias{DBA_DATA_GRANGES}
\alias{DBA_DATA_RANGEDDATA}
\alias{DBA_DATA_SUMMARIZED_EXPERIMENT}
\alias{DBA_DATA_DBAOBJECT}
\alias{DBA_BLACKLIST_CE10}
\alias{DBA_BLACKLIST_CE11}
\alias{DBA_BLACKLIST_DM3}
\alias{DBA_BLACKLIST_DM6}
\alias{DBA_BLACKLIST_GRCH37} 
\alias{DBA_BLACKLIST_GRCH38}
\alias{DBA_BLACKLIST_HG19}
\alias{DBA_BLACKLIST_HG38}
\alias{DBA_BLACKLIST_MM9}
\alias{DBA_BLACKLIST_MM10} 
\alias{DBA_BLACKLIST}
\alias{DBA_GREYLIST}
\alias{DBA_BLACKLISTED_PEAKS}
\alias{DBA_LIBSIZE_DEFAULT}
\alias{DBA_LIBSIZE_FULL}
\alias{DBA_LIBSIZE_PEAKREADS}
\alias{DBA_LIBSIZE_BACKGROUND}
\alias{DBA_LIBSIZE_USER}
\alias{DBA_NORM_DEFAULT}
\alias{DBA_NORM_NATIVE}
\alias{DBA_NORM_LIB}
\alias{DBA_NORM_TMM}
\alias{DBA_NORM_RLE}
\alias{DBA_NORM_SPIKEIN}
\alias{DBA_NORM_USER}
\alias{DBA_NORM_OFFSETS}
\alias{DBA_NORM_OFFSETS_ADJUST}
\alias{DBA_OFFSETS_LOESS}
\alias{DBA_OFFSETS_USER}
\alias{DBA_SCORE_FOLD}          
\alias{DBA_SCORE_CONCENTRATION}    
\alias{DBA_SCORE_CONC_NUMERATOR}   
\alias{DBA_SCORE_CONC_DENOMINATOR} 
\alias{DBA_SCORE_PVAL}             
\alias{DBA_SCORE_FDR}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Constant variables used in DiffBind package
}
\description{
Constant variables used in DiffBind package
}
\usage{
DBA_ID
DBA_FACTOR
DBA_TISSUE
DBA_CONDITION
DBA_TREATMENT
DBA_REPLICATE
DBA_CALLER
DBA_CONSENSUS
DBA_CONTROL
DBA_READS
DBA_ALL_ATTRIBUTES

DBA_INTERVALS
DBA_FRIP

DBA_GROUP

DBA_OLAP_PEAKS
DBA_OLAP_ALL
DBA_OLAP_RATE

DBA_COR
DBA_OLAP
DBA_INALL

DBA_SCORE_READS
DBA_SCORE_NORMALIZED
DBA_SCORE_CONTROL_READS
DBA_SCORE_READS_MINUS
DBA_SCORE_READS_FULL
DBA_SCORE_READS_MINUS_FULL
DBA_SCORE_READS_EFFECTIVE
DBA_SCORE_READS_MINUS_EFFECTIVE
DBA_SCORE_READS_FOLD
DBA_SCORE_RPKM
DBA_SCORE_RPKM_FOLD
DBA_SCORE_RPKM_MINUS
DBA_SCORE_TMM_READS_FULL
DBA_SCORE_TMM_READS_EFFECTIVE
DBA_SCORE_TMM_MINUS_FULL
DBA_SCORE_TMM_MINUS_EFFECTIVE
DBA_SCORE_TMM_READS_FULL_CPM
DBA_SCORE_TMM_READS_EFFECTIVE_CPM
DBA_SCORE_TMM_MINUS_FULL_CPM
DBA_SCORE_TMM_MINUS_EFFECTIVE_CPM
DBA_SCORE_SUMMIT
DBA_SCORE_SUMMIT_ADJ
DBA_SCORE_SUMMIT_POS
DBA_SCORE_FOLD          
DBA_SCORE_CONCENTRATION    
DBA_SCORE_CONC_NUMERATOR   
DBA_SCORE_CONC_DENOMINATOR 
DBA_SCORE_PVAL             
DBA_SCORE_FDR

DBA_READS_DEFAULT
DBA_READS_BAM
DBA_READS_BED

DBA_EDGER
DBA_DESEQ2
DBA_EDGER_BLOCK
DBA_DESEQ2_BLOCK
DBA_EDGER_GLM
DBA_ALL_METHODS
DBA_ALL_BLOCK
DBA_ALL_METHODS_BLOCK

DBA_DATA_FRAME
DBA_DATA_GRANGES
DBA_DATA_RANGEDDATA
DBA_DATA_SUMMARIZED_EXPERIMENT
DBA_DATA_DBAOBJECT

DBA_BLACKLIST_CE10
DBA_BLACKLIST_CE11
DBA_BLACKLIST_DM3
DBA_BLACKLIST_DM6
DBA_BLACKLIST_GRCH37
DBA_BLACKLIST_GRCH38
DBA_BLACKLIST_HG19
DBA_BLACKLIST_HG38
DBA_BLACKLIST_MM9
DBA_BLACKLIST_MM10
DBA_BLACKLIST
DBA_GREYLIST
DBA_BLACKLISTED_PEAKS

DBA_LIBSIZE_DEFAULT
DBA_LIBSIZE_FULL
DBA_LIBSIZE_PEAKREADS
DBA_LIBSIZE_BACKGROUND
DBA_LIBSIZE_USER
DBA_NORM_DEFAULT
DBA_NORM_NATIVE
DBA_NORM_LIB
DBA_NORM_TMM
DBA_NORM_RLE
DBA_NORM_SPIKEIN
DBA_NORM_USER
DBA_NORM_OFFSETS
DBA_NORM_OFFSETS_ADJUST
DBA_OFFSETS_LOESS
DBA_OFFSETS_USER

}

%- maybe also 'usage' for other objects documented here.
\arguments{
\item{DBA_ID}{
DBA peakset metadata: Peakset ID
}
\item{DBA_FACTOR}{
DBA peakset metadata: Factor
}
\item{DBA_TISSUE}{
DBA peakset metadata: Tissue
}
\item{DBA_CONDITION}{
DBA peakset metadata: Condition
}
\item{DBA_TREATMENT}{
DBA peakset metadata: Treatment
}
\item{DBA_REPLICATE}{
DBA peakset metadata: Replicate
}
\item{DBA_CALLER}{
DBA peakset metadata: Peak Caller
}
\item{DBA_CONSENSUS}{
DBA peakset metadata: Is this a consensus peakset?
}
\item{DBA_CONTROL}{
DBA peakset metadata: ID of Control sample
}
\item{DBA_READS}{
Number of reads counted in BAM file.
}
\item{DBA_ALL_ATTRIBUTES}{
DBA peakset metadata: all attributes that can be used in certain plot labels (cf \code{\link{dba.plotVenn}}), equivalent to \code{c(DBA_ID, DBA_TISSUE, DBA_FACTOR, DBA_CONDITION,DBA_TREATMENT, DBA_REPLICATE, DBA_CALLER)} 
}
\item{DBA_INTERVALS}{
DBA peakset metadata: Number of intervals in peakset
}
\item{DBA_FRIP}{
DBA peakset metadata: Fraction of Reads in Peaks (number of reads in intervals divided by total number of reads in library)
}

\item{DBA_GROUP}{
DBA peakset metadata: color PCA plot using contras groups
}

\item{DBA_OLAP_PEAKS}{
dba.overlap mode: return overlapping/unique peaksets
}
\item{DBA_OLAP_ALL}{
dba.overlap mode: return report of correlations/overlaps for each pair of samples
}
\item{DBA_OLAP_RATE}{
dba.overlap mode: return overlap rates
}
\item{DBA_COR}{
When plotting a heatmap from an overlap record, use the correlation value.
}
\item{DBA_OLAP}{
When plotting a heatmap from an overlap record, use the percentage overlap value.
}
\item{DBA_INALL}{
When plotting a heatmap from an overlap record, use the number of peaks in common to both samples.
}


\item{DBA_SCORE_READS}{
dba.count score is number of reads in ChIP
}
\item{DBA_SCORE_CONTROL_READS}{
dba.count score is number of reads in Control
}
\item{DBA_SCORE_READS_FOLD}{
dba.count score is number of reads in ChIP divided by number of reads in Control
}
\item{DBA_SCORE_READS_MINUS}{
dba.count score is number of reads in ChIP minus  number of reads in Control
}

\item{DBA_SCORE_READS_FULL}{
dba.count score is normalized ChIP read counts, using Full Library size
}
\item{DBA_SCORE_READS_MINUS_FULL}{
dba.count score is normalized ChIP read counts minus Control read counts, using Full Library size
}
\item{DBA_SCORE_READS_EFFECTIVE}{
dba.count score is normalized ChIP read counts, using Effective Library size
}
\item{DBA_SCORE_READS_MINUS_EFFECTIVE}{
dba.count score is normalized ChIP read counts minus Control read counts, using Effective Library size
}

\item{DBA_SCORE_NORMALIZED}{
dba.count score is normalized reads
}

\item{DBA_SCORE_RPKM}{
dba.count score is RPKM of ChIP 
}
\item{DBA_SCORE_RPKM_FOLD}{
dba.count score is RPKM of ChIP divided by RPKM of Control
}
\item{DBA_SCORE_RPKM_MINUS}{
dba.count score is RPKM of ChIP minus RPKM of Control
}

\item{DBA_SCORE_TMM_READS_FULL}{
dba.count score is TMM normalized (using edgeR), using ChIP read counts and Full Library size
}
\item{DBA_SCORE_TMM_READS_EFFECTIVE}{
dba.count score is TMM normalized (using edgeR), using ChIP read counts and Effective Library size
}
\item{DBA_SCORE_TMM_MINUS_FULL}{
dba.count score is TMM normalized (using edgeR), using ChIP read counts minus Control read counts and Full Library size
}
\item{DBA_SCORE_TMM_MINUS_EFFECTIVE}{
dba.count score is TMM normalized (using edgeR), using ChIP read counts minus Control read counts and Effective Library size
}

\item{DBA_SCORE_TMM_READS_FULL_CPM}{
dba.count score is TMM normalized (using edgeR), using ChIP read counts and Full Library size, reported in counts-per-million.
}
\item{DBA_SCORE_TMM_READS_EFFECTIVE_CPM}{
dba.count score is TMM normalized (using edgeR), using ChIP read counts and Effective Library size, reported in counts-per-million.
}
\item{DBA_SCORE_TMM_MINUS_FULL_CPM}{
dba.count score is TMM normalized (using edgeR), using ChIP read counts minus Control read counts and Full Library size, reported in counts-per-million.
}
\item{DBA_SCORE_TMM_MINUS_EFFECTIVE_CPM}{
dba.count score is TMM normalized (using edgeR), using ChIP read counts minus Control read counts and Effective Library size, reported in counts-per-million. 
}
\item{DBA_SCORE_SUMMIT}{
dba.count score is summit height (highest pile-up).
}
\item{DBA_SCORE_SUMMIT_ADJ}{
dba.count score is summit height (highest pile-up), adjusted for library size.
}
\item{DBA_SCORE_SUMMIT_POS}{
dba.count score is summit location (position of highest pile-up).
}

\item{DBA_SCORE_FOLD}{
score for report-based DBA object is Log Fold Change.
}          
\item{DBA_SCORE_CONCENTRATION}{
score for report-based DBA object is Log Mean Concentration.
}         
\item{DBA_SCORE_CONC_NUMERATOR}{
score for report-based DBA object is Log Mean Concentration
of numerator (first group in contrast).
}        
\item{DBA_SCORE_CONC_DENOMINATOR}{
score for report-based DBA object isLog Mean Concentration
of denominator (second group in contrast).
}      
\item{DBA_SCORE_PVAL}{
score for report-based DBA object is p-value.
}                  
\item{DBA_SCORE_FDR}{
score for report-based DBA object is FDR.
}     

\item{DBA_READS_DEFAULT}{
When counting read files, use the file extension to determine the file type.
}
\item{DBA_READS_BAM}{
When counting read files, assume the file type is BAM, regardless of the file extension.
}
\item{DBA_READS_BED}{
When counting read files, assume the file type is BED (or zipped BED), regardless of the file extension.
}

\item{DBA_EDGER}{
differential analysis method: edgeR (default: DBA_EDGER_GLM)
}
\item{DBA_DESEQ2}{
differential analysis method: DESeq2 (using a single-factor GLM)
}
\item{DBA_EDGER_BLOCK}{
differential analysis method: edgeR with blocking factors (GLM)
}
\item{DBA_DESEQ2_BLOCK}{
differential analysis method: DESeq2 with blocking factors (GLM)
}

\item{DBA_EDGER_GLM}{
differential analysis method: use GLM in edgeR for two-group comparisons
}
\item{DBA_ALL_METHODS}{
use both analysis methods: \code{c(DBA_EDGER, DBA_DESEQ2)}
}
\item{DBA_ALL_BLOCK}{
report on block results for both analysis methods: \code{c(DBA_EDGER_BLOCK, DBA_DESEQ2_BLOCK)}
}
\item{DBA_ALL_METHODS_BLOCK}{
report on block results for all analysis methods, both blocked and unblocked: \code{c(DBA_ALL_METHODS, DBA_ALL_BLOCK)}
}

\item{DBA_DATA_GRANGES}{
Use GRanges class for peaksets and reports. This is the  default (DBA$config$DataType = DBA_DATA_GRANGES).
}
\item{DBA_DATA_RANGEDDATA}{
Use RangedData class for peaksets and reports. Can be set as default (DBA$config$DataType = DBA_DATA_RANGEDDATA).
}
\item{DBA_DATA_FRAME}{
Use data.frame class for peaksets and reports. Can be set as default (DBA$config$DataType = DBA_DATA_FRAME).
}
\item{DBA_DATA_SUMMARIZED_EXPERIMENT}{
Return report as a \code{\link{SummarizedExperiment}}.
}
\item{DBA_DATA_DBAOBJECT}{
Return a result-based DBA object from \code{\link{dba.plotVenn}}.
}

\item{DBA_BLACKLIST_HG19}{Homo sapiens 19 (chromosomes have "chr")}
\item{DBA_BLACKLIST_HG38}{Homo sapiens 38 (chromosomes have "chr")}  
\item{DBA_BLACKLIST_GRCH37}{Homo sapiens 37 (chromosomes are numbers)}
\item{DBA_BLACKLIST_GRCH38}{Homo sapiens 38 (chromosomes are numbers)}
\item{DBA_BLACKLIST_MM9}{Mus musculus 9 }
\item{DBA_BLACKLIST_MM10}{Mus musculus 10}
\item{DBA_BLACKLIST_CE10}{C. elegans 10}
\item{DBA_BLACKLIST_CE11}{C. elegans 11}
\item{DBA_BLACKLIST_DM3}{Drosophila melanogaster 3}
\item{DBA_BLACKLIST_DM6}{Drosophila melanogaster 6}
\item{DBA_BLACKLIST}{Retrieve blacklist}
\item{DBA_GREYLIST}{Retrieve greylist}
\item{DBA_BLACKLISTED_PEAKS}{Retrieve blacklisted peaks}

\item{DBA_LIBSIZE_DEFAULT}{Default library size
(\code{DBA_LIBSIZE_FULL} if no background, and \code{DBA_LIBSIZE_CHR} if
background present)}
\item{DBA_LIBSIZE_FULL}{Full library size (all reads in library)}
\item{DBA_LIBSIZE_PEAKREADS}{Library size is Reads in Peaks}
\item{DBA_LIBSIZE_BACKGROUND}{Library size is Reads in  Background}
\item{DBA_LIBSIZE_USER}{User supplied library sizes}
\item{DBA_NORM_DEFAULT}{Default normalization method}
\item{DBA_NORM_NATIVE}{"Native"" normalization method 
(TMM for \code{DBA_EDGER} and RLE for \code{DBA_DESEQ2})}
\item{DBA_NORM_LIB}{Normalize by library size only}
\item{DBA_NORM_TMM}{Normalize using TMM method (\code{edgeR})}
\item{DBA_NORM_RLE}{Normalize using RLE method (\code{DESeq2})}
\item{DBA_NORM_SPIKEIN}{Normalize based on spike-ins}
\item{DBA_NORM_USER}{User supplied normalization factors}
\item{DBA_NORM_OFFSETS}{Use offsets instead of normalization factors}
\item{DBA_NORM_OFFSETS_ADJUST}{Use offsets instead of normalization factors; 
adjust based on library size (DESeq) }
\item{DBA_OFFSETS_LOESS}{Compute offsets using loess fit}
\item{DBA_OFFSETS_USER}{Use offsetrs supplied by user}
}
%\details{
%%
%}
%\value{
%}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
\note{
Variables with ALL CAP names are used as constants within \code{DiffBind}.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
%\examples{
%}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{DBA tamoxifen resistance dataset}
\alias{tamoxifen}
\alias{tamoxifen_peaks}
\alias{tamoxifen_counts}
\alias{tamoxifen_analysis}
\alias{tamoxifen_greylist}
\alias{tamoxifen.greylist}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Tamoxifen resistance dataset used for DBA examples
}
\description{
Tamoxifen resistance dataset used for DBA examples
}
\usage{
data(tamoxifen_peaks)

data(tamoxifen_counts)

data(tamoxifen_analysis)

data(tamoxifen_greylist)
}

%- maybe also 'usage' for other objects documented here.
\arguments{
\item{tamoxifen_peaks}{
load tamoxifen resistance dataset DBA object with peak (occupancy) data
}
\item{tamoxifen_counts}{
load tamoxifen resistance dataset DBA object with count (affinity) data.
Also includes background bins counts for background normalization.
}

\item{tamoxifen_analysis}{
load tamoxifen resistance dataset DBA object with count (affinity) data 
and \code{DESeq2}-based differential binding analysis results.
This analysis uses a blacklists, computed greylists,
 background normalization, and a two-factor design.
}

\item{tamoxifen_greylist}{
load greylist for tamoxifen dataset. 
Generated as shown in \code{dba.blacklist} example: \code{\link{dba.blacklist}}.
}
}
\details{
The tamoxifen resistance dataset is used for the DBA vignette 
and man page examples. 

Data used to create these objects can be downloaded at
\url{https://content.cruk.cam.ac.uk/bioinformatics/software/DiffBind/DiffBind_vignette_data.tar.gz}.
}
\value{
loads a DBA object named \code{tamoxifen} (or \code{tamoxifen.greylist}).
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
\note{
The script for generating these files (\code{GenerateDataFiles.R})
is included with the package in the \code{inst/extras} directory.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
\examples{
data(tamoxifen_peaks)
tamoxifen
data(tamoxifen_counts)
plot(tamoxifen)
data(tamoxifen_analysis)
dba.plotMA(tamoxifen)
data(tamoxifen_greylist)
tamoxifen.greylist$master
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba}
\alias{dba}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Construct a DBA object
}
\description{
Constructs a new DBA object from a sample sheet, 
or based on an existing DBA object
}
\usage{
dba(DBA,mask, minOverlap=2,
    sampleSheet="dba_samples.csv", 
    config=data.frame(AnalysisMethod=DBA_DESEQ2,th=0.05,
                      DataType=DBA_DATA_GRANGES, RunParallel=TRUE, 
                      minQCth=15, fragmentSize=125, 
                      bCorPlot=FALSE, reportInit="DBA", 
                      bUsePval=FALSE, design=TRUE,
                      doBlacklist=TRUE, doGreylist=TRUE),
    peakCaller="raw", peakFormat, scoreCol, bLowerScoreBetter, 
    filter, skipLines=0, 
    bAddCallerConsensus=FALSE, 
    bRemoveM=TRUE, bRemoveRandom=TRUE, 
    bSummarizedExperiment=FALSE,
    attributes, dir)  
}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Optional or defaulted arguments}{}

  \item{DBA}{
existing DBA object -- if present, will return a fully-constructed DBA object
based on the passed one,
using criteria specified in the \code{mask} and/or \code{minOverlap} parameters. 
If missing, will create a new DBA object based on the \code{sampleSheet}.
}
\item{mask}{
logical or numerical vector indicating which peaksets to include 
in the resulting model if basing DBA object on an existing one. 
See  \code{\link{dba.mask}}.
}
\item{minOverlap}{
only include peaks in at least this many peaksets in the main binding matrix
if basing DBA object on an existing one. 
If \code{minOverlap} is between zero and one, peak will be included from at
least this proportion of peaksets.
}
\item{sampleSheet}{
data frame containing sample sheet, or file name of sample sheet to load 
(ignored if DBA is specified). 
Columns names in sample sheet may include:
\describe{
\item{\code{SampleID:}}{Identifier string for sample. 
Must be unique for each sample.}
\item{\code{Tissue:}}{Identifier string for tissue type}
\item{\code{Factor:}}{Identifier string for factor}
\item{\code{Condition:}}{Identifier string for condition}
\item{\code{Treatment:}}{Identifier string for treatment}
\item{\code{Replicate:}}{Replicate number of sample}
\item{\code{bamReads:}}{file path for bam file containing aligned reads for ChIP sample}
\item{\code{bamControl:}}{file path for bam file containing aligned reads for control sample}
\item{\code{Spikein:}}{file path for bam file containing aligned spike-in reads}
\item{\code{ControlID:}}{Identifier string for control sample}
\item{\code{Peaks:}}{path for file containing peaks for sample. 
Format determined by PeakCaller field or caller parameter}
\item{\code{PeakCaller:}}{Identifier string for peak caller used. 
If Peaks is not a bed file, this will determine how the Peaks file is parsed. 
If missing, will use default peak caller specified in caller parameter. Possible values:}
\describe{
\item{\dQuote{raw}:}{text file file; peak score is in fourth column}
\item{\dQuote{bed}:}{.bed file; peak score is in fifth column}
\item{\dQuote{narrow}:}{default peak.format: narrowPeaks file}
\item{\dQuote{macs}:}{MACS .xls file}
\item{\dQuote{swembl}:}{SWEMBL .peaks file}
\item{\dQuote{bayes}:}{bayesPeak file}
\item{\dQuote{peakset}:}{peakset written out using pv.writepeakset}
\item{\dQuote{fp4}:}{FindPeaks v4}
}
\item{\code{PeakFormat:}}{string indicating format for peak files; 
see PeakCaller and  \code{\link{dba.peakset}}}
\item{\code{ScoreCol:}}{column in peak files that contains peak scores}
\item{\code{LowerBetter:}}{logical indicating that lower scores signify better peaks}
\item{\code{Counts:}}{file path for externally computed read counts; 
see \code{\link{dba.peakset}}
(\code{counts} parameter)}
}
For sample sheets loaded from a file, the accepted formats are comma-separated values 
(column headers, followed by one line per sample), 
or Excel-formatted spreadsheets (\code{.xls} 
or \code{.xlsx} extension). 
Leading and trailing white space will be removed from all values, with a warning.
}
  \item{config}{
\code{list} containing configuration options, 
or file name of config file to load when constructing a new DBA object from a sample sheet.
\code{NULL} indicates no config file.

See \link{DBA-config} for full set of options. Relevant fields include:
\describe{
\item{\code{AnalysisMethod:}}{either \code{DBA_DESEQ2} or \code{DBA_EDGER}.}
\item{\code{th:}}{default threshold for reporting and 
plotting analysis results.}
\item{\code{DataType:}}{default class for peaks and reports
(\code{DBA_DATA_GRANGES, DBA_DATA_RANGEDDATA, or DBA_DATA_FRAME}).}
\item{\code{RunParallel:}}{logical indicating if counting and analysis 
operations should be run in parallel using multicore by default.}
\item{\code{minQCth:}}{numeric, for filtering reads based on mapping 
quality score; only reads with a mapping quality score
greater than or equal to this will be counted.}
\item{\code{fragmentSize:}}{numeric with mean fragment size.
Reads will be extended to this length before counting overlaps. 
May be a vector of lengths, one for each sample.}
\item{\code{bCorPlot:}}{logical indicating that a correlation heatmap 
should be plotted automatically}
\item{\code{ReportInit:}}{string to append to the beginning of saved 
report file names.}
\item{\code{bUsePval:}}{logical, default indicating whether to use FDR 
(\code{FALSE}) or p-values (\code{TRUE}).}
\item{\code{doBlacklist:}}{logical, whether to attempt to find and apply
a blacklist if none is present when running \code{\link{dba.analyze}}}.
\item{\code{doGreylist:}}{logical, whether to attempt to generate and apply 
a greylist if none is present when running \code{\link{dba.analyze}}}.
}
}
  \item{peakCaller}{
if a \code{sampleSheet} is specified, the default peak caller that will be used 
if the \code{PeakCaller} column is absent.
}
 \item{peakFormat}{
if a \code{sampleSheet} is specified, the default peak file format 
that will be used if the \code{PeakFormat} column is absent.
}
 \item{scoreCol}{
if a \code{sampleSheet} is specified, the default column  
in the peak files that will be used 
for scoring if the \code{ScoreCol} column is absent.
}
 \item{bLowerScoreBetter}{
if a \code{sampleSheet} is specified, the  sort order for peak scores 
if the \code{LowerBetter} column is absent.
}
 \item{filter}{
if a \code{sampleSheet} is specified, a filter value if the
\code{Filter} column is absent.
Peaks with scores lower than this value 
(or higher if \code{ bLowerScoreBetter} or \code{LowerBetter} is
\code{TRUE}) will be removed.
}
  \item{skipLines}{
if a \code{sampleSheet} is specified, the number of lines (ie header lines)
at the beginning of each peak file to skip.
}
  \item{bAddCallerConsensus}{
add a consensus peakset for each sample with more than one peakset 
(i.e. different peak callers) when constructing a new DBA object from a
\code{sampleSheet}.
}
  \item{bRemoveM}{
logical indicating whether to remove peaks on chrM (mitochondria) 
when constructing a new DBA object from a sample sheet.
}
\item{bRemoveRandom}{
logical indicating whether to remove peaks on chrN_random when 
constructing a new DBA object from a sample sheet.
}

\item{bSummarizedExperiment}{
logical indicating whether to return resulting object as a \code{\link{SummarizedExperiment}}.
}
\item{bCorPlot}{
logical indicating that a correlation heatmap should be plotted before returning. 
If \code{DBA} is \code{NULL} (a new DBA object is being created), 
and \code{bCorPlot} is missing, then this will take the default value (\code{FALSE}).
However if \code{DBA} is \code{NULL} (a new DBA object is being created), 
and \code{bCorPlot} is specified, then the specified value will become the 
default value of \code{bCorPlot} for the resultant \code{DBA} object.
}
\item{attributes}{
vector of attributes to use subsequently as defaults when generating 
labels in plotting functions:
\itemize{ 
\item \code{DBA_ID}
\item \code{DBA_TISSUE}
\item \code{DBA_FACTOR}
\item \code{DBA_CONDITION}
\item \code{DBA_TREATMENT}
\item \code{DBA_REPLICATE}
\item \code{DBA_CONSENSUS}
\item \code{DBA_CALLER}
\item \code{DBA_CONTROL}
}
}
\item{dir}{
Directory path. 
If supplied, files referenced in the \code{sampleSheet} will have
this path prepended. 
Applies to \code{PeakFiles}, \code{bamReads}, \code{bamControl},
and \code{Spikein}, if present.
If \code{sampleSheet} is a filepath, this will prepended to that as well.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~

MODE: Construct a new DBA object from a samplesheet:

\code{dba(sampleSheet, config,
    bAddCallerConsensus, bRemoveM, bRemoveRandom,
    attributes)}

MODE: Construct a DBA object based on an existing one:

\code{dba(DBA, mask, attributes)}

MODE: Convert a DBA object to a SummarizedExperiment object:

\code{dba(DBA, bSummarizedExperiment=TRUE)}
}
\value{
DBA object
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark and Gordon Brown
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{dba.peakset}},  \code{\link{dba.show}}, \code{\link{DBA.config}}.
}

\examples{
# Create DBA object from a samplesheet
\dontrun{
basedir <- system.file("extra", package="DiffBind")
tamoxifen <- dba(sampleSheet="tamoxifen.csv", dir=basedir)
tamoxifen

tamoxifen <- dba(sampleSheet="tamoxifen_allfields.csv")
tamoxifen

tamoxifen <- dba(sampleSheet="tamoxifen_allfields.csv",config="config.csv")
tamoxifen
}

#Create a DBA object with a subset of samples
data(tamoxifen_peaks)
Responsive <- dba(tamoxifen,tamoxifen$masks$Responsive)
Responsive

# change peak caller but leave peak format the same
basedir <- system.file("extra", package="DiffBind")
tamoxifen <- dba(sampleSheet="tamoxifen.csv", dir=basedir,
                 peakCaller="macs", peakFormat="raw", scoreCol=5 )
dba.show(tamoxifen, attributes=c(DBA_TISSUE,DBA_CONDITION,DBA_REPLICATE,DBA_CALLER))

# Convert DBA object to SummarizedExperiment
data(tamoxifen_counts)
sset <- dba(tamoxifen,bSummarizedExperiment=TRUE)
sset
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.analyze}
\alias{dba.analyze}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Perform differential binding affinity analysis
}
\description{
Performs differential binding affinity analysis. 
Performs default generation of a consensus peakset, read counting,
normalization, and setting up of contrasts if they have
not been specified.
}
\usage{
dba.analyze(DBA, method=DBA$config$AnalysisMethod, design,
            bBlacklist=DBA$config$doBlacklist,
            bGreylist=DBA$config$doGreylist,
            bRetrieveAnalysis=FALSE, bReduceObjects=TRUE, 
            bParallel=DBA$config$RunParallel)
}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}

\item{DBA}{
Either a \code{DBA} object, or a sample sheet 
(either a \code{character} vector with the name of the
sample sheet, or a \code{data.frame} containing the experimental
metadata.

If no blacklist or greylists are included,
a call will be made to
\code{\link{dba.blacklist}} using defaults.
This can be skipped by setting the \code{bBlacklist} and/or
\code{bGreylist} parameters.

If no counts are included, a default consensus will be formed
and read counts computed via a call to
\code{\link{dba.count}} using defaults.

If no normalization has been specified,
the reads will be normalized via a call to
\code{\link{dba.normalize}} using defaults.

If no contrasts are specified (\code{DBA$contrast} is \code{NULL}),
default contrasts will be added via a call to \code{\link{dba.contrast}}
using defaults.
}

\item{method}{
Underlying method, or vector of methods, by which to analyze 
differential binding affinity. 

Supported methods:
\describe{ 
  \item{\code{\link{DBA_EDGER}}}{use \code{edgeR} package for analysis}
  \item{\code{\link{DBA_DESEQ2}}}{use \code{DESeq2} package for analysis}
  \item{\code{\link{DBA_ALL_METHODS}}}{perform two analyses, 
using both \code{edgeR} and \code{DESeq2}}
}
}

\item{design}{
If present and a character string, will be used as the design formula
for the analysis, replacing any previously established design if present.

If \code{FALSE}, will complete analysis in pre-version 3 mode.

See \code{link{dba.contrast}}.
}

\item{bBlacklist}{
If \code{TRUE}, and no blacklist has been applied to the \code{DBA} object
(or when starting from a samplesheet), the read bam files will
be examined to determine the reference genome, and an appropriate blacklist
applied, if available.
See \code{link{dba.blacklist}}.
}

\item{bGreylist}{
If \code{TRUE}, and no greylist has been applied to the \code{DBA} object
(or when starting from a samplesheet), the control bam files, if present, will
be examined to determine the reference genome, greylists will be
computed for each, merged into a master greylist, and applied to the
peaksets.
See \code{link{dba.blacklist}}.
}

\item{bRetrieveAnalysis}{
If changed from \code{FALSE}, the underlying DE analysis object is returned
instead of running a new analysis.
Possible values for \code{bRetrieveAnalysis}:
\describe{
  \item{\code{DBA_DESEQ2}}{Returns the \code{DESeq2} \code{\link{DESeqDataSet}}}.
  \item{\code{DBA_EDGER}}{Returns the \code{edgeR} \code{DGEList}}.  
  \item{\code{TRUE}}{Returns the \code{DESeq2} \code{\link{DESeqDataSet}}, 
  if present. If not, returns the \code{edgeR} \code{DGEList}, if present.}.
}
An analysis object will only be successfully returned if there is at
least one contrast utilizing an explicit design 
(see \code{\link{dba.contrast}}), and an analysis has been carried out.
}

\item{bReduceObjects}{
logical indicating whether strip the analysis objects of unnecessary
fields to save memory. 
If it is desired to use the \code{DBA$contrasts[[n]]$edgeR}
and/or \code{DBA$contrasts[[n]]$DESeq2} objects directly in the
\code{edgeR} and/or \code{DESeq2} packages, this should be set to \code{FALSE}.
}
\item{bParallel}{
logical indicating that the analyses is to be done in parallel using multicore 
(one process for each contrast for each method,
plus an additional process per method).
}
}
\details{
In general, prior to calling \code{dba.analyze}, \code{\link{dba.count}}
should have been run.
If no contrasts have been established prior to invoking \code{dba.analyze},
then the default set of contrasts will be added using (\code{\link{dba.contrast}}).

If no normalization parameters have been supplied by 
calling \code{\link{dba.normalize}},
default normalization parameters will be used.

See the DBA User Guide for more details on how 
the \code{edgeR} and \code{DESeq2} analyses are carried out.  
}
\value{
DBA object with results of analysis added to \code{DBA$contrasts}.

Alternatively, an analysis object (either a \code{\link{DESeqDataSet}}
or a \code{DGEList}) if \code{bRetrieveAnalysis} if not \code{FALSE}.
}

\author{
Rory Stark
}
\note{
If there is a blocking factor for the contrast(s) specified using a 
previous call to \code{\link{dba.contrast}} with \code{design=FALSE}, 
a multi-factor analysis will automatically be carried out in addition
to a single factor analysis.
}

\seealso{

\code{\link{dba.blacklist}}, \code{\link{dba.count}},
\code{\link{dba.contrast}}, \code{\link{dba.normalize}},
\code{\link{dba.report}}, \code{\link{DBA.config}}.

}

\examples{
data(tamoxifen_counts)
dba.analyze(tamoxifen)

tamoxifen <- dba.analyze(tamoxifen, method=DBA_ALL_METHODS,
                         design="~Tissue + Condition")
dba.show(tamoxifen, bContrasts=TRUE)

dba.analyze(tamoxifen, bRetrieveAnalysis=TRUE)
edger.object <- dba.analyze(tamoxifen, bRetrieveAnalysis=DBA_EDGER)
class(edger.object)
}

\name{dba.plotPCA}
\alias{dba.plotPCA}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
PCA plot
}
\description{
Principal Component Analysis plot
}
\usage{
dba.plotPCA(DBA, attributes, minval, maxval,
           contrast, method=DBA$config$AnalysisMethod, 
           th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
           report, score, bLog=TRUE, mask, sites, label, cor=FALSE,
           b3D=FALSE, vColors, dotSize, labelSize, labelCols, 
           components=1:3, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}



\item{DBA}{
DBA object.
}

%\subsection{Optional/defaulted arguments}{}

\item{attributes}{
attribute or vector of attributes to use to color plotted points. 
Each unique combination of attribute values will be assigned a color. 
Chosen from:
\itemize{ 
\item \code{\link{DBA_GROUP}}
\item \code{\link{DBA_ID}}
\item \code{\link{DBA_TISSUE}}
\item \code{\link{DBA_FACTOR}}
\item \code{\link{DBA_CONDITION}}
\item \code{\link{DBA_TREATMENT}}
\item \code{\link{DBA_REPLICATE}}
\item \code{\link{DBA_CONSENSUS}}
\item \code{\link{DBA_CALLER}}
}
Note that \code{DBA_GROUP} is a special attribute which will result in samples from each group in a contrast
(if present) being colored separately.
}

\item{minval}{
Set all scores less than this to minval
}
\item{maxval}{
Set all scores greater than this to maxval
}

\item{contrast}{
number of contrast to use for PCA; if present, plots a PCA based on a differential binding affinity analysis
(see  \code{\link{dba.analyze}}). 
If \code{mask} is unspecified, only the samples in the contrast will be included. 
See  \code{\link{dba.show}(DBA, bContrast=T)} to get contrast numbers. 
If missing, uses scores in the main binding matrix.
}
\item{method}{
method used for analysis (used in conjunction with contrast):
\itemize{ 
\item \code{\link{DBA_DESEQ2}}
\item \code{\link{DBA_DESEQ2_BLOCK}}
\item \code{\link{DBA_EDGER}}
\item \code{\link{DBA_EDGER_BLOCK}}
}
}

\item{th}{
significance threshold; all sites with FDR (or p-values, see \code{bUsePval}) 
less than or equal to this value will be included in the PCA, subject to \code{maxVal}. 
Used in conjunction with \code{contrast}.
}
\item{bUsePval}{
if \code{TRUE}, uses p-value instead of FDR for thresholding. Used in conjunction with \code{contrast}.
}
\item{report}{
report (obtained from  \code{\link{dba.report}}) specifying the data to be used .
If this is present, the \code{method}, \code{th}, and \code{bUsePval} parameters are ignored.
}

\item{score}{
Score to use for count data.
Only used when plotting the global binding matrix (no \code{contrast} specified). 
One of:
\itemize{
\item \code{\link{DBA_SCORE_READS}}
\item \code{\link{DBA_SCORE_NORMALIZED}}
\item \code{\link{DBA_SCORE_CONTROL_READS}}
\item \code{\link{DBA_SCORE_READS_MINUS}}
%\item \code{\link{DBA_SCORE_READS_FULL}}
%\item \code{\link{DBA_SCORE_READS_EFFECTIVE}}
%\item \code{\link{DBA_SCORE_READS_MINUS_FULL}}
%\item \code{\link{DBA_SCORE_READS_MINUS_EFFECTIVE}}
\item \code{\link{DBA_SCORE_READS_FOLD}}
\item \code{\link{DBA_SCORE_RPKM}}
\item \code{\link{DBA_SCORE_RPKM_FOLD}}
\item \code{\link{DBA_SCORE_RPKM_MINUS}}
%\item \code{\link{DBA_SCORE_TMM_READS_FULL}}
%\item \code{\link{DBA_SCORE_TMM_READS_EFFECTIVE}}
%\item \code{\link{DBA_SCORE_TMM_MINUS_FULL}}
%\item \code{\link{DBA_SCORE_TMM_MINUS_EFFECTIVE}}
}
}
\item{bLog}{
Logical indicating that log2 values should be used. 
Only applicable to read count scores (not peak scores).
}
\item{mask}{
mask indicating a subset of peaksets to use when using global binding matrix scores.
If a \code{contrast} is specified, these peaksets will be included, 
but only the significantly differentially bound sites 
(using \code{th}, \code{bUsePval}, or \code{report}) will be included. 
See  \code{\link{dba.mask}}.
}
 \item{sites}{
logical vector indicating which sites to include in PCA. 
Only relevant when using global binding matrix (\code{contrast} is missing).
}
 \item{label}{
A metadata field to use as a label in 2D plots. 
The value for this field will be written directly on the plot near the dot for each sample. 
Values can be any of those valid for the \code{attributes} parameter.
}

 \item{cor}{
a logical value indicating whether the calculation should use the 
correlation matrix or the covariance matrix.
Passed into princomp.
}
\item{b3D}{
logical indicating that three principal components should be plotted (requires package \code{rgl}). 
If \code{FALSE}, the first two principal components are plotted.
}

\item{vColors}{
vector of custom colors; is absent, default colors will be used.
}
\item{dotSize}{
size of dots to plot; is absent, a default  will be calculated.
}

\item{labelSize}{
Scaling factor for labels if present. Default is 0.8.
}

\item{labelCols}{
Vector of colors to use for labels. Default is "black".
}

\item{components}{
Number(s) of the components to plot.
Can be a vector of two or three component numbers, or a single integer.
If an integer, that component, 
in addition to the succeeding one (\code{b3D=FALSE}) or two (\code{b3D=TRUE})
will be plotted.
}
\item{\dots}{
arguments passed to \code{\link{plot}} or \code{plot3d} (rgl).
}

}
\details{
%%  ~~ If necessary, more details than the description above ~~
MODE: PCA plot using significantly differentially bound sites:

\code{dba.plotPCA(DBA, attributes, minval, maxval,
                       contrast, method, th, bUsePval,
                       b3D=F, vColors, dotSize, ...)}

MODE: PCA plot using global binding matrix:

\code{dba.plotPCA(DBA, attributes, minval, maxval,
                       mask, sites,
                       b3D=F, vColors, dotSize, ...)}
}
\value{
\code{trellis} plot from \code{\link{lattice}} package; see \code{\link{xyplot}}
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
\note{
uses rgl package for 3D plots (if available)
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{dba.analyze}},  \code{\link{dba.plotHeatmap}}
}

\examples{
data(tamoxifen_peaks)

# peakcaller scores PCA
dba.plotPCA(tamoxifen)

# raw count correlation PCA
data(tamoxifen_analysis)
dba.plotPCA(tamoxifen)

#PCA based on normalized data for all sites
dba.plotPCA(tamoxifen,contrast=1,th=1)

#PCA based on DB sites only
p <- dba.plotPCA(tamoxifen,contrast=1)
p <- dba.plotPCA(tamoxifen,contrast=1,attributes=DBA_TISSUE)
p <- dba.plotPCA(tamoxifen,contrast=1,attributes=DBA_TISSUE,label=DBA_CONDITION)
p <- dba.plotPCA(tamoxifen,contrast=1,attributes=DBA_CONDITION,label=DBA_TISSUE)
p <- dba.plotPCA(tamoxifen,contrast=1,attributes=c(DBA_TISSUE,DBA_CONDITION),
                label=DBA_REPLICATE)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.show}
\alias{dba.show}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
List attributes of peaksets of contrasts associated with a DBA object
}
\description{
Returns attributes of peaksets and/or contrasts associated with a DBA object.
}
\usage{
dba.show(DBA, mask, attributes, bContrasts=FALSE, bDesign=FALSE, 
         th=DBA$config$th) 
}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}


  \item{DBA}{
DBA object
}
%\subsection{Optional/defaulted arguments}{}
  \item{mask}{
mask of peaksets for which to get attributes (used when obtaining peakset attributes, 
i.e. \code{bContrasts=FALSE}).
}
\item{attributes}{
attribute or vector of attributes to retrieve. 
Number of intervals is always shown. 
Used when obtaining peakset attributes, i.e. \code{bContrasts=FALSE}. Values:
\itemize{ 
\item \code{\link{DBA_ID}}
\item \code{\link{DBA_TISSUE}}
\item \code{\link{DBA_FACTOR}}
\item \code{\link{DBA_CONDITION}}
\item \code{\link{DBA_TREATMENT}}
\item \code{\link{DBA_REPLICATE}}
\item \code{\link{DBA_CONSENSUS}}
\item \code{\link{DBA_CALLER}}
\item \code{\link{DBA_CONTROL}}
\item \code{\link{DBA_READS}}
\item \code{\link{DBA_INTERVALS}}
\item \code{\link{DBA_FRIP}}
}
}

 \item{bContrasts}{
logical indicating whether peaksets or contrast attributes are to be retrieved.
\code{TRUE} retrieves a dataframe of contrast information instead of peakset attributes. 
If no contrasts are set, returns possible contrasts. See  \code{\link{dba.contrast}}.
}

 \item{bDesign}{
logical indicating whether the model design should be returned, if present. 
\code{bContrasts} must be \code{FALSE} for this parameter to be used.
}

  \item{th}{
if \code{bContrasts} is \code{TRUE}, then \code{th} is used as the threshold for determining how many
significant sites there are for each contrast.
Only relevant when obtaining contrast attributes (\code{bContrasts=TRUE}) 
and  \code{\link{dba.analyze}} has been run.
}

}
\details{
%%  ~~ If necessary, more details than the description above ~~
MODE: Return attributes of peaksets associated with a DBA object:

\code{dba.show(DBA, mask, attributes)}

MODE: Return contrasts associated with a DBA object:

\code{dba.show(DBA,bContrasts=TRUE, th)}

MODE: Return design associated with a DBA object:

\code{dba.show(DBA,bDesign=TRUE)}
}
\value{
dataframe with peakset attributes. 

If \code{bContrasts == FALSE}, each row represents a peakset, and each column is an attributes, with the final column, Intervals, indicating how many sites there are in the peakset.

If \code{bContrasts == TRUE}, each row represent a contrast, with the following columns:
\item{\code{Group1}}{Label for first group of contrast}
\item{\code{Members1}}{Number of samples in first group of contrast}
\item{\code{Group2}}{Label for first group of contrast}
\item{\code{Members3}}{Number of samples in first group of contrast}

if \code{\link{dba.analyze}} has been successfully run, there there will be up to 
four more columns showing the number of significant differentially bound (DB) sites identified for 
\item{\code{DB.edgeR}}{Number of significantly differentially bound sites identified using edgeR}
\item{\code{DB.DESeq}}{Number of significantly differentially bound sites identified using DESeq}
\item{\code{DB.edgeR.block}}{Number of significantly differentially bound sites identified for blocking analysis using edgeR}
\item{\code{DB.DESeq.block}}{Number of significantly differentially bound sites identified for blocking analysis using DESeq}
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{dba}}, \code{\link{dba.peakset}}, \code{\link{dba.contrast}}
\code{\link{dba.analyze}},  \code{\link{DBA.config}}.
}

\examples{
data(tamoxifen_peaks)
dba.show(tamoxifen)
dba.show(tamoxifen,tamoxifen$masks$Responsive)
dba.show(tamoxifen,attributes=c(DBA_TISSUE,DBA_REPLICATE,DBA_CONDITION))

data(tamoxifen_analysis)
dba.show(tamoxifen,bContrasts=TRUE)

#alternatively:
data(tamoxifen_analysis)
tamoxifen
tamoxifen$config$th <- .01
tamoxifen
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.normalize}
\alias{dba.normalize}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Specify parameters for normalizing a dataset;
calculate library sizes and normalization factors.
}
\description{
Enables normalization of datasets using a variety of  methods,
including background, spike-in, and parallel factor normalization.
Alternatively, allows a user to specify library sizes 
and normalization factors directly, or retrieve computed ones.
}
\usage{
dba.normalize(DBA, method = DBA$config$AnalysisMethod,
              normalize = DBA_NORM_DEFAULT, library = DBA_LIBSIZE_DEFAULT, 
              background = FALSE, spikein = FALSE, offsets = FALSE,
              libFun=mean, bRetrieve=FALSE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{DBA}{
DBA object that includes count data for a consensus peakset.
}
\item{method}{
Underlying method, or vector of methods, for which to normalize.

Supported methods:
\describe{ 
  \item{\code{\link{DBA_EDGER}}}{use \code{edgeR} package for analysis}
  \item{\code{\link{DBA_DESEQ2}}}{use \code{DESeq2} package for analysis}
  \item{\code{\link{DBA_ALL_METHODS}}}{normalize for both 
 both \code{edgeR} and \code{DESeq2}}
}
}

  \item{normalize}{
Either user-supplied normalization factors in a numeric vector,
or a specification of a method to use to calculate normalization factors.


Methods can be specified using one of the following:
 \describe{
   \item{\code{DBA_NORM_RLE} ("RLE")}{RLE normalization (native to \code{DBA_DESEQ2},
   and available for \code{DBA_EDGER}).}
   \item{\code{DBA_NORM_TMM} ("TMM")}{TMM normalization (native to \code{DBA_EDGER},
   and available for \code{DBA_DESEQ2}).}
   \item{\code{DBA_NORM_NATIVE} ("native")}{Use native method based on \code{method}: 
   \code{DBA_NORM_RLE} for \code{DBA_DESEQ2} or
   \code{DBA_NORM_TMM} for \code{DBA_EDGER}.}
   \item{\code{DBA_NORM_LIB} ("lib")}{Normalize by library size only.
   Library sizes can be specified using the \code{library} parameter.
   Normalization factors will be calculated to give each equal weight
   in a manner appropriate for the analysis \code{method}.
   See also the \code{libFun} parameter, which can be used to
   scale the normalization factors for \code{DESeq2.}}
   \item{\code{DBA_NORM_DEFAULT} ("default")}{Default method: The "preferred" normalization approach
   depending on \code{method} and whether an explicit
   design is present. See \code{Details} below.}
   \item{\code{DBA_NORM_OFFSETS} ("offsets")}{Indicates that offsets have been specified using the \code{offsets}
   parameter, and they should be used without alteration.}
   \item{\code{DBA_NORM_OFFSETS_ADJUST} ("adjust offsets")}{Indicates that offsets have been specified using the \code{offsets}
   parameter, and they should be adjusted for library size and mean centering
   before being used in a \code{DBA_DESEQ2} analysis.}
 }
}

\item{library}{
Either user-supplied library sizes in a numeric vector,
or a specification of a method to use to calculate library sizes.


Library sizes can be based on one of the following:
 \describe{
  \item{\code{DBA_LIBSIZE_FULL} ("full")}{Use the full library size (total number of reads in BAM/SAM/BED file)}
  \item{\code{DBA_LIBSIZE_PEAKREADS} ("RiP")}{Use the number of reads that overlap consensus peaks.}
  \item{\code{DBA_LIBSIZE_BACKGROUND} ("background")}{Use the total number of reads aligned to the chromosomes for which there is
  at least one peak. This required a background bin calculation (see parameter
  \code{background}). These values are usually the same or similar to
  \code{DBA_LIBSIZE_FULL}.}
  \item{\code{DBA_LIBSIZE_DEFAULT} ("default")}{Default method: The "preferred" library size
   depending on \code{method}, \code{background}, 
   and whether an explicit design is present. 
   See \code{Details} below.}
 }
}

\item{background}{
This parameter controls the option to use "background" bins, which
should not have differential enrichment between samples,
as the basis for normalizing (instead of using reads counts
overlapping consensus peaks). 
When enabled, the chromosomes for which there are peaks
in the consensus peakset are tiled into large bins and reads
overlapping these bins are counted.

If present, \code{background} can either be a logical value, a numeric value,
or a previously computed \code{$background} object.

If \code{background} is a logical value and set to \code{TRUE}, background bins will be
computed using the default bin size of 15000bp.
Setting this value to \code{FALSE} will prevent background mode
from being used in any default settings.

If \code{background} is a numeric value, it will be used as the bin size.

If \code{background} is a previously  computed
\code{$background} object, these counts will be used as the background.
A \code{$background} object can be obtained by calling 
\code{\link{dba.normalize}} with \code{bRetrieve=TRUE}
and \code{method=DBA_ALL_METHODS}.

After counting (or setting) background bins,
both the \code{normalize} and \code{library} parameters
will be used to determine how the
final normalization factors are calculated.

If \code{background} is missing, it will be set to \code{TRUE} if 
\code{library=DBA_LIBSIZE_BACKGROUND}, or if 
\code{library=DBA_LIBSIZE_DEFAULT} and certain conditions are met
(see \code{Details} below).

If \code{background} is not \code{FALSE}, then
the library size will be set to \code{library=DBA_LIBSIZE_BACKGROUND}
}

\item{spikein}{
Either a logical value, a character vector of chromosome names,
a \code{\link{GRanges}} object containing peaks for a parallel factor,
or a \code{$background} object containing previously computed 
spike-in read counts.

If \code{spikein} is a logical value set to \code{FALSE}, 
no spike-in normalization is performed.

If \code{spikein} is a logical value set to  \code{TRUE},
background normalization is performed using spike-in tracks.
There must be a spike-in track for each sample.
see \code{\link{dba}} and/or \code{\link{dba.peakset}} for
details on how to include a spike-in track with a sample
(eg. by including a \code{Spikein} column in the sample sheet.)
All chromosomes in the spike-in bam files will be used.

If \code{spikein} is a character vector of one or more chromosome names,
only reads on the named chromosome(s) will be used for background normalization.
If spike-in tracks are available, reads on chromosomes with these names in the
spike-in track will be counted.
If no spike-in tracks are available, reads on chromosomes with these names
in the main \code{bamReads} bam files will be counted.

If \code{spikein} is a \code{\link{GRanges}} object containing peaks
for a parallel factor, then background normalization is performed counting reads
in the spike-in tracks overlapping peaks in this object.

If \code{spikein} is a previously  computed
\code{$background} object, these counts will be used as the spikein background.
A \code{$background} object can be obtained by calling 
\code{\link{dba.normalize}} with \code{bRetrieve=TRUE}
and \code{method=DBA_ALL_METHODS}.

Note that if \code{spikein} is not \code{FALSE}, then
the library size will be set to \code{library=DBA_LIBSIZE_BACKGROUND}
}
\item{offsets}{
This parameter controls the use of offsets (matrix of normalization factors)
instead of a single normalization factor for each sample. It can either 
be a logical value, a \code{matrix}, or a \code{\link{SummarizedExperiment}}.

If it is a logical value and set to \code{FALSE}, 
no offsets will be computed or used. A value of \code{TRUE}
indicates that an offset matrix should be computed using a \code{loess} fit.

Alternatively, user-calculated normalization offsets can be supplied
as a \code{matrix} or as a  \code{\link{SummarizedExperiment}} 
(containing an \code{assay} named "offsets").
In this case, the user may also set the 
\code{normalize} parameter to indicate whether the 
offsets should be applied as-is to a  \code{DESeq2} analysis 
(\code{DBA_NORM_OFFSETS}, default),
or if they should be adjusted for library size and mean centering
(\code{DBA_NORM_OFFSETS_ADJUST}).

}

\item{libFun}{
When \code{normalize=DBA_NORM_LIB}, normalization factors are
calculated by dividing the library sizes for each sample by
a common denominator, obtained by applying \code{libFun}
to the vector of library sizes.

For \code{method=DBA_EDGER}, the normalization factors are further 
adjusted so as to make all the effective library sizes (library sizes multiplied by normalization factors) the same, and adjusted to multiply to 1.
}

\item{bRetrieve}{
If set to \code{TRUE}, information about the current normalization will be 
returned. 
The only other relevant parameter in this case is the \code{method}.

If \code{method=DBA_DESEQ2} or \code{method=DBA_EDGER}, 
a record will be returned including normalization values 
for the appropriate analysis method. This record is a \code{list}
consists of the following elements:
 \describe{
   \item{$norm.method}{A character string corresponding to the normalization method,
   generally one of the values that can be supplied as a value to 
   \code{normalize}.}
   \item{$norm.factors}{A vector containing the computed normalization factors.}
   \item{$lib.method}{A character string corresponding to the value of the method used to
    calculate the library size,
   generally one of the values that can be supplied as a value to 
   \code{library}.}
   \item{$lib.sizes}{A vector containing the computed library sizes.}
%   \item{$filter.value}
%   {A numeric value indicating the minimum values used to 
%   filter consensus peaks.} 
   \item{$background}{If the normalization if based on binned background reads,
   this field will be \code{TRUE}.}
   \item{$control.subtract}{If control reads were subtracted from the read counts,
   this field will be \code{TRUE}.}
 }
 
 If \code{method=DBA_ALL_METHODS}, the record be a list
 with one of the above records for each \code{method} for
 which normalization factors have been computed 
 (\code{$DESeq2} and \code{edgeR}).
 

 If \code{background} bins have been calculated,
 this will include an element called \code{$background}.
  This element can be passed in as the value to \code{background} or 
 \code{spikein} to re-use a previously computed set of reads.
 It contains three subfields:
 \describe{
   \item{$background$binned}{a \code{SummarizedExperiment} object containing the binned counts.}
   \item{$background$bin.size}{a numeric value with the bin size used.}
      \item{$background$back.calc}{character string indicating how the background was calculated 
   (bins, spike-ins, or parallel factor).}
 }

 
 If \code{offsets} are available,
 this will include an element called \code{$offsets} with two
 subfields:
 \describe{
   \item{$offsets$offsets}{a \code{matrix} or a \code{SummarizedExperiment} object 
   containing the offsets.}
   \item{offsets$offset.method}{a character string indicating the source of the offsets, either
   \code{"loess"} or \code{"user"}.}
 }
 
}

\item{...}{
Extra parameters to be passed to \code{limma::loessFit}
when computing offsets.
}
}
\details{
The default normalization parameters are as follows:
\itemize{
  \item{\code{normalize=DBA_NORM_LIB}}
  \item{\code{library=DBA_LIBSIZE_FULL}}
  \item{\code{background=FALSE}}
}

If \code{background=TRUE}, then the default becomes
\code{library=DBA_LIBSIZE_BACKGROUND}.

If \code{\link{dba.contrast}} has been
used to set up contrasts with \code{design=FALSE} (pre-3.0 mode),
then the defaults are:
\itemize{
  \item{\code{normalize=DBA_NORM_DEFAULT}}
  \item{\code{library=DBA_LIBSIZE_FULL}}
  \item{\code{background=FALSE}}
}
In this case, \code{normalize=DBA_NORM_LIB} will be set for 
\code{method=DBA_DESEQ2} for backwards compatibility.
}

\value{
Either a \code{DBA} object with normalization terms added,
or (if \code{bRetrieve=TRUE}), a record
or normalization details.
}

\author{
Rory Stark
}

\note{
The \code{csaw} package is used to compute  
\code{background} bins and \code{offsets} based on 
\code{limma::loessFit}.

See the \code{DiffBind} vignette for technical details of how this
is done, and the \code{csaw} vignette for details on 
background bins and loess offsets can be used to address 
different biases in ChIP-seq data.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{dba.count}}, \code{\link{dba.analyze}}, \code{\link{dba.save}}
}

\examples{
# load DBA object with counts 
data(tamoxifen_counts)
tamoxifen <- dba.contrast(tamoxifen,design="~Tissue + Condition")

# default normalization: Full library sizes
tamoxifen <- dba.normalize(tamoxifen)
dba.normalize(tamoxifen, bRetrieve=TRUE)
dba.analyze(tamoxifen)

# RLE/TMM using Reads in Peaks
tamoxifen <- dba.normalize(tamoxifen, method=DBA_ALL_METHODS,
                           normalize=DBA_NORM_NATIVE, 
                           library=DBA_LIBSIZE_PEAKREADS)
dba.normalize(tamoxifen, method=DBA_DESEQ2, bRetrieve=TRUE)
dba.normalize(tamoxifen, method=DBA_EDGER, bRetrieve=TRUE)
tamoxifen <- dba.analyze(tamoxifen, method=DBA_ALL_METHODS)
dba.show(tamoxifen,bContrasts=TRUE)
dba.plotVenn(tamoxifen,contrast=1,method=DBA_ALL_METHODS,bDB=TRUE)

# TMM in Background using precomputed background
norm <- dba.normalize(tamoxifen,method=DBA_ALL_METHODS,bRetrieve=TRUE)
tamoxifen <- dba.normalize(tamoxifen, background=norm$background,
                           normalize="TMM", method=DBA_ALL_METHODS)
tamoxifen <- dba.analyze(tamoxifen)
dba.show(tamoxifen,bContrasts=TRUE)
dba.plotMA(tamoxifen)

# LOESS offsets
tamoxifen <- dba.normalize(tamoxifen, method=DBA_ALL_METHODS, offsets=TRUE)
tamoxifen <- dba.analyze(tamoxifen, method=DBA_ALL_METHODS)
dba.show(tamoxifen,bContrasts=TRUE)

par(mfrow=c(3,1))
dba.plotMA(tamoxifen,th=0,bNormalized=FALSE)
dba.plotMA(tamoxifen,method=DBA_DESEQ2)
dba.plotMA(tamoxifen,method=DBA_EDGER)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.

\name{dba.plotMA}
\alias{dba.plotMA}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Generate MA and scatter plots of differential binding analysis results
}
\description{
Generates MA and scatter plots of differential binding analysis results.
}
\usage{
dba.plotMA(DBA, contrast=1, method=DBA$config$AnalysisMethod, 
           th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
           fold=0, bNormalized=TRUE,
           factor="", bFlip=FALSE, bXY=FALSE, dotSize=.45, 
           bSignificant=TRUE, highlight=NULL,
           bSmooth=TRUE, bLoess=TRUE, xrange, yrange, ...)
}

%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}


  \item{DBA}{
DBA object, on which  \code{\link{dba.analyze}} 
should have been successfully run.
}
%\subsection{Optional/defaulted arguments}{}
  \item{contrast}{
number of contrast to report on. 
See  \code{\link{dba.show}(DBA, bContrast=TRUE)} to get contrast numbers.

Alternatively, an MA plot can be generated without a specific contrast,
plotting one set of samples against another.
In this case, \code{contrast} should be a list on length one or two.
Each element of the list should be either a logical
sample mask, or a vector of sample numbers.
If the second set of samples is jot specified (list is length one),
all the samples other than those specified will be used for the second group.
The list elements should be named; these names will be used as labels
for the sample groups in the plot.
}
\item{method}{
 method or vector of methods to plot results for:
\itemize{ 
\item \code{\link{DBA_DESEQ2}}
\item \code{\link{DBA_DESEQ2_BLOCK}}
\item \code{\link{DBA_EDGER}}
\item \code{\link{DBA_EDGER_BLOCK}}
}
}


\item{th}{
significance threshold; all sites with FDR (or p-values, see \code{bUsePval}) 
less than or equal to this value will be colored red in the plot
}
  \item{bUsePval}{
logical indicating whether to use FDR (\code{FALSE}) or p-value (\code{TRUE})
for thresholding.
}
  \item{fold}{
will only include sites with fold change greater than this as significant 
(colored red).

If \code{fold} is greater than zero, 
and an explicit design was used for the contrast,
the \code{p-value} and \code{FDR} will be re-calculated based on testing
for changes greater than the specified fold change.
For a \code{DESeq2} analysis, this involves including the \code{fold}
when calling \code{DESeq2::results}.
For a \code{edgeR} analysis, \code{edgeR::glmTreat} is used.
}
  \item{bNormalized}{
logical indicating whether to plot normalized data using normalization factors 
computed by differential analysis method (\code{TRUE}) 
or raw read counts (\code{FALSE}).
}
 \item{factor}{
string to be prepended to plot main title; e.g. factor name.
}
 \item{bFlip}{
logical indicating that order of groups in contrast should be "flipped", 
allowing control of which sample group
will have positive and which will have negative fold changes.
}
\item{bXY}{
logical indicating whether to draw MA plot (\code{FALSE}) or 
XY scatter plot (\code{TRUE}).
}

  \item{dotSize}{
size of points on plot (\code{cex}).
}
  \item{bSignificant}{
Logical indicating if points corresponding to significantly 
differentially bound sites (based on \code{contrast},
\code{th}, \code{bUsePval}, and \code{fold} parameters) 
should be overlaid in red.
}
\item{highlight}{
  \code{\link{GRanges}} object with sites to highlight in green.
}

  \item{bSmooth}{
logical indicating that basic plot should be plotted using 
\code{\link{smoothScatter}}.
Note that overlaid significant sites will be not plotted 
using a smoothing function.
}
  \item{bLoess}{
logical indicating that a MA plot should include a fitted loess curve.
}

  \item{xrange}{
vector of length 2 containing the desired minimum and 
maximum concentrations to plot.
}

  \item{yrange}{
vector of length 2 containing the desired minimum and 
maximum fold changes to plot.
}

  \item{\dots}{
passed to underlying plotting functions.
}
}
%\details{
%}
%\value{
%}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%plots log2 values of read counts.
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{dba.analyze}}
}

\examples{
data(tamoxifen_analysis)

# default MA plot
dba.plotMA(tamoxifen)

# Show different normalizations
tamoxifen <- dba.normalize(tamoxifen,method=DBA_ALL_METHODS, 
                           library=DBA_LIBSIZE_PEAKREADS, background=FALSE)
tamoxifen <- dba.analyze(tamoxifen, method=DBA_ALL_METHODS)

par(mfrow=c(3,2))
dba.plotMA(tamoxifen,th=0,bNormalized=FALSE,sub="NON-NORMALIZED")
dba.plotMA(tamoxifen,th=0,bNormalized=FALSE,sub="NON-NORMALIZED")

dba.plotMA(tamoxifen,method=DBA_DESEQ2,bNormalized=TRUE,
           sub="DESeq2_RLE-RiP")
dba.plotMA(tamoxifen,method=DBA_EDGER,bNormalized=TRUE,
           sub="edgeR_TMM-RiP")

tamoxifen <- dba.normalize(tamoxifen, method=DBA_ALL_METHODS,
                           normalize=DBA_NORM_LIB, background=FALSE) 
tamoxifen <- dba.analyze(tamoxifen,method=DBA_ALL_METHODS)

dba.plotMA(tamoxifen,method=DBA_DESEQ2,bNormalized=TRUE, 
           sub="DESeq2_LIB-FULL")
dba.plotMA(tamoxifen,method=DBA_EDGER,bNormalized=TRUE,
           sub="edgeR_LIB-FULL")
           
# MA plots of samples without a contrast
data(tamoxifen_counts)
par(mfrow=c(2,2))
dba.plotMA(tamoxifen,list(Resistant=tamoxifen$masks$Resistant,
                          Responsive=tamoxifen$masks$Responsive),
                          bNormalized=FALSE)
dba.plotMA(tamoxifen,list(MCF7=tamoxifen$masks$MCF7),
                          bNormalized=FALSE)
dba.plotMA(tamoxifen, list(Sample1=1), bNormalized=FALSE)
dba.plotMA(tamoxifen, list(Random=sample(1:11,5)), bNormalized=FALSE)

#XY plots (with raw and normalized data)
data(tamoxifen_analysis)
par(mfrow=c(1,2))
dba.plotMA(tamoxifen,bXY=TRUE,bSmooth=FALSE,bNormalized=FALSE, 
           sub="NON_NORMALIZED")
dba.plotMA(tamoxifen,bXY=TRUE,bSmooth=FALSE,bNormalized=TRUE,
           sub="DESeq2-RLE-Background")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.count}
\alias{dba.count}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Count reads in binding site intervals
}
\description{
Counts reads in binding site intervals.  Files must be one of bam,
bed and gzip-compressed bed.  File suffixes must be ".bam", ".bed", or ".bed.gz"
respectively.
}
\usage{
dba.count(DBA, peaks, minOverlap=2, score=DBA_SCORE_NORMALIZED,
          fragmentSize=DBA$config$fragmentSize, 
          summits=200, filter=1, bRemoveDuplicates=FALSE, bScaleControl=TRUE,
          bSubControl = is.null(DBA$greylist),
          mapQCth=DBA$config$mapQCth, filterFun=max, minCount=0, 
          bLog=FALSE, bUseSummarizeOverlaps=TRUE, 
          readFormat=DBA_READS_DEFAULT, bParallel=DBA$config$RunParallel) 
}

%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}


 \item{DBA}{
DBA object
}
 \item{peaks}{
If GRanges, RangedData, dataframe, or matrix, this parameter contains the intervals to use for counting. If character string, it specifies a file containing the intervals to use (with the first three columns specifying chromosome, startpos, endpos).If missing or a mask, generates a consensus peakset using minOverlap parameter (after applying the mask if present). If NULL, the \code{score}, \code{filter}, and \code{summits} parameters are honored, updating the global binding matrix without re-counting in the cases of \code{score} and \code{filter}, and only counting after re-centering in the case of \code{summits}.
}
\item{minOverlap}{
only include peaks in at least this many peaksets when generating consensus peakset (i.e. when peaks parameter is missing).  If minOverlap is between zero and one, peak will be included from at least this proportion of peaksets.
}
\item{score}{
which score to use in the binding affinity matrix.
Note that all raw read counts are maintained for use by \code{\link{dba.analyze}}, regardless of how this is set.
One of:
\tabular{ll}{
DBA_SCORE_NORMALIZED \tab normalized reads, as set by \code{\link{dba.normalize}}\cr
DBA_SCORE_READS \tab raw read count for interval using only reads from ChIP\cr
DBA_SCORE_CONTROL_READS \tab raw read count for interval using only reads from Control\cr
DBA_SCORE_READS_FOLD \tab raw read count for interval from ChIP divided by read count for interval from control\cr
DBA_SCORE_READS_MINUS \tab raw read count for interval from ChIP minus read count for interval from control\cr
%DBA_SCORE_READS_FULL \tab read count for interval from ChIP normalized based on Full Library size\cr
%DBA_SCORE_READS_MINUS_FULL \tab read count for interval from ChIP minus read count for interval from control normalized based on Full Library size\cr
%DBA_SCORE_READS_EFFECTIVE \tab read count for interval from ChIP normalized based on Effective Library size\cr
%DBA_SCORE_READS_MINUS_EFFECTIVE \tab read count for interval from ChIP minus read count for interval from control normalized based on Effective Library size\cr
DBA_SCORE_RPKM \tab RPKM for interval using only reads from ChIP\cr
DBA_SCORE_RPKM_FOLD \tab RPKM for interval from ChIP divided by RPKM for interval from control\cr
DBA_SCORE_RPKM_MINUS \tab RPKM for interval from ChIP minus RPKM for interval from control\cr
%DBA_SCORE_TMM_READS_FULL \tab TMM normalized (using edgeR), using ChIP read counts and Full Library size\cr
%DBA_SCORE_TMM_READS_EFFECTIVE \tab TMM normalized (using edgeR), using ChIP read counts and Effective Library size\cr
%DBA_SCORE_TMM_MINUS_FULL \tab TMM normalized (using edgeR), using ChIP read counts minus Control read counts and Full Library size\cr
%DBA_SCORE_TMM_MINUS_EFFECTIVE \tab TMM normalized (using edgeR), using ChIP read counts minus Control read counts and Effective Library size\cr
%DBA_SCORE_TMM_READS_FULL_CPM \tab same as \code{DBA_SCORE_TMM_READS_FULL}, but reported in counts-per-million.\cr
%DBA_SCORE_TMM_READS_EFFECTIVE_CPM \tab same as \code{DBA_SCORE_TMM_READS_EFFECTIVE}, but reported in counts-per-million.\cr
%DBA_SCORE_TMM_MINUS_FULL_CPM \tab same as \code{DBA_SCORE_TMM_MINUS_FULL}, but reported in counts-per-million.\cr
%DBA_SCORE_TMM_MINUS_EFFECTIVE_CPM \tab same as \code{DBA_SCORE_TMM_MINUS_EFFECTIVE}, but reported in counts-per-million.\cr
DBA_SCORE_SUMMIT \tab summit height (maximum read pileup value)\cr
DBA_SCORE_SUMMIT_ADJ \tab summit height (maximum read pileup value), normalized to relative library size\cr
DBA_SCORE_SUMMIT_POS \tab summit position (location of maximum read pileup)\cr
}

If \code{DBA} is a report-based object, the allowable scores are:
\tabular{ll}{
DBA_SCORE_FOLD  \tab log2 Fold Change\cr        
DBA_SCORE_CONCENTRATION \tab mean concentration (log2)\cr      
DBA_SCORE_CONC_NUMERATOR \tab mean concentration (log2) of first group in contrast\cr
DBA_SCORE_CONC_DENOMINATOR \tab mean concentration (log2) of second group in contrast\cr
DBA_SCORE_PVAL  \tab p-value\cr            
DBA_SCORE_FDR  \tab FDR\cr  
}
}

\item{fragmentSize}{
This value will be used as the length of the reads. 
Each read will be extended from its endpoint along the appropriate strand by this many bases. 
If set to zero, the read size indicated in the BAM/BED file will be used.
\code{fragmentSize} may also be a vector of values, one for each ChIP sample plus one for 
each unique Control library.
}
\item{summits}{
unless set to \code{FALSE}, summit heights (read pileup) and locations will be calculated for each peak. 
The values can retrieved using \code{\link{dba.peakset}}. 
The summits can also be used as a read score in the global binding matrix (see \code{score}). 

If the value of \code{summits} is \code{TRUE} (or \code{0}), 
the summits will be calculated but the peaksets will be unaffected.  
If the value is greater than zero, all consensus peaks will be re-centered around a consensus summit, 
with the value of \code{summits} indicating how many base pairs to include upstream and downstream 
of the summit (so all consensus peaks will be of the same width, namely \code{2 * summits + 1}). 

Note that if \code{summits} is greater than zero, the counting procedure will 
take twice as long.
}

\item{filter}{
value to use for filtering intervals with low read counts. 
The \code{filterFun} will be applied to the counts for each interval, 
and if it returns a value below the \code{filter} value, 
the interval will be removed from further analysis.
If \code{peaks} is \code{NULL}, will remove sites from existing DBA object without recounting. 
If filter is a vector of values, \code{dba.count} will return a vector of the same length, 
indicating how many intervals will be retained for each specified \code{filter} level.

NB: the filtering will be based on RPKM values. 
If \code{bSubControl} is \code{FALSE}, this is the RPKM value of the read counts
(equivalent to \code{score=DBA_SCORE_RPKM}.
If \code{bSubControl} is \code{TRUE}, this is the RPKM value of the 
control counts subtracted from the RPKM of the read counts
(equivalent to \code{score=DBA_SCORE_RPKM_MINUS}).

}
\item{bRemoveDuplicates}{
logical indicating if duplicate reads (ones that map to exactly the same genomic position) should be removed.
If \code{TRUE}, any location where multiple reads map will be counted as a single read. 
Note that if \code{bLowMem} is set, duplicates needs to have been already marked 
in all of the BAM files.
The built-in counting code may not correctly handle certain cases when the 
\code{bRemoveDuplicates} parameter is set to \code{TRUE}. 
These cases include paired-end data and datasets where the read length may differ within a single BAM file. 
In these cases, see the \code{bUseSummarizeOverlaps} parameter.
}
\item{bScaleControl}{
logical indicating if the Control reads should be scaled based on relative library sizes. 
If \code{TRUE}, and there are more reads in the Control library than in the ChIP library, 
the number of Control reads for each peak will be multiplied by a scaling factor 
determined by dividing the total number of reads in the ChIP library by 
the total number of reads in the Control library. 
If this value is not an integer, the number of Control reads for each peak  
will be the next highest integer.
}

\item{bSubControl}{
logical indicating whether Control read counts are subtracted for 
each site in each sample.
If there are more overlapping control reads than ChIP reads, 
the count will be set to the \code{minCount} value specified
when \code{\link{dba.count}} was called, or zero if no value is specified.

If \code{bSubControl} is not explicitly specified,
it will be set to \code{TRUE} unless a greylist has been applied
(see \code{\link{dba.blacklist}}).

}

\item{mapQCth}{
for filtering by mapping quality (mapqc). 
Only alignments with mapping scores of at least this value will be included. 
Only applicable for bam files when \code{bUseSummarizeOverlaps=FALSE} 
(setting \code{DBA$config$scanbamparam} appropriately to filter on quality scores when using \code{\link{summarizeOverlaps}}.)
}

\item{filterFun}{
function that will be invoked for each interval with a
vector of scores for each sample. 
Returns a score that will be evaluated against the \code{filter} value 
(only intervals with a score 
at least as high as \code{filter} will be kept).
Default is \code{max}, indicating that at least one sample 
should have a score of at least \code{filter}; 
other useful values include \code{sum} (indicating that all the scores added together should be at least \code{filter}) and \code{mean}
(setting a minimum mean normalized count level). 
Users can supply their own function as well.
}
\item{minCount}{
minimum read count value. 
Any interval with fewer than this many overlapping reads will
be set to have this count.
Also applies to scores.
}

\item{bLog}{
logical indicating whether log2 of score should be used (only applies to 
DBA_SCORE_RPKM_FOLD and DBA_SCORE_READS_FOLD).
}

\item{bUseSummarizeOverlaps}{
logical indicating that \code{\link{summarizeOverlaps}} should be used for
counting instead of the built-in counting code. 
This option is slower but uses the more standard counting function.
If \code{TRUE}, all read files must be BAM (.bam extension), with associated index files 
(.bam.bai extension). 
The \code{fragmentSize} parameter must absent. 

See notes for when the \code{bRemoveDuplicates} parameter is set to \code{TRUE}, 
where the built-in counting code may not correctly handle certain cases and 
\code{bUseSummarizeOverlaps} should be set to \code{TRUE}.

Five additional parameters for \code{\link{summarizeOverlaps}} may be specified in \code{DBA$config}:
\tabular{ll}{
\code{DBA$config$yieldSize} \tab yieldSize indicating how many reads to process at one time; default is 5000000. 
The lower this value, the less memory will be used, but the more time it will take to 
complete the count operation.\cr
\code{DBA$config$intersectMode} \tab mode indicating which overlap algorithm to use; default is \code{"IntersectionNotEmpty"}\cr 
\code{DBA$config$singleEnd} \tab logical indicating if reads are single end; 
if NULL, status will be automatically detected.\cr 
\code{DBA$config$fragments} \tab logical indicating how unmatched reads are counted; default is \code{FALSE}\cr 
\code{DBA$config$inter.feature} \tab logical indicating the setting
for the \code{inter.feature} parameter; default is \code{TRUE}\cr 
\code{DBA$config$scanbamparam} \tab \code{ScanBamParam} object to pass to \code{\link{summarizeOverlaps}}. 
If present, \code{bRemoveDuplicates} is ignored.\cr 
}
}
\item{readFormat}{
Specify the file type of the read files, over-riding the file extension. Possible values:
\tabular{ll}{
\code{DBA_READS_DEFAULT} \tab use file extension (.bam, .bed, .bed.gz) to determine file type\cr
\code{DBA_READS_BAM} \tab assume the file type is BAM, regardless of the file extension\cr
\code{DBA_READS_BED} \tab assume the file type is BED (or zipped BED), regardless of the file extension.
}
Note that if \code{readFormat} is anything other than \code{DBA_READS_DEFAULT}, 
all the read files must be of the same file type.
}
\item{bParallel}{
if \code{TRUE}, use multicore to get counts for each read file in parallel
}
}

\value{
DBA object with binding affinity matrix based on read count scores.
}

%\note{
%The consensus set will be determine
%}

\author{
Rory Stark and Gordon Brown
}
 
 \seealso{
 \code{\link{dba.analyze}}
 }

\examples{
# These won't run unless you have the reads available in a BAM or BED file
data(tamoxifen_peaks)
\dontrun{tamoxifen <- dba.count(tamoxifen)}


# Count using a peakset made up of only peaks in all responsive MCF7 replicates
data(tamoxifen_peaks)
mcf7Common <- dba.overlap(tamoxifen,tamoxifen$masks$MCF7&tamoxifen$masks$Responsive)
\dontrun{tamoxifen <- dba.count(tamoxifen,peaks=mcf7Common$inAll)}
tamoxifen

#First make consensus peaksets from each set of replicates, 
#then derive master consensus set for counting from those
data(tamoxifen_peaks)
tamoxifen <- dba.peakset(tamoxifen,consensus = -DBA_REPLICATE)
\dontrun{tamoxifen <- dba.count(tamoxifen, peaks=tamoxifen$masks$Consensus)}
tamoxifen

# Change binding affinity scores
data(tamoxifen_counts)
dba.peakset(tamoxifen, bRetrieve=TRUE) # default: DBA_SCORE_NORMALIZED
tamoxifen <- dba.count(tamoxifen,peaks=NULL,score=DBA_SCORE_READS)
dba.peakset(tamoxifen, bRetrieve=TRUE)
tamoxifen <- dba.count(tamoxifen,peaks=NULL,score=DBA_SCORE_RPKM_MINUS)
dba.peakset(tamoxifen, bRetrieve=TRUE)

# Plot effect of a range of filter values and then apply filter 
data(tamoxifen_counts)
rate.max <- dba.count(tamoxifen, peaks=NULL, filter=0:250)
rate.sum <- dba.count(tamoxifen, peaks=NULL, filter=0:250,filterFun=sum)
plot(0:250,rate.max/rate.max[1],type='l',xlab="Filter Value",ylab="Proportion Retained Sites")
lines(0:250,rate.sum/rate.sum[1],col=2)
tamoxifen <- dba.count(tamoxifen,peaks=NULL,filter=125,filterFun=sum)
tamoxifen

# Calculate summits
data(tamoxifen_counts) 
# pre-counted with summits=250 or 501bp intervals
as.numeric(dba.show(tamoxifen)$FRiP)
\dontrun{tamoxifen <- dba.count(tamoxifen,peaks=NULL,summits=50)}
# re-counted with summits=50 or 101bp intervals
as.numeric(dba.show(tamoxifen)$FRiP)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{DiffBind3}
\alias{DiffBind3}

\title{Differences between DiffBind 3.0 and earlier versions}


\description{Notes on the differences between 
DiffBind 3.0 and previous versions, and how run in a 
"backward compatible" manner.}

\section{Overview}{

Beginning with version 3.0, \code{\link{DiffBind}} introduces 
substantial updates and new features that may cause scripts
written for earlier versions to function differently 
(or not at all), as well as altering the results.
This page givens details on these changes,
and how to approximate results computed
with earlier version if desired.

The major change in version 3.0 is in how the data are modeled.
In previous versions, a separate model was derived for each contrast,
including data only for those samples present in the contrast.
Model design options were implicit and limited to either a single
factor, or a subset of two-factor "blocked" designs.
Starting in version 3.0, the default mode is to 
include all the data in a single model,
allowing for any allowable design formula and any set of
allowable contrasts.

Another change starting from version 3.0 is in how normalization is done.
There are more normalization options, and more explicit control over them.
The default normalization options have also changed, 
so reproducing a pre-3.0 analysis requires that normalization 
parameters to be specified.

It is recommended that existing analyses be re-run with the current software.
Existing scripts should execute (with the exception of two
normalization parameters which have been moved from \code{\link{dba.analyze}}
to the new interface function \code{\link{dba.normalize}}.)

See the \code{\link{DiffBind}} vignette for more information on 
processing and analyzing ChIP-seq (and ATAC-seq) experiments.

}

\section{Changes to Defaults}{
\itemize{
 \item{\bold{blacklist} is applied by default, if available, using automatic 
detection of reference genome.}
 \item{\bold{greylists} are generated from controls and applied by default.}
 \item{\bold{minimum read counts} are now 0 instead of being rounded up to 1
 (this is now controllable).}
 \item{\bold{centering peaks around summits} is now done by default using 401-bp 
 wide peaks (recommend to use `summits=100` for ATAC-seq).}
 \item{\bold{read counting} is now performed by `summarizeOverlaps()` by default, 
 with single-end/paired-end counting automatically detected.}
 \item{\bold{filtering} is performed by default; consensus peaks where no peak has
 and RPKM value of at least 1 in any sample are filtered.}
 \item{\bold{control read subtraction} is now turned off by default if a greylist 
 is present}
 \item{\bold{normalization} is based on full library sizes by default for both 
 `edgeR` and `DESeq2`analyses.}
 \item{\bold{score} is set to normalized values by default.}
 }
}

\section{Backward compatibility}{

Most existing \code{\link{DiffBind}} scripts and saved objects will
run correctly using version 3.0, but there may be differences
in the results. 

This section describes how to approximate earlier
results for existing scripts and objects.

\subsection{Running with saved DBA objects:}{
If a \code{DBA} object was created with an earlier version of 
\code{\link{DiffBind}}, and saved using the \code{\link{dba.save}}
function, and loaded using the \code{\link{dba.load}} function,
all settings should be preserved, such that running the analysis anew
will yield the same results.

In order to re-run the analysis using the post-version 3.0 settings,
the original script should be used to re-create the \code{DBA} object.
}

\subsection{Re-running DiffBind scripts:}{
By default, if you re-run a \code{\link{DiffBind}} script, it will use the
new defaults from version 3.0 and beyond.
In order to re-analyze an experiment in the pre-version 3.0 mode,
a number of defaults need to be changed.

When calling \code{\link{dba.count}}, the following defaults are changed:
\describe{
  \item{\code{summits}:}{This parameter is now set by default. Setting 
     \code{summits=FALSE} will preempt re-centering each 
      peak interval around its point of highest pileup.}  
  \item{\code{filter}:}{The new default for this parameter is \code{1}
  and is based on \code{RPKM} values; previously
       it was set to \code{filter=0} and was based on read counts.}
  \item{\code{minCount}:}{This is a new parameter representing a minimum read count value.
                   It now default to \code{0}; 
                   to get the previous behavior, set \code{minCount=1}. }
}

The easiest way to perform subsequent processing in a pre-version 3.0 
manner is to set a configuration option:

\code{DBA$config$design <- FALSE}

This will result in the appropriate defaults being set for
the new interface function, \code{\link{dba.normalize}} (which
does not need to be invoked explicitly.)
The pre-version 3.0 settings for \code{\link{dba.normalize}} parameters
are as follows:
\describe{
  \item{\code{normalize}:}{\code{DBA_NORM_DEFAULT}}
  \item{\code{library}:}{\code{DBA_LIBSIZE_FULL}}
  \item{\code{background}:}{\code{FALSE}}
}
Note that two parameters that used to be available when calling 
\code{\link{dba.analyze}} have been moved:

\describe{
  \item{\code{bSubControl}:}{now integrated into  \code{\link{dba.count}}. \code{FALSE} by default (unless a greylist has
  been added using \code{\link{dba.blacklist}}).}
  \item{\code{bFullLibrarySize}:}{now integrated into  
  \code{\link{dba.normalize}} as an option for  the \code{library} parameter. 
  \code{library=DBA_LIBSIZE_FULL} is equivalent to \code{bFullLibrarySize=TRUE},
  and \code{library=DBA_LIBSIZE_PEAKREADS} is equivalent to 
  \code{bFullLibrarySize=FALSE}.}
}
}
}
\author{
Rory Stark
}

\seealso{
The \code{\link{DiffBind}} vignette has been updated to show how to
analyze experiments using version 3.0.
}

\name{dba.plotProfile}
\alias{dba.plotProfile}

\title{
Generate profiles and make profile heatmaps
}
\description{
Generates profiles and makes heatmap plots.
}
\usage{
dba.plotProfile(Object, samples, sites, scores, labels, 
                normalize=TRUE, merge=DBA_REPLICATE,
                maxSites=1000, absScores=TRUE,
                doPlot=is(Object,"profileplyr"), 
                ...)
}

\arguments{


\item{Object}{
Either a \code{DBA} object, or a \code{profileplyr-class} object.
}

 \item{samples}{
Sample mask. 

A vector of \code{logical}  or \code{numeric} values indicating
which samples to be included in the plot.
Alternatively, \code{samples} can be specified
as a \code{list} of sample masks to specify sample groups
(using list element names if present).

If absent, all samples will be included; 
if \code{sites} indicates that the results of an analysis should be used, 
the samples involved in the specified contrast will be included 
(if it is a two-way contrast); 
these samples will be merged into two sample groups representing the 
two sides of the contrast.

Some groups of samples may be merged as indicated 
in the \code{merge} parameter.
}

 \item{sites}{
\code{sites} is used to specify which sites are to be used in the heatmaps.
It can be specified in a number of ways:
\describe{

\item{\code{\link{GRanges}}}{object containing a set of genomic intervals 
(eg. as returned by \code{\link{dba.report}})}

\item{\code{logical} or \code{numeric}}{vector of length > 1 
indicating which sites to include in the heatmaps.
If \code{logical}, vector should be same length as number of 
consensus sites binding matrix.}

\item{\code{\link{GRangesList}}}{containing a list of \code{\link{GRanges}},
each containing a set of genomic intervals. 
Each element of the list will be plotted in a separate heatmap as a group of sites.
If the constituent \code{\link{GRanges}} elements are named, the names will
be used as labels for the site groups.}

\item{A \code{numeric} value}{indicating a contrast on which an analysis has
been run. 
In this case, all of the differentially-bound sites will be included, divided
into two groups: a group of \code{Gain} sites (\code{Fold > 0}) and a group
of \code{Loss} sites (\code{Fold < 0}).}

\item{A report-based \code{DBA} object,}{as generated by \code{\link{dba.report}}.
Each set of peaks in the object will be included as a separate group of sites.}

}

If \code{sites} is absent, and an analysis has been completed, 
the first contrast will be used (\code{sites=1}); 
otherwise, all sites (subject to the \code{maxSites} limit) will be 
included.
}

\item{scores}{
\code{character} string corresponding to the name of a metadata column containing 
numerical scores used to sort the sites (within each group).

These can be any of the \code{\link{mcols}} name values when passing in \code{sites} 
as a \code{GRanges} or \code{GRangesList} object,
or the metadata fields in a report-based DBA object.
If the \code{Object} is of type \code{profileplyr-class}, it can
be any of its \code{\link{mcols}} names for columns corresponding 
to numeric values. 

If \code{scores=NULL}, the sites will be sorted by their
mean counts across all the samples.
}
 
\item{labels}{
Either a vector of sample label names (one for each sample in the plot),
or a set of attributes to include (positive values)
or exclude (negative values).
Attributes include:
\itemize{ 
\item \code{\link{DBA_ID}}
\item \code{\link{DBA_TISSUE}}
\item \code{\link{DBA_FACTOR}}
\item \code{\link{DBA_CONDITION}}
\item \code{\link{DBA_TREATMENT}}
\item \code{\link{DBA_REPLICATE}}
\item \code{\link{DBA_CONSENSUS}}
\item \code{\link{DBA_CALLER}}
}
}

% \item{annotate}{
% \code{logical} indicating if a genome feature annotation should be included.
% }

\item{normalize}{
\code{logical} indicating if the window counts should be normalized
using the normalization established by \code{\link{dba.normalize}}.

Can also be a vector of normalization factors, once for each sample.
All counts for a sample will be divided by the normalization factor for that sample.
}

\item{merge}{
Set of attributes to be used to determine which samples should be merged.
All samples that share the same values for all other attributes except those specified
will be merged by taking their mean count score 
(after normalizing, if specified),
and included as a single sample column.

Can also be specified as a list of vectors of sample numbers (relative to their
order in \code{mask}). 
The samples corresponding to the values in each vector will
be merged into a single sample.

}
\item{maxSites}{
Maximum number of sites to include in a heatmap group.
The top-scoring sites will be retained.
}

\item{absScores}{
If \code{TRUE}, the absolute values for the score values
(specified by the \code{scores} parameter)
will be used for 
sorting sites.
Useful for fold changes. 
If score values are greater than zero, this has no effect.
}


\item{doPlot}{
\code{logical} indicating if the heatmap should be plotted.
If \code{FALSE}, the profiles are generated and returned but not plotted.
}

\item{...}{
additional parameters passed on to \code{profileplyr::generateEnrichedHeatmap}.
}

}

\details{
This function enables the computation of peakset profiles and 
the plotting of complex heatmaps. 
It serves as a front-end to enable experiments analyzed using 
\code{\link{DiffBind}} to more easily use the 
profiling and plotting functionality provided by the \code{profileplyr} package 
written by Tom Carroll and Doug Barrows.

Processing proceeds in two phases.

In the first phase, specific peaksets are extracted from a
\code{\link{DiffBind}} \code{DBA} object, 
and profiles are calculated for these peaks for set of samples 
in the \code{\link{DiffBind}} experiment. 
Profiles are calculated by counting the number of overlapping reads 
in a series of bins upstream and downstream of each peak center.

In the second phase, the derived profiles are plotted in a series of 
complex heatmaps showing the relative intensity of overlapping peaks 
in each bin for each peak in each sample, 
along with summary plots showing the average profile 
across the sites for each sample.

Due to the computational cost of this function, 
it is advised that the calculation of profiles 
and the plotting of heatmaps be separated into two calls,
so that the profiles do not need to be re-generated if something goes wrong 
in the plotting. 
By default, when a \code{DBA} object is passed in to generate profiles, 
plotting is turned off and a \code{profileplyr} object is returned. 
When \code{\link{dba.plotProfile}} is called with a \code{profileplyr} object, 
a plot is generated by default.

More detailed documentation is included in a markdown demonstration script
included with the \code{\link{DiffBind}} package. This can be located as
follows:

\code{system.file('extra/plotProfileDemo.Rmd',package='DiffBind')}

An HTML version of the demonstration notebook can be accessed online
at 
\url{https://content.cruk.cam.ac.uk/bioinformatics/software/DiffBind/plotProfileDemo.html}

}
\value{
silently returns a \code{profileplyr-class} object.
}

\note{
This function is currently disabled in this release of DiffBind because the
\code{profileplyr} package is not installable in the current Bioconductor
release. Calling \code{dba.plotProfile} will print a message and return
\code{NULL} invisibly. Profile plotting will be restored in a future release
when \code{profileplyr} is available again or a replacement backend is wired
in.
}
\references{
Carroll T, Barrows D (2020). profileplyr: Visualization and annotation of 
read signal over genomic ranges with profileplyr. 
DOI: 10.18129/B9.bioc.profileplyr 
}

\author{
Rory Stark
}
%\note{
%plots log2 values of read counts.
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\itemize{ 
\item \code{profileplyr::profileplyr-class}
\item \code{profileplyr::BamBigwig_to_chipProfile}
\item \code{profileplyr::generateEnrichedHeatmap}
\item \code{profileplyr::profileplyr} (Vignette)
\item \code{\link{DBA.config}}
}
}

\examples{

# See plotProfileDemo notebook:
# system.file('extra/plotProfileDemo.Rmd',package='DiffBind')

data(tamoxifen_analysis)

# default Profile plot
\dontrun{dba.plotProfile(tamoxifen)}

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.plotHeatmap}
\alias{dba.plotHeatmap}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Draw a binding site heatmap
}
\description{
Draws a binding site heatmap
}
\usage{
dba.plotHeatmap(DBA, attributes=DBA$attributes, maxSites=1000, minval, maxval,
                contrast, method=DBA$config$AnalysisMethod, 
                th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
                report, score, bLog=TRUE, mask, sites, sortFun=sd,
                correlations=TRUE, olPlot=DBA_COR, 
                ColAttributes,RowAttributes, colSideCols, rowSideCols=colSideCols,
                margin=10, colScheme="Greens", distMethod="pearson",
                ...)
}
%- maybe also 'usage' for other objects documented here.

\arguments{

%\subsection{Required arguments}{}

\item{DBA}{
DBA object. 
}

%\subsection{Optional/defaulted arguments}{}

\item{attributes}{
attribute or vector of attributes to use for column labels:
\itemize{ 
\item \code{\link{DBA_ID}}
\item \code{\link{DBA_TISSUE}}
\item \code{\link{DBA_FACTOR}}
\item \code{\link{DBA_CONDITION}}
\item \code{\link{DBA_TREATMENT}}
\item \code{\link{DBA_REPLICATE}}
\item \code{\link{DBA_CONSENSUS}}
\item \code{\link{DBA_CALLER}}
}
}

\item{maxSites}{
maximum number of binding sites to use in heatmap. 
Only used when not drawing a correlation heatmap (\code{correlations=FALSE})
}

\item{minval}{
Set all scores less than this to minval
}
\item{maxval}{
Set all scores greater than this to maxval
}

\item{contrast}{
number of contrast to report on; if present, draws a heatmap based on a differential binding affinity analysis
(see \code{\link{dba.analyze}}). 
Only significantly differentially bound sites will be used 
(subject to the \code{th} and \code{bUsePval} parameters). 
If mask is unspecified, only the samples in the contrast will be included. 
See  \code{\link{dba.show}(DBA, bContrast=TRUE)} to get contrast numbers. 
If missing, uses scores in the main binding matrix.
}
\item{method}{
analysis method (used in conjunction with contrast):
\itemize{ 
\item \code{\link{DBA_DESEQ2}}
\item \code{\link{DBA_DESEQ2_BLOCK}}
\item \code{\link{DBA_EDGER}}
\item \code{\link{DBA_EDGER_BLOCK}}
}
}

\item{th}{
significance threshold; all sites with FDR (or p-values, see b\code{UsePval})
less than or equal to this value will be included in the report (subject to \code{maxSites}). 
Used in conjunction with \code{contrast}.
}
\item{bUsePval}{
logical indicating whether to use FDR (\code{FALSE}) or p-value (\code{TRUE})
for thresholding. Used in conjunction with \code{contrast}.
}
\item{report}{
report (obtained from \code{\link{dba.report}} specifying the data to be used. 
If this is present, the \code{method}, \code{th}, and \code{bUsePval} parameters are ignored.
Used in conjunction with \code{contrast}.
}
\item{score}{
Score to use for count data. Only used when plotting the global binding matrix (no contrast specified). One of:
\itemize{
\item \code{\link{DBA_SCORE_NORMALIZED}}
\item \code{\link{DBA_SCORE_READS}}
\item \code{\link{DBA_SCORE_CONTROL_READS}}
\item \code{\link{DBA_SCORE_READS_MINUS}}
%\item \code{\link{DBA_SCORE_READS_FULL}}
%\item \code{\link{DBA_SCORE_READS_EFFECTIVE}}
%\item \code{\link{DBA_SCORE_READS_MINUS_FULL}}
%\item \code{\link{DBA_SCORE_READS_MINUS_EFFECTIVE}}
\item \code{\link{DBA_SCORE_READS_FOLD}}
\item \code{\link{DBA_SCORE_RPKM}}
\item \code{\link{DBA_SCORE_RPKM_FOLD}}
\item \code{\link{DBA_SCORE_RPKM_MINUS}}
%\item \code{\link{DBA_SCORE_TMM_READS_FULL}}
%\item \code{\link{DBA_SCORE_TMM_READS_EFFECTIVE}}
%\item \code{\link{DBA_SCORE_TMM_MINUS_FULL}}
%\item \code{\link{DBA_SCORE_TMM_MINUS_EFFECTIVE}}
}
}
\item{bLog}{
Logical indicating that log2 values should be used. 
Only applicable with read count scores (not peak scores).
}
\item{mask}{
mask indicating a subset of peaksets to use when using global binding matrix scores. 
If a \code{contrast} is specified, these peaksets will be included, 
but only the significantly differentially bound sites 
(using \code{th}, \code{bUsePva}l, and/or \code{report}) will be included.
}
  \item{sites}{
logical vector indicating which sites to include; first \code{maxSites} of these. 
Only relevant when using global binding matrix (\code{contrast} is missing).
}

 \item{sortFun}{
function taking a vector of scores and returning a single value.
Only relevant when using global binding matrix (\code{contrast} is missing).
If not equal to \code{FALSE}, the global binding matrix will be sorted (descending) on the results, 
and the first \code{maxSites} used in the heatmap. 
Recommended sort function options include \code{\link{sd}}, \code{\link{mean}}, \code{\link{median}}, \code{\link{min}}.
}

\item{correlations}{
logical indicating that a correlation heatmap should be plotted (\code{TRUE}). 
If \code{FALSE}, a binding heatmap of scores/reads is plotted. 
This parameter can also be set to a correlation record; 
see  \code{\link{dba.overlap}(mode=DBA_OLAP_ALL)}, in which case a correlation heatmap is plotted
based on the specified correlation record, using the statistic specified in \code{olPlot}.
}

 \item{olPlot}{
if correlations is specified as a dataframe returned by  \code{\link{dba.overlap}}, 
indicates which statistic to plot. 
One of:
\describe{
\item{\code{\link{DBA_COR}}}{Correlation}
\item{\code{\link{DBA_OLAP}}}{Percentage overlap}
\item{\code{\link{DBA_INALL}}}{number of peaks common to both samples}
}
}
\item{ColAttributes}{
Attribute or vector of attributes to plot for column color bars. 
If missing, all attributes with two or more unique non-NA values will be plotted. 
(For correlation heatmaps, \code{DBA_GROUP} will be plotted in the column color bar by default 
when a \code{contrast} is specified). 
A value of \code{NULL} indicates that no column color bar should be drawn. 
Allowable attribute values include:
\itemize{ 
\item \code{\link{DBA_GROUP}}
\item \code{\link{DBA_TISSUE}}
\item \code{\link{DBA_FACTOR}}
\item \code{\link{DBA_CONDITION}}
\item \code{\link{DBA_TREATMENT}}
\item \code{\link{DBA_REPLICATE}}
\item \code{\link{DBA_CALLER}}
}
}
\item{RowAttributes}{
Attribute or vector of attributes for row color bars. 
Row color bars are only allowed for correlation heatmaps.  
Same values as for \code{ColAttributes} parameter. 
Default is  to draw a row color bar only if a \code{contrast} is specified, 
in which case the plotted attribute is \code{DBA_GROUP} (if present).
}
\item{rowSideCols}{
Vector of colors to use in row color bars.
Uses default colors if missing. 
Can also be a list of color vectors.
}
\item{colSideCols}{
Vector of colors to use in column color bars.
Uses default colors if missing.
Can also be a list of color vectors.
}
  \item{margin}{
margin size of plot
}
  \item{colScheme}{
Color scheme; see \code{\link{colorRampPalette}} 
}
  \item{distMethod}{
distance method for clustering; see \code{\link{Dist}}
}

\item{\dots}{
passed on to \code{\link{heatmap.2}}, e.g. \code{scale} etc.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
MODE: Correlation Heatmap plot using statistics for global binding matrix:

\code{dba.plotHeatmap(DBA, attributes=DBA$attributes, minval, maxval,
                      correlations, olPlot,
                      colScheme="Greens", distMethod="pearson", ...)}
                      
MODE: Correlation Heatmap plot using statistics for significantly differentially bound sites:

\code{dba.plotHeatmap(DBA, attributes=DBA$attributes, minval, maxval,
                      contrast, method=DBA_DESEQ2, th=0.05, bUsePval=F, mask,
                      overlaps, olPlot=DBA_COR,
                      colScheme="Greens", distMethod="pearson", ...)}
                      
MODE: Binding heatmap plot using significantly differentially bound sites:

\code{dba.plotHeatmap(DBA, attributes, maxSites, minval, maxval,
                      contrast, method, th, bUsePval, correlations=FALSE,
                      colScheme, distMethod, ...)}


MODE: Binding heatmap plot using the global binding matrix:

\code{dba.plotHeatmap(DBA, attributes, maxSites, minval, maxval,
                      mask, sites, correlations=FALSE, sortFun,
                      colScheme, distMethod, ...)}
}
\value{
%%  ~Describe the value returned
if  correlations is not \code{FALSE}, the overlap/correlation matrix is returned.

if correlations is \code{FALSE}, the sites used in the heatmap are returned in a
\code{\link{GRanges}} object,
in the row order they appear (top to bottom).
The metadata contains a column for 
each sample (also in the order they are appear in the clustering plot), 
with the values being the actual plotted values.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{dba.overlap}}
}

\examples{
data(tamoxifen_peaks)
# peak overlap correlation heatmap
dba.plotHeatmap(tamoxifen)

data(tamoxifen_counts)
# counts correlation heatmap
dba.plotHeatmap(tamoxifen)

data(tamoxifen_analysis)
#correlation heatmap based on all normalized data
dba.plotHeatmap(tamoxifen,contrast=1,th=1)

#correlation heatmap based on DB sites only
dba.plotHeatmap(tamoxifen,contrast=1)

#binding heatmap based on DB sites
dba.plotHeatmap(tamoxifen,contrast=1,correlations=FALSE)

#binding heatmap based on 1,000 sites with highest variance
sites <- dba.plotHeatmap(tamoxifen,contrast=1,th=1,
                         correlations=FALSE,sortFun=var)
sites

data(tamoxifen_counts)
#Examples of  heatmaps using DB sites with different subsets of samples
#exclude T47D
tamoxifen <- dba.contrast(tamoxifen,design=FALSE,
                          group1=tamoxifen$masks$Resistant,
                          group2=c(3:5,10:11)) 
tamoxifen <- dba.analyze(tamoxifen)

# regular heatmaps with samples from two contrast groups only
dba.plotHeatmap(tamoxifen, contrast=1) 
#also include the T47D samples
dba.plotHeatmap(tamoxifen,contrast=1,mask=tamoxifen$masks$All) 

#correlation heatmap without MCF7 
plot(tamoxifen,contrast=1,mask=!tamoxifen$masks$MCF7) 

# binding heatmap using only the MCF7 samples
dba.plotHeatmap(tamoxifen,contrast=1,mask=tamoxifen$masks$MCF7,correlations=FALSE)  

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.report}
\alias{dba.report}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Generate a report for a differential binding affinity analysis
}
\description{
Generates a report for a differential binding affinity analysis
}
\usage{
dba.report(DBA, contrast, method=DBA$config$AnalysisMethod, 
           th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
           fold=0, bNormalized=TRUE, bFlip=FALSE, precision,
           bCalled=FALSE, bCounts=FALSE, bCalledDetail=FALSE,
           bDB, bNotDB, bAll=TRUE, bGain=FALSE, bLoss=FALSE,
           file,initString=DBA$config$reportInit,ext='csv',
           DataType=DBA$config$DataType) 
}        
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}


\item{DBA}{
DBA object. 
A differential binding affinity analysis needs to have been previously carried out 
(see  \code{\link{dba.analyze}}).
}
%\subsection{Optional/defaulted arguments}{}
  \item{contrast}{
contrast number to report on. 
When generating a report-based DBA object, this can be a vector of contrast numbers. 
If missing, defaults to first contrast for reports, 
and all contrasts when generating a report-based DBA object.  
See  \code{\link{dba.show}(DBA, bContrast=T)} to get contrast numbers.
}
  \item{method}{
method used for analysis:
\itemize{ 
\item \code{\link{DBA_DESEQ2}}
\item \code{\link{DBA_DESEQ2_BLOCK}}
\item \code{\link{DBA_EDGER}}
\item \code{\link{DBA_EDGER_BLOCK}}
}
When generating a report-based DBA object (see \code{bDB} and \code{bNotDB} parameters below),
a vector of methods may be supplied, including the shortcuts
\itemize{ 
\item \code{\link{DBA_ALL_METHODS}}
\item \code{\link{DBA_ALL_BLOCK}}
\item \code{\link{DBA_ALL_METHODS_BLOCK}}
}
}
\item{th}{
significance threshold; all sites with FDR (or p-values, see \code{bUsePval}) 
less than or equal to this value will be included in the report. 
A value of \code{1} will include all binding sites in the report.
}
\item{bUsePval}{
logical indicating whether to use FDR (\code{FALSE}) or p-value (\code{TRUE}) for thresholding.
}
\item{fold}{
only sites with an absolute log Fold value greater than equal to this 
will be included in the report.
This should be supplied as a \code{log2()} value.

If \code{fold} is greater than zero, 
and an explicit design was used for the contrast,
the \code{p-value} and \code{FDR} will be re-calculated based on testing
for changes greater than the specified fold change.
For a \code{DESeq2} analysis, this involves including the \code{fold}
when calling \code{DESeq2::results}.
For a \code{edgeR} analysis, \code{edgeR::glmTreat} is used.

}
\item{bNormalized}{
logical indicating that normalized data (using normalization factors computed 
by differential analysis method) should be reported.

When \code{bNormalized=TRUE}, read counts are adjusted by the 
normalization factors for calculating concentration values.
Fold changes are reported using the potentially shrunk values
computed by the underlying analysis package.

When \code{bNormalized=FALSE}, raw count data is used as the basis for reporting 
log concentration values, and Fold changes are reported based on 
subtracting the log concentration of one sample group from the other.

Confidence statistics (p-value/FDR) are always reported as computed by the
underlying analysis package, which incorporate normalization factors.
}
 \item{bFlip}{
logical indicating that order of groups in contrast should be "flipped",
allowing control of which sample group
will have positive and which will have negative fold changes.
}
 \item{precision}{
If present, alters the default precision for the 
\code{Concentration}, \code{Fold}, \code{p-value}, and \code{FDR} values in the returned report.
A value of \code{0} indicates maximum precision. 
Otherwise, it should be a 2-value vector. 
The first value controls how many digits to the right of the decimal to include for concentration and fold values. 
These second value control how many digits to the right of the decimal to include for the p-value and FDRs.
Default is \code{precision=2:3}, 
unless \code{DataType=DBA_DATA_SUMMARIZED_EXPERIMENT}, 
in which case the default is \code{0} (full precision).
}

\item{bCalled}{
logical indicating that peak caller status should be included. 
This will add a column for each group, each indicating the number of samples in the group identified as a peak in the original peaksets.
Note that this option is only available if the consensus peakset was calculated by 
\code{\link{dba.count}}; 
if a consensus peakset was passed in explicitly using the \code{peaks} parameter, 
original peak origins are lost.
}
\item{bCounts}{
logical indicating that count data for individual samples should be reported as well as group statistics. Columns are added for each sample in the first group, followed by columns for each sample in the second group.
}
\item{bCalledDetail}{
logical indicating that peak caller status should be included for each sample (if available). 
Columns are added for each sample in the first group, followed by columns for each sample in the second group.
}
\item{bDB}{
logical indicating that a report-based DBA object should be generated, and that it should include Differentially Bound (DB) sites (respecting the \code{th}, \code{bUsePval}, and \code{fold} parameters).
}
\item{bNotDB}{
logical indicating that a report-based DBA object should be generated, and that it should include non-Differentially Bound (non-DB) sites (respecting the \code{th}, \code{bUsePval}, and \code{fold} parameters).
}
\item{bAll}{
logical indicating that a report-based DBA object should be generated, and that it should include peaksets combining peaks with both positive and negative fold changes.
}
\item{bGain}{
logical indicating that a report-based DBA object should be generated, and that it should include peaksets with only positive fold changes.
}
\item{bLoss}{
logical indicating that a report-based DBA object should be generated, and that it should include peaksets with only negative fold changes.
}
  \item{file}{
if present, also save the report to a comma separated value (csv) file, using this filename.
}
  \item{initString}{
if saving to a file, pre-pend this string to the filename.
}
  \item{ext}{
if saving to a file, append this extension to the filename.
}
\item{DataType}{
The class of object for returned report:
\itemize{
\item \code{\link{DBA_DATA_GRANGES}}
\item \code{\link{DBA_DATA_RANGEDDATA}}
\item \code{\link{DBA_DATA_FRAME}}
}
If set to \code{\link{DBA_DATA_SUMMARIZED_EXPERIMENT}}, the result will be 
a \code{\link{SummarizedExperiment}} object, with all the count data and 
sample metadata for the experiment. 
The contrast statistics will be included as metadata columns in the 
\code{rowData} of the object.

Can be set as default behavior by setting \code{DBA$config$DataType}.
}
}
%\details{
%}
\value{
if neither \code{bDB} or \code{bNotDB} is set to \code{TRUE}, 
a report dataframe or \code{\link{GRanges}} object is returned, 
with a row for each binding site within the thresholding parameters, 
and the following columns:
\item{\code{Chr}}{Chromosome of binding site}
\item{\code{Start}}{Starting base position of binding site}
\item{\code{End}}{End base position of binding site}
\item{\code{Conc}}{Concentration -- mean (log) reads across all samples in both groups}
\item{\code{Conc_group1}}{Group 1 Concentration -- mean (log) reads across all samples first group}
\item{\code{Conc_group2}}{Group 2 Concentration -- mean (log) reads across all samples in second group}
\item{\code{Fold}}{Fold difference -- mean fold difference of binding affinity of group 1 over group 2 (Conc1 - Conc2). Absolute value indicates magnitude of the difference, and sign indicates which one is bound with higher affinity, with a positive value indicating higher affinity in the first group }
\item{\code{p-value}}{p-value calculation -- statistic indicating significance of difference (likelihood difference is not attributable to chance)}
\item{\code{FDR}}{adjusted p-value calculation -- p-value subjected to multiple-testing correction}

If \code{bCalled} is \code{TRUE} and caller status is available, two more columns will follow:
\item{\code{Called1}}{Number of samples in group 1 that identified this binding site as a peak}
\item{\code{Called2}}{Number of samples in group 2 that identified this binding site as a peak}

If \code{bCounts} is \code{TRUE}, a column will be present for each sample in group 1, followed by each sample in group 2, if present.
The \code{SampleID} will be used as the column header.
This column contains the read counts for the sample.

If \code{bCalledDetail} is \code{TRUE}, a column will be present for each sample in group 1, 
followed by each sample in group 2, if present. 
The \code{SampleID} will be used as the column header. 
This column contains a "+" to indicate for which sites the sample was called as a peak,
and a "-" if it was not so identified.

If  \code{bDB} or \code{bNotDB} is set to \code{TRUE}, a special \code{DBA object} is returned,
containing peaksets based on sites determined to be differentially bound (or not) 
as specified using the \code{bDB}, \code{bNotDB}, \code{bGain}, \code{bLoss}, and \code{bAll} parameters. 
In this \code{DBA object}, the \code{Tissue} value will specify the direction of the change (\code{Gain} 
for positive fold changes, \code{Loss} for negative fold changes, and \code{All} 
for any fold change). 
The \code{Factor} value specifies if the peaks are differentially bound 
(\code{DB}) or not (\code{!DB}). 
The \code{Condition} value specifies the analysis method (e.g. \code{edgeR}), 
and the \code{Treatment} value is blank for unblocked analyses and set to \code{block} for blocked analyses.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{dba.analyze}},  \code{\link{DBA.config}}.
}

\examples{
data(tamoxifen_analysis)

#Retrieve DB sites with FDR <  0.05
tamoxifen.DB <- dba.report(tamoxifen)
tamoxifen.DB

#Retrieve DB sites with p-value <  0.05 and Fold > 2
tamoxifen.DB <- dba.report(tamoxifen, th=.05, bUsePval=TRUE, fold=2)
tamoxifen.DB

#Retrieve all sites with confidence stats
# and how many times each site was identified as a peak
tamoxifen.DB <- dba.report(tamoxifen, th=1, bCalled=TRUE)
tamoxifen.DB

#Retrieve all sites with confidence stats and normalized counts
tamoxifen.DB <- dba.report(tamoxifen, th=1, bCounts=TRUE)
tamoxifen.DB

#Retrieve all sites with confidence stats and raw counts
tamoxifen.DB <- dba.report(tamoxifen, th=1, bCounts=TRUE,bNormalized=FALSE)
tamoxifen.DB

#Retrieve report as a SummarizedObject
tamoxifen.sset <- dba.report(tamoxifen, DataType=DBA_DATA_SUMMARIZED_EXPERIMENT)
tamoxifen.sset

#Retrieve report-based DBA object
data(tamoxifen_analysis)
tamoxifen <- dba.analyze(tamoxifen,method=DBA_ALL_METHODS)
tamoxifen.DB <- dba.report(tamoxifen,method=c(DBA_EDGER,DBA_DESEQ2),
                          bDB=TRUE)
tamoxifen.DB
dba.plotVenn(tamoxifen.DB,1:2)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.plotBox}
\alias{dba.plotBox}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Boxplots
}
\description{
Boxplots for read count distributions within differentially bound sites
}
\usage{
dba.plotBox(DBA, contrast=1, method=DBA$config$AnalysisMethod, 
            th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
            bNormalized=TRUE, attribute=DBA_GROUP, mask,
            bAll=FALSE, bAllIncreased=FALSE, bAllDecreased=FALSE, 
            bDB=TRUE, bDBIncreased=TRUE, bDBDecreased=TRUE,
            pvalMethod=wilcox.test,  bReversePos=FALSE, attribOrder, 
            vColors, varwidth=TRUE, notch=TRUE, ...) 
}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}

\item{DBA}{
DBA object.
}

%\subsection{Optional/defaulted arguments}{}

\item{contrast}{
number of contrast to use for boxplot.
}

\item{method}{
method used for analysis (used in conjunction with contrast):
\itemize{ 
\item \code{\link{DBA_DESEQ2}}
\item \code{\link{DBA_DESEQ2_BLOCK}}
\item \code{\link{DBA_EDGER}}
\item \code{\link{DBA_EDGER_BLOCK}}
}
}
\item{th}{
significance threshold; all sites with FDR (or p-values, see bUsePval) 
less than or equal to this value will be included in the boxplot.
}
\item{bUsePval}{
logical indicating whether to use FDR (FALSE) or p-value (TRUE) for thresholding.
}

\item{bNormalized}{
logical indicating that normalized data (using normalization factors computed by differential analysis method) 
should be plotted. \code{FALSE} uses raw count data.
}


\item{attribute}{
attribute to use for determining groups of samples. 
Default (\code{DBA_GROUP}) plots the two groups used in the contrast, if available. 
Possible values:
\itemize{ 
\item \code{\link{DBA_GROUP}}
\item \code{\link{DBA_ID}}
\item \code{\link{DBA_TISSUE}}
\item \code{\link{DBA_FACTOR}}
\item \code{\link{DBA_CONDITION}}
\item \code{\link{DBA_TREATMENT}}
\item \code{\link{DBA_REPLICATE}}
\item \code{\link{DBA_CONSENSUS}}
\item \code{\link{DBA_CALLER}}
}
}

\item{mask}{
logical mask of samples to include when no groups are present.
}

\item{bAll}{
logical indicating if plot should include a set of boxplots using all counts, 
regardless of whether or not they pass the significance threshold.
}
\item{bAllIncreased}{
logical indicating if plot should include a set of boxplots using all counts that increase in affinity, regardless of whether or not they pass the significance threshold.
}
\item{bAllDecreased}{
logical indicating if plot should include a set of boxplots using all counts that decrease in affinity, regardless of whether or not they pass the significance threshold.
}
\item{bDB}{
logical indicating if plot should include a set of boxplots using all counts in significantly differentially bound sites (i.e. those that pass the significance threshold), 
regardless of whether they increase or decrease in affinity.
}
\item{bDBIncreased}{
logical indicating if plot should include a set of boxplots using all counts  in significantly differentially bound sites that increase in affinity.
}
\item{bDBDecreased}{
logical indicating if plot should include a set of boxplots using all counts  in significantly differentially bound sites that decrease in affinity.
}

\item{pvalMethod}{
method to use when computing matrix of p-values. 
If \code{NULL}, no matrix is computed, and NULL is returned; this may speed up processing if there are many boxplots.
}

\item{bReversePos}{
logical indicating if the default definition of positive affinity (higher affinity in the second group of the contrast) should be reversed 
(i.e. positive affinity is defined as being higher in the first group of the contrast).
}

\item{attribOrder}{
vector of group numbers used to change the order that groups are plotted. 
If \code{NULL}, default order is used (group order for \code{DBA_GROUP}, and the order the attribute values appear for other values of attribute).
}

\item{vColors}{
vector of custom colors; if absent, default colors will be used.
}
\item{varwidth}{
passed to boxplot
}
\item{notch}{
passed to boxplot
}
\item{\dots}{
other arguments passed to boxplot
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
Draws a boxplot showing distributions of read counts for various groups of samples under various conditions.
In default mode, draws six boxes: one pair of boxes showing the distribution of read counts within all
significantly differentially bound sites (one box for each sample group), one pair of boxes showing the
distribution of read counts for significantly differentially bound sites that increase affinity in 
the second group, and a second pair of boxes showing the distribution of read counts 
for significantly differentially bound sites that have higher mean affinity in the first group. 
}
\value{
if \code{pvalMethod} is not \code{NULL}, returns a matrix of p-values indicating the significance of the difference between each pair of distributions.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{

%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
\examples{
data(tamoxifen_analysis)

#default boxplot includes all DB sites, then divided into those increasing 
# affinity in each group
dba.plotBox(tamoxifen)

# plot non-normalized data for DB sites by tissue
# (changing order to place Resistant samples last)
dba.plotBox(tamoxifen, attribute=DBA_CONDITION, bDBIncreased=FALSE,
            bDBDecreased=FALSE, attribOrder=c(2,1), bNormalized=FALSE)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.overlap}
\alias{dba.overlap}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Compute binding site overlaps (occupancy analysis)
}
\description{
Computes binding overlaps and co-occupancy statistics 
}
\usage{
dba.overlap(DBA, mask, mode=DBA_OLAP_PEAKS, 
            contrast, method=DBA$config$AnalysisMethod, th=DBA$config$th, 
            bUsePval=DBA$config$bUsePval, 
            report, byAttribute, bCorOnly=TRUE, CorMethod="pearson", 
            DataType=DBA$config$DataType)
}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\emph{Required arguments:}


\item{DBA}{
DBA object
}

%\emph{Optional/defaulted arguments:}
 
\item{mask}{
mask or vector of peakset numbers indicating a subset of peaksets to use (see \code{\link{dba.mask}}). 
When generating overlapping/unique peaksets, either two, three, or four peaksets may be specified. 
If the mode type is \code{DBA_OLAP_ALL}, and a contrast is specified, a value of \code{TRUE} (mask=TRUE)
indicates that all samples should be included 
(otherwise only those present in one of the contrast groups will be included).
}

\item{mode}{
indicates which results should be returned (see MODES below). One of:
\itemize{
\item \code{\link{DBA_OLAP_PEAKS}}
\item \code{\link{DBA_OLAP_ALL}}
\item \code{\link{DBA_OLAP_RATE}}
}
}

  \item{contrast}{
contrast number to use. Only specified if contrast data is to be used when \code{mode=DBA_OLAP_ALL}. 
See \code{\link{dba.show}(DBA, bContrast=T)} to get contrast numbers. 
}
  \item{method}{
if contrast is specified and \code{mode=DBA_OLAP_ALL}, use data from method used for analysis:
\itemize{ 
\item \code{\link{DBA_DESEQ2}}
\item \code{\link{DBA_DESEQ2_BLOCK}}
\item \code{\link{DBA_EDGER}}
\item \code{\link{DBA_EDGER_BLOCK}}
}
}
\item{th}{
if contrast is specified and \code{mode=DBA_OLAP_ALL}, 
significance threshold; all sites with FDR (or p-values, see \code{bUsePval}) 
less than or equal to this value will be included. 
A value of \code{1} will include all binding sites, but only the samples included in the contrast.
}
\item{bUsePval}{
if contrast is specified and \code{mode=DBA_OLAP_ALL}, logical indicating whether to use 
FDR (\code{FALSE}) or p-value (\code{TRUE}) for thresholding.
}
\item{report}{
if contrast is specified and \code{mode=DBA_OLAP_ALL}, a report (obtained from \code{\link{dba.report}}) 
specifying the data to be used. 
If counts are included in the report (and a contrast is specified), 
the count data from the report will be used to compute correlations, 
rather than the scores in the global binding affinity matrix. 
If report is present, the \code{method}, \code{th}, and \code{bUsePval} parameters are ignored.
}
\item{byAttribute}{
when computing co-occupancy statistics (\code{DBA_OLAP_ALL}), limit comparisons to peaksets with the same value for a specific attribute, one of:
\itemize{
\item \code{\link{DBA_ID}}
\item \code{\link{DBA_TISSUE}}
\item \code{\link{DBA_FACTOR}}
\item \code{\link{DBA_CONDITION}}
\item \code{\link{DBA_TREATMENT}}
\item \code{\link{DBA_REPLICATE}}
\item \code{\link{DBA_CONSENSUS}}
\item \code{\link{DBA_CALLER}}
}
}

\item{bCorOnly}{
when computing co-occupancy statistics (\code{DBA_OLAP_ALL}), logical indicating that only correlations, and not overlaps, should be computed. 
This is much faster if only correlations are desired 
(e.g. to plot the correlations using  \code{\link{dba.plotHeatmap}}).
}

\item{CorMethod}{
when computing co-occupancy statistics (\code{DBA_OLAP_ALL}), method to use when computing correlations.
}

\item{DataType}{
if \code{mode==DBA_OLAP_PEAKS}, the class of object that peaksets should be returned as:
\itemize{
\item \code{\link{DBA_DATA_GRANGES}}
\item \code{\link{DBA_DATA_RANGEDDATA}}
\item \code{\link{DBA_DATA_FRAME}}
}
Can be set as default behavior by setting \code{DBA$config$DataType}.
}

}
\details{
%%  ~~ If necessary, more details than the description above ~~

MODE: Generate overlapping/unique peaksets:

\code{dba.overlap(DBA, mask, mode=DBA_OLAP_PEAKS, minVal)}

MODE: Compute correlation and co-occupancy statistics (e.g. for dba.plotHeatmap):

\code{dba.overlap(DBA, mask, mode=DBA_OLAP_ALL, byAttribute, minVal,
            attributes, bCorOnly, CorMethod)}

MODE: Compute correlation and co-occupancy statistics using significantly differentially bound sites (e.g. for dba.plotHeatmap):

\code{dba.overlap(DBA, mask, mode=DBA_OLAP_ALL, byAttribute, minVal,
            contrast, method, th=, bUsePval,
            attributes, bCorOnly, CorMethod)}
       
Note that the scores from the global binding affinity matrix will be used for correlations unless a report containing count data is specified.

MODE: Compute overlap rates at different stringency thresholds:

\code{dba.overlap(DBA, mask, mode=DBA_OLAP_RATE, minVal)}
}
\value{
Value depends on the mode specified in the mode parameter.

If \code{mode=DBA_OLAP_PEAKS}, Value is an overlap record: a list of three peaksets for an A-B overlap,  seven peaksets for a A-B-C overlap, and fifteen peaksets for a A-B-C-D overlap:
\item{\code{inAll}}{peaks in all peaksets}
\item{\code{onlyA}}{peaks unique to peakset A}
\item{\code{onlyB}}{peaks unique to peakset B}
\item{\code{onlyC}}{peaks unique to peakset C}
\item{\code{onlyD}}{peaks unique to peakset D}
\item{\code{notA}}{peaks in all peaksets except peakset A}
\item{\code{notB}}{peaks in all peaksets except peakset B}
\item{\code{notC}}{peaks in all peaksets except peakset C}
\item{\code{notD}}{peaks in all peaksets except peakset D}
\item{\code{AandB}}{peaks in  peaksets A and B but not in peaksets C or D}
\item{\code{AandC}}{peaks in  peaksets A and C but not in peaksets B or D}
\item{\code{AandD}}{peaks in  peaksets A and D but not in peaksets B or C}
\item{\code{BandC}}{peaks in  peaksets B and C but not in peaksets A or D}
\item{\code{BandD}}{peaks in  peaksets B and D but not in peaksets A or C}
\item{\code{CandD}}{peaks in  peaksets C and D but not in peaksets A or B}


If \code{mode=DBA_OLAP_ALL}, Value is a correlation record: 
a matrix with a row for each pair of peaksets and the following columns:
\item{\code{A}}{peakset number of first peakset in overlap}
\item{\code{B}}{peakset number of second peakset in overlap}
\item{\code{onlyA}}{number of sites unique to peakset A}
\item{\code{onlyB}}{number of sites unique to peakset B}
\item{\code{inAll}}{number of peaks in both peakset A and B (merged)}
\item{\code{R2}}{correlation value A vs B}
\item{\code{Overlap}}{percentage overlap (number of overlapping sites divided by number of peaks unique to smaller peakset}


If \code{mode=DBA_OLAP_RATE}, Value is a vector whose length is the number of peaksets, 
containing the number of overlapping peaks at the corresponding 
\code{minOverlaps} threshold (i.e., Value[1] is the total number of unique sites, Value[2] is the number of unique sites appearing in at least two peaksets, Value[3] the number of sites overlapping in at least three peaksets, etc.).
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{dba.plotVenn}},  \code{\link{dba.plotHeatmap}}
}

\examples{
data(tamoxifen_peaks)
# default mode: DBA_OLAP_PEAKS -- get overlapping/non overlapping peaksets
mcf7 <- dba.overlap(tamoxifen,tamoxifen$masks$MCF7&tamoxifen$masks$Responsive)
names(mcf7)
mcf7$inAll

# mode:  DBA_OLAP_ALL -- get correlation record
mcf7 <- dba(tamoxifen,tamoxifen$masks$MCF7)
mcf7.corRec <- dba.overlap(mcf7,mode=DBA_OLAP_ALL,bCorOnly=FALSE)
mcf7.corRec

# mode: DBA_OLAP_RATE -- get overlap rate vector
data(tamoxifen_peaks)
rate <- dba.overlap(tamoxifen, mode=DBA_OLAP_RATE)
rate
plot(rate,type='b',xlab="# peaksets",ylab="# common peaks",
     main="Tamoxifen dataset overlap rate")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.load}
\alias{dba.load}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
load DBA object
}
\description{
Reads in saved DBA object
}
\usage{
dba.load(file='DBA', dir='.', pre='dba_', ext='RData')
}
%- maybe also 'usage' for other objects documented here.
\arguments{
%\subsection{Optional/defaulted arguments}{}
  \item{file}{
main filename
}
  \item{dir}{
directory in which to save model
}
  \item{pre}{
string to pre-pend to filename
}
  \item{ext}{
file extension to use
}
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
loaded DBA object
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{dba.save}}, \code{\link{DBA.config}}.
}

\examples{
data(tamoxifen_peaks)
savefile <- dba.save(tamoxifen,'tamoxifenPeaks')
savefile
rm(tamoxifen)
tamoxifen <- dba.load('tamoxifenPeaks')
tamoxifen
unlink(savefile)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.plotVenn}
\alias{dba.plotVenn}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Draw 2-way, 3-way, or 4-way Venn diagrams of overlaps
}
\description{
Draws 2-way, 3-way, or 4-way Venn diagrams of overlaps
}
\usage{
dba.plotVenn(DBA, mask, overlaps, label1, label2, label3, label4, main, sub, 
             contrast, method=DBA$config$AnalysisMethod, 
             th=DBA$config$th, bUsePval=DBA$config$bUsePval,
             bDB=TRUE, bNotDB, bAll=TRUE, bGain=FALSE, bLoss=FALSE,
             labelAttributes, DataType=DBA$config$DataType)
}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}

\item{DBA}{
DBA object; if present, only the mask parameter will apply.
}

\item{mask}{
mask or vector of peakset numbers indicating which peaksets to include in Venn diagram. 
Only 2 or 3 peaksets should be included.  
See  \code{\link{dba.mask}}.
Only one of mask or overlaps is used.
}

\item{overlaps}{
overlap record, as computed by  \code{\link{dba.overlap}(Report=DBA_OLAP_PEAKS)}. 
Only one of mask or overlaps is used.
}
%\subsection{Optional/defaulted arguments}{}

  \item{label1}{
label for first peakset in diagram
}
  \item{label2}{
label for second peakset in diagram
}
  \item{label3}{
label for third peakset in diagram
}
  \item{label4}{
label for fourth peakset in diagram
}
  \item{main}{
main title for plot
}
  \item{sub}{
subtitle for plot
}
  \item{contrast}{
contrast number(s) to use for results-based plots.
This can be a vector of contrast numbers.  
See \code{\link{dba.show}(DBA, bContrast=T)} to get contrast numbers.
}
 \item{method}{
if \code{contrast} is specified, include results from analyses using this method or methods:
\itemize{ 
\item \code{\link{DBA_DESEQ2}}
\item \code{\link{DBA_DESEQ2_BLOCK}}
\item \code{\link{DBA_EDGER}}
\item \code{\link{DBA_EDGER_BLOCK}}
\item \code{\link{DBA_ALL_METHODS}}
\item \code{\link{DBA_ALL_BLOCK}}
\item \code{\link{DBA_ALL_METHODS_BLOCK}}
}
}
\item{th}{
if \code{contrast} is specified, use this significance threshold; 
all sites with FDR (or p-values, see \code{bUsePval}) less than or equal to this value 
will be considered differentially bound (DB). 
}
\item{bUsePval}{
if \code{contrast} is specified, this logical indicates whether to use FDR (\code{FALSE}) 
or p-value (\code{TRUE}) for thresholding.
}
\item{bDB}{
if \code{contrast} is specified, this logical indicates that peaksets should include
Differentially Bound (DB) sites (respecting the \code{th}, \code{bUsePval}, and \code{fold} parameters).
}
\item{bNotDB}{
if \code{contrast} is specified, this logical indicates that peaksets should include 
non-Differentially Bound (non-DB) sites (respecting the \code{th}, \code{bUsePval}, and \code{fold} parameters).
}
\item{bAll}{
if \code{contrast} is specified, this logical indicates peaksets 
combining peaks with both positive and negative fold changes should be included.
}
\item{bGain}{
if \code{contrast} is specified, this logical indicates that peaksets with only positive fold changes 
should be included.
}
\item{bLoss}{
if \code{contrast} is specified, this logical indicates that peaksets with only negative fold changes 
should be included.
}

\item{labelAttributes}{
if \code{label}s are not specified, use these attributes to create default labels:
\itemize{ 
\item \code{\link{DBA_ID}}
\item \code{\link{DBA_TISSUE}}
\item \code{\link{DBA_FACTOR}}
\item \code{\link{DBA_CONDITION}}
\item \code{\link{DBA_TREATMENT}}
\item \code{\link{DBA_REPLICATE}}
\item \code{\link{DBA_CONSENSUS}}
\item \code{\link{DBA_CALLER}}
}

Only specified attributes that differ between peaksets will be used for labels; 
the ones that have the same value for all peaksets will be used as the default subtitle.
}
%\item{bReturnPeaksets}{
%logical indicating that the peaksets that make up portions of the Venn diagram should be returned. See \code{\link{dba.overlap}}
% for the format of the returned object. 
%If the \code{DataType} parameter is set to \code{\link{DBA_DATA_DBAOBJECT}}, and a \code{contrast} has been specified, 
% a result-based DBA object will be returned, as described in \code{\link{dba.report}}.
%}
\item{DataType}{
if \code{bReturnPeaksets} is set to \code{TRUE}, the class of object that peaksets should be returned as:
\itemize{
\item \code{\link{DBA_DATA_GRANGES}}
\item \code{\link{DBA_DATA_RANGEDDATA}}
\item \code{\link{DBA_DATA_FRAME}}
}
Can be set as default behavior by setting \code{DBA$config$DataType}.

Alternatively, this can be set to:
\itemize{
\item \code{\link{DBA_DATA_DBAOBJECT}}
}
to return a results-based DBA object, if a \code{contrast} is specified (see \code{\link{dba.report}}).
}

}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
Either a list of peaksets is returned invisibly (as described in \code{\link{dba.overlap}}), or, if \code{DataType=DBA_DATA_DBAOBJECT}, a results-based DBA object.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
\note{

When working with results overlaps (a least one \code{contrast} is specified), and results-oriented DBA object is generated internally (as described in \code{\link{dba.report}}). In some cases, it may be better to generate the DBA object explicitly (using \code{\link{dba.report}} or setting \code{bReturnPeaksets=TRUE} and \code{DataType=DBA_DATA_DBAOBJECT}). This include the case where several plots are being made of the same results set, and it takes a long time to generate the results-based DBA object, as well as the case where there are more than four results peaksets and a mask needs to be specified. I


This function relies on  \code{\link{vennPlot}} in the  \code{systemPipeR} package, written by Thomas Girke.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{dba.analyze}},  \code{\link{dba.overlap}},  
 \code{\link{dba.report}}, \code{\link{dba.plotPCA}},
 \code{\link{vennPlot}}
}

\examples{
data(tamoxifen_peaks)

par(mfrow=c(2,2))
# 2-way Venn
dba.plotVenn(tamoxifen,6:7)
dba.plotVenn(tamoxifen,tamoxifen$masks$ZR75)

# 3-way Venn (done two different ways)
dba.plotVenn(tamoxifen,tamoxifen$masks$MCF7&tamoxifen$masks$Responsive)
olaps <- dba.overlap(tamoxifen,tamoxifen$masks$MCF7&tamoxifen$masks$Responsive)
dba.plotVenn(tamoxifen,overlaps=olaps,
             label1="Rep 1",label2="Rep 2",label3="Rep 3",
             main="MCF7 (Responsive) Replicates")

#Venn of overlaps
Responsive=dba(tamoxifen,tamoxifen$masks$Responsive)
Responsive
Responsive <- dba.peakset(Responsive,1:3,sampID="MCF7")
Responsive <- dba.peakset(Responsive,4:5,sampID="T47D")
Responsive <- dba.peakset(Responsive,6:7,sampID="ZR75")
par(mfrow=c(1,1))
dba.plotVenn(Responsive,Responsive$masks$Consensus)

#4-way overlap
data(tamoxifen_peaks)
tamoxifen <- dba.peakset(tamoxifen, consensus=DBA_TISSUE)
par(mfrow=c(1,1))
dba.plotVenn(tamoxifen,tamoxifen$masks$Consensus,
             main="Tissue consensus overlaps")

#Venns of differentially bound sites
data(tamoxifen_counts)
tamoxifen <- dba.contrast(tamoxifen,design="~Tissue+Condition")
tamoxifen <- dba.analyze(tamoxifen,method=c(DBA_EDGER,DBA_DESEQ2))
dba.plotVenn(tamoxifen,contrast=1,method=DBA_ALL_METHODS,
             bAll=FALSE,bGain=TRUE,bLoss=TRUE)
par(mfrow=c(2,1))
dba.plotVenn(tamoxifen,contrast=1,method=DBA_ALL_METHODS,
             bAll=FALSE,bGain=TRUE,bLoss=FALSE)
dba.plotVenn(tamoxifen,contrast=1,method=DBA_ALL_METHODS,
             bAll=FALSE,bGain=FALSE,bLoss=TRUE)

data(tamoxifen_counts)
tamoxifen <- dba.contrast(tamoxifen,design=FALSE,block=DBA_TISSUE)
tamoxifen <- dba.contrast(tamoxifen,design="~Tissue + Condition",
                          contrast=c("Condition","Responsive","Resistant"))
tamoxifen <- dba.analyze(tamoxifen,method=DBA_ALL_METHODS)
dba.plotVenn(tamoxifen,contrast=1:2,method=c(DBA_DESEQ2,DBA_DESEQ2_BLOCK))
tamoxifen.db <- dba.report(tamoxifen,contrast=1:2,method=DBA_ALL_METHODS_BLOCK,
                           bDB=TRUE)
dba.plotVenn(tamoxifen.db,mask=1:2)
dba.plotVenn(tamoxifen.db,mask=3:6)
}

\name{dba.blacklist}
\alias{dba.blacklist}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Apply blacklists and/or greylists to peaks (and generate greylist)
}
\description{
Filters peak intervals that overlap a blacklist (from ENCODE or user supplied.) 
Filter peak intervals that overlap a greylist, either user supplied or generated based on 
aligned reads for control samples (e.g. Inputs).
}
\usage{
dba.blacklist(DBA, blacklist=DBA$config$doBlacklist, 
              greylist=DBA$config$doGreylist, 
              Retrieve, cores=DBA$config$cores)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{DBA}{
DBA object
}
  \item{blacklist}{
If not equal to \code{FALSE}, specifies that a blacklist should be 
applied to the peak intervals in the \code{DBA} object.

If equal to \code{TRUE}, the read bam files will be examined
to determine an appropriate reference genome.
If successful, and a blacklist is available for that genome, it
will be applied.

A user specified blacklist can be specified by setting this parameter to
a \code{\link{GRanges}} object containing the blacklisted regions.

Otherwise, this parameter may be set to one of the following constants, 
indicating which of the ENCODE blacklists should be applied:
 \describe{
\item{\code{DBA_BLACKLIST_HG19}:}{Homo sapiens 19 (chromosomes have "chr")}
\item{\code{DBA_BLACKLIST_HG38}:}{Homo sapiens 38 (chromosomes have "chr")}  
\item{\code{DBA_BLACKLIST_GRCH37}:}{Homo sapiens 37 (chromosomes are numbers)}
\item{\code{DBA_BLACKLIST_GRCH38}:}{Homo sapiens 38 (chromosomes are numbers)}
\item{\code{DBA_BLACKLIST_MM9}:}{Mus musculus 9}
\item{\code{DBA_BLACKLIST_MM10}:}{Mus musculus 10}
\item{\code{DBA_BLACKLIST_CE10}:}{C. elegans 10}
\item{\code{DBA_BLACKLIST_CE11}:}{C. elegans 11}
\item{\code{DBA_BLACKLIST_DM3}:}{Drosophila melanogaster 3}
\item{\code{DBA_BLACKLIST_DM6}:}{Drosophila melanogaster 6}
 }
}
  \item{greylist}{
If not equal to \code{FALSE}, specifies that a greylist should be 
applied to the peak intervals in the \code{DBA} object.

If equal to \code{TRUE}, the control bam files (if present),
will be examined to determine an appropriate reference genome.
Genomes associated with a valid \code{BSgenome}
can be detected.
If successful, this genome will be used to generate greylists
for each available control 
(eg specified as \code{bamControls} in the sample sheet.)).

The \code{greylist} parameter can also be set explicitly to either
a valid \code{BSgenome} object, or a character string
with the name of a valid \code{BSgenome} object.

The following constants map to a subset of possible \code{BSgenome}
objects:

\describe{
\item{\code{DBA_BLACKLIST_HG19}  :}{\code{ seqinfo from BSgenome.Hsapiens.UCSC.hg19}}
\item{\code{DBA_BLACKLIST_HG38}  :}{\code{ seqinfo from BSgenome.Hsapiens.UCSC.hg38}}  
\item{\code{DBA_BLACKLIST_GRCH38}:}{\code{ seqinfo from BSgenome.Hsapiens.NCBI.GRCh38}}
\item{\code{DBA_BLACKLIST_MM9}    :}{\code{ seqinfo from BSgenome.Mmusculus.UCSC.mm9}}
\item{\code{DBA_BLACKLIST_MM10}  :}{\code{ seqinfo from BSgenome.Mmusculus.UCSC.mm10}}
\item{\code{DBA_BLACKLIST_CE10}  :}{\code{ seqinfo from BSgenome.Celegans.UCSC.ce10}}
\item{\code{DBA_BLACKLIST_CE11}  :}{\code{ seqinfo from BSgenome.Celegans.UCSC.ce11}}
\item{\code{DBA_BLACKLIST_DM3}    :}{\code{ seqinfo from BSgenome.Dmelanogaster.UCSC.dm3}}
\item{\code{DBA_BLACKLIST_DM6}    :}{\code{ seqinfo from BSgenome.Dmelanogaster.UCSC.dm6}}
}     

A user specified greylist can also be specified by setting this parameter to
a \code{\link{GRanges}} object containing the greylisted regions.
It can also be a \code{list} with an element named \code{greylist$master},
which is a \code{\link{GRanges}} object containing the greylist to be applied.
}

\item{Retrieve}{

If present, some aspects of a previous run of the function is retrieved instead
of returning a \code{DBA} object.

If \code{Retrieve=DBA_BLACKLIST}, the blacklist, if present, is returned as a
\code{\link{GRanges}} object.

If \code{Retrieve=DBA_GREYLIST}, the greylist, if present, is returned.
If it was generated from more than one control, it will be returned as
a \code{list} object with the first element (named \code{$master}) a 
\code{\link{GRanges}} object containing the merged greylist, and the second
element (named \code{$controls}) being a \code{\link{GRangesList}}
with each element containing the greylist for one control

If \code{Retrieve=DBA_BLACKLISTED_PEAKS}, 
the excluded peaks for each sample will be returned in
a \code{\link{GRangesList}} object (with each element containing the
filtered peak intervals for each sample).
If counts are available for the peaks, this will include the following metadata columns:
\describe{
\item{cReads:}{Number of control reads overlapping this interval}
\item{Reads:}{Number of primary (ChIP) reads overlapping this interval}
\item{Score:}{Read score calculated by \code{\link{dba.count}}}
}

Note that the if \code{Retrieve} is set,
\code{dba.blacklist} must have been previously run,
and all other parameters will be ignored.
}
  \item{cores}{
Parallel cores to use when running greylist generation.
}
}
\details{
This function is intended to filter peak intervals that fall in regions of the genome that
are known to be problematic for ChIP analysis.
Blacklists, which are derived for a reference genome and should be applied
for any experiments that use that reference,
are distinguished from greylists, which are derived on a per-experiment basis
using anomalous pileups in the control tracks (such as Inputs).

A core set of blacklists have been defined as part of the ENCODE project (see references).

Greylists can be generated using this function, which serves as a front-end to the \code{GreyListChIP} package. 
See the details of that package for more information on how it works.
Note that the \code{GreyListChIP} package can be utilized separately to generate greylists
with more fine-grained control, with the results passed back to \code{DiffBind} to filter peaks.

}
\value{
\code{DBA} object, with peaks filtered (unless \code{Retrieve} is specified.)
}
\references{
\itemize{
\item{Amemiya HM, Kundaje A, Boyle AP. The ENCODE blacklist: identification of problematic regions of the genome. Sci Rep. 2019 Dec; 9(1) 9354 DOI: 10.1038/s41598-019-45839-z
}
\item{
ENCODE Project Consortium. An integrated encyclopedia of DNA elements in the human genome. Nature. 2012 Sep 6;489(7414):57-74. doi: 10.1038/nature11247.
}
\item{Brown, Gord. Generating Grey Lists from Input Libraries. Bioconductor. https://bioconductor.org/packages/release/bioc/html/GreyListChIP.html}
}
}
\author{
Rory Stark with thanks to Gord Brown
}
\note{

The \code{p} threshold can be altered by setting \code{DBA$config$greylist.pval}. 
The default is \code{0.999}. 
See \code{GreyListChIP::}\code{\link{calcThreshold}} for details.

Ideally, Blacklists and Greylists will be applied to the aligned reads prior
to calling peaks, as removing reads in anomalous regions
will yield better background noise models. 
Once greylists have been generated, peaks can be
re-called and read into \code{DiffBind}.
}

\seealso{
\code{GreyListChIP (\link{GreyList})}, \code{BSgenome}, 
\code{\link{DBA.config}}.
}
\examples{

data(tamoxifen_peaks)
\dontrun{tamoxifen <- dba.blacklist(tamoxifen, blacklist=TRUE,
                                    greylist="BSgenome.Hsapiens.UCSC.hg19")}
data(tamoxifen_greylist)
tamoxifen <- dba.blacklist(tamoxifen, blacklist=DBA_BLACKLIST_HG19,
                           greylist=tamoxifen.greylist$master)
dba.blacklist(tamoxifen,Retrieve=DBA_GREYLIST)

data(tamoxifen_counts)
tamoxifen <- dba.count(tamoxifen, peaks=NULL, score=DBA_SCORE_CONTROL_READS)
tamoxifen <- dba.blacklist(tamoxifen, blacklist=DBA_BLACKLIST_HG19,
                           greylist=tamoxifen.greylist$master)
blacklisted <- dba.blacklist(tamoxifen, Retrieve=DBA_BLACKLISTED_PEAKS)
mean(blacklisted[[1]]$cReads)
mean(dba.peakset(tamoxifen,peaks=1,bRetrieve=TRUE)$Score)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory (show via RShowDoc("KEYWORDS")):
% \keyword{ ~kwd1 }
% \keyword{ ~kwd2 }
% Use only one keyword per line.
% For non-standard keywords, use \concept instead of \keyword:
% \concept{ ~cpt1 }
% \concept{ ~cpt2 }
% Use only one concept per line.

\name{dba.plotVolcano}
\alias{dba.plotVolcano}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Generate volcano plots of differential binding analysis results
}
\description{
Generates volcano plots of differential binding analysis results.
}
\usage{
dba.plotVolcano(DBA, contrast=1, method=DBA$config$AnalysisMethod, 
                            th=DBA$config$th, bUsePval=DBA$config$bUsePval, 
                            fold=0, factor="", bFlip=FALSE, 
                            bLabels=FALSE, maxLabels=50, dotSize=1,
                            bReturnSites=TRUE)
}

%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}


\item{DBA}{
DBA object, on which  \code{\link{dba.analyze}} should have been successfully run.
}
%\subsection{Optional/defaulted arguments}{}
 \item{contrast}{
number of contrast to report on. 
See  \code{\link{dba.show}(DBA, bContrast=TRUE)} to get contrast numbers.
}
\item{method}{
 method or vector of methods to plot results for:
\itemize{ 
\item \code{\link{DBA_DESEQ2}}
\item \code{\link{DBA_DESEQ2_BLOCK}}
\item \code{\link{DBA_EDGER}}
\item \code{\link{DBA_EDGER_BLOCK}}
}
}


\item{th}{
significance threshold; sites with FDR (or p-values, see \code{bUsePval})
less than or equal to this value will be colored red in the plot
}
  \item{bUsePval}{
logical indicating whether to use FDR (\code{FALSE}) or p-value (\code{TRUE}) for thresholding.
}
  \item{fold}{
will only include sites with fold change greater than this 
as significant (colored red).

If \code{fold} is greater than zero, 
and an explicit design was used for the contrast,
the \code{p-value} and \code{FDR} will be re-calculated based on testing
for changes greater than the specified fold change.
For a \code{DESeq2} analysis, this involves including the \code{fold}
when calling \code{DESeq2::results}.
For a \code{edgeR} analysis, \code{edgeR::glmTreat} is used.
}

 \item{factor}{
string to be prepended to plot main title; e.g. factor name.
}

 \item{bFlip}{
logical indicating that order of groups in contrast should be "flipped", 
allowing control of which sample group
will have positive and which will have negative fold changes.
}

 \item{bLabels}{
logical indicating that labels should be drawn on the plot.
The labels are the site numbers, the row index in the (silently) returned set of
significant sites. The maximum number of sites can be specified 
using \code{maxLabels}.
}

 \item{maxLabels}{
The maximum number of labels to use in the plot.
Ignored if \code{bLabels=FALSE}.
}

  \item{dotSize}{
size of points on plot.
}
  \item{bReturnSites}{
If \code{TRUE}, silently returns the differential sites. 
If \code{FALSE}, the \code{ggplot} object is silently returned.
}
}

\details{
Makes a volcano plot.
}
\value{
Silently returns wither a \code{GRanges} object of the sites highlighted in red or a \code{ggplot} object.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%plots log2 values of read counts.
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{dba.analyze}},  \code{\link{dba.plotMA}}
}

\examples{
data(tamoxifen_analysis)

# default volcano plot
dba.plotVolcano(tamoxifen)

# only highlight significant sites with at least 3x Fold Change
sigSites <- dba.plotVolcano(tamoxifen, fold=log2(3))

# use labels to find outlier sites
sigSites <- dba.plotVolcano(tamoxifen, fold=log2(5), th=0.01, bLabels=TRUE)
sigSites
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.contrast}
\alias{dba.contrast}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Set up contrasts for differential binding affinity analysis
}
\description{
Sets up contrasts for differential binding affinity analysis
}
\usage{
dba.contrast(DBA, design=missing(group1), contrast,
             group1, group2=!group1, name1, name2,
             minMembers=3, block, bNot=FALSE, bComplex=FALSE,
             categories=c(DBA_TISSUE,DBA_FACTOR,DBA_CONDITION,DBA_TREATMENT),
             bGetCoefficients=FALSE, reorderMeta)

}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}


  \item{DBA}{
DBA object with count data
}
%\subsection{Optional/defaulted arguments}{}
\item{design}{
Either a logical value, or a character string containing a valid design formula. 

If a logical value is specified, \code{TRUE} indicates that a design 
should automatically be generated. 
If \code{contrast} is missing, contrasts will automatically be added 
and an appropriate design computed. 
If a \code{contrast} is specified, it must consist of a character vector 
of length three, containing a factor and two factor values. 
No \code{group}s can be specified. 
If set to \code{FALSE}, the contrast will be added between the \code{groups},
if specified; otherwise, if \code{group} is missing, 
all possible contrasts will be added.

If a design formula is specified, it must be composed from 
the following allowable factors:
   \itemize{ 
     \item Tissue
     \item Factor
     \item Condition
     \item Treatment
     \item Replicate
     \item Caller
  }
}

If \code{design} is not explictly specified, and no \code{group} is
specified, then \code{design} will be set to
the value of \code{DBA$config$design}, if present (see \code{\link{DiffBind3}}).

\item{contrast}{
If a \code{design} has been specified (previously or in the current call),
the following contrasts forms may be indicated:

\itemize{
  \item Character vector of length three. 
  The first element is a factor from the \code{design}. 
  The second and third elements are values for that factor 
  associated with sample groups.
  \item List of length 1, containing a design matrix column name 
  (as obtained using \code{bGetCoefficients}).
  \item List of length 2, containing two design matrix column names 
  (as obtained using \code{bGetCoefficients}), first the numerator
  and the second the denominator.
  \item Character vector of length one, containing a design matrix column name 
  (as obtained using \code{bGetCoefficients}).
  \item Numeric vector of the same length as the list of 
  design matrix column names (as obtained using \code{bGetCoefficients}), 
  with a weighting for each column.
  }
}
  \item{group1}{
mask of samples in first group (when adding a specific contrast).
See \code{\link{dba.mask}}.
Can not be used with an explicit \code{design}.
}
  \item{group2}{
mask of samples in second group (when adding a specific contrast). 
See \code{\link{dba.mask}}.
Can not be used with an explicit \code{design}.
}
  \item{name1}{
label for samples in first group (when adding a specific contrast). 
}
  \item{name2}{
label for samples in second group (when adding a specific contrast). 
}
  \item{minMembers}{
when automatically generating contrasts, minimum number of unique samples 
in a group. 
Must be at least 2, as replicates are strongly advised.
If you wish to do an analysis with no replicates, you can set the 
group1 and group2 parameters explicitly.
}
  \item{bNot}{
include contrasts consisting of a group and all other samples not in that group 
(indicated by a ! in the contrast name).
}

  \item{bComplex}{
include complex contrasts where groups include samples with the 
same values for multiple factors.
}

  \item{categories}{
when automatically generating contrasts, attribute or vector of attributes 
to base contrasts on:
\itemize{ 
\item DBA_ID
\item DBA_TISSUE
\item DBA_FACTOR
\item DBA_CONDITION
\item DBA_TREATMENT
\item DBA_REPLICATE
\item DBA_CALLER
}
}
\item{block}{
blocking attribute for multi-factor analysis.  
This may be specified as either a value, a vector, or a list. 

If block is a value, the specified metadata field is used to derive 
the blocking factor. One of:
\itemize{ 
\item DBA_TISSUE
\item DBA_FACTOR
\item DBA_CONDITION
\item DBA_TREATMENT
\item DBA_REPLICATE
\item DBA_CALLER
}

If block is a vector, it can either be a mask (logical vector) 
or a vector of peakset numbers. 
In this case, the peaksets indicated in the blocking vector 
are all given the same factor value (true), while any peaksets not included 
in the vector take the alternative factor value (false).

If block is a list, it should be a list of vectors 
(either logical masks or vectors of peakset numbers), 
with each indicating a set of peaksets that should share the same value. 
Each peakset should appear at most once, and any peaksets not specified 
will be given an default value (other).
}

\item{bGetCoefficients}{
If \code{TRUE}, return the names of the columns (coefficients) 
associated with the \code{design}.
These can be used to specify a \code{contrast}. 
If \code{bGetCoefficients=TRUE}, all other parameters 
(except \code{DBA} and \code{design}, if specified) will be ignored.
}

\item{reorderMeta}{
By default, the metadata factor levels will be ordered in the 
order they appear in the sample sheet. 
They can be re-ordered using this parameter.
\code{reorderMeta} is specified as a list, with each element being a 
vector of character strings corresponding
to unique factor values in the desired order.
Each element should be named for the appropriate metadata factor, one of:
   \itemize{ 
     \item Tissue
     \item Factor
     \item Condition
     \item Treatment
     \item Replicate
     \item Caller
  }

If the vector of factor values contains a subset of the possible values,
the specified values will be set to be ordered first, with the remaining values
following in their default order. 
If only one factor value is supplied, it will be set as the reference 
(or "control") value.
Contrasts that are no longer valid will be removed 
(and a warning issued) if detected.
These include contrasts specified as a numeric vector of coefficients,
or contrasts specified using coefficient names that no longer
exists after reordering the metadata factor levels.
Any existing analysis will be removed when metadata factor levels 
are reordered, necessitating 
another call to \code{\link{dba.analyze}}
}
}
\details{

MODE: Set up a specific contrast using a design:

\code{dba.contrast(DBA, design, contrast)}

MODE: Set up all possible contrasts:

\code{dba.contrast(DBA, minMembers, categories)}

MODE: Set up a specific contrast without an explicit design:

\code{dba.contrast(DBA, design=FALSE, group1, group2, name1, name2, block)}

}
\value{
DBA object with contrast(s) set as \code{DBA$contrasts}. 

Contrast list can be retrieved using \code{dba.show(DBA, bContrasts=TRUE)}.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
\note{
Contrasts will only be set up for peaksets where \code{DBA_CALLER == "counts"}.

Contrasts can be cleared by \code{DBA$contrasts <- NULL}.
}

\seealso{

\code{\link{dba.analyze}}, \code{\link{DBA.config}}.

}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\examples{
# Set up an explicit contrast
data(tamoxifen_counts)
tamoxifen <- dba.contrast(tamoxifen, contrast=c("Condition","Responsive","Resistant"))
tamoxifen
tamoxifen <- dba.analyze(tamoxifen)
dba.show(tamoxifen,bContrasts=TRUE)

# Add another contrast
tamoxifen <- dba.contrast(tamoxifen, contrast=c("Tissue","MCF7","BT474"))
dba.show(tamoxifen,bDesign=TRUE)

# Change design
tamoxifen <- dba.contrast(tamoxifen,design="~Tissue + Condition")
tamoxifen <- dba.analyze(tamoxifen)
tamoxifen

# Automatically add all contrasts between sample groups 
# where at least THREE samples have the same factor value
data(tamoxifen_counts)
tamoxifen <- dba.contrast(tamoxifen)
tamoxifen

# Automatically add all contrasts between sample groups 
# where at least TWO samples have the same factor value
tamoxifen <- dba.contrast(tamoxifen, minMembers=2)
dba.show(tamoxifen,bContrasts=TRUE)

### Use of complex contrasts                          
data(tamoxifen_counts)
tamoxifen <- dba.contrast(tamoxifen, contrast=c("Tissue","BT474","MCF7"))
dba.contrast(tamoxifen, bGetCoefficients=TRUE)

#Change design and factor ordering
tamoxifen <- dba.contrast(tamoxifen,design="~Tissue + Condition",
                          reorderMeta=list(Condition="Responsive",
                          Tissue=c("MCF7","ZR75","T47D","BT474")))
dba.contrast(tamoxifen, bGetCoefficients=TRUE)
tamoxifen <- dba.contrast(tamoxifen,contrast="Tissue_BT474_vs_MCF7")
tamoxifen <- dba.contrast(tamoxifen,contrast=list("Tissue_BT474_vs_MCF7"))
tamoxifen <- dba.contrast(tamoxifen,contrast=c(0,0,0,1,0))
tamoxifen <- dba.contrast(tamoxifen,
                          contrast=list("Tissue_BT474_vs_MCF7","Tissue_T47D_vs_MCF7"))
tamoxifen <- dba.contrast(tamoxifen,contrast=c(0,0,-1,1,0))
tamoxifen <- dba.contrast(tamoxifen,contrast=c(0,0,0,0,1))
dba.show(tamoxifen,bContrasts=TRUE)
tamoxifen <- dba.analyze(tamoxifen)
tamoxifen
tamoxifen <- dba.contrast(tamoxifen, 
                          contrast=c("Condition","Responsive","Resistant"))
tamoxifen <- dba.analyze(tamoxifen)
dba.show(tamoxifen,bContrasts=TRUE)[7:8,]
dba.plotVenn(tamoxifen, contrast=7:8, bDB=TRUE,          
             bAll=FALSE, bGain=TRUE, bLoss=TRUE)

## Explicit contrast, without design
data(tamoxifen_counts)
tamoxifen <- dba.contrast(tamoxifen, design=FALSE,
                          group1=tamoxifen$masks$Responsive, name1="Responsive",
                          group2=tamoxifen$masks$Resistant,  name2="Resistant",
                          block=DBA_TISSUE)
dba.show(tamoxifen, bContrasts=TRUE)
tamoxifen <- dba.analyze(tamoxifen)
dba.show(tamoxifen,bContrasts=TRUE)
dba.plotVenn(tamoxifen,contrast=1,method=c(DBA_DESEQ2,DBA_DESEQ2_BLOCK))
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{DBA object methods}
\alias{DBA-object}
\alias{DBA.object}
\alias{print.DBA}
\alias{summary.DBA}
\alias{plot.DBA}
\alias{DiffBind-config}
\alias{DBA-config}
\alias{DiffBind.config}
\alias{DBA.config}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Standard S3 methods for DBA object
}
\description{
Standard S3 methods for DBA object.
}
\usage{
\method{print}{DBA}(x, \dots)
\method{summary}{DBA}(object, \dots)
\method{plot}{DBA}(x, \dots)
}

%- maybe also 'usage' for other objects documented here.
\arguments{
\item{x}{
DBA object
}
\item{object}{
DBA object
}

\item{\dots}{
Arguments passed on to parent methods
}
}
\details{
S3 methods for DBA object from the \code{\link{DiffBind}} package.

DBA objects are usually constructed using the \code{\link{dba}} function.

There are a number of internal parameters that can be set, 
and defaults overridden, by setting \code{DBA$config} options:

\describe{
\item{\code{DBA$config$AnalysisMethod:}}{either \code{DBA_DESEQ2} or \code{DBA_EDGER}.}
  
\item{\code{DBA$config$th:}}{default threshold for reporting and plotting analysis results.}
  
\item{\code{DBA$config$DataType:}}{default class for peaks and reports
(\code{DBA_DATA_GRANGES, DBA_DATA_RANGEDDATA, or DBA_DATA_FRAME}).}

\item{\code{DBA$config$RunParallel:}}{logical indicating if counting and analysis 
  operations should be run in parallel using multicore by default.}

\item{\code{DBA$config$cores:}}{number of cores to use when performing multi-core parallel processing.}
  
\item{\code{DBA$config$minQCth:}}{numeric, for filtering reads based on mapping 
quality score; only reads with a mapping quality score
greater than or equal to this will be counted.}

\item{\code{DBA$config$fragmentSize:}}{numeric indicating mean fragment size for single-end counting.
Reads will be extended to this length before counting overlaps. 
May be a vector of lengths, one for each sample.}

\item{\code{DBA$config$bCorPlot:}}{logical indicating that a correlation heatmap 
should be plotted automatically}

\item{\code{DBA$config$ReportInit:}}{string to append to the beginning of saved report file names.}
  
\item{\code{DBA$config$bUsePval:}}{logical, default indicating whether to use FDR 
(\code{FALSE}) or p-values (\code{TRUE}).}

\item{\code{DBA$config$doBlacklist:}}{logical, whether to attempt to find and apply
a blacklist if none is present when running \code{\link{dba.analyze}}}.

\item{\code{DBA$config$doGreylist}}{logical, whether to attempt to generate and apply 
a greylist if none is present when running \code{\link{dba.analyze}}}.

\item{\code{DBA$config$DataType}}{
The class of object for returned reports and peaksets:
\itemize{
\item \code{\link{DBA_DATA_GRANGES}}
\item \code{\link{DBA_DATA_RANGEDDATA}}
\item \code{\link{DBA_DATA_FRAME}}
\item \code{\link{DBA_DATA_SUMMARIZED_EXPERIMENT}}
}
}

\item{\code{DBA$config$mergeOverlap:}}{The overlap (in basepairs) between peaks to merge when generating 
  a consensus peakset.
  A positive valuecontrols how many basepairs peaks 
  must overlap to be merged,
  while a negative value will result in non-overlapping peaks to be merged, 
  
  If absent, the default value of \code{1} will result in any peaks
  overlapping by at least one basepair to be merged into a single interval.}

\item{\code{DBA$config$design:}}{When calling \code{\link{dba.contrast}}, if \code{design} parameter is
  missing, this will be used as the value for that parameter.}
  
\item{\code{DBA$config$edgeR$bTagwise:}}{\code{logical} indicating if \code{edgeR::estimateGLMTagwiseDisp} should
  be called when performing an \code{edgeR} analysis. 
  If absent the default is \code{TRUE}, so setting this to \code{FALSE}
  prevents the tagwise dispersion estimate form being calculated.
}  

\item{\code{DBA$config$DESeq2$fitType:}}{\code{logical} indicating the \code{fitType}
  to be used in \code{DESeq2::estimateDispersions} 
  when performing a \code{DESeq2} analysis. 
  If absent the default is \code{local}.
}  

\item{\code{DBA$config$savePrefix:}}{When calling \code{\link{dba.save}} or \code{\link{dba.load}}, 
  this value (if present)
  will override the default value for the \code{pre} parameter.
  }
  
\item{\code{DBA$config$saveExt:}}{When calling \code{\link{dba.save}} or \code{\link{dba.load}},
  this value (if present)
  will override the default value for the \code{ext} parameter.
  }  
  
\item{\code{DBA$config$greylist.pval:}}{pvalue cutoff to use when generating a greylist
  using \code{GreyListChIP::calcThreshold}.
  If missing, the default is \code{0.999}
  } 
  
\item{\code{DBA$config$saveExt:}}{When calling \code{\link{dba.save}}, this value (if present)
  will override the default value for the \code{ext} parameter.
  } 
  
\item{\code{DBA$config$yieldSize:}}{yieldSize indicating how many reads to process at one time; default is 5000000. 
The lower this value, the less memory will be used, but the more time it will take to 
complete the count operation.}

\item{\code{DBA$config$intersectMode:}}{mode indicating which overlap algorithm to use; 
  default is \code{"IntersectionNotEmpty"}}
  
\item{\code{DBA$config$singleEnd:}}{\code{logical} indicating if reads are single end; 
  if \code{NULL}, status will be automatically detected.}
  
\item{\code{DBA$config$fragments:}}{\code{logical} indicating how unmatched reads are counted; 
  default is \code{FALSE}.}

\item{\code{DBA$config$scanbamparam:}}{\code{ScanBamParam} object to pass to \code{\link{summarizeOverlaps}}. 
  If present, \code{bRemoveDuplicates} is ignored.}
  
\item{\code{DBA$config$pp.style:}}{Sets \code{style} parameter for \code{profileplyr::BamBigwig_to_chipProfile}
  when calling \code{\link{dba.plotProfile}.}}

\item{\code{DBA$config$pp.nOfWindows:}}{Sets \code{nOfWindow} parameter for 
  \code{profileplyr::BamBigwig_to_chipProfile}
  when calling \code{\link{dba.plotProfile}.}}
  
\item{\code{DBA$config$bin_size:}}{Sets \code{bin_size} parameter for 
  \code{profileplyr::BamBigwig_to_chipProfile}
  when calling \code{\link{dba.plotProfile}.}}

\item{\code{DBA$config$distanceAround:}}{Sets \code{distanceAround} parameter for 
  \code{profileplyr::BamBigwig_to_chipProfile}
  when calling \code{\link{dba.plotProfile}.}}
  
\item{\code{DBA$config$distanceUp:}}{Sets \code{distanceUp} parameter for 
  \code{profileplyr::BamBigwig_to_chipProfile}
  when calling \code{\link{dba.plotProfile}.}}
  
\item{\code{DBA$config$distanceDown:}}{Sets \code{distanceDown} parameter for 
  \code{profileplyr::BamBigwig_to_chipProfile}
  when calling \code{\link{dba.plotProfile}.}}
  
\item{\code{DBA$config$id:}}{\code{character} string to use to replace \code{"ID"}
  when displaying a \code{DBA} object (\code{\link{dba.show}})}
  
\item{\code{DBA$config$group:}}{\code{character} string to use to replace \code{"Group"}
  when displaying a \code{DBA} object (\code{\link{dba.show}})}

\item{\code{DBA$config$tissue:}}{\code{character} string to use to replace \code{"Tissue"}
  when displaying a \code{DBA} object (\code{\link{dba.show}})}

\item{\code{DBA$config$factor:}}{\code{character} string to use to replace \code{"Factor"}
  when displaying a \code{DBA} object (\code{\link{dba.show}})}
  
\item{\code{DBA$config$condition:}}{\code{character} string to use to replace \code{"Condition"}
  when displaying a \code{DBA} object (\code{\link{dba.show}})}

\item{\code{DBA$config$treatment:}}{\code{character} string to use to replace \code{"Treatment"}
  when displaying a \code{DBA} object (\code{\link{dba.show}})}

\item{\code{DBA$config$replicate:}}{\code{character} string to use to replace \code{"Replicate"}
  when displaying a \code{DBA} object (\code{\link{dba.show}})}
  
\item{\code{DBA$config$caller:}}{\code{character} string to use to replace \code{"Caller"}
  when displaying a \code{DBA} object (\code{\link{dba.show}})}

\item{\code{DBA$config$reads:}}{\code{character} string to use to replace \code{"Reads"}
  when displaying a \code{DBA} object (\code{\link{dba.show}})}
  
}
}

%\value{
%}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
\examples{
data(tamoxifen_peaks)
tamoxifen
data(tamoxifen_counts)
tamoxifen
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.mask}
\alias{dba.mask}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Derive a mask to define a subset of peaksets or sites for a DBA object
}
\description{
Derives a mask to define a subset of peaksets or sites for a DBA object.
}
\usage{
dba.mask(DBA, attribute, value, combine='or', mask, merge='or', bApply=FALSE,
         peakset, minValue=-1)
}

%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}


  \item{DBA}{
DBA object
}
  \item{attribute}{
when deriving a peakset mask, attribute to base mask on:
\itemize{  	
\item DBA_ID
\item DBA_TISSUE
\item DBA_FACTOR
\item DBA_CONDITION
\item DBA_TREATMENT
\item DBA_REPLICATE
\item DBA_CONSENSUS
\item DBA_CALLER
\item DBA_CONTROL
}
}
%\subsection{Optional/defaulted arguments}{}
  \item{value}{
when deriving a peakset/sample mask, attribute value (or vector of attribute values) to match.
}

  \item{combine}{
when deriving a peakset/sample mask, if value is a vector, OR when deriving a site mask, and peaksets is a vector, this is method for combining result of each value:
\itemize{ 
\item \dQuote{or}
\item \dQuote{and}
\item \dQuote{nor}
\item \dQuote{nand}  
}
}
\item{mask}{
when deriving a peakset/sample mask, this specifies an existing mask to merge with; if missing, create new mask
}
  \item{merge}{
when deriving a peakset/sample mask, and an existing mask is supplied, this specifies the method for combining new mask with supplied mask:
\itemize{ 
\item \dQuote{or}
\item \dQuote{and}
\item \dQuote{nor}
\item \dQuote{nand}  note: if mask is missing, \dQuote{nand} results in negative of mask
}
}
\item{bApply}{
when deriving a peakset/sample mask, a logical indicating that a new DBA object 
with the mask applied will be returned.
}

\item{peakset}{
when deriving a peak/site mask, this specifies a peakset number, or a vector of peakset numbers. 
The resulting mask will indicate which of the overall sites were called as peaks 
in this peakset or set of peaksets. 
If a vector, the masks for each of the peaksets will be combined using the method 
specified in the combine parameter.
}

\item{minValue}{
when deriving a peak/site mask, scores greater than this value will be considered as indicating that the site corresponds to a called peakset.
}

}
\details{
%%  ~~ If necessary, more details than the description above ~~

MODE: Derive a a mask of peaksets/samples:

\code{dba.mask(DBA, attribute, value, combine, mask, merge, bApply)}

MODE: Derive a mask of peaks/sites:

\code{dba.mask(DBA, combine, mask, merge,bApply, peakset, minValue)}
}
\value{
either a logical mask, or new DBA object if \code{bApply} is \code{TRUE}.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
\note{
%%  ~~further notes~~
dba automatically generates masks for each unique value of \code{DBA_TISSUE}, \code{DBA_FACTOR}, \code{DBA_CONDITION}, \code{DBA_TREATMENT},  \code{DBA_CALLER}, and \code{DBA_REPLICATE}. These are accessible using masks field of the DBA object (\code{DBA$masks)}, and can be viewed using \code{names(DBA$masks)}.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link{dba.show}}
}
\examples{
data(tamoxifen_peaks)

# Pre-made masks
names(tamoxifen$masks)
dba.show(tamoxifen,tamoxifen$masks$MCF7)

# New masks
mcf7Mask <- dba.mask(tamoxifen,DBA_TISSUE, "MCF7")
mcf7DerivedMask <- dba.mask(tamoxifen,DBA_TISSUE,"TAMR",mask=mcf7Mask)
mcf7Derived <- dba(tamoxifen,mcf7DerivedMask)
mcf7Derived
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{DiffBind-package}
\alias{DiffBind-package}
\alias{DiffBind}
\docType{package}
\title{
Differential Binding Analysis of ChIP-seq peaksets
}
\description{
Differential binding analysis of ChIP-seq peaksets

}
\details{
Computes differentially bound sites from multiple ChIP-seq experiments using affinity (quantitative) data.
Also enables occupancy (overlap) analysis and plotting functions.


Entry Points:
\tabular{ll}{
\code{\link{dba}}:		\tab 	Construct a dba object\cr
\code{\link{dba.peakset}}:	\tab	Add a peakset to, or retrieve a peakset from, a dba object\cr
\cr

\code{\link{dba.overlap}}:	\tab	Compute binding site overlaps and/or correlations\cr
\code{\link{dba.blacklist}}:	\tab	Filter peaks using blacklists and greylists\cr
\code{\link{dba.count}}:	\tab	Count reads in binding sites\cr
\cr
	
\code{\link{dba.contrast}}:	\tab	Establish design and contrast(s) for analysis\cr
\code{\link{dba.normalize}}: \tab	Normalize count data for analysis\cr
\code{\link{dba.analyze}}:	\tab	Execute quantitative analysis\cr
\code{\link{dba.report}}:	\tab	Generate results report for a contrast analysis\cr
\cr

\code{\link{dba.plotHeatmap}}:\tab	Heatmap plot\cr
\code{\link{dba.plotPCA}}:	\tab	Principal Components plot\cr
\code{\link{dba.plotBox}}:	\tab	Boxplots\cr
\code{\link{dba.plotMA}}:	\tab	MA/scatter plot\cr
\code{\link{dba.plotVenn}}:	\tab 	Venn diagram plot\cr
\code{\link{dba.plotVolcano}}:	\tab 	Volcano plot\cr
\code{\link{dba.plotProfile}}:	\tab 	Peak profile heatmaps\cr
\cr
	
\code{\link{dba.show}}:	\tab	Show dba metadata\cr
\code{\link{dba.mask}}:	\tab	Mask samples or sites \cr
\cr
	
\code{\link{dba.save}}:	\tab	Save dba object\cr
\code{\link{dba.load}}:	\tab	Load dba object\cr
}
}
\author{
Rory Stark <rory.stark @at@ cruk.cam.ac.uk> and Gord Brown 
}
%\references{
%}
\keyword{ package }
%\seealso{
%}
%\examples{
%
%}

\name{dba.save}
\alias{dba.save}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
save DBA object
}
\description{
Writes out DBA object
}
\usage{
dba.save(DBA, file='DBA', dir='.', pre='dba_', ext='RData', 
         bRemoveAnalysis=FALSE, bRemoveBackground=FALSE,
         bCompress=FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}


  \item{DBA}{
DBA object
}
%\subsection{Optional/defaulted arguments}{}
  \item{file}{
main filename
}
  \item{dir}{
directory to save model in
}
  \item{pre}{
string to pre-pend to filename
}
 \item{ext}{
extensions to use
}
 \item{bRemoveAnalysis}{
if \code{TRUE}, will remove the global \code{DESeq2} and/or \code{edgeR}
analysis objects. 
The analysis results will be retained.
If the analysis objects are required after re-loading, they will
be automatically re-generated.
}
 \item{bRemoveBackground}{
if \code{TRUE}, will remove the global binned background
counts used for normalization.
Any normalization factors calculated using these counts
will be retained.
If the the normalization factors need to be re-re-calculated after re-loading, 
the binned background counts will
be automatically re-generated.
}
\item{bCompress}{
logical indicating saved DBA object should be compressed as much as possible.
}
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
\value{
string containing full path and filename.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
 \code{\link{dba.load}},  \code{\link{DBA.config}}.
}

\examples{
\dontrun{
data(tamoxifen_peaks)
savefile <- dba.save(tamoxifen,'tamoxifenPeaks')
savefile
rm(tamoxifen)
tamoxifen <- dba.load('tamoxifenPeaks')
unlink(savefile)
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{dba.peakset}
\alias{dba.peakset}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Add a peakset to, or retrieve a peakset from, a DBA object
}
\description{
Adds a peakset to, or retrieves a peakset from, a DBA object
}
\usage{
dba.peakset(DBA=NULL, peaks, sampID, tissue, factor, condition, treatment, replicate,
            control, peak.caller, peak.format, reads=0, consensus=FALSE, 
            bamReads, bamControl, spikein,
            scoreCol, bLowerScoreBetter, filter, counts,
            bRemoveM=TRUE, bRemoveRandom=TRUE,
            minOverlap=2, bMerge=TRUE,
            bRetrieve=FALSE, writeFile, numCols=4,
            DataType=DBA$config$DataType)
}
%- maybe also 'usage' for other objects documented here.
\arguments{

%\subsection{Required arguments}{}


\item{DBA}{
DBA object. Required unless creating a new DBA object by adding an initial peakset.
}

\item{peaks}{
When adding a specified peakset: set of peaks, either a \code{\link{GRanges}} object,
or a peak dataframe or matrix (chr,start,end,score), or a filename where the peaks are stored.

When adding a consensus peakset: a sample mask or vector of peakset numbers to include in the consensus. 
If missing or \code{NULL}, a consensus is derived from all peaksets present in the model. 
See  \code{\link{dba.mask}}, or \code{\link{dba.show}} to get peakset numbers.

When adding and empty peakset (zero peaks), set \code{peaks=NA}.

When adding a set of consensus peaksets: a sample mask or vector of peakset numbers. 
Sample sets will  be derived only from subsets of these peaksets.

When adding all the peaks from one DBA object to another: a DBA object. 
In this case, the only other parameter to have an effect is \code{minOverlap}.

When retrieving and/or writing a peakset: either a \code{\link{GRanges}}, or a peak dataframe or 
matrix (chr,start,end,score), or a peakset number; 
if \code{NULL}, retrieves/writes the full binding matrix.
}

%\subsection{Optional/defaulted arguments}{}

\item{sampID}{
ID string for the peakset being added; if missing, one is assigned 
(a serial number for a new peakset, or a concatenation of IDs for a consensus peakset).
Must be unique for each sample.
}
\item{tissue}{
tissue name for the peakset being added; if missing, one is assigned 
for a consensus peakset (a concatenation of tissues).
}
  \item{factor}{
factor name for the peakset being added; if missing, one is assigned 
for a consensus peakset (a concatenation of factors).
}
  \item{condition}{
condition name for the peakset being added; 
if missing, one is assigned for a consensus peakset (a concatenation of conditions).
}
  \item{treatment}{
treatment name for the peakset being added;
if missing, one is assigned for a consensus peakset (a concatenation of treatment).
}
  \item{replicate}{
replicate number for the peakset being added; 
if missing, one is assigned for a consensus peakset (a concatenation of replicate numbers).
}
  \item{control}{
control name for the peakset being added; 
if missing, one is assigned for a consensus peakset (a concatenation of control names).
}
\item{peak.caller}{
peak caller name string. If peaks is specified as a file, and peak.format is missing, a default fie format for the caller will be used (see peak.format).  Supported values:
\describe{
\item{\dQuote{raw}:}{default peak.format: raw text file}
\item{\dQuote{bed}:}{default peak.format: bed file}
\item{\dQuote{narrow}:}{default peak.format: narrowPeaks file}
\item{\dQuote{macs}:}{default peak.format: MACS .xls file}
\item{\dQuote{bayes}:}{default peak.format: bayesPeak file}
\item{\dQuote{tpic}:}{default peak.format: TPIC file}
\item{\dQuote{sicer}:}{default peak.format: SICER file}
\item{\dQuote{fp4}:}{default peak.format: FindPeaks v4 file}
\item{\dQuote{swembl}:}{default peak.format: SWEMBL file}
\item{\dQuote{csv}:}{default peak.format: comma separated value file}
\item{\dQuote{report}:}{default peak.format: csv file saved via \code{\link{dba.report}}}
}
When adding a consensus peakset, a default value (a concatenation of peak caller names) is assigned if this is missing. 
}
\item{peak.format}{
peak format string. If specified, overrides the default file format for the specified peak caller. Supported formats (with default score column):
\describe{
\item{\dQuote{raw}:}{raw text file file; scoreCol=4}
\item{\dQuote{bed}:}{bed file; scoreCol=5}
\item{\dQuote{narrow}:}{narrowPeaks file; scoreCol=8}
\item{\dQuote{macs}:}{MACS .xls file; scoreCol=7}
\item{\dQuote{bayes}:}{bayesPeak file; scoreCol=4, filter=0.5}
\item{\dQuote{tpic}:}{TPIC file; scoreCol=0 (all scores=1)}
\item{\dQuote{sicer}:}{SICER file; scoreCol=7}
\item{\dQuote{fp4}:}{FindPeaks v4 file; scoreCol=5}
\item{\dQuote{swembl}:}{SWEMBL file; scoreCol=4}
\item{\dQuote{csv}:}{csv file; scoreCol=4}
\item{\dQuote{report}:}{report file; scoreCol=9, bLowerScoreBetter=T}
}
}
\item{reads}{
total number of ChIPed library reads for the peakset being added.
}
 \item{consensus}{
either the logical value of the consensus attribute when adding a specific peakset 
(set to \code{TRUE} for consensus peaksets generated by  \code{\link{dba.peakset}}), 
or a metadata attribute or vector of attributes when generating a set of consensus peaksets. 
In the latter case, a consensus peakset will be added for each set of samples that have 
the same values for the specified attributes. 
Alternatively, attributes may be specified proceeded by a negative sign, 
in which case a consensus peakset will be added for each set of samples 
that differ only in their values for those attributes. 
See examples.  Allowable attributes:
\itemize{
\item \code{DBA_TISSUE; -DBA_TISSUE}
\item \code{DBA_FACTOR; -DBA_FACTOR}
\item \code{DBA_CONDITION; -DBA_CONDITION}
\item \code{DBA_TREATMENT; -DBA_TREATMENT}
\item \code{DBA_REPLICATE; -DBA_REPLICATE}
\item \code{DBA_CALLER; -DBA_CALLER}
}
}
\item{bamReads}{
file path of the BAM/BED file containing the aligned reads for the 
peakset being added.
}
\item{bamControl}{
file path of the BAM/BED file containing the aligned reads for the control 
used for the peakset being added.
}
\item{spikein}{
file path of the BAM/BED file containing the aligned reads for the spike-ins
used for the peakset being added.
}
  \item{scoreCol}{
peak column to normalize to 0...1 scale when adding a peakset; 
0 indicates no normalization
}
  \item{bLowerScoreBetter}{
Logical indicating that lower scores indicate higher confidence peaks; 
default is that higher scores indicate better peaks.
}
  \item{filter}{
Numeric indicating a filter value for peaks. 
If present, any peaks with a score less than this value 
(or higher if \code{bLowerScoreBetter==TRUE}) will be removed from the peakset. 
}
  \item{counts}{
Used for adding externally computed peak counts. 
Can be a filename or a dataframe. 
Can consist of a single column (or vector) with the counts, or two columns, 
with an ID for each interval in the first column and the counts in the second column,
or four columns (chr, start, end, counts). 
When \code{counts} is specified, \code{peaks} and related parameters are ignored, 
and all peaksets in the DBA object must be specified in this way, 
all with exactly the same number of intervals.
}
  \item{bRemoveM}{
logical indicating whether to remove peaks on chrM when adding a peakset
}
  \item{bRemoveRandom}{
logical indicating whether to remove peaks on chrN_random when adding a peakset
}
  \item{minOverlap}{
the minimum number of peaksets a peak must be in to be included when adding a consensus peakset.
When retrieving, if the peaks parameter is 
a vector (logical mask or vector of peakset numbers), a binding matrix will be retrieved 
including all peaks in at least this many peaksets. 
If \code{minOverlap} is between zero and one, 
peak will be included from at least this proportion of peaksets.
}
  \item{bMerge}{
logical indicating whether global binding matrix should be compiled after adding the peakset. 
When adding several peaksets via successive calls to  \code{\link{dba.peakset}},
it may be more efficient to set this parameter to \code{FALSE} and call \code{dba(DBA)} 
after all of the peaksets have been added.
}
  \item{bRetrieve}{
logical indicating that a peakset is being retrieved and/or written, not added.
}
 \item{writeFile}{
file to write retrieved peakset.
}
 \item{numCols}{
number of columns to include when writing out peakset.
First four columns are chr, start, end, score; 
the remainder are maintained from the original peakset. 
Ignored when writing out complete binding matrix.
}
\item{DataType}{
The class of object for returned peaksets:
\itemize{
\item \code{DBA_DATA_GRANGES}
\item \code{DBA_DATA_FRAME}
}
Can be set as default behavior by setting \code{DBA$config$DataType}.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~

MODE: Add a specified peakset:

\code{dba.peakset(DBA=NULL, peaks, sampID, tissue, factor, condition, replicate,
                       control, peak.caller, reads, consensus, bamReads, bamControl,
                       normCol, bRemoveM, bRemoveRandom)}

MODE: Add a consensus peakset (derived from overlapping peaks in peaksets already present):

\code{dba.peakset(DBA, peaks, minOverlap)}

MODE: Add a sets of consensus peaksets bases on sample sets that share or differ in specified attributes

\code{dba.peakset(DBA, peaks, consensus, minOverlap)}

MODE: Retrieve a peakset:

\code{dba.peakset(DBA, peaks, bRetrieve=T)}

MODE: Write a peakset out to a file:

\code{dba.peakset(DBA, peaks, bRetrieve=T,  writeFile, numCols)}
}
\value{
DBA object when adding a peakset.
Peakset matrix or \code{\link{GRanges}} object when retrieving and/or writing a peakset.
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Rory Stark
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
to add peaksets using a sample sheet, see  \code{\link{dba}}.

\code{$config$} options are described in \code{\link{DBA.config}}.
}

\examples{

# create a new DBA object by adding three peaksets
mcf7 <- dba.peakset(NULL,
                   peaks=system.file("extra/peaks/MCF7_ER_1.bed.gz", package="DiffBind"),
                   peak.caller="bed", sampID="MCF7.1",tissue="MCF7",
                   factor="ER",condition="Responsive",replicate=1)
mcf7 <- dba.peakset(mcf7,
                   peaks=system.file("extra/peaks/MCF7_ER_2.bed.gz", package="DiffBind"),    
                   peak.caller="bed", sampID="MCF7.2",tissue="MCF7",
                   factor="ER",condition="Responsive",replicate=2)
mcf7 <- dba.peakset(mcf7,
                   peaks=system.file("extra/peaks/MCF7_ER_3.bed.gz", package="DiffBind"),      
                   peak.caller="bed", sampID="MCF7.3",tissue="MCF7",
                   factor="ER",condition="Responsive",replicate=3)
mcf7

#retrieve peaks that are in all three peaksets
mcf7.consensus <- dba.peakset(mcf7, 1:3, minOverlap=3, bRetrieve=TRUE)
mcf7.consensus

#add a consensus peakset -- peaks in all three replicates
mcf7 <- dba.peakset(mcf7, 1:3, minOverlap=3,sampID="MCF7_3of3")
mcf7

#add consensus peaksets for all sample types by combining replicates
data(tamoxifen_peaks)
tamoxifen <- dba.peakset(tamoxifen,consensus = -DBA_REPLICATE)
dba.show(tamoxifen,mask=tamoxifen$masks$Consensus)

#add consensus peaksets for all sample types by (same tissue and condition) 
data(tamoxifen_peaks)
tamoxifen <- dba.peakset(tamoxifen,consensus = c(DBA_TISSUE,DBA_CONDITION))
dba.show(tamoxifen,mask=tamoxifen$masks$Consensus)
dba.plotVenn(tamoxifen,tamoxifen$masks$Responsive & tamoxifen$masks$Consensus)

#create consensus peaksets from sample type consensuses for Responsive and Resistant sample groups
tamoxifen <- dba.peakset(tamoxifen,peaks=tamoxifen$masks$Consensus,consensus=DBA_CONDITION)
dba.show(tamoxifen,mask=tamoxifen$masks$Consensus)
dba.plotVenn(tamoxifen,17:18)
 
#retrieve the consensus peakset as GRanges object
mcf7.consensus <- dba.peakset(mcf7,mcf7$masks$Consensus,bRetrieve=TRUE)
mcf7.consensus

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
